﻿
/*

			Class:              AffiliatedOrganization

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.AffiliatedOrganizationMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkAffiliatedOrganizations
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class AffiliatedOrganization : AffiliatedOrganizationBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors

		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkAffiliatedOrganizations entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public AffiliatedOrganization(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}

		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private AffiliatedOrganization(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of AffiliatedOrganization that will be used to add a record to the VtkAffiliatedOrganizations database table.
		/// </summary>
		/// <param name="stationId">Primary key value for VtkStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="AffiliatedOrganization" /></returns>
		public static AffiliatedOrganization AddRecord(int stationId, ApplicationConnection appCon)
		{
			AffiliatedOrganization aoObj = new AffiliatedOrganization(appCon);
			aoObj.FillDataNew();
			aoObj.StationId = stationId;
			return aoObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus" /></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationId(OrganizationId, appCon);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AffiliatedOrganizationBase.ValidateStationId.
		/// </remarks>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus" /></returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = AffiliatedOrganizationBase.ValidateStationId(value, appCon);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationId property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling AffiliatedOrganizationBase.ValidateOrganizationId.
		/// </remarks>
		/// <param name="value">Current instance value of OrganizationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus" /></returns>
		public static new ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = AffiliatedOrganizationBase.ValidateOrganizationId(value, appCon);	 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		/// List of Organizations Affiliated with a station
		/// </summary>
		/// <param name="idValue">StationID</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: AffiliatedOrganizationList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationFK</br>
		/// <br>OrganizationFK</br>
		/// <br>DisplayName</br>
		/// <br></br>
		///	<br>Sorted By: None Specified</br>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select AO.id ID, " +
				" AO." + sqlDrv.stationIdField		               + " As StationId, " +
				" AO." + sqlDrv.organizationIdField	               + " As OrganizationId, " +
				" ORG." + OrganizationMsSqlSrv.organizationNameField + " As DisplayName " +
				" FROM  " + sqlDrv.tableName + " AO " +
				" INNER JOIN " + OrganizationMsSqlSrv.tableName + " ORG ON AO." + sqlDrv.organizationIdField + " = ORG." + OrganizationMsSqlSrv.idField +
				" WHERE AO." + sqlDrv.stationIdField + " = '" + idValue + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "AffiliatedOrganizationList");
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
