﻿
/*

			Class:              AffiliatedOrganizationCollection

			Date Produced:      11/20/2001 10:32:24 AM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        11/20/2001 10:31:10 AM
			Revision:           392

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	/// A collection that stores <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> objects.
	/// </summary>
	/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>
	[Serializable()]
	#if msSql
	public class AffiliatedOrganizationCollection :  MsSqlDataSrvCollection
	#endif
	{
        
		private int stationId;
        
		/// <summary>
		///  Initializes a new instance of <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name="stationId">Primary key for an entry in VtkStationParamters table</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public AffiliatedOrganizationCollection(int stationId, ApplicationConnection appCon) 
		{
			this.stationId = stationId;
			this.appCon   = appCon;
			Populate(stationId);
		}
        
        #if msSql

		/// <summary>
		/// Populates the collection with <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> instances for the specified station.
		/// </summary>
		/// <param name="stationId">Primary key for an entry in VtkStationParamters table</param>
		public void Populate(int stationId)
		{
			Hashtable entries = new Hashtable();
			foreach(AffiliatedOrganization entry in List)
			{
				entries.Add(entry.ID, entry);
			}
      
			int keyId;
			AffiliatedOrganization refObj;
			// TODO: Code Enhancement Possibility: (3) For collections in general, it would be better to use a 'SELECT *' and call a constructer that accepts a DataRow as input. See User(DataRow dr, ApplicationConnection appCon) for example.
			SqlDataAdapter da = new SqlDataAdapter("SELECT id, " + AffiliatedOrganizationMsSqlSrv.stationIdField + " FROM VtkAffiliatedOrganizations WHERE " + AffiliatedOrganizationMsSqlSrv.stationIdField + " = " + stationId.ToString(), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, "VtkAffiliatedOrganizations");
			da.Dispose();
			DataTable dt = ds.Tables["VtkAffiliatedOrganizations"];
			if (dt == null) return;
			DataRow dr;
        
			for (int row = 0 ; row < dt.Rows.Count ; row++)
			{
				dr = dt.Rows[row];
				keyId = (int)dr["id"];
				if(entries.ContainsKey(keyId))
				{
					refObj = (AffiliatedOrganization)entries[keyId];
					refObj.Refresh();
					entries.Remove(keyId);
				}
				else
				{
					refObj = new AffiliatedOrganization((int)dr["id"], appCon);
					Add(refObj);
				}
			}
        
			// remove existing entries that the database no longer contains (rare)
			IDictionaryEnumerator entryEnum = entries.GetEnumerator();
			while (entryEnum.MoveNext()) List.Remove(entryEnum.Value);
		}
        #endif
        
		/// <summary>
		/// Initializes a new instance of <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> based on another <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>
		///       A <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> from which the contents are copied
		/// </param>
		public AffiliatedOrganizationCollection(AffiliatedOrganizationCollection value) 
		{
			this.AddRange(value);
		}
        
		/// <summary>
		/// Initializes a new instance of <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> containing any array of <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> objects.
		/// </summary>
		/// <param name='value'>
		///       A array of <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> objects with which to intialize the collection
		/// </param>
		public AffiliatedOrganizationCollection(AffiliatedOrganization[] value) 
		{
			this.AddRange(value);
		}
        
		/// <summary>
		/// Represents the entry at the specified index of the <see cref='Vha.Vtk.Common.AffiliatedOrganization'/>.
		/// </summary>
		/// <param name='index'>The zero-based index of the entry to locate in the collection.</param>
		/// <value>
		/// The entry at the specified index of the collection.
		/// </value>
		/// <exception cref='System.ArgumentOutOfRangeException'><paramref name='index'/> is outside the valid range of indexes for the collection.</exception>
		public AffiliatedOrganization this[int index] 
		{
			get 
			{
				return ((AffiliatedOrganization)(List[index]));
			}
			set 
			{
				List[index] = value;
			}
		}
        
		/// <summary>
		/// Adds a <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> with the specified value to the 
		/// <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>Reference to a <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> variable.</param>
		/// <returns>
		/// The index at which the new element was inserted. Reference returned in 'out' parameter.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.AddRange'/>
		public int Add(out AffiliatedOrganization value) 
		{
			value = AffiliatedOrganization.AddRecord(stationId, appCon);
			return List.Add(value);
		}
        
		/// <summary>
		/// Adds a <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> with the specified value to the 
		/// <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>The <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> to add.</param>
		/// <returns>
		/// The index at which the new element was inserted.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.AddRange'/>
		private int Add(AffiliatedOrganization value) 
		{
			return List.Add(value);
		}
        
		/// <summary>
		/// Mark instance of <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> in the collection as Deleted.
		/// </summary>
		/// <param name="value">Instance of <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> in the collection.</param>
		public void Delete(AffiliatedOrganization value) 
		{
			value.Delete();
		}
        
		/// <summary>
		/// Copies the elements of an array to the end of the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>
		///    An array of type <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> containing the objects to add to the collection.
		/// </param>
		/// <returns>
		/// None.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.Add'/>
		private void AddRange(AffiliatedOrganization[] value) 
		{
			for (int i = 0; (i < value.Length); i = (i + 1)) 
			{
				this.Add(value[i]);
			}
		}
        
		/// <summary>
		/// Adds the contents of another <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> to the end of the collection.
		/// </summary>
		/// <param name='value'>
		///    A <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> containing the objects to add to the collection.
		/// </param>
		/// <returns>
		/// None.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.Add'/>
		private void AddRange(AffiliatedOrganizationCollection value) 
		{
			for (int i = 0; (i < value.Count); i = (i + 1)) 
			{
				this.Add(value[i]);
			}
		}
        
		/// <summary>
		/// Saves the collection of <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> instances to the database.
		/// </summary>
		public void Save()
		{
			ReturnStatus returnStatus = ValidateCollection();
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
        
			try
			{
				DoBeginTransaction();
				ArrayList deletedList = new ArrayList();
				foreach(AffiliatedOrganization oRef in List)
				{
					// keep track of to be deleted and new entries
					if (oRef.IsDeleted) deletedList.Add(oRef);
					//if ((oRef.IsNew) && (!oRef.IsDeleted)) oRef.StationId = this.stationId;
					oRef.Save();
				}
				DoCommitTransaction();
	   
				// remove objects from list
				for(int i=0; i < deletedList.Count ;i++)
				{
					List.Remove(deletedList[i]);
				}
				Populate(stationId);
			}
			catch (Exception e)
			{
				DoRollbackTransaction();
				throw e;
			}
		}
        
		/// <summary>
		/// Performs validation rules that apply across all <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> instances in the collection,
		/// like checking for duplicate organization entries. 
		/// </summary>
		/// <remarks>This method is called by the <see cref="Vha.Vtk.Common.AffiliatedOrganizationCollection.Save"/> method.</remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus" /></returns>
		public ReturnStatus ValidateCollection()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "AffiliatedOrganizationCollection";
			ret.PropertyName = "AffiliatedOrganization.OrganizationId";

			Hashtable ht = new Hashtable();
			foreach(AffiliatedOrganization entry in this)
			{
				if (!entry.IsDeleted)
				{
					if (ht.ContainsKey(entry.OrganizationId))
					{
						ret.Status = si.Fail;
						ret.ErrorText = "Adding Organization more then once is not allowed. (Organization ID: " + entry.OrganizationId + ")";
						break;
					}
					else
					{	
						ht.Add(entry.OrganizationId,"");
					}
				}
			}
			return ret;
		}
		
		/// <summary>
		/// Searches the collection for an <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> instance that matches the specified id.
		/// </summary>
		/// <remarks>If a match is found, a reference to the instance is returned. Otherwise, null is returned.</remarks>
		/// <param name="id">Primary key for an entry in the VtkAffiliatedOrganizations table.</param>
		/// <returns>Matching <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> instance.</returns>
		public AffiliatedOrganization GetObjectForId(int id)
		{
			AffiliatedOrganization aoObj;
			for (int i = 0; (i < List.Count); i = (i + 1))
			{
				aoObj = this[i];
				if (aoObj.ID == id) return aoObj;
			}
			return null;
		}
        
		/// <summary>
		/// Returns all rows in a DataSet to used for inserts, updates and deletes.
		/// Use SaveCollectionDataSet to save edits.
		/// </summary>
		/// <param name="stationId">Primary key for an entry in VtkStationParamters table</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns all rows
		/// <ul>
		/// <li>DataSet TableName:</li> <ul><li><b>AffiliatedOrganizationCollection</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>StationId</b>  [Int32]</li>
		///  <li><b>OrganizationId</b>  [Int32]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetCollectionDataSet(int stationId)
		{
			// TODO: Stored Procedure: (4) Not sure how often this called. Probably not often.
			string sCommand = 
				"Select "
				+ AffiliatedOrganizationMsSqlSrv.idField + " As ID"
				+ ", " + AffiliatedOrganizationMsSqlSrv.stationIdField + " As StationId"
				+ ", " + AffiliatedOrganizationMsSqlSrv.organizationIdField + " As OrganizationId"
				+ ", " + AffiliatedOrganizationMsSqlSrv.versionField + " As Version"
				+ " FROM  " + AffiliatedOrganizationMsSqlSrv.tableName
				+ " WHERE " + AffiliatedOrganizationMsSqlSrv.stationIdField + " = " + stationId;
       
			return ApplicationConnection.ExecuteQuery(sCommand, "AffiliatedOrganizationCollection");
		}
        
		/// <summary>
		/// Saves inserts, updates and deletes in a dataset initially created with the <see cref="GetCollectionDataSet"/> method.
		/// </summary>
		/// <param name="stationId">Primary key for an entry in VtkStationParamters table</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <param name="ds">DataSet containing <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> information.</param>
		public static void SaveCollectionDataSet(int stationId, ApplicationConnection appCon, DataSet ds)
		{
			if (!ds.HasChanges()) return; // no changes in dataset

			DataTable dtChanges = ds.Tables["AffiliatedOrganizationCollection"].GetChanges();
        
			if (dtChanges.Rows.Count == 0) return; // no changes in table
        
			AffiliatedOrganization aoObj;
			AffiliatedOrganizationCollection coll = new AffiliatedOrganizationCollection(stationId, appCon);
			foreach(DataRow dr in ds.Tables["AffiliatedOrganizationCollection"].Rows)
			{
				switch (dr.RowState)
				{
					case DataRowState.Added:
						int index = coll.Add(out aoObj);
						PopulateInstance(aoObj, dr);
						break;
        
					case DataRowState.Modified:
						aoObj = coll.GetObjectForId((int)dr[AffiliatedOrganizationMsSqlSrv.idField]);
						PopulateInstance(aoObj, dr);
						break;
        
					case DataRowState.Deleted:
						dr.RejectChanges();
						aoObj = coll.GetObjectForId((int)dr[AffiliatedOrganizationMsSqlSrv.idField]);
						dr.Delete();
						if (aoObj != null) aoObj.Delete();
						break;
        
					default:
						break;
				}
			}
			coll.Save();
			ds.AcceptChanges();
		}
		
		/// <summary>
		/// Populates a <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> instance based on information in a DataRow.
		/// </summary>
		/// <param name="aoObj">Instance of <see cref="Vha.Vtk.Common.AffiliatedOrganization"/></param>
		/// <param name="dr">DataRow contain information for a <see cref="AffiliatedOrganization"/>.</param>
		private static void PopulateInstance(AffiliatedOrganization aoObj, DataRow dr)
		{
			if (!dr.IsNull("OrganizationId"))
			{
				aoObj.OrganizationId = (Int32)dr["OrganizationId"];
			}
			else
			{
				aoObj.OrganizationId = Int32.MinValue;
			}
		
			if (!dr.IsNull("Version"))
			{
				aoObj.SetVersion((int)dr["Version"]);
			}
		}
        
		/// <summary>
		/// Gets a value indicating whether the 
		/// <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> contains the specified <see cref='Vha.Vtk.Common.AffiliatedOrganization'/>.
		/// </summary>
		/// <param name='value'>The <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> to locate.</param>
		/// <returns>
		/// <see langword='true'/> if the <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> is contained in the collection; 
		/// otherwise, <see langword='false'/>.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.IndexOf'/>
		public bool Contains(AffiliatedOrganization value) 
		{
			return List.Contains(value);
		}
        
		/// <summary>
		/// Copies the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> values to a one-dimensional <see cref='System.Array'/> instance at the 
		/// specified index.
		/// </summary>
		/// <param name='array'>The one-dimensional <see cref='System.Array'/> that is the destination of the values copied from <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> .</param>
		/// <param name='index'>The index in <paramref name='array'/> where copying begins.</param>
		/// <returns>
		/// None.
		/// </returns>
		/// <exception cref='System.ArgumentException'><paramref name='array'/> is multidimensional. -or- The number of elements in the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> is greater than the available space between <paramref name='arrayIndex'/> and the end of <paramref name='array'/>.</exception>
		/// <exception cref='System.ArgumentNullException'><paramref name='array'/> is <see langword='null'/>. </exception>
		/// <exception cref='System.ArgumentOutOfRangeException'><paramref name='arrayIndex'/> is less than <paramref name='array'/>'s lowbound. </exception>
		/// <seealso cref='System.Array'/>
		public void CopyTo(AffiliatedOrganization[] array, int index) 
		{
			List.CopyTo(array, index);
		}
        
		/// <summary>
		/// Returns the index of a <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> in 
		/// the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>The <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> to locate.</param>
		/// <returns>
		/// The index of the <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> of <paramref name='value'/> in the 
		/// <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>, if found; otherwise, -1.
		/// </returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>
		public int IndexOf(AffiliatedOrganization value) 
		{
			return List.IndexOf(value);
		}
        
		/// <summary>
		/// Inserts a <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> into the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> at the specified index.
		/// </summary>
		/// <param name='index'>The zero-based index where <paramref name='value'/> should be inserted.</param>
		/// <param name=' value'>The <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> to insert.</param>
		/// <returns>None.</returns>
		/// <seealso cref='Vha.Vtk.Common.AffiliatedOrganizationCollection.Add'/>
		private void Insert(int index, AffiliatedOrganization value) 
		{
			List.Insert(index, value);
		}
        
		/// <summary>
		/// Returns an enumerator that can iterate through 
		/// the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <returns>None.</returns>
		/// <seealso cref='System.Collections.IEnumerator'/>
		public new AffiliatedOrganizationEnumerator GetEnumerator() 
		{
			return new AffiliatedOrganizationEnumerator(this);
		}
        
		/// <summary>
		/// Removes a specific <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> from the 
		/// <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/>.
		/// </summary>
		/// <param name='value'>The <see cref='Vha.Vtk.Common.AffiliatedOrganization'/> to remove from the <see cref='Vha.Vtk.Common.AffiliatedOrganizationCollection'/> .</param>
		/// <returns>None.</returns>
		/// <exception cref='System.ArgumentException'><paramref name='value'/> is not found in the Collection. </exception>
		private void Remove(AffiliatedOrganization value) 
		{
			List.Remove(value);
		}
        
	}

	/// <summary>
	/// Enumerator class used to navigate an instance of <see cref="AffiliatedOrganizationCollection" />.
	/// </summary>
	public class AffiliatedOrganizationEnumerator : object, IEnumerator 
	{
        
		private IEnumerator baseEnumerator;
        
		private IEnumerable temp;
        
		/// <summary>
		/// Set mappings for this enumerator instance.
		/// </summary>
		/// <param name="mappings"><see cref="AffiliatedOrganizationCollection"/></param>
		public AffiliatedOrganizationEnumerator(AffiliatedOrganizationCollection mappings) 
		{
			this.temp = ((IEnumerable)(mappings));
			this.baseEnumerator = temp.GetEnumerator();
		}
        
		/// <summary>
		/// Get <see cref="Vha.Vtk.Common.AffiliatedOrganization" /> instance at the current cursor position.
		/// </summary>
		public AffiliatedOrganization Current 
		{
			get 
			{
				return ((AffiliatedOrganization)(baseEnumerator.Current));
			}
		}
        
		/// <summary>
		/// Get object at current cursor position.
		/// </summary>
		object IEnumerator.Current 
		{
			get 
			{
				return baseEnumerator.Current;
			}
		}
        
		/// <summary>
		/// Move cursor to next <see cref="Vha.Vtk.Common.AffiliatedOrganization"/> instance in collection.
		/// </summary>
		/// <returns>Returns 'true' if operation moved cursor to next instance. Otherwise, returns 'false' cursor is at end of collection. </returns>
		public bool MoveNext() 
		{
			return baseEnumerator.MoveNext();
		}
        
		/// <summary>
		/// Moves cursor to next instance in collection.
		/// </summary>
		/// <returns>Returns 'true' if operation moved cursor to next instance. Otherwise, returns 'false' cursor is at end of collection. </returns>
		bool IEnumerator.MoveNext() 
		{
			return baseEnumerator.MoveNext();
		}
        
		/// <summary>
		/// Resets <see cref="Vha.Vtk.Common.AffiliatedOrganizationCollection"/> enumerator.
		/// </summary>
		public void Reset() 
		{
			baseEnumerator.Reset();
		}
        
		/// <summary>
		/// Resets enumerator.
		/// </summary>
		void IEnumerator.Reset() 
		{
			baseEnumerator.Reset();
		}
	}
}
