﻿
/*

			Class:              ScheduleWorkday

			Date Produced:      11/6/2001 9:51:21 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ScheduleWorkdayMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerScheduleWorkdays
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class ScheduleWorkday : ScheduleWorkdayBase
	{
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerScheduleWorkdays entry</param>
		public ScheduleWorkday(int id) : base(id)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		private ScheduleWorkday() : base()
		{
		}
		
		/// <summary>
		/// Creates an instance of ScheduleWorkday that will be used to add a record to the VtkVolunteerScheduleWorkdays database table.
		/// </summary>
		/// <returns><see cref="ScheduleWorkday" /></returns>
		public static ScheduleWorkday AddRecord()
		{
			ScheduleWorkday swdObj = new ScheduleWorkday();
			swdObj.FillDataNew();
			return swdObj;
		}
		
		#endregion
				
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCode(Code);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDays(Days);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAppearsAs(AppearsAs);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Code property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ScheduleWorkdayBase.ValidateCode.
		/// </remarks>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCode(string value)
		{
			ReturnStatus ret = ScheduleWorkdayBase.ValidateCode(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Days property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ScheduleWorkdayBase.ValidateDays.
		/// </remarks>
		/// <param name="value">Current instance value of Days</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDays(string value)
		{
			ReturnStatus ret = ScheduleWorkdayBase.ValidateDays(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AppearsAs property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ScheduleWorkdayBase.ValidateAppearsAs.
		/// </remarks>
		/// <param name="value">Current instance value of AppearsAs</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAppearsAs(string value)
		{
			ReturnStatus ret = ScheduleWorkdayBase.ValidateAppearsAs(value);
			return ret;
		}
		 		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		/// <summary>
		/// Returns a list of all schedule workday entries
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: ScheduleWorkdayList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>Code</br>
		/// <br>Days</br>
		/// <br><b>DisplayName</b> combination of AppearsAs and Code (i.e. 'AppearsAs (code)')</br>
		/// <br>AppearsAs</br>
		/// <br></br>
		///	<br>Sorted By: None Specified</br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select Id ID, " + 
				sqlDrv.codeField + " Code, " +
				sqlDrv.daysField + " Days, " +
				sqlDrv.appearsAsField + " + ' (' + " + sqlDrv.codeField + " + ')' AS DisplayName, " +
				sqlDrv.appearsAsField + " AppearsAs " +
				" FROM " + sqlDrv.tableName;
		
			return ApplicationConnection.ExecuteQuery(sCommand, "ScheduleWorkdayList");
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
				
		#endregion
		
	}
}
