﻿
/*

			Class:              Service

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Text.RegularExpressions;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ServiceMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkBenefitingServices
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Service : ServiceBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors

		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkBenefitingServices entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Service(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Service(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Service that will be used to add a record to the VtkBenefitingServices database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Service" /></returns>
		public static Service AddRecord(ApplicationConnection appCon)
		{
			Service servObj = new Service(appCon);
			servObj.FillDataNew();
			return servObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();

			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateScope(Scope);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCode(Code, Scope, StationId);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateServiceName(ServiceName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSubdivision(Subdivision);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAbbreviation(Abbreviation);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(ID, ServiceName, Subdivision, Code, Abbreviation, Scope, StationId);
			return returnStatus;
		}
		
		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Locally scoped code must be associated with a station</description></item>
		/// <item><description>Station can only be associated with locally scoped code</description></item>
		/// <item><description>Local code must be in the 900-999 range</description></item>
		/// <item><description>Code must be unique with scope.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();

			if (!IsUniqueCode(this))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Service codes must be unique.";
				return ret;
			}
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for Scope property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServiceBase.ValidateScope.</description></item>
		/// <item><description>Also see <see cref="ValidateRelations"/> for other Scope validity checks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = ServiceBase.ValidateScope(value);
			if (ret.Status == si.Fail) return ret;

			// is it a valid scope value
			if (!Regex.IsMatch(value, @"\b[L|N]\b"))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Scope can be either 'N'ational or 'L'ocal. The value entered is not valid. (Scope: " + value + ")";
				return ret;
			}

			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServiceBase.ValidateStationId.</description></item>
		/// <item><description>Also see <see cref="ValidateRelations"/> for other StationId validity checks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ServiceBase.ValidateStationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Code property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ServiceBase.ValidateCode.</description></item>
		/// <item><description>Also see <see cref="ValidateRelations"/> for other Code validity checks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCode(string value, string Scope, int StationId)
		{
			ReturnStatus ret = ServiceBase.ValidateCode(value);
			if (ret.Status == si.Fail) return ret;
			
			if(Scope == "L")
			{
				if (StationId <= 0)
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Local codes must be associated with a station. No station was entered.";
					return ret;
				}					
				if(!Regex.IsMatch(value, @"^[8][0-9]{2}[A-Z]?$"))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Local service codes must be between 800-899 and/or an UPPERCASE alpha character. The code entered is not valid. (Code: " + value + ")";
					return ret;
				}
			}
				
			if(Scope == "N")
			{
				if (StationId > 0)
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Service entries must be have a scope of 'L' (Local) in order to specify a station.";
					return ret;
				}		
				if(!Regex.IsMatch(value, @"^[1-7][0-9]{2}[A-Z]?$"))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Service codes must contain three numeric characters and/or one UPPERCASE character (i.e. ###U). The code entered is not valid. (Code: " + value + ")";
					return ret;
				}
			}	 
		  

			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ServiceName property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ServiceBase.ValidateServiceName.
		/// </remarks>
		/// <param name="value">Current instance value of ServiceName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateServiceName(string value)
		{
			ReturnStatus ret = ServiceBase.ValidateServiceName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Subdivision property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ServiceBase.ValidateSubdivision.
		/// </remarks>
		/// <param name="value">Current instance value of Subdivision</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateSubdivision(string value)
		{
			ReturnStatus ret = ServiceBase.ValidateSubdivision(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Abbreviation property.
		/// </summary>
		/// <remarks>
		/// Database-centric validation checks are performed by calling ServiceBase.ValidateAbbreviation.
		/// </remarks>
		/// <param name="value">Current instance value of Abbreviation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAbbreviation(string value)
		{
			ReturnStatus ret = ServiceBase.ValidateAbbreviation(value);
			return ret;
		}
		 
		private static ReturnStatus CheckForDuplicates(int ServiceId, string ServiceName, string Subdivision, string Code, string Abbreviation, string Scope, int StationFK)
		{			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd		= new SqlCommand("VtkServiceExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@ServiceId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= ServiceId;
			
			sqlParam				= sqlCmd.Parameters.Add("@ServiceName", SqlDbType.VarChar, 35);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= ServiceName;

			sqlParam				= sqlCmd.Parameters.Add("@Subdivision", SqlDbType.VarChar, 30);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= Subdivision;

			sqlParam				= sqlCmd.Parameters.Add("@Code", SqlDbType.VarChar, 4);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= Code;

			sqlParam				= sqlCmd.Parameters.Add("@Abbreviation", SqlDbType.VarChar, 6);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= Abbreviation;

			sqlParam				= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= "N";
			
			sqlParam				= sqlCmd.Parameters.Add("@StationFK", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value			= StationFK;
			
			//These are all Return Parameters and Return Value
			sqlParam				= sqlCmd.Parameters.Add("@IsFullNameExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;

			sqlParam				= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam				= sqlCmd.Parameters.Add("@IsAbbreviationExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam				= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISFULLNAMEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsFullNameExisting"].Value);
			bool RETURN_ISABBREVIATIONEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsAbbreviationExisting"].Value);
			bool RETURN_ISCODEEXISTING = Convert.ToBoolean(sqlCmd.Parameters["@IsCodeExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Service";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the Organization table.";		
			}
			else if(RETURN_ISFULLNAMEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "ServiceName";
				if(Scope == "N")
					ret.ErrorText = "'ServiceName'(" + ServiceName + ")  already exists Nationally, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate an 'ServiceName'(" + ServiceName + ")  which already exists Nationally, please enter another value.";
			}
			else if(RETURN_ISCODEEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "Code";
				if(Scope == "N")
					ret.ErrorText = "'Code'(" + Code + ")  already exists, please enter another value.";
				else if(Scope == "L")
					ret.ErrorText = "'Code' (" + Code + ")  already exists in your Local Service Codes, please enter another value.";
			}
			else if(RETURN_ISABBREVIATIONEXISTING)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "Abbreviation";
				if(Scope == "N")
					ret.ErrorText = "'Abbreviation'(" + Abbreviation + ")  already exists, please enter another value.";
				else
					ret.ErrorText = "Local Sites can't duplicate an 'Abbreviation'(" + Abbreviation + ")  which already exists Nationally, please enter another value.";
			}


			if(ret.Status == si.Pass && Scope == "L")
			{
				//Run a DB Check to see if another Volunteer exists with this SSN
				sqlConn					= new SqlConnection(ApplicationConnection.GetConnectionString());

				sqlCmd					= new SqlCommand("VtkServiceExistsQuery", sqlConn);
				sqlCmd.CommandType		= CommandType.StoredProcedure;

				sqlParam				= sqlCmd.Parameters.Add("@ServiceId", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= ServiceId;
			
				sqlParam				= sqlCmd.Parameters.Add("@ServiceName", SqlDbType.VarChar, 35);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= ServiceName;

				sqlParam				= sqlCmd.Parameters.Add("@Subdivision", SqlDbType.VarChar, 30);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= Subdivision;

				sqlParam				= sqlCmd.Parameters.Add("@Code", SqlDbType.VarChar, 4);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= Code;

				sqlParam				= sqlCmd.Parameters.Add("@Abbreviation", SqlDbType.VarChar, 6);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= Abbreviation;

				sqlParam				= sqlCmd.Parameters.Add("@Scope", SqlDbType.VarChar, 1);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= "L";
			
				sqlParam				= sqlCmd.Parameters.Add("@StationFK", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.Input;
				sqlParam.Value			= StationFK;
			
				//These are all Return Parameters and Return Value
				sqlParam				= sqlCmd.Parameters.Add("@IsFullNameExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam				= sqlCmd.Parameters.Add("@IsCodeExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam				= sqlCmd.Parameters.Add("@IsAbbreviationExisting", SqlDbType.Bit);
				sqlParam.Direction		= ParameterDirection.Output;			

				sqlParam				= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
				sqlParam.Direction		= ParameterDirection.ReturnValue;

				sqlConn.Open();
				sqlCmd.ExecuteNonQuery();

				RETURN_ISFULLNAMEEXISTING			= Convert.ToBoolean(sqlCmd.Parameters["@IsFullNameExisting"].Value);
				RETURN_ISABBREVIATIONEXISTING		= Convert.ToBoolean(sqlCmd.Parameters["@IsAbbreviationExisting"].Value);
				RETURN_ISCODEEXISTING				= Convert.ToBoolean(sqlCmd.Parameters["@IsCodeExisting"].Value);
				RETURN_STATUS						= Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
				sqlConn.Close();

				ret						= new ReturnStatus();
				ret.ClassName			= "Service";

				if(RETURN_STATUS)
				{
					ret.Status = si.Fail;
					ret.ErrorText = "An error accured while checking for duplicates in the Organization table.";		
				}
				else if(RETURN_ISFULLNAMEEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "ServiceName";
					ret.ErrorText = "'ServiceName'(" + ServiceName + ")  already exists, please enter another value.";
				}
				else if(RETURN_ISCODEEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "Code";
					ret.ErrorText = "'Code'(" + Code + ")  already exists, please enter another value.";
				}
				else if(RETURN_ISABBREVIATIONEXISTING)
				{
					ret.Status = si.Fail;
					ret.PropertyName = "Abbreviation";
					ret.ErrorText = "'Abbreviation'(" + Abbreviation + ")  already exists, please enter another value.";
				}
			}
			return ret;
		}
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		/// Returns a list of services for a station sorted by name
		/// </summary>
		/// <param name="StationId">StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: ServiceList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>ServiceName</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of ServiceName and Code (i.e. 'ServiceName (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>Subdivision</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: ServiceName</br>
		/// </returns>
		public static DataSet GetSiteQuickListByName(int StationId)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.serviceNameField  + " ServiceName, " +
				sqlDrv.codeField         + " Code, " +
				"Case When Len(" + sqlDrv.subdivisionField + ") > 0 " +
				"THEN " + sqlDrv.serviceNameField + " + ' -  ' + " + sqlDrv.subdivisionField + " + ' (' + " + sqlDrv.codeField + " + ')'" +
				"ELSE " + sqlDrv.serviceNameField + " + ' (' + " + sqlDrv.codeField + " + ')' END  AS DisplayName, " +
				sqlDrv.abbreviationField + " Abbreviation, " +
				sqlDrv.subdivisionField  + " Subdivision, " +
				sqlDrv.scopeField        + " Scope, " +
				sqlDrv.stationIdField    + " StationId " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE ((" + sqlDrv.scopeField + " = 'N') OR (" 	+ sqlDrv.stationIdField + " = '" + StationId.ToString() + "')) AND (" + sqlDrv.codeField + " NOT LIKE '6%') " +
				"ORDER BY " + sqlDrv.serviceNameField + " ";
			
			return ApplicationConnection.ExecuteQuery(sCommand, "ServiceList");
		}


		/// <summary>
		/// Returns a list of services for a station sorted by code
		/// </summary>
		/// <param name="StationId">StationId </param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: ServiceList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>ServiceName</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of ServiceName and Code (i.e. 'ServiceName (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>Subdivision</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: Code</br>
		/// </returns>
		public static DataSet GetSiteQuickListByCode(int StationId)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.serviceNameField  + " ServiceName, " +
				sqlDrv.codeField         + " Code, " +
				"Case When Len(" + sqlDrv.subdivisionField + ") > 0 " +
				"THEN " + sqlDrv.serviceNameField + " + ' -  ' + " + sqlDrv.subdivisionField + " + ' (' + " + sqlDrv.codeField + " + ')'" +
				"ELSE " + sqlDrv.serviceNameField + " + ' (' + " + sqlDrv.codeField + " + ')' END  AS DisplayName, " +
				sqlDrv.abbreviationField + " Abbreviation, " +
				sqlDrv.subdivisionField  + " Subdivision, " +
				sqlDrv.scopeField        + " Scope, " +
				sqlDrv.stationIdField    + " StationId " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE (" + sqlDrv.scopeField + " = 'N') OR (" 	+ sqlDrv.stationIdField + " = '" + StationId.ToString() + "') " +
				"ORDER BY " + sqlDrv.codeField + " ";
			
			return ApplicationConnection.ExecuteQuery(sCommand, "ServiceList");
		}

		/// <summary>
		/// Returns a list of national services for a station sorted by code
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: ServiceList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>ServiceName</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of ServiceName and Code (i.e. 'ServiceName (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>Subdivision</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: Code</br>
		/// </returns>
		public static DataSet GetNationalQuickListByCode()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.serviceNameField  + " ServiceName, " +
				sqlDrv.codeField         + " Code, " +
				"Case When Len(" + sqlDrv.subdivisionField + ") > 0 " +
				"THEN " + sqlDrv.serviceNameField + " + ' -  ' + " + sqlDrv.subdivisionField + " + ' (' + " + sqlDrv.codeField + " + ')'" +
				"ELSE " + sqlDrv.serviceNameField + " + ' (' + " + sqlDrv.codeField + " + ')' END  AS DisplayName, " +
				sqlDrv.abbreviationField + " Abbreviation, " +
				sqlDrv.subdivisionField  + " Subdivision, " +
				sqlDrv.scopeField        + " Scope, " +
				sqlDrv.stationIdField    + " StationId " +
				"FROM " + sqlDrv.tableName + " " +
				"WHERE (" + sqlDrv.scopeField + " = 'N') " +
				"ORDER BY " + sqlDrv.codeField + " ";

			return ApplicationConnection.ExecuteQuery(sCommand, "ServiceList");
		}

		/// <summary>
		/// Returns a list of services sorted by name
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: ServiceList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>ServiceName</br>
		/// <br>Code</br>
		/// <br><b>DisplayName</b> combination of ServiceName and Code (i.e. 'ServiceName (code)')</br>
		/// <br>Abbreviation</br>
		/// <br>Subdivision</br>
		/// <br>Scope</br>
		/// <br>StationId</br>
		/// <br></br>
		///	<br>Sorted By: ServiceName</br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.serviceNameField  + " ServiceName, " +
				sqlDrv.codeField         + " Code, " +
				"Case When Len(" + sqlDrv.subdivisionField + ") > 0 " +
				"THEN " + sqlDrv.serviceNameField + " + ' -  ' + " + sqlDrv.subdivisionField + " + ' (' + " + sqlDrv.codeField + " + ')'" +
				"ELSE " + sqlDrv.serviceNameField + " + ' (' + " + sqlDrv.codeField + " + ')' END  AS DisplayName, " +
				sqlDrv.abbreviationField + " Abbreviation, " +
				sqlDrv.subdivisionField  + " Subdivision, " +
				sqlDrv.scopeField        + " Scope, " +
				sqlDrv.stationIdField    + " StationId " +
				"FROM " + sqlDrv.tableName + " " +
				"ORDER BY " + sqlDrv.serviceNameField + " ";

			
			return ApplicationConnection.ExecuteQuery(sCommand, "ServiceList");
		}
		
		public static DataSet GetQuickListForGames()
		{
			return Service.GetQuickListForGames("%");
		}

		public static DataSet GetQuickListForGames(string GameTypeCode)
		{			
			return ApplicationConnection.ExecuteQuery("spS_GamesServiceCodes '" + GameTypeCode + "'", "GamesServiceCodes");
		}
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#if msSql
		/// <summary>
		/// Determines if service code for instance is unique.
		/// </summary>
		/// <remarks>Station is considered for local codes. Code must be unique for station.</remarks>
		/// <param name="srvObj"><see cref="Service"/></param>
		/// <returns>Boolean indicate whether service code for instance is unique.</returns>
		private static bool IsUniqueCode(Service srvObj)
		{
			bool localCode = ((srvObj.scope == "L") && (srvObj.stationId > 0));

			string sCommand;
			if (localCode)
			{
				// TODO: Stored Procedure: (5) Called by ValidateRelations.
				sCommand = "SELECT Count(*) " + 
					"FROM " + ServiceMsSqlSrv.tableName + " " +
					"WHERE (" + ServiceMsSqlSrv.idField + " <> '" + srvObj.ID + "') AND (" + ServiceMsSqlSrv.codeField + " = '" + srvObj.Code + "') AND (" 	+ ServiceMsSqlSrv.stationIdField + " = '" + srvObj.stationId.ToString() + "') ";
			}
			else
			{
				// TODO: Stored Procedure: (5) Called by ValidateRelations.
				sCommand = "SELECT Count(*) " + 
					"FROM " + ServiceMsSqlSrv.tableName + " " +
					"WHERE (" + ServiceMsSqlSrv.idField + " <> '" + srvObj.ID + "') AND (" + ServiceMsSqlSrv.codeField + " = '" + srvObj.Code + "')";
			}

			SqlConnection conn = new SqlConnection(srvObj.AppCon.ConnectString);
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			int count = (int)cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();

			return (count == 0);		 
		}
		#endif
		#endregion
		
	}
}
