﻿
/*			Class:              StationParameters

			Date Produced:      6/18/2002 6:22:51 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        6/18/2002 11:43:05 AM
			Revision:           655

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\Vha.Vtk.Common

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text.RegularExpressions;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.StationParametersMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Common
{
	/// <summary>
	///  Public Class mapped to VtkVoluntaryStationParameters
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class StationParameters : StationParametersBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public StationParameters(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private StationParameters(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of StationParameters thate will be used to add a record to the VtkVoluntaryStationParameters database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="StationParameters"/></returns>
		public static StationParameters AddRecord(ApplicationConnection appCon)
		{
			StationParameters spObj = new StationParameters(appCon);
			spObj.FillDataNew();
			return spObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateId(ID);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIntroductoryText(IntroductoryText);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsRequireAlternateLanguage(IsRequireAlternateLanguage);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDefaultLanguageId(DefaultLanguageId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAlternateLanguageId(AlternateLanguageId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNumberOfMeals(NumberOfMeals);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMealAuthorization(MealAuthorization);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsSaturdayMeal(IsSaturdayMeal);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsSundayMeal(IsSundayMeal);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsHolidayMeal(IsHolidayMeal);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMealPrice(MealPrice);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDurationForMeal1(DurationForMeal1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCutOffTimeForMeal1(CutOffTimeForMeal1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDurationForMeal2(DurationForMeal2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCutOffTimeForMeal2(CutOffTimeForMeal2);
			return returnStatus;
		}
		
		/// <summary>
		/// Validates Id is a valid institution.
		/// </summary>
		/// <param name="value">Current instance value of Id</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This Id is the primary key for this StationParameters class/table and the Instition class/table.</description>
		/// </item>
		/// <item>
		/// <description>This class is a filtered extension of the Institution class containing data that relates
		///  only to Voluntary Timekeeping.</description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static ReturnStatus ValidateId(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
		 
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "Id";
					
			// foreign key check
			if (!InstitutionBase.DoesExist(value))
			{
				ret.Status = si.Fail;
				ret.ErrorText = " 'Id' ('InstitutionId')  is not valid. (" + value + ")";
				return ret;
			}
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IntroductoryText property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateIntroductoryText.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IntroductoryText</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIntroductoryText(string value)
		{
			ReturnStatus ret = StationParametersBase.ValidateIntroductoryText(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsRequireAlternateLanguage property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateIsRequireAlternateLanguage.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsRequireAlternateLanguage</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsRequireAlternateLanguage(bool value)
		{
			ReturnStatus ret = StationParametersBase.ValidateIsRequireAlternateLanguage(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DefaultLanguageId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateDefaultLanguageId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DefaultLanguageId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDefaultLanguageId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationParametersBase.ValidateDefaultLanguageId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AlternateLanguageId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateAlternateLanguageId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AlternateLanguageId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAlternateLanguageId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationParametersBase.ValidateAlternateLanguageId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NumberOfMeals property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateNumberOfMeals.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NumberOfMeals</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNumberOfMeals(Int32 value)
		{
			ReturnStatus ret = StationParametersBase.ValidateNumberOfMeals(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MealAuthorization property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateMealAuthorization.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MealAuthorization</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMealAuthorization(string value)
		{
			ReturnStatus ret = StationParametersBase.ValidateMealAuthorization(value);
			if (ret.Status == si.Fail) return ret;

			// nulls allowed
			if (value == string.Empty) return ret;

			// is it a valid authorization type value
			if (!Regex.IsMatch(value, @"\b[L|T]\b"))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Meal Authorization type can be either 'L'ist or 'T'icket. The value entered is not valid. (Type: " + value + ")";
				return ret;
			}
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsSaturdayMeal property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateIsSaturdayMeal.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsSaturdayMeal</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsSaturdayMeal(bool value)
		{
			ReturnStatus ret = StationParametersBase.ValidateIsSaturdayMeal(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsSundayMeal property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateIsSundayMeal.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsSundayMeal</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsSundayMeal(bool value)
		{
			ReturnStatus ret = StationParametersBase.ValidateIsSundayMeal(value);	
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsHolidayMeal property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateIsHolidayMeal.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsHolidayMeal</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsHolidayMeal(bool value)
		{
			ReturnStatus ret = StationParametersBase.ValidateIsHolidayMeal(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MealPrice property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateMealPrice.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MealPrice</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMealPrice(decimal value)
		{
			ReturnStatus ret = StationParametersBase.ValidateMealPrice(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DurationForMeal1 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateDurationForMeal1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DurationForMeal1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDurationForMeal1(Int32 value)
		{
			ReturnStatus ret = StationParametersBase.ValidateDurationForMeal1(value);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for CutOffTimeForMeal1 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateCutOffTimeForMeal1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CutOffTimeForMeal1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>	 
		public static new ReturnStatus ValidateCutOffTimeForMeal1(string value)
		{
			ReturnStatus ret = StationParametersBase.ValidateCutOffTimeForMeal1(value);
			return ret;
		}
		 	 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DurationForMeal2 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateDurationForMeal2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DurationForMeal2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDurationForMeal2(Int32 value)
		{
			ReturnStatus ret = StationParametersBase.ValidateDurationForMeal2(value);
		 
			// TODO: Add property specific validation logic for 'DurationForMeal2'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for CutOffTimeForMeal2 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationParametersBase.ValidateCutOffTimeForMeal2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CutOffTimeForMeal2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCutOffTimeForMeal2(string value)
		{
			ReturnStatus ret = StationParametersBase.ValidateCutOffTimeForMeal2(value);
		 
			// TODO: Add property specific validation logic for 'CutOffTimeForMeal2'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		/// <summary>
		/// Saves object data to database
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>	 
		public override ReturnStatus Save()
		{
			ReturnStatus ret = SaveCheck();
			if (ret.Status != si.Pass) throw new VhaValidationException(ret.ErrorText, ret.ClassName, returnStatus.PropertyName);

			return base.Save();
		}
		
		/// <summary>
		/// Performs special validity checks before save is performed 
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>	 
		public ReturnStatus SaveCheck()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "";
			
			//delete not allowed
			if (isDeleted)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Deleting Station Parameters is not allowed.";
			}			
			return ret;
		}
		
		#endregion
		
		#region Section: Quick Lists
		#if msSql
		
		/// <summary>
		/// Returns a list of all stations
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <ul><li><b>StationParametersList</b></li></ul></li> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>ID</b> [int]</li>
		/// <li><b>IntroductoryText</b> [string (240)]</li>
		/// <li><b>IsRequireAlternateLanguage</b> [bool]</li>
		/// <li><b>DefaultLanguageId</b> [int]</li>
		/// <li><b>AlternateLanguageId</b> [int]</li>
		/// <li><b>MealAuthorization</b> [string (1)]</li>
		/// <li><b>HasSaturdayMeal</b> [bool]</li>
		/// <li><b>HasSundayMeal</b> [bool]</li>
		/// <li><b>HasHolidayMeal</b> [bool]</li>
		/// <li><b>MealPrice</b> [decimal (money)]</li>
		/// <li><b>DurationForMeal</b> [int]</li>
		/// <li><b>Version</b> [int]</li>
		/// <li><b>CutOffTimeForMeal</b> [int]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By: None Specified</li>
		///	</ul>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (5) Doubt this is used often...if at all.
			// TODO: Code Enhancement Possibility: (5) SqlCommand.DataReader candidate?
			string sCommand = "Select " + sqlDrv.idField + " ID, "         +
				sqlDrv.introductoryTextField           + " IntroductoryText, " +
				sqlDrv.isRequireAlternateLanguageField + " IsRequireAlternateLanguage, " +
				sqlDrv.defaultLanguageIdField          + " DefaultLanguage, " +
				sqlDrv.alternateLanguageIdField        + " AlternateLanguage, " +
				sqlDrv.mealAuthorizationField          + " MealAuthorization, " +
				sqlDrv.isHolidayMealField             + " IsHolidayMeal, " + 
				sqlDrv.isSaturdayMealField            + " IsSaturdayMeal, " +
				sqlDrv.isSundayMealField              + " IsSundayMeal, " +
				sqlDrv.mealPriceField				   + " MealPrice, " +
				sqlDrv.cutOffTimeForMeal1Field          + " CutOffTimeForMeal, " +
				sqlDrv.durationForMeal1Field            + " DurationForMeal, " +
				sqlDrv.versionField	                   + " Version " +
				" FROM " + sqlDrv.tableName;
		
			return ApplicationConnection.ExecuteQuery(sCommand, "StationParametersList");
		}

		/// <summary>
		///  Returns stationParameters for Specified StationId.
		/// </summary>
		/// <param name="stationId">[int] StationParameter Id</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// </returns>
		public static DataSet GetQuickList(int stationId)
		{
			// TODO: Stored Procedure: (3) Not sure how often this called
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select " + sqlDrv.idField + " ID, "         +
				sqlDrv.introductoryTextField           + " IntroductoryText, " +
				sqlDrv.isRequireAlternateLanguageField + " IsRequireAlternateLanguage, " +
				sqlDrv.defaultLanguageIdField          + " DefaultLanguage, " +
				sqlDrv.alternateLanguageIdField        + " AlternateLanguage, " +
				sqlDrv.mealAuthorizationField          + " MealAuthorization, " +
				sqlDrv.isHolidayMealField             + " IsHolidayMeal, " + 
				sqlDrv.isSaturdayMealField            + " IsSaturdayMeal, " +
				sqlDrv.isSundayMealField              + " IsSundayMeal, " +
				sqlDrv.mealPriceField				   + " MealPrice, " +
				sqlDrv.cutOffTimeForMeal1Field          + " CutOffTimeForMeal, " +
				sqlDrv.versionField	                   + " Version, " +
				sqlDrv.durationForMeal1Field            + " DurationForMeal " +
				" FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.idField + " = '" + stationId + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "StationParametersList");
		}

		/// <summary>
		///  Returns a dataset containing the Key Column and External column of
		///  MealAuthorization.  The External Column is to display to Users, the Key column
		///  is set to the StationParameters.MealAuthorization property
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// Returns a list of valid StationParameters.MealAuthorization internal and external values
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> MealAuthorizationList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>Key</b> [string (1)]</li>
		/// <li><b>External</b> [string]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>External</b></li></ul>
		/// </ul>
		/// </returns>
		public static DataSet GetMealAuthorizationList(ApplicationConnection appCon)
		{
			DataSet ds = new DataSet("MealAuthorizationList");

			DataTable dt = new DataTable("MealAuthorizationList");
			DataColumn[] keys = new DataColumn[1];
			DataColumn keyCol = new DataColumn("Key",System.Type.GetType("System.String"));
			dt.Columns.Add(keyCol);
			keys[0] = keyCol;
			dt.PrimaryKey = keys;

			DataColumn externalCol = new DataColumn("External",System.Type.GetType("System.String"));
			dt.Columns.Add(externalCol);

			DataRow dr;
			dr = dt.NewRow(); dr["Key"] = "L"; dr["External"] = "List"; dt.Rows.Add(dr);
			dr = dt.NewRow(); dr["Key"] = "T"; dr["External"] = "Ticket"; dt.Rows.Add(dr);

			ds.Tables.Add(dt);
			return ds;
		}
		/// <summary>
		/// Gets a record for this Stations Meal Ticket Parameters.
		/// </summary>
		/// <param name="InstitutionId" type="System.Int"/>
		/// <returns type="System.Data.DataSet"/>
		public static DataSet GetInstitutionMealTicketParams(int InstitutionId)
		{
			int Success = 0;
			return ApplicationConnection.ExecuteQuery("VtkInstitutionMealQuery " + InstitutionId.ToString(), "MealParams", out Success);
		}

		public static NameObjectCollection GetInstitutionDRMealTicketParams(int InstitutionId)
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "VtkInstitutionMealQuery " + InstitutionId.ToString();

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
