﻿
/*

			Class:              VolunteerAdjustmentsBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVolunteerAdjustments
	/// </summary>
	[Serializable()]

	public abstract class VolunteerAdjustmentsBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.StationFK database field
		/// </summary>
		protected internal Int32  stationId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.ProfileFK database field
		/// </summary>
		protected internal Int32  profileId;

		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.VolunteerFK database field
		/// </summary>
		protected internal Int32  volunteerId;

		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.AdjustmentDate database field
		/// </summary>
		protected internal DateTime  adjustmentDate;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.AdjustmentHours database field
		/// </summary>
		protected internal Int32  adjustmentHours;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.AdjustmentDescription database field
		/// </summary>
		protected internal string  adjustmentDescription;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerAdjustments.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to stationId class field
		/// </summary>
		public Int32  StationId
		{
			get { return stationId;}    set {isChanged = true; stationId = value;}
		}
		
		/// <summary>
		/// Property that maps to profileId class field
		/// </summary>
		public Int32  ProfileId
		{
			get { return profileId;}    set {isChanged = true; profileId = value;}
		}

		/// <summary>
		/// Property that maps to volunteerId class field
		/// </summary>
		public Int32  VolunteerId
		{
			get { return volunteerId;}    set {isChanged = true; volunteerId = value;}
		}

		/// <summary>
		/// Property that maps to adjustmentDate class field
		/// </summary>
		public DateTime  AdjustmentDate
		{
			get { return adjustmentDate;}    set {isChanged = true; adjustmentDate = value;}
		}
		
		/// <summary>
		/// Property that maps to adjustmentHours class field
		/// </summary>
		public Int32  AdjustmentHours
		{
			get { return adjustmentHours;}    set {isChanged = true; adjustmentHours = value;}
		}

		/// <summary>
		/// Property that maps to adjustmentDescription class field
		/// </summary>
		public string  AdjustmentDescription
		{
			get { return adjustmentDescription;}    set {isChanged = true; adjustmentDescription = value;}
		}

		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		/// <summary>
		/// Basic constructor
		/// </summary>
		protected VolunteerAdjustmentsBase():base(){}
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerAdjustments entry</param>
		protected VolunteerAdjustmentsBase(int id) : base()
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVolunteerAdjustments</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVolunteerAdjustments definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected VolunteerAdjustmentsBase(DataRow dr) : base()
		{
			FillCommon((int)dr[VolunteerAdjustmentsMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			stationId = Int32.MinValue;
			profileId = Int32.MinValue;
			volunteerId = Int32.MinValue;
			adjustmentDate = DateTime.MinValue;
			adjustmentHours = Int32.MinValue;
			adjustmentDescription =string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
//			allowDelete   = true;
//			allowUnDelete = true;
			#if msSql
			this.dataSrv = new VolunteerAdjustmentsMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of VolunteerAdjustments.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for StationId property values
		/// </summary>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "StationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationId' is a required. No value is entered.";
			}

			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationParametersBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric validation checks for ProfileId property values
		/// </summary>
		/// <param name="value">Current instance value of ProfileId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "ProfileId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationProfileId' is a required. No value is entered.";
			}

			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationProfileBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationProfileId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for VolunteerId property values
		/// </summary>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "VolunteerId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'VolunteerId' is a required. No value is entered.";
			}

			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!VolunteerBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'VolunteerId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}


		/// <summary>
		/// Performs basic database-centric validation checks for AdjustmentDate property values
		/// </summary>
		///<Params>
		/// <param name="value" type="DateTime">Current instance value of AdjustmentDate</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateAdjustmentDate(DateTime value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "AdjustmentDate";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == DateTime.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AdjustmentDate' is a required. No value is entered.";
			}
			if(value > DateTime.Now)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AdjustmentDate' can not be a future date.";				
			}
			
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric validation checks for AdjustmentHours property values
		/// </summary>
		///<Params>
		/// <param name="value" type="DateTime">Current instance value of AdjustmentHours</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateAdjustmentHours(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "AdjustmentHours";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AdjustmentHours' is a required. No value is entered.";
			}
		
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric validation checks for AdjustmentDescription property values
		/// </summary>
		/// <param name="value">Current instance value of AdjustmentDescription</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateAdjustmentDescription(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerAdjustments";
			ret.PropertyName = "AdjustmentDescription";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AdjustmentDescription' is a required field. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 256))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AdjustmentDescription' length (" + value.Length +  ") is greater than 13 characters.";
			}
			
			return ret;
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVolunteerAdjustments.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
/*				else
				{
					dataSrv.Update();
				} */
			isChanged = false;
			// Refresh not done on Save() for collection data to prevent deadly embrace (locking problems)
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVolunteerAdjustments table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVolunteerAdjustments entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return VolunteerAdjustmentsMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "StationId")  {return stationId.ToString();}
			if (prop == "ProfileId")  {return profileId.ToString();}
			if (prop == "VolunteerId")  {return VolunteerId.ToString();}
			if (prop == "AdjustmentDate")  {return adjustmentDate.ToString();}
			if (prop == "AdjustmentHours")  {return adjustmentHours.ToString();}
			if (prop == "AdjustmentDescription")  {return adjustmentDescription.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
