﻿
/*

			Class:              AdministrativeUnitMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkAdministrativeUnits
	/// </summary>
	public class AdministrativeUnitMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private AdministrativeUnitBase auObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkAdministrativeUnits)
		/// </summary>
		public static string tableName = "VtkAdministrativeUnits";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkAdministrativeUnits.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkAdministrativeUnits.UnitName database field
		/// </summary>
		public const string unitNameField = "UnitName";
		
		/// <summary>
		/// Class field that maps to VtkAdministrativeUnits.UnitNumber database field
		/// </summary>
		public const string unitNumberField = "UnitNumber";
		
		/// <summary>
		/// Class field that maps to VtkAdministrativeUnits.Type database field
		/// </summary>
		public const string typeField = "Type";
		
		/// <summary>
		/// Class field that maps to VtkAdministrativeUnits.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		/// <Params>
		///	<param name = "auObj"></param>
		///	</Params>
		public AdministrativeUnitMsSqlSrv(AdministrativeUnitBase auObj)
		{
			Initialize(auObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		/// <Params>
		///<param name = "auObj"></param>
		///</Params>
		private void Initialize(AdministrativeUnitBase auObj)
		{
			this.auObj = auObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = auObj.AppCon;
			this.databaseTableName = AdministrativeUnitMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = AdministrativeUnitMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(auObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create AdministrativeUnit instance. Invalid ID: " + auObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <Params>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		/// </Params>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				auObj.id = (Int32)dr[idField];
			}
			else
			{
				auObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(unitNameField))
			{
				auObj.unitName = (string)dr[unitNameField];
			}
			else
			{
				auObj.unitName = string.Empty;
			}
		
			if (!dr.IsNull(unitNumberField))
			{
				auObj.unitNumber = (Int32)dr[unitNumberField];
			}
			else
			{
				auObj.unitNumber = Int32.MinValue;
			}
		
			if (!dr.IsNull(typeField))
			{
				auObj.type = (string)dr[typeField];
			}
			else
			{
				auObj.type = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				auObj.version = (Int32)dr[versionField];
			}
			else
			{
				auObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <Params>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// </Params>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		
		/// <summary>
		/// No Insert Allowed
		/// </summary>
		/// <returns type="Integer"> integer value of zero to indicate failure. </returns>
		public int Insert()
		{
			return 0;
		}
 
		
		/// <summary>
		/// No Updating Allowed
		/// </summary>
		public void Update()
		{
		}
 
		/// <summary>
		/// No Deletion Allowed
		/// </summary>
		public void Delete()
		{
		}
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <Parmas>
		/// <param name="id">The integer ID of the record to retrieve</param>
		/// </Parmas>
		///<returns type="String"> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + AdministrativeUnitMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <params>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// </params>
		///<returns type="bool"> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, AdministrativeUnitMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
