﻿
/*

			Class:              AffiliatedOrganizationBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkAffiliatedOrganizations
	/// </summary>
	[Serializable()]
	public abstract class AffiliatedOrganizationBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.StationFK database field
		/// </summary>
		protected internal Int32  stationId;
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.OrganizationFK database field
		/// </summary>
		protected internal Int32  organizationId;
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to stationId class field
		/// </summary>
		public Int32  StationId
		{
			get { return stationId;}    set {isChanged = true; stationId = value;}
		}
		
		/// <summary>
		/// Property that maps to organizationId class field
		/// </summary>
		public Int32  OrganizationId
		{
			get { return organizationId;}    set {isChanged = true; organizationId = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor used by AffiliatedOrgainzation.AddRecord
		/// </summary>
		/// <Params>
		/// <param name="appCon">ApplicationConnection Object See Refs.</param>
		/// </Params> 
		///<References>
		///<seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</References>
		protected AffiliatedOrganizationBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <Params>
		/// <param name="id" type="System.Int">
		/// Primary key value for VtkAffiliatedOrganizations entry
		/// </param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection" Required="Manditory">
		/// Application Connection Object See Refs.
		/// </param>
		/// </Params>
		///<References>
		///<seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</References>
		protected AffiliatedOrganizationBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <Params>
		/// <param name="dr" type="DataRow">DataRow for entry in VtkAffiliatedOrganizations</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		/// <remarks>
		/// <OrderedList type="bullet">
		///		<ListItem>Column names in DataRow are the same as those in VtkAffiliatedOrganizations definition.</ListItem>
		///		<ListItem>This constructor may be obsolete as a result of changes made in vtk.</ListItem>
		/// </OrderedList>
		/// </remarks>
		protected AffiliatedOrganizationBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[AffiliatedOrganizationMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			stationId = Int32.MinValue;
			organizationId = Int32.MinValue;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new AffiliatedOrganizationMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of AffiliatedOrganization.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for StationId property values
		/// </summary>
		/// <Params>
		/// <param name="value" type="System.Int">Current instance value of StationId</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus">Indicator of the Status</returns>
		/// 
		///<References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		///</References>
		protected static ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "AffiliatedOrganization";
			ret.PropertyName = "StationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationParametersBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for OrganizationId property values
		/// </summary>
		/// <Params>
		/// <param name="value" type="System.Int" Required="Mandatory">Current instance value of OrganizationId</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection" Required="Mandatory">See Refs.</param>
		/// </Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		///<References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ReturnStatus"/>
		///</References>
		protected static ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "AffiliatedOrganization";
			ret.PropertyName = "OrganizationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'OrganizationId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!OrganizationBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'OrganizationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <OrderedList type="bullet">
		/// <ListItem>This method saves inserts, updates and deletes to VtkAffiliatedOrganizations.</ListItem>
		/// <ListItem>For inserts, updates field validation is performed.</ListItem>
		/// </OrderedList>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			// Refresh not done on Save() for collection data to prevent deadly embrace (locking problems)
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkAffiliatedOrganizations table for the specified idValue
		/// </summary>
		/// <Params>
		/// <param name="idValue" type="System.Int">Primary key value for VtkAffiliatedOrganizations entry</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		/// <returns type="System.Bool"></returns>
		///<References>
		/// <seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</References>
		public static bool DoesExist(int idValue)
		{
			return AffiliatedOrganizationMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		/// <returns type="System.String"/>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <Params>
		/// <param name="prop" type="System.String">Name of the property</param>
		/// </Params>
		/// <returns type="System.String"/>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "StationId")  {return stationId.ToString();}
			if (prop == "OrganizationId")  {return organizationId.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
