﻿
/*

			Class:              AffiliatedOrganizationMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkAffiliatedOrganizations
	/// </summary>
	public class AffiliatedOrganizationMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private AffiliatedOrganizationBase aoObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkAffiliatedOrganizations)
		/// </summary>
		public static string tableName = "VtkAffiliatedOrganizations";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.OrganizationFK database field
		/// </summary>
		public const string organizationIdField = "OrganizationFK";
		
		/// <summary>
		/// Class field that maps to VtkAffiliatedOrganizations.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		/// <params>
		///	<param name = "aoObj" type="AffiliatedOrganizationBase" Required="Mandatory"></param>
		///	</params>
		public AffiliatedOrganizationMsSqlSrv(AffiliatedOrganizationBase aoObj)
		{
			Initialize(aoObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		/// <params>
		///<param name = "aoObj" type="AffiliatedOrganizationBase" Required="Mandatory"></param>
		///</params>
		///<returns type="void"></returns>
		private void Initialize(AffiliatedOrganizationBase aoObj)
		{
			this.aoObj = aoObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = aoObj.AppCon;
			this.databaseTableName = AffiliatedOrganizationMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		/// <returns type="void"/>
		public void GetIdData()
		{
			Clean();
		
			string tableName = AffiliatedOrganizationMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(aoObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create AffiliatedOrganization instance. Invalid ID: " + aoObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		/// <returns type="void"/>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <params>
		/// <param name="dr" type="DataRow" Required="Mandatory">DataRow that contains data to populate an object</param>
		/// </params>
		/// <returns type="void"/>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				aoObj.id = (Int32)dr[idField];
			}
			else
			{
				aoObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				aoObj.stationId = (Int32)dr[stationIdField];
			}
			else
			{
				aoObj.stationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(organizationIdField))
			{
				aoObj.organizationId = (Int32)dr[organizationIdField];
			}
			else
			{
				aoObj.organizationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				aoObj.version = (Int32)dr[versionField];
			}
			else
			{
				aoObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <params>
		/// <param name="ds" type="DataSet">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName" type="System.String">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow" type="System.Int">Data row number to associate with instance</param>
		/// </params>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		/// <returns type="void"/>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		/// <returns type="void"/>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns type="System.Int"> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkAffiliatedOrganizations spParam = new spParams.spI_VtkAffiliatedOrganizations ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._StationFK = aoObj.stationId;
			spParam._OrganizationFK = aoObj.organizationId;
			spParam._Ver = aoObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkAffiliatedOrganizations spSProc = new spSProcs.spI_VtkAffiliatedOrganizations();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {aoObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("AffiliatedOrganization", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return aoObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		/// <returns type="void"/>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[AffiliatedOrganizationMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkAffiliatedOrganizations spParam = new spParams.spU_VtkAffiliatedOrganizations();
 
			if (aoObj.IsChanged && (!aoObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkAffiliatedOrganizations spSProc = new spSProcs.spU_VtkAffiliatedOrganizations(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("AffiliatedOrganization", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (aoObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (aoObj.organizationId == Int32.MinValue && !dr.IsNull(organizationIdField))  {return true;} 
			else
			if (aoObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkAffiliatedOrganizations spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  aoObj.id; 
			spParam._StationFK =  aoObj.stationId; 
			spParam._OrganizationFK =  aoObj.organizationId; 
			spParam._Ver =  aoObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkAffiliatedOrganizations spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = aoObj.id; 
			spParam._StationFK = aoObj.stationId; 
			spParam._OrganizationFK = aoObj.organizationId; 
			spParam._Ver =  aoObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		/// <returns type="void"/>
		public void Delete()
		{
			if (aoObj.id > 0)
			{
				spParams.spD_VtkAffiliatedOrganizations spParam = new spParams.spD_VtkAffiliatedOrganizations ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = aoObj.id;
				spParam._Ver = aoObj.version; 
				spSProcs.spD_VtkAffiliatedOrganizations spSProc = new spSProcs.spD_VtkAffiliatedOrganizations();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("AffiliatedOrganization", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <params>
		/// <param name="id" type="System.Int">The integer ID of the record to retrieve</param>
		/// </params>
		///<returns type="System.String"> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + AffiliatedOrganizationMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <params>
		/// <param name="idValue" type="System.Int">The integer ID of the record</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection">See Refs.</param>
		/// </params>
		///<returns> boolean value if entry (idValue) exists</returns>
		///<References>
		///<seealso cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</References>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, AffiliatedOrganizationMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
