﻿
/*

			Class:              CombinationAssignmentMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerCombinationAssignments
	/// </summary>
	public class CombinationAssignmentMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private CombinationAssignmentBase caObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerCombinationAssignments)
		/// </summary>
		public static string tableName = "VtkVolunteerCombinationAssignments";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.VolunteerStationProfilesFK database field
		/// </summary>
		public const string stationProfileIdField = "VolunteerStationProfilesFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.OrganizationFK database field
		/// </summary>
		public const string organizationIdField = "OrganizationFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.WorkdayScheduleFK database field
		/// </summary>
		public const string workdayScheduleIdField = "WorkdayScheduleFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.BenefitingServiceFK database field
		/// </summary>
		public const string benefitingServiceIdField = "BenefitingServiceFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.CombinationCode database field
		/// </summary>
		public const string combinationCodeField = "CombinationCode";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.IsInactive database field
		/// </summary>
		public const string isInactiveField = "IsInactive";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerCombinationAssignments.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "caObj"></param>
		public CombinationAssignmentMsSqlSrv(CombinationAssignmentBase caObj)
		{
			Initialize(caObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "caObj"></param>
		private void Initialize(CombinationAssignmentBase caObj)
		{
			this.caObj = caObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = caObj.AppCon;
			this.databaseTableName = CombinationAssignmentMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = CombinationAssignmentMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(caObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create CombinationAssignment instance. Invalid ID: " + caObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				caObj.id = (Int32)dr[idField];
			}
			else
			{
				caObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationProfileIdField))
			{
				caObj.stationProfileId = (Int32)dr[stationProfileIdField];
			}
			else
			{
				caObj.stationProfileId = Int32.MinValue;
			}
		
			if (!dr.IsNull(organizationIdField))
			{
				caObj.organizationId = (Int32)dr[organizationIdField];
			}
			else
			{
				caObj.organizationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(workdayScheduleIdField))
			{
				caObj.workdayScheduleId = (Int32)dr[workdayScheduleIdField];
			}
			else
			{
				caObj.workdayScheduleId = Int32.MinValue;
			}
		
			if (!dr.IsNull(benefitingServiceIdField))
			{
				caObj.benefitingServiceId = (Int32)dr[benefitingServiceIdField];
			}
			else
			{
				caObj.benefitingServiceId = Int32.MinValue;
			}
		
			if (!dr.IsNull(combinationCodeField))
			{
				caObj.combinationCode = (string)dr[combinationCodeField];
			}
			else
			{
				caObj.combinationCode = string.Empty;
			}
		
			if (!dr.IsNull(isInactiveField))
			{
				caObj.isInactive = (bool)dr[isInactiveField];
			}
			else
			{
				caObj.isInactive = false;
			}
		
			if (!dr.IsNull(versionField))
			{
				caObj.version = (Int32)dr[versionField];
			}
			else
			{
				caObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerCombinationAssignments spParam = new spParams.spI_VtkVolunteerCombinationAssignments ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._VolunteerStationProfilesFK = caObj.stationProfileId;
			spParam._OrganizationFK = caObj.organizationId;
			spParam._WorkdayScheduleFK = caObj.workdayScheduleId;
			spParam._BenefitingServiceFK = caObj.benefitingServiceId;
			spParam._CombinationCode = caObj.combinationCode;
			spParam._IsInactive = caObj.isInactive;
			spParam._Ver = caObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkVolunteerCombinationAssignments spSProc = new spSProcs.spI_VtkVolunteerCombinationAssignments();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {caObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("CombinationAssignment", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return caObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[CombinationAssignmentMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerCombinationAssignments spParam = new spParams.spU_VtkVolunteerCombinationAssignments();
 
			if (caObj.IsChanged && (!caObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerCombinationAssignments spSProc = new spSProcs.spU_VtkVolunteerCombinationAssignments(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("CombinationAssignment", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (caObj.stationProfileId == Int32.MinValue && !dr.IsNull(stationProfileIdField))  {return true;} 
			else
			if (caObj.organizationId == Int32.MinValue && !dr.IsNull(organizationIdField))  {return true;} 
			else
			if (caObj.workdayScheduleId == Int32.MinValue && !dr.IsNull(workdayScheduleIdField))  {return true;} 
			else
			if (caObj.benefitingServiceId == Int32.MinValue && !dr.IsNull(benefitingServiceIdField))  {return true;} 
			else
			if (caObj.combinationCode == string.Empty && !dr.IsNull(combinationCodeField))  {return true;} 
			else
			if (caObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerCombinationAssignments spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  caObj.id; 
			spParam._VolunteerStationProfilesFK =  caObj.stationProfileId; 
			spParam._OrganizationFK =  caObj.organizationId; 
			spParam._WorkdayScheduleFK =  caObj.workdayScheduleId; 
			spParam._BenefitingServiceFK =  caObj.benefitingServiceId; 
			spParam._CombinationCode =  caObj.combinationCode; 
			spParam._IsInactive =  caObj.isInactive; 
			spParam._Ver =  caObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerCombinationAssignments spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = caObj.id; 
			spParam._VolunteerStationProfilesFK = caObj.stationProfileId; 
			spParam._OrganizationFK = caObj.organizationId; 
			spParam._WorkdayScheduleFK = caObj.workdayScheduleId; 
			spParam._BenefitingServiceFK = caObj.benefitingServiceId; 
			spParam._CombinationCode = caObj.combinationCode; 
			spParam._IsInactive = caObj.isInactive; 
			spParam._Ver =  caObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (caObj.id > 0)
			{
				spParams.spD_VtkVolunteerCombinationAssignments spParam = new spParams.spD_VtkVolunteerCombinationAssignments ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = caObj.id;
				spParam._Ver = caObj.version; 
				spSProcs.spD_VtkVolunteerCombinationAssignments spSProc = new spSProcs.spD_VtkVolunteerCombinationAssignments();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("CombinationAssignment", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + CombinationAssignmentMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, CombinationAssignmentMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
