﻿
/*

			Class:              ContactInformationMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerContactInformation
	/// </summary>
	public class ContactInformationMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ContactInformationBase ciObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerContactInformation)
		/// </summary>
		public static string tableName = "VtkVolunteerContactInformation";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.VolunteerFK database field
		/// </summary>
		public const string volunteerIdField = "VolunteerFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.StreetAddress1 database field
		/// </summary>
		public const string streetAddress1Field = "StreetAddress1";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.StreetAddress2 database field
		/// </summary>
		public const string streetAddress2Field = "StreetAddress2";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.City database field
		/// </summary>
		public const string cityField = "City";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.StateFK database field
		/// </summary>
		public const string stateIdField = "StateFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.ZipCode database field
		/// </summary>
		public const string zipCodeField = "ZipCode";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.Telephone database field
		/// </summary>
		public const string telephoneField = "Telephone";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.AlternateTelephone database field
		/// </summary>
		public const string alternateTelephoneField = "AlternateTelephone";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.AlternateTelephone2 database field
		/// </summary>
		public const string alternateTelephone2Field = "AlternateTelephone2";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.EMailAddress database field
		/// </summary>
		public const string eMailAddressField = "EMailAddress";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerContactInformation.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "ciObj"></param>
		public ContactInformationMsSqlSrv(ContactInformationBase ciObj)
		{
			Initialize(ciObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "ciObj"></param>
		private void Initialize(ContactInformationBase ciObj)
		{
			this.ciObj = ciObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = ciObj.AppCon;
			this.databaseTableName = ContactInformationMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ContactInformationMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(ciObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create ContactInformation instance. Invalid ID: " + ciObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				ciObj.id = (Int32)dr[idField];
			}
			else
			{
				ciObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(volunteerIdField))
			{
				ciObj.volunteerId = (Int32)dr[volunteerIdField];
			}
			else
			{
				ciObj.volunteerId = Int32.MinValue;
			}
		
			if (!dr.IsNull(streetAddress1Field))
			{
				ciObj.streetAddress1 = (string)dr[streetAddress1Field];
			}
			else
			{
				ciObj.streetAddress1 = string.Empty;
			}
		
			if (!dr.IsNull(streetAddress2Field))
			{
				ciObj.streetAddress2 = (string)dr[streetAddress2Field];
			}
			else
			{
				ciObj.streetAddress2 = string.Empty;
			}
		
			if (!dr.IsNull(cityField))
			{
				ciObj.city = (string)dr[cityField];
			}
			else
			{
				ciObj.city = string.Empty;
			}
		
			if (!dr.IsNull(stateIdField))
			{
				ciObj.stateId = (Int32)dr[stateIdField];
			}
			else
			{
				ciObj.stateId = Int32.MinValue;
			}
		
			if (!dr.IsNull(zipCodeField))
			{
				ciObj.zipCode = (string)dr[zipCodeField];
			}
			else
			{
				ciObj.zipCode = string.Empty;
			}
		
			if (!dr.IsNull(telephoneField))
			{
				ciObj.telephone = (string)dr[telephoneField];
			}
			else
			{
				ciObj.telephone = string.Empty;
			}
		
			if (!dr.IsNull(alternateTelephoneField))
			{
				ciObj.alternateTelephone = (string)dr[alternateTelephoneField];
			}
			else
			{
				ciObj.alternateTelephone = string.Empty;
			}
		
			if (!dr.IsNull(alternateTelephone2Field))
			{
				ciObj.alternateTelephone2 = (string)dr[alternateTelephone2Field];
			}
			else
			{
				ciObj.alternateTelephone2 = string.Empty;
			}
		
			if (!dr.IsNull(eMailAddressField))
			{
				ciObj.eMailAddress = (string)dr[eMailAddressField];
			}
			else
			{
				ciObj.eMailAddress = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				ciObj.version = (Int32)dr[versionField];
			}
			else
			{
				ciObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteerContactInformation spParam = new spParams.spI_VtkVolunteerContactInformation ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._VolunteerFK = ciObj.volunteerId;
			spParam._StreetAddress1 = ciObj.streetAddress1;
			spParam._City = ciObj.city;
			spParam._StateFK = ciObj.stateId;
			spParam._ZipCode = ciObj.zipCode;
			spParam._Ver = ciObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (ciObj.streetAddress2 != string.Empty) {spParam._StreetAddress2 = ciObj.streetAddress2;}
			if (ciObj.telephone != string.Empty) {spParam._Telephone = ciObj.telephone;}
			if (ciObj.alternateTelephone != string.Empty) {spParam._AlternateTelephone = ciObj.alternateTelephone;}
			if (ciObj.alternateTelephone2 != string.Empty) {spParam._AlternateTelephone2 = ciObj.alternateTelephone2;}
			if (ciObj.eMailAddress != string.Empty) {spParam._EMailAddress = ciObj.eMailAddress;}
	
			spSProcs.spI_VtkVolunteerContactInformation spSProc = new spSProcs.spI_VtkVolunteerContactInformation();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {ciObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("ContactInformation", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return ciObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ContactInformationMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerContactInformation spParam = new spParams.spU_VtkVolunteerContactInformation();
 
			if (ciObj.IsChanged && (!ciObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerContactInformation spSProc = new spSProcs.spU_VtkVolunteerContactInformation(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("ContactInformation", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (ciObj.volunteerId == Int32.MinValue && !dr.IsNull(volunteerIdField))  {return true;} 
			else
			if (ciObj.streetAddress1 == string.Empty && !dr.IsNull(streetAddress1Field))  {return true;} 
			else
			if (ciObj.streetAddress2 == string.Empty && !dr.IsNull(streetAddress2Field))  {return true;} 
			else
			if (ciObj.city == string.Empty && !dr.IsNull(cityField))  {return true;} 
			else
			if (ciObj.stateId == Int32.MinValue && !dr.IsNull(stateIdField))  {return true;} 
			else
			if (ciObj.zipCode == string.Empty && !dr.IsNull(zipCodeField))  {return true;} 
			else
			if (ciObj.telephone == string.Empty && !dr.IsNull(telephoneField))  {return true;} 
			else
			if (ciObj.alternateTelephone == string.Empty && !dr.IsNull(alternateTelephoneField))  {return true;} 
			else
			if (ciObj.alternateTelephone2 == string.Empty && !dr.IsNull(alternateTelephone2Field))  {return true;} 
			else
			if (ciObj.eMailAddress == string.Empty && !dr.IsNull(eMailAddressField))  {return true;} 
			else
			if (ciObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerContactInformation spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  ciObj.id; 
			spParam._VolunteerFK =  ciObj.volunteerId; 
			spParam._StreetAddress1 =  ciObj.streetAddress1; 
			spParam._City =  ciObj.city; 
			spParam._StateFK =  ciObj.stateId; 
			spParam._ZipCode =  ciObj.zipCode; 
			spParam._Ver =  ciObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (ciObj.streetAddress2 != string.Empty)  {spParam._StreetAddress2 = ciObj.streetAddress2;}
			if (ciObj.telephone != string.Empty)  {spParam._Telephone = ciObj.telephone;}
			if (ciObj.alternateTelephone != string.Empty)  {spParam._AlternateTelephone = ciObj.alternateTelephone;}
			if (ciObj.alternateTelephone2 != string.Empty)  {spParam._AlternateTelephone2 = ciObj.alternateTelephone2;}
			if (ciObj.eMailAddress != string.Empty)  {spParam._EMailAddress = ciObj.eMailAddress;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerContactInformation spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = ciObj.id; 
			spParam._VolunteerFK = ciObj.volunteerId; 
			spParam._StreetAddress1 = ciObj.streetAddress1; 
			spParam._City = ciObj.city; 
			spParam._StateFK = ciObj.stateId; 
			spParam._ZipCode = ciObj.zipCode; 
			spParam._Ver =  ciObj.version; 
	
			//streetAddress2 property
			if (!dr.IsNull(streetAddress2Field))
			{ 
				if (ciObj.streetAddress2 != (string)dr[streetAddress2Field]) 
				{ 
					spParam._StreetAddress2 = ciObj.streetAddress2; 
				} 
			} 
			else if (ciObj.streetAddress2 != string.Empty)
			{ 
				spParam._StreetAddress2 = ciObj.streetAddress2; 
			} 
	
			//telephone property
			if (!dr.IsNull(telephoneField))
			{ 
				if (ciObj.telephone != (string)dr[telephoneField]) 
				{ 
					spParam._Telephone = ciObj.telephone; 
				} 
			} 
			else if (ciObj.telephone != string.Empty)
			{ 
				spParam._Telephone = ciObj.telephone; 
			} 
	
			//alternateTelephone property
			if (!dr.IsNull(alternateTelephoneField))
			{ 
				if (ciObj.alternateTelephone != (string)dr[alternateTelephoneField]) 
				{ 
					spParam._AlternateTelephone = ciObj.alternateTelephone; 
				} 
			} 
			else if (ciObj.alternateTelephone != string.Empty)
			{ 
				spParam._AlternateTelephone = ciObj.alternateTelephone; 
			} 
	
			//alternateTelephone2 property
			if (!dr.IsNull(alternateTelephone2Field))
			{ 
				if (ciObj.alternateTelephone2 != (string)dr[alternateTelephone2Field]) 
				{ 
					spParam._AlternateTelephone2 = ciObj.alternateTelephone2; 
				} 
			} 
			else if (ciObj.alternateTelephone2 != string.Empty)
			{ 
				spParam._AlternateTelephone2 = ciObj.alternateTelephone2; 
			} 
	
			//eMailAddress property
			if (!dr.IsNull(eMailAddressField))
			{ 
				if (ciObj.eMailAddress != (string)dr[eMailAddressField]) 
				{ 
					spParam._EMailAddress = ciObj.eMailAddress; 
				} 
			} 
			else if (ciObj.eMailAddress != string.Empty)
			{ 
				spParam._EMailAddress = ciObj.eMailAddress; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (ciObj.id > 0)
			{
				spParams.spD_VtkVolunteerContactInformation spParam = new spParams.spD_VtkVolunteerContactInformation ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = ciObj.id;
				spParam._Ver = ciObj.version; 
				spSProcs.spD_VtkVolunteerContactInformation spSProc = new spSProcs.spD_VtkVolunteerContactInformation();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("ContactInformation", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ContactInformationMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ContactInformationMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
