﻿
/*

			Class:              DonorMsSqlSrv

			Date Produced:      11/15/2002 8:37:24 AM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkDonor
	/// </summary>
	public class DonorMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private DonorBase donorObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkDonor)
		/// </summary>
		public static string tableName = "VtkDonor";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkDonor.ID database field
		/// </summary>
		public const string idField = "ID";
		
		/// <summary>
		/// Class field that maps to VtkDonor.DonorTypeFK database field
		/// </summary>
		public const string donorTypeIdField = "DonorTypeFK";
		
		/// <summary>
		/// Class field that maps to VtkDonor.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkDonor.OrganizationFK database field
		/// </summary>
		public const string organizationIdField = "OrganizationFK";
		
		/// <summary>
		/// Class field that maps to VtkDonor.NamePrefix database field
		/// </summary>
		public const string namePrefixField = "NamePrefix";
		
		/// <summary>
		/// Class field that maps to VtkDonor.FirstName database field
		/// </summary>
		public const string firstNameField = "FirstName";
		
		/// <summary>
		/// Class field that maps to VtkDonor.MiddleName database field
		/// </summary>
		public const string middleNameField = "MiddleName";
		
		/// <summary>
		/// Class field that maps to VtkDonor.LastName database field
		/// </summary>
		public const string lastNameField = "LastName";
		
		/// <summary>
		/// Class field that maps to VtkDonor.NameSuffix database field
		/// </summary>
		public const string nameSuffixField = "NameSuffix";
		
		/// <summary>
		/// Class field that maps to VtkDonor.DonorAffiliation database field
		/// </summary>
		public const string donorAffiliationField = "DonorAffiliation";
		
		/// <summary>
		/// Class field that maps to VtkDonor.Address1 database field
		/// </summary>
		public const string address1Field = "Address1";
		
		/// <summary>
		/// Class field that maps to VtkDonor.Address2 database field
		/// </summary>
		public const string address2Field = "Address2";
		
		/// <summary>
		/// Class field that maps to VtkDonor.City database field
		/// </summary>
		public const string cityField = "City";
		
		/// <summary>
		/// Class field that maps to VtkDonor.StateFK database field
		/// </summary>
		public const string stateIdField = "StateFK";
		
		/// <summary>
		/// Class field that maps to VtkDonor.Zip database field
		/// </summary>
		public const string zipField = "Zip";
		
		/// <summary>
		/// Class field that maps to VtkDonor.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "donorObj"></param>
		public DonorMsSqlSrv(DonorBase donorObj)
		{
			Initialize(donorObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "donorObj"></param>
		private void Initialize(DonorBase donorObj)
		{
			this.donorObj = donorObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = donorObj.AppCon;
			this.databaseTableName = DonorMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = DonorMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(donorObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Donor instance. Invalid ID: " + donorObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				donorObj.id = (Int32)dr[idField];
			}
			else
			{
				donorObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(donorTypeIdField))
			{
				donorObj.donorTypeId = (Int32)dr[donorTypeIdField];
			}
			else
			{
				donorObj.donorTypeId = Int32.MinValue;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				donorObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				donorObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(organizationIdField))
			{
				donorObj.organizationId = (Int32)dr[organizationIdField];
			}
			else
			{
				donorObj.organizationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(namePrefixField))
			{
				donorObj.namePrefix = (string)dr[namePrefixField];
			}
			else
			{
				donorObj.namePrefix = string.Empty;
			}
		
			if (!dr.IsNull(firstNameField))
			{
				donorObj.firstName = (string)dr[firstNameField];
			}
			else
			{
				donorObj.firstName = string.Empty;
			}
		
			if (!dr.IsNull(middleNameField))
			{
				donorObj.middleName = (string)dr[middleNameField];
			}
			else
			{
				donorObj.middleName = string.Empty;
			}
		
			if (!dr.IsNull(lastNameField))
			{
				donorObj.lastName = (string)dr[lastNameField];
			}
			else
			{
				donorObj.lastName = string.Empty;
			}
		
			if (!dr.IsNull(nameSuffixField))
			{
				donorObj.nameSuffix = (string)dr[nameSuffixField];
			}
			else
			{
				donorObj.nameSuffix = string.Empty;
			}
		
			if (!dr.IsNull(donorAffiliationField))
			{
				donorObj.donorAffiliation = (string)dr[donorAffiliationField];
			}
			else
			{
				donorObj.donorAffiliation = string.Empty;
			}
		
			if (!dr.IsNull(address1Field))
			{
				donorObj.address1 = (string)dr[address1Field];
			}
			else
			{
				donorObj.address1 = string.Empty;
			}
		
			if (!dr.IsNull(address2Field))
			{
				donorObj.address2 = (string)dr[address2Field];
			}
			else
			{
				donorObj.address2 = string.Empty;
			}
		
			if (!dr.IsNull(cityField))
			{
				donorObj.city = (string)dr[cityField];
			}
			else
			{
				donorObj.city = string.Empty;
			}
		
			if (!dr.IsNull(stateIdField))
			{
				donorObj.stateId = (Int32)dr[stateIdField];
			}
			else
			{
				donorObj.stateId = Int32.MinValue;
			}
		
			if (!dr.IsNull(zipField))
			{
				donorObj.zip = (string)dr[zipField];
			}
			else
			{
				donorObj.zip = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				donorObj.version = (Int32)dr[versionField];
			}
			else
			{
				donorObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkDonor spParam = new spParams.spI_VtkDonor ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._DonorTypeFK = donorObj.donorTypeId;
			spParam._Ver = donorObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (donorObj.institutionId != Int32.MinValue) {spParam._InstitutionFK = donorObj.institutionId;}
			if (donorObj.organizationId != Int32.MinValue) {spParam._OrganizationFK = donorObj.organizationId;}
			if (donorObj.namePrefix != string.Empty) {spParam._NamePrefix = donorObj.namePrefix;}
			if (donorObj.firstName != string.Empty) {spParam._FirstName = donorObj.firstName;}
			if (donorObj.middleName != string.Empty) {spParam._MiddleName = donorObj.middleName;}
			if (donorObj.lastName != string.Empty) {spParam._LastName = donorObj.lastName;}
			if (donorObj.nameSuffix != string.Empty) {spParam._NameSuffix = donorObj.nameSuffix;}
			if (donorObj.donorAffiliation != string.Empty) {spParam._DonorAffiliation = donorObj.donorAffiliation;}
			if (donorObj.address1 != string.Empty) {spParam._Address1 = donorObj.address1;}
			if (donorObj.address2 != string.Empty) {spParam._Address2 = donorObj.address2;}
			if (donorObj.city != string.Empty) {spParam._City = donorObj.city;}
			if (donorObj.stateId != Int32.MinValue) {spParam._StateFK = donorObj.stateId;}
			if (donorObj.zip != string.Empty) {spParam._Zip = donorObj.zip;}
	
			spSProcs.spI_VtkDonor spSProc = new spSProcs.spI_VtkDonor();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._ID != null) {donorObj.id = (Int32)spParam._ID;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Donor", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return donorObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[DonorMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkDonor spParam = new spParams.spU_VtkDonor();
 
			if (donorObj.IsChanged && (!donorObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkDonor spSProc = new spSProcs.spU_VtkDonor(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Donor", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (donorObj.donorTypeId == Int32.MinValue && !dr.IsNull(donorTypeIdField))  {return true;} 
			else
			if (donorObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (donorObj.organizationId == Int32.MinValue && !dr.IsNull(organizationIdField))  {return true;} 
			else
			if (donorObj.namePrefix == string.Empty && !dr.IsNull(namePrefixField))  {return true;} 
			else
			if (donorObj.firstName == string.Empty && !dr.IsNull(firstNameField))  {return true;} 
			else
			if (donorObj.middleName == string.Empty && !dr.IsNull(middleNameField))  {return true;} 
			else
			if (donorObj.lastName == string.Empty && !dr.IsNull(lastNameField))  {return true;} 
			else
			if (donorObj.nameSuffix == string.Empty && !dr.IsNull(nameSuffixField))  {return true;} 
			else
			if (donorObj.donorAffiliation == string.Empty && !dr.IsNull(donorAffiliationField))  {return true;} 
			else
			if (donorObj.address1 == string.Empty && !dr.IsNull(address1Field))  {return true;} 
			else
			if (donorObj.address2 == string.Empty && !dr.IsNull(address2Field))  {return true;} 
			else
			if (donorObj.city == string.Empty && !dr.IsNull(cityField))  {return true;} 
			else
			if (donorObj.stateId == Int32.MinValue && !dr.IsNull(stateIdField))  {return true;} 
			else
			if (donorObj.zip == string.Empty && !dr.IsNull(zipField))  {return true;} 
			else
			if (donorObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkDonor spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._ID =  donorObj.id; 
			spParam._DonorTypeFK =  donorObj.donorTypeId; 
			spParam._Ver =  donorObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (donorObj.institutionId != Int32.MinValue)  {spParam._InstitutionFK = donorObj.institutionId;}
			if (donorObj.organizationId != Int32.MinValue)  {spParam._OrganizationFK = donorObj.organizationId;}
			if (donorObj.namePrefix != string.Empty)  {spParam._NamePrefix = donorObj.namePrefix;}
			if (donorObj.firstName != string.Empty)  {spParam._FirstName = donorObj.firstName;}
			if (donorObj.middleName != string.Empty)  {spParam._MiddleName = donorObj.middleName;}
			if (donorObj.lastName != string.Empty)  {spParam._LastName = donorObj.lastName;}
			if (donorObj.nameSuffix != string.Empty)  {spParam._NameSuffix = donorObj.nameSuffix;}
			if (donorObj.donorAffiliation != string.Empty)  {spParam._DonorAffiliation = donorObj.donorAffiliation;}
			if (donorObj.address1 != string.Empty)  {spParam._Address1 = donorObj.address1;}
			if (donorObj.address2 != string.Empty)  {spParam._Address2 = donorObj.address2;}
			if (donorObj.city != string.Empty)  {spParam._City = donorObj.city;}
			if (donorObj.stateId != Int32.MinValue)  {spParam._StateFK = donorObj.stateId;}
			if (donorObj.zip != string.Empty)  {spParam._Zip = donorObj.zip;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkDonor spParam, DataRow dr)
		{
			//required or bool properties
			spParam._ID = donorObj.id; 
			spParam._DonorTypeFK = donorObj.donorTypeId; 
			spParam._Ver =  donorObj.version; 
	
			//institutionId property
			if (!dr.IsNull(institutionIdField))
			{ 
				if (donorObj.institutionId != (Int32)dr[institutionIdField]) 
				{ 
					spParam._InstitutionFK = donorObj.institutionId; 
				} 
			} 
			else if (donorObj.institutionId != Int32.MinValue)
			{ 
				spParam._InstitutionFK = donorObj.institutionId; 
			} 
	
			//organizationId property
			if (!dr.IsNull(organizationIdField))
			{ 
				if (donorObj.organizationId != (Int32)dr[organizationIdField]) 
				{ 
					spParam._OrganizationFK = donorObj.organizationId; 
				} 
			} 
			else if (donorObj.organizationId != Int32.MinValue)
			{ 
				spParam._OrganizationFK = donorObj.organizationId; 
			} 
	
			//namePrefix property
			if (!dr.IsNull(namePrefixField))
			{ 
				if (donorObj.namePrefix != (string)dr[namePrefixField]) 
				{ 
					spParam._NamePrefix = donorObj.namePrefix; 
				} 
			} 
			else if (donorObj.namePrefix != string.Empty)
			{ 
				spParam._NamePrefix = donorObj.namePrefix; 
			} 
	
			//firstName property
			if (!dr.IsNull(firstNameField))
			{ 
				if (donorObj.firstName != (string)dr[firstNameField]) 
				{ 
					spParam._FirstName = donorObj.firstName; 
				} 
			} 
			else if (donorObj.firstName != string.Empty)
			{ 
				spParam._FirstName = donorObj.firstName; 
			} 
	
			//middleName property
			if (!dr.IsNull(middleNameField))
			{ 
				if (donorObj.middleName != (string)dr[middleNameField]) 
				{ 
					spParam._MiddleName = donorObj.middleName; 
				} 
			} 
			else if (donorObj.middleName != string.Empty)
			{ 
				spParam._MiddleName = donorObj.middleName; 
			} 
	
			//lastName property
			if (!dr.IsNull(lastNameField))
			{ 
				if (donorObj.lastName != (string)dr[lastNameField]) 
				{ 
					spParam._LastName = donorObj.lastName; 
				} 
			} 
			else if (donorObj.lastName != string.Empty)
			{ 
				spParam._LastName = donorObj.lastName; 
			} 
	
			//nameSuffix property
			if (!dr.IsNull(nameSuffixField))
			{ 
				if (donorObj.nameSuffix != (string)dr[nameSuffixField]) 
				{ 
					spParam._NameSuffix = donorObj.nameSuffix; 
				} 
			} 
			else if (donorObj.nameSuffix != string.Empty)
			{ 
				spParam._NameSuffix = donorObj.nameSuffix; 
			} 
	
			//donorAffiliation property
			if (!dr.IsNull(donorAffiliationField))
			{ 
				if (donorObj.donorAffiliation != (string)dr[donorAffiliationField]) 
				{ 
					spParam._DonorAffiliation = donorObj.donorAffiliation; 
				} 
			} 
			else if (donorObj.donorAffiliation != string.Empty)
			{ 
				spParam._DonorAffiliation = donorObj.donorAffiliation; 
			} 
	
			//address1 property
			if (!dr.IsNull(address1Field))
			{ 
				if (donorObj.address1 != (string)dr[address1Field]) 
				{ 
					spParam._Address1 = donorObj.address1; 
				} 
			} 
			else if (donorObj.address1 != string.Empty)
			{ 
				spParam._Address1 = donorObj.address1; 
			} 
	
			//address2 property
			if (!dr.IsNull(address2Field))
			{ 
				if (donorObj.address2 != (string)dr[address2Field]) 
				{ 
					spParam._Address2 = donorObj.address2; 
				} 
			} 
			else if (donorObj.address2 != string.Empty)
			{ 
				spParam._Address2 = donorObj.address2; 
			} 
	
			//city property
			if (!dr.IsNull(cityField))
			{ 
				if (donorObj.city != (string)dr[cityField]) 
				{ 
					spParam._City = donorObj.city; 
				} 
			} 
			else if (donorObj.city != string.Empty)
			{ 
				spParam._City = donorObj.city; 
			} 
	
			//stateId property
			if (!dr.IsNull(stateIdField))
			{ 
				if (donorObj.stateId != (Int32)dr[stateIdField]) 
				{ 
					spParam._StateFK = donorObj.stateId; 
				} 
			} 
			else if (donorObj.stateId != Int32.MinValue)
			{ 
				spParam._StateFK = donorObj.stateId; 
			} 
	
			//zip property
			if (!dr.IsNull(zipField))
			{ 
				if (donorObj.zip != (string)dr[zipField]) 
				{ 
					spParam._Zip = donorObj.zip; 
				} 
			} 
			else if (donorObj.zip != string.Empty)
			{ 
				spParam._Zip = donorObj.zip; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (donorObj.id > 0)
			{
				spParams.spD_VtkDonor spParam = new spParams.spD_VtkDonor ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._ID  = donorObj.id;
				spParam._Ver = donorObj.version; 
				spSProcs.spD_VtkDonor spSProc = new spSProcs.spD_VtkDonor();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Donor", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + DonorMsSqlSrv.tableName + " WHERE ID = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, DonorMsSqlSrv.tableName, "ID");
		}
		
		#endregion
		
	}
}
