﻿
/*

			Class:              GamesScheduleBase

			Date Produced:      11/21/2002 12:13:25 PM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkGamesSchedule
	/// </summary>
	public abstract class GamesScheduleBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.HostStationFk database field
		/// </summary>
		protected internal Int32  hostStationFk;
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.GameTypeFk database field
		/// </summary>
		protected internal Int32  gameTypeFk;
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.StartDate database field
		/// </summary>
		protected internal DateTime  startDate;
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.EndDate database field
		/// </summary>
		protected internal DateTime  endDate;
		
		/// <summary>
		/// Class field that maps to VtkGamesSchedule.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to hostStationFk class field
		/// </summary>
		public Int32  HostStationFk
		{
			get { return hostStationFk;}    set {isChanged = true; hostStationFk = value;}
		}
		
		/// <summary>
		/// Property that maps to gameTypeFk class field
		/// </summary>
		public Int32  GameTypeFk
		{
			get { return gameTypeFk;}    set {isChanged = true; gameTypeFk = value;}
		}
		
		/// <summary>
		/// Property that maps to startDate class field
		/// </summary>
		public DateTime  StartDate
		{
			get { return startDate;}    set {isChanged = true; startDate = value;}
		}
		
		/// <summary>
		/// Property that maps to endDate class field
		/// </summary>
		public DateTime  EndDate
		{
			get { return endDate;}    set {isChanged = true; endDate = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		/// <summary>
		/// Main constructor.
		/// </summary>
		protected GamesScheduleBase() : base(){}

		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGamesSchedule entry</param>
		protected GamesScheduleBase(int id) : base ()
		{
			FillData(id);
		}
		/// <summary>
		/// Basic constructor used by <see cref="Vha.Vtk.Games.GamesSchedule.AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected GamesScheduleBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGamesSchedule entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected GamesScheduleBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkGamesSchedule</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkGamesSchedule definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected GamesScheduleBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[GamesScheduleMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			hostStationFk = Int32.MinValue;
			gameTypeFk = Int32.MinValue;
			startDate = DateTime.MinValue;
			endDate = DateTime.MinValue;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new GamesScheduleMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of GamesSchedule.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for HostStationFk property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of HostStationFk</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateHostStationFk(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "GamesSchedule";
			ret.PropertyName = "HostStationFk";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'HostStationFk' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!InstitutionBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Error: 'HostStationFk' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for GameTypeFk property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of GameTypeFk</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateGameTypeFk(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "GamesSchedule";
			ret.PropertyName = "GameTypeFk";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'GameTypeFk' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!GameTypeBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "Error: 'GameTypeFk' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for StartDate property values
		/// </summary>
		///<Params>
		/// <param name="value" type="DateTime">Current instance value of StartDate</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateStartDate(DateTime value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "GamesSchedule";
			ret.PropertyName = "StartDate";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == DateTime.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'StartDate' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for EndDate property values
		/// </summary>
		///<Params>
		/// <param name="value" type="DateTime">Current instance value of EndDate</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateEndDate(DateTime value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "GamesSchedule";
			ret.PropertyName = "EndDate";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == DateTime.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'EndDate' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkGamesSchedule.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkGamesSchedule table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkGamesSchedule entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return GamesScheduleMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "HostStationFk")  {return hostStationFk.ToString();}
			if (prop == "GameTypeFk")  {return gameTypeFk.ToString();}
			if (prop == "StartDate")  {return startDate.ToString();}
			if (prop == "EndDate")  {return endDate.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
