﻿
/*

			Class:              MealsProvidedMsSqlSrv

			Date Produced:      6/17/2002 12:46:57 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        5/28/2002 11:22:47 AM
			Revision:           645

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkMealsProvided
	/// </summary>
	public class MealsProvidedMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private MealsProvidedBase mtObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkMealsProvided)
		/// </summary>
		public static string tableName = "VtkMealsProvided";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.DateOfMeal database field
		/// </summary>
		public const string dateOfMealField = "DateOfMeal";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.VolunteerFK database field
		/// </summary>
		public const string volunteerIdField = "VolunteerFK";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.NumberOfMeals database field
		/// </summary>
		public const string numberOfMealsField = "NumberOfMeals";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.IsUnscheduled database field
		/// </summary>
		public const string isUnscheduledField = "IsUnscheduled";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.NameOfUnscheduled database field
		/// </summary>
		public const string nameOfUnscheduledField = "NameOfUnscheduled";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.HowAdded database field
		/// </summary>
		public const string howAddedField = "HowAdded";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.IsReprinted database field
		/// </summary>
		public const string isReprintedField = "IsReprinted";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.TimeLastPrinted database field
		/// </summary>
		public const string timeLastPrintedField = "TimeLastPrinted";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.IsRemovedFromList database field
		/// </summary>
		public const string isRemovedFromListField = "IsRemovedFromList";
		
		/// <summary>
		/// Class field that maps to VtkMealsProvided.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "mtObj"></param>
		public MealsProvidedMsSqlSrv(MealsProvidedBase mtObj)
		{
			Initialize(mtObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "mtObj"></param>
		private void Initialize(MealsProvidedBase mtObj)
		{
			this.mtObj = mtObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = mtObj.AppCon;
			this.databaseTableName = MealsProvidedMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = MealsProvidedMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(mtObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create MealsProvided instance. Invalid ID: " + mtObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				mtObj.id = (Int32)dr[idField];
			}
			else
			{
				mtObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(dateOfMealField))
			{
				mtObj.dateOfMeal = (DateTime)dr[dateOfMealField];
			}
			else
			{
				mtObj.dateOfMeal = DateTime.MinValue;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				mtObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				mtObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(volunteerIdField))
			{
				mtObj.volunteerId = (Int32)dr[volunteerIdField];
			}
			else
			{
				mtObj.volunteerId = Int32.MinValue;
			}
		
			if (!dr.IsNull(numberOfMealsField))
			{
				mtObj.numberOfMeals = (Int32)dr[numberOfMealsField];
			}
			else
			{
				mtObj.numberOfMeals = Int32.MinValue;
			}
		
			if (!dr.IsNull(isUnscheduledField))
			{
				mtObj.isUnscheduled = (bool)dr[isUnscheduledField];
			}
			else
			{
				mtObj.isUnscheduled = false;
			}
		
			if (!dr.IsNull(nameOfUnscheduledField))
			{
				mtObj.nameOfUnscheduled = (string)dr[nameOfUnscheduledField];
			}
			else
			{
				mtObj.nameOfUnscheduled = string.Empty;
			}
		
			if (!dr.IsNull(howAddedField))
			{
				mtObj.howAdded = (string)dr[howAddedField];
			}
			else
			{
				mtObj.howAdded = string.Empty;
			}
		
			if (!dr.IsNull(isReprintedField))
			{
				mtObj.isReprinted = (bool)dr[isReprintedField];
			}
			else
			{
				mtObj.isReprinted = false;
			}
		
			if (!dr.IsNull(timeLastPrintedField))
			{
				mtObj.timeLastPrinted = (DateTime)dr[timeLastPrintedField];
			}
			else
			{
				mtObj.timeLastPrinted = DateTime.MinValue;
			}
		
			if (!dr.IsNull(isRemovedFromListField))
			{
				mtObj.isRemovedFromList = (bool)dr[isRemovedFromListField];
			}
			else
			{
				mtObj.isRemovedFromList = false;
			}
		
			if (!dr.IsNull(versionField))
			{
				mtObj.version = (Int32)dr[versionField];
			}
			else
			{
				mtObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkMealsProvided spParam = new spParams.spI_VtkMealsProvided ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._DateOfMeal = mtObj.dateOfMeal;
			spParam._InstitutionFK = mtObj.institutionId;
			spParam._NumberOfMeals = mtObj.numberOfMeals;
			spParam._HowAdded = mtObj.howAdded;
			spParam._Ver = mtObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (mtObj.volunteerId != Int32.MinValue) {spParam._VolunteerFK = mtObj.volunteerId;}
			if (mtObj.isUnscheduled == false) {spParam._IsUnscheduled = (0);} // set to default Value 
			else {spParam._IsUnscheduled = mtObj.isUnscheduled;}
			if (mtObj.nameOfUnscheduled != string.Empty) {spParam._NameOfUnscheduled = mtObj.nameOfUnscheduled;}
			if (mtObj.isReprinted == false) {spParam._IsReprinted = (0);} // set to default Value 
			else {spParam._IsReprinted = mtObj.isReprinted;}
			if (mtObj.timeLastPrinted != DateTime.MinValue) {spParam._TimeLastPrinted = mtObj.timeLastPrinted;}
			if (mtObj.isRemovedFromList == false) {spParam._IsRemovedFromList = (0);} // set to default Value 
			else {spParam._IsRemovedFromList = mtObj.isRemovedFromList;}
	
			spSProcs.spI_VtkMealsProvided spSProc = new spSProcs.spI_VtkMealsProvided();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {mtObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("MealsProvided", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return mtObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[MealsProvidedMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkMealsProvided spParam = new spParams.spU_VtkMealsProvided();
 
			if (mtObj.IsChanged && (!mtObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkMealsProvided spSProc = new spSProcs.spU_VtkMealsProvided(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("MealsProvided", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (mtObj.dateOfMeal == DateTime.MinValue && !dr.IsNull(dateOfMealField))  {return true;} 
			else
			if (mtObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (mtObj.volunteerId == Int32.MinValue && !dr.IsNull(volunteerIdField))  {return true;} 
			else
			if (mtObj.numberOfMeals == Int32.MinValue && !dr.IsNull(numberOfMealsField))  {return true;} 
			else
			if (mtObj.isUnscheduled == false && !dr.IsNull(isUnscheduledField))  {return true;} 
			else
			if (mtObj.nameOfUnscheduled == string.Empty && !dr.IsNull(nameOfUnscheduledField))  {return true;} 
			else
			if (mtObj.howAdded == string.Empty && !dr.IsNull(howAddedField))  {return true;} 
			else
			if (mtObj.isReprinted == false && !dr.IsNull(isReprintedField))  {return true;} 
			else
			if (mtObj.timeLastPrinted == DateTime.MinValue && !dr.IsNull(timeLastPrintedField))  {return true;} 
			else
			if (mtObj.isRemovedFromList == false && !dr.IsNull(isRemovedFromListField))  {return true;} 
			else
			if (mtObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkMealsProvided spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  mtObj.id; 
			spParam._DateOfMeal =  mtObj.dateOfMeal; 
			spParam._InstitutionFK =  mtObj.institutionId; 
			spParam._NumberOfMeals =  mtObj.numberOfMeals; 
			spParam._HowAdded =  mtObj.howAdded; 
			spParam._Ver =  mtObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (mtObj.volunteerId != Int32.MinValue)  {spParam._VolunteerFK = mtObj.volunteerId;}
			if (mtObj.isUnscheduled != false)  {spParam._IsUnscheduled = mtObj.isUnscheduled;}
			if (mtObj.nameOfUnscheduled != string.Empty)  {spParam._NameOfUnscheduled = mtObj.nameOfUnscheduled;}
			if (mtObj.isReprinted != false)  {spParam._IsReprinted = mtObj.isReprinted;}
			if (mtObj.timeLastPrinted != DateTime.MinValue)  {spParam._TimeLastPrinted = mtObj.timeLastPrinted;}
			if (mtObj.isRemovedFromList != false)  {spParam._IsRemovedFromList = mtObj.isRemovedFromList;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkMealsProvided spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = mtObj.id; 
			spParam._DateOfMeal = mtObj.dateOfMeal; 
			spParam._InstitutionFK = mtObj.institutionId; 
			spParam._NumberOfMeals = mtObj.numberOfMeals; 
			spParam._HowAdded = mtObj.howAdded; 
			spParam._Ver =  mtObj.version; 
	
			//volunteerId property
			if (!dr.IsNull(volunteerIdField))
			{ 
				if (mtObj.volunteerId != (Int32)dr[volunteerIdField]) 
				{ 
					spParam._VolunteerFK = mtObj.volunteerId; 
				} 
			} 
			else if (mtObj.volunteerId != Int32.MinValue)
			{ 
				spParam._VolunteerFK = mtObj.volunteerId; 
			} 
	
			//isUnscheduled property
			if (!dr.IsNull(isUnscheduledField))
			{ 
				if (mtObj.isUnscheduled != (bool)dr[isUnscheduledField]) 
				{ 
					spParam._IsUnscheduled = mtObj.isUnscheduled; 
				} 
			} 
			else if (mtObj.isUnscheduled != false)
			{ 
				spParam._IsUnscheduled = mtObj.isUnscheduled; 
			} 
	
			//nameOfUnscheduled property
			if (!dr.IsNull(nameOfUnscheduledField))
			{ 
				if (mtObj.nameOfUnscheduled != (string)dr[nameOfUnscheduledField]) 
				{ 
					spParam._NameOfUnscheduled = mtObj.nameOfUnscheduled; 
				} 
			} 
			else if (mtObj.nameOfUnscheduled != string.Empty)
			{ 
				spParam._NameOfUnscheduled = mtObj.nameOfUnscheduled; 
			} 
	
			//isReprinted property
			if (!dr.IsNull(isReprintedField))
			{ 
				if (mtObj.isReprinted != (bool)dr[isReprintedField]) 
				{ 
					spParam._IsReprinted = mtObj.isReprinted; 
				} 
			} 
			else if (mtObj.isReprinted != false)
			{ 
				spParam._IsReprinted = mtObj.isReprinted; 
			} 
	
			//timeLastPrinted property
			if (!dr.IsNull(timeLastPrintedField))
			{ 
				if (mtObj.timeLastPrinted != (DateTime)dr[timeLastPrintedField]) 
				{ 
					spParam._TimeLastPrinted = mtObj.timeLastPrinted; 
				} 
			} 
			else if (mtObj.timeLastPrinted != DateTime.MinValue)
			{ 
				spParam._TimeLastPrinted = mtObj.timeLastPrinted; 
			} 
	
			//isRemovedFromList property
			if (!dr.IsNull(isRemovedFromListField))
			{ 
				if (mtObj.isRemovedFromList != (bool)dr[isRemovedFromListField]) 
				{ 
					spParam._IsRemovedFromList = mtObj.isRemovedFromList; 
				} 
			} 
			else if (mtObj.isRemovedFromList != false)
			{ 
				spParam._IsRemovedFromList = mtObj.isRemovedFromList; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (mtObj.id > 0)
			{
				spParams.spD_VtkMealsProvided spParam = new spParams.spD_VtkMealsProvided ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = mtObj.id;
				spParam._Ver = mtObj.version; 
				spSProcs.spD_VtkMealsProvided spSProc = new spSProcs.spD_VtkMealsProvided();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("MealsProvided", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + MealsProvidedMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, MealsProvidedMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
