﻿
/*

			Class:              NACStatusMsSqlSrv

			Date Produced:      3/13/2002 3:17:52 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/13/2002 3:14:43 PM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\VHA.VSS\BusinessLayer\VHA.VTK.DATACLASSES\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkNACStatuses
	/// </summary>
	public class NACStatusMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private NACStatusBase nacObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkNACStatuses)
		/// </summary>
		public static string tableName = "VtkNACStatuses";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkNACStatuses.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkNACStatuses.MembershipStatus database field
		/// </summary>
		public const string membershipStatusField = "MembershipStatus";
		
		/// <summary>
		/// Class field that maps to VtkNACStatuses.Description database field
		/// </summary>
		public const string descriptionField = "Description";
		
		/// <summary>
		/// Class field that maps to VtkNACStatuses.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "nacObj"></param>
		public NACStatusMsSqlSrv(NACStatusBase nacObj)
		{
			Initialize(nacObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "nacObj"></param>
		private void Initialize(NACStatusBase nacObj)
		{
			this.nacObj = nacObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = nacObj.AppCon;
			this.databaseTableName = NACStatusMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = NACStatusMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(nacObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create NACStatus instance. Invalid ID: " + nacObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				nacObj.id = (Int32)dr[idField];
			}
			else
			{
				nacObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(membershipStatusField))
			{
				nacObj.membershipStatus = (String)dr[membershipStatusField];
			}
			else
			{
				nacObj.membershipStatus = string.Empty;
			}
		
			if (!dr.IsNull(descriptionField))
			{
				nacObj.description = (String)dr[descriptionField];
			}
			else
			{
				nacObj.description = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				nacObj.version = (Int32)dr[versionField];
			}
			else
			{
				nacObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkNACStatuses spParam = new spParams.spI_VtkNACStatuses ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._MembershipStatus = nacObj.membershipStatus;
			spParam._Ver = nacObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (nacObj.description != string.Empty) {spParam._Description = nacObj.description;}
	
			spSProcs.spI_VtkNACStatuses spSProc = new spSProcs.spI_VtkNACStatuses();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {nacObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("NACStatus", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return nacObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[NACStatusMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkNACStatuses spParam = new spParams.spU_VtkNACStatuses();
 
			if (nacObj.IsChanged && (!nacObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkNACStatuses spSProc = new spSProcs.spU_VtkNACStatuses(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("NACStatus", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (nacObj.membershipStatus == string.Empty && !dr.IsNull(membershipStatusField))  {return true;} 
			else
			if (nacObj.description == string.Empty && !dr.IsNull(descriptionField))  {return true;} 
			else
			if (nacObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkNACStatuses spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  nacObj.id; 
			spParam._MembershipStatus =  nacObj.membershipStatus; 
			spParam._Ver =  nacObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (nacObj.description != string.Empty)  {spParam._Description = nacObj.description;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkNACStatuses spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = nacObj.id; 
			spParam._MembershipStatus = nacObj.membershipStatus; 
			spParam._Ver =  nacObj.version; 
	
			//description property
			if (!dr.IsNull(descriptionField))
			{ 
				if (nacObj.description != (String)dr[descriptionField]) 
				{ 
					spParam._Description = nacObj.description; 
				} 
			} 
			else if (nacObj.description != string.Empty)
			{ 
				spParam._Description = nacObj.description; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (nacObj.id > 0)
			{
				spParams.spD_VtkNACStatuses spParam = new spParams.spD_VtkNACStatuses ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = nacObj.id;
				spParam._Ver = nacObj.version; 
				spSProcs.spD_VtkNACStatuses spSProc = new spSProcs.spD_VtkNACStatuses();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("NACStatus", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + NACStatusMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, NACStatusMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
