﻿
/*

			Class:              ParkingStickerBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkParkingSticker
	/// </summary>
	[Serializable()]
	public abstract class ParkingStickerBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StationProfileFK database field
		/// </summary>
		protected internal Int32  stationProfileId;
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StickerNumber database field
		/// </summary>
		protected internal string  stickerNumber;
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StateFK database field
		/// </summary>
		protected internal Int32  stateId;
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.LicensePlate database field
		/// </summary>
		protected internal string  licensePlate;
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to stationProfileId class field
		/// </summary>
		public Int32  StationProfileId
		{
			get { return stationProfileId;}    set {isChanged = true; stationProfileId = value;}
		}
		
		/// <summary>
		/// Property that maps to stickerNumber class field
		/// </summary>
		public string  StickerNumber
		{
			get { return stickerNumber;}    set {isChanged = true; stickerNumber = value;}
		}
		
		/// <summary>
		/// Property that maps to stateId class field
		/// </summary>
		public Int32  StateId
		{
			get { return stateId;}    set {isChanged = true; stateId = value;}
		}
		
		/// <summary>
		/// Property that maps to licensePlate class field
		/// </summary>
		public string  LicensePlate
		{
			get { return licensePlate;}    set {isChanged = true; licensePlate = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		/// <summary>
		/// Basic constructor
		/// </summary>
		protected ParkingStickerBase():base(){}
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkParkingSticker entry</param>
		protected ParkingStickerBase(int id) : base()
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkParkingSticker</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkParkingSticker definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected ParkingStickerBase(DataRow dr) : base()
		{
			FillCommon((int)dr[ParkingStickerMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			stationProfileId = Int32.MinValue;
			stickerNumber = string.Empty;
			stateId = Int32.MinValue;
			licensePlate = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new ParkingStickerMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of ParkingSticker.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for StationProfileId property values
		/// </summary>
		/// <param name="value">Current instance value of StationProfileId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStationProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ParkingSticker";
			ret.PropertyName = "StationProfileId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationProfileId' is a required. No value is entered.";
			}

			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationProfileBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationProfileId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for StickerNumber property values
		/// </summary>
		/// <param name="value">Current instance value of StickerNumber</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStickerNumber(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ParkingSticker";
			ret.PropertyName = "StickerNumber";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StickerNumber' is a required field. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 13))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StickerNumber' length (" + value.Length +  ") is greater than 13 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for StateId property values
		/// </summary>
		/// <param name="value">Current instance value of StateId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStateId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ParkingSticker";
			ret.PropertyName = "StateId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StateBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StateId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for LicensePlate property values
		/// </summary>
		/// <param name="value">Current instance value of LicensePlate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateLicensePlate(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ParkingSticker";
			ret.PropertyName = "LicensePlate";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 12))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'LicensePlate' length (" + value.Length +  ") is greater than 12 characters.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkParkingSticker.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			// Refresh not done on Save() for collection data to prevent deadly embrace (locking problems)
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkParkingSticker table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkParkingSticker entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return ParkingStickerMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "StationProfileId")  {return stationProfileId.ToString();}
			if (prop == "StickerNumber")  {return stickerNumber.ToString();}
			if (prop == "StateId")  {return stateId.ToString();}
			if (prop == "LicensePlate")  {return licensePlate.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
