﻿
/*

			Class:              ParkingStickerMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkParkingSticker
	/// </summary>
	public class ParkingStickerMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ParkingStickerBase psObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkParkingSticker)
		/// </summary>
		public static string tableName = "VtkParkingSticker";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StationProfileFK database field
		/// </summary>
		public const string stationProfileIdField = "StationProfileFK";
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StickerNumber database field
		/// </summary>
		public const string stickerNumberField = "StickerNumber";
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.StateFK database field
		/// </summary>
		public const string stateIdField = "StateFK";
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.LicensePlate database field
		/// </summary>
		public const string licensePlateField = "LicensePlate";
		
		/// <summary>
		/// Class field that maps to VtkParkingSticker.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "psObj"></param>
		public ParkingStickerMsSqlSrv(ParkingStickerBase psObj)
		{
			Initialize(psObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "psObj"></param>
		private void Initialize(ParkingStickerBase psObj)
		{
			this.psObj = psObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = psObj.AppCon;
			this.databaseTableName = ParkingStickerMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ParkingStickerMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(psObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create ParkingSticker instance. Invalid ID: " + psObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				psObj.id = (Int32)dr[idField];
			}
			else
			{
				psObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationProfileIdField))
			{
				psObj.stationProfileId = (Int32)dr[stationProfileIdField];
			}
			else
			{
				psObj.stationProfileId = Int32.MinValue;
			}
		
			if (!dr.IsNull(stickerNumberField))
			{
				psObj.stickerNumber = (string)dr[stickerNumberField];
			}
			else
			{
				psObj.stickerNumber = string.Empty;
			}
		
			if (!dr.IsNull(stateIdField))
			{
				psObj.stateId = (Int32)dr[stateIdField];
			}
			else
			{
				psObj.stateId = Int32.MinValue;
			}
		
			if (!dr.IsNull(licensePlateField))
			{
				psObj.licensePlate = (string)dr[licensePlateField];
			}
			else
			{
				psObj.licensePlate = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				psObj.version = (Int32)dr[versionField];
			}
			else
			{
				psObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkParkingSticker spParam = new spParams.spI_VtkParkingSticker ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._StationProfileFK = psObj.stationProfileId;
			spParam._StickerNumber = psObj.stickerNumber;
			spParam._Ver = psObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (psObj.stateId != Int32.MinValue) {spParam._StateFK = psObj.stateId;}
			if (psObj.licensePlate != string.Empty) {spParam._LicensePlate = psObj.licensePlate;}
	
			spSProcs.spI_VtkParkingSticker spSProc = new spSProcs.spI_VtkParkingSticker();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {psObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("ParkingSticker", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return psObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ParkingStickerMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkParkingSticker spParam = new spParams.spU_VtkParkingSticker();
 
			if (psObj.IsChanged && (!psObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkParkingSticker spSProc = new spSProcs.spU_VtkParkingSticker(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("ParkingSticker", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (psObj.stationProfileId == Int32.MinValue && !dr.IsNull(stationProfileIdField))  {return true;} 
			else
			if (psObj.stickerNumber == string.Empty && !dr.IsNull(stickerNumberField))  {return true;} 
			else
			if (psObj.stateId == Int32.MinValue && !dr.IsNull(stateIdField))  {return true;} 
			else
			if (psObj.licensePlate == string.Empty && !dr.IsNull(licensePlateField))  {return true;} 
			else
			if (psObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkParkingSticker spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  psObj.id; 
			spParam._StationProfileFK =  psObj.stationProfileId; 
			spParam._StickerNumber =  psObj.stickerNumber; 
			spParam._Ver =  psObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (psObj.stateId != Int32.MinValue)  {spParam._StateFK = psObj.stateId;}
			if (psObj.licensePlate != string.Empty)  {spParam._LicensePlate = psObj.licensePlate;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkParkingSticker spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = psObj.id; 
			spParam._StationProfileFK = psObj.stationProfileId; 
			spParam._StickerNumber = psObj.stickerNumber; 
			spParam._Ver =  psObj.version; 
	
			//stateId property
			if (!dr.IsNull(stateIdField))
			{ 
				if (psObj.stateId != (Int32)dr[stateIdField]) 
				{ 
					spParam._StateFK = psObj.stateId; 
				} 
			} 
			else if (psObj.stateId != Int32.MinValue)
			{ 
				spParam._StateFK = psObj.stateId; 
			} 
	
			//licensePlate property
			if (!dr.IsNull(licensePlateField))
			{ 
				if (psObj.licensePlate != (string)dr[licensePlateField]) 
				{ 
					spParam._LicensePlate = psObj.licensePlate; 
				} 
			} 
			else if (psObj.licensePlate != string.Empty)
			{ 
				spParam._LicensePlate = psObj.licensePlate; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (psObj.id > 0)
			{
				spParams.spD_VtkParkingSticker spParam = new spParams.spD_VtkParkingSticker ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = psObj.id;
				spParam._Ver = psObj.version; 
				spSProcs.spD_VtkParkingSticker spSProc = new spSProcs.spD_VtkParkingSticker();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("ParkingSticker", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ParkingStickerMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ParkingStickerMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
