﻿
/*

			Class:              RollupLogMsSqlSrv

			Date Produced:      3/19/2002 11:59:58 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkRollupLog
	/// </summary>
	public class RollupLogMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private RollupLogBase rulObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkRollupLog)
		/// </summary>
		public static string tableName = "VtkRollupLog";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.RollupRun database field
		/// </summary>
		public const string rollupRunField = "RollupRun";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.RollupEnd database field
		/// </summary>
		public const string rollupEndField = "RollupEnd";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.ClosedMonth database field
		/// </summary>
		public const string closedMonthField = "ClosedMonth";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.RegularRowsInserted database field
		/// </summary>
		public const string regularRowsInsertedField = "RegularRowsInserted";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.OccasionalRowsInserted database field
		/// </summary>
		public const string occasionalRowsInsertedField = "OccasionalRowsInserted";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.IsSuccessful database field
		/// </summary>
		public const string isSuccessfulField = "IsSuccessful";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.History database field
		/// </summary>
		public const string historyField = "History";
		
		/// <summary>
		/// Class field that maps to VtkRollupLog.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "rulObj"></param>
		public RollupLogMsSqlSrv(RollupLogBase rulObj)
		{
			Initialize(rulObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "rulObj"></param>
		private void Initialize(RollupLogBase rulObj)
		{
			this.rulObj = rulObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = rulObj.AppCon;
			this.databaseTableName = RollupLogMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = RollupLogMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(rulObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create RollupLog instance. Invalid ID: " + rulObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				rulObj.id = (Int32)dr[idField];
			}
			else
			{
				rulObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(rollupRunField))
			{
				rulObj.rollupRun = (DateTime)dr[rollupRunField];
			}
			else
			{
				rulObj.rollupRun = DateTime.MinValue;
			}
		
			if (!dr.IsNull(rollupEndField))
			{
				rulObj.rollupEnd = (DateTime)dr[rollupEndField];
			}
			else
			{
				rulObj.rollupEnd = DateTime.MinValue;
			}
		
			if (!dr.IsNull(closedMonthField))
			{
				rulObj.closedMonth = (DateTime)dr[closedMonthField];
			}
			else
			{
				rulObj.closedMonth = DateTime.MinValue;
			}
		
			if (!dr.IsNull(regularRowsInsertedField))
			{
				rulObj.regularRowsInserted = (Int32)dr[regularRowsInsertedField];
			}
			else
			{
				rulObj.regularRowsInserted = Int32.MinValue;
			}
		
			if (!dr.IsNull(occasionalRowsInsertedField))
			{
				rulObj.occasionalRowsInserted = (Int32)dr[occasionalRowsInsertedField];
			}
			else
			{
				rulObj.occasionalRowsInserted = Int32.MinValue;
			}
		
			if (!dr.IsNull(isSuccessfulField))
			{
				rulObj.isSuccessful = (bool)dr[isSuccessfulField];
			}
			else
			{
				rulObj.isSuccessful = false;
			}
		
			if (!dr.IsNull(historyField))
			{
				rulObj.history = (string)dr[historyField];
			}
			else
			{
				rulObj.history = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				rulObj.version = (Int32)dr[versionField];
			}
			else
			{
				rulObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkRollupLog spParam = new spParams.spI_VtkRollupLog ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._RollupRun = rulObj.rollupRun;
			spParam._RollupEnd = rulObj.rollupEnd;
			spParam._Ver = rulObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (rulObj.closedMonth != DateTime.MinValue) {spParam._ClosedMonth = rulObj.closedMonth;}
			if (rulObj.regularRowsInserted != Int32.MinValue) {spParam._RegularRowsInserted = rulObj.regularRowsInserted;}
			if (rulObj.occasionalRowsInserted != Int32.MinValue) {spParam._OccasionalRowsInserted = rulObj.occasionalRowsInserted;}
			if (rulObj.isSuccessful == false) {spParam._IsSuccessful = (0);} // set to default Value 
			else {spParam._IsSuccessful = rulObj.isSuccessful;}
			if (rulObj.history != string.Empty) {spParam._History = rulObj.history;}
	
			spSProcs.spI_VtkRollupLog spSProc = new spSProcs.spI_VtkRollupLog();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {rulObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("RollupLog", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return rulObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[RollupLogMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkRollupLog spParam = new spParams.spU_VtkRollupLog();
 
			if (rulObj.IsChanged && (!rulObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkRollupLog spSProc = new spSProcs.spU_VtkRollupLog(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("RollupLog", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (rulObj.rollupRun == DateTime.MinValue && !dr.IsNull(rollupRunField))  {return true;} 
			else
			if (rulObj.rollupEnd == DateTime.MinValue && !dr.IsNull(rollupEndField))  {return true;} 
			else
			if (rulObj.closedMonth == DateTime.MinValue && !dr.IsNull(closedMonthField))  {return true;} 
			else
			if (rulObj.regularRowsInserted == Int32.MinValue && !dr.IsNull(regularRowsInsertedField))  {return true;} 
			else
			if (rulObj.occasionalRowsInserted == Int32.MinValue && !dr.IsNull(occasionalRowsInsertedField))  {return true;} 
			else
			if (rulObj.isSuccessful == false && !dr.IsNull(isSuccessfulField))  {return true;} 
			else
			if (rulObj.history == string.Empty && !dr.IsNull(historyField))  {return true;} 
			else
			if (rulObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkRollupLog spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  rulObj.id; 
			spParam._RollupRun =  rulObj.rollupRun; 
			spParam._RollupEnd =  rulObj.rollupEnd; 
			spParam._Ver =  rulObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (rulObj.closedMonth != DateTime.MinValue)  {spParam._ClosedMonth = rulObj.closedMonth;}
			if (rulObj.regularRowsInserted != Int32.MinValue)  {spParam._RegularRowsInserted = rulObj.regularRowsInserted;}
			if (rulObj.occasionalRowsInserted != Int32.MinValue)  {spParam._OccasionalRowsInserted = rulObj.occasionalRowsInserted;}
			if (rulObj.isSuccessful != false)  {spParam._IsSuccessful = rulObj.isSuccessful;}
			if (rulObj.history != string.Empty)  {spParam._History = rulObj.history;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkRollupLog spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = rulObj.id; 
			spParam._RollupRun = rulObj.rollupRun; 
			spParam._RollupEnd = rulObj.rollupEnd; 
			spParam._Ver =  rulObj.version; 
	
			//closedMonth property
			if (!dr.IsNull(closedMonthField))
			{ 
				if (rulObj.closedMonth != (DateTime)dr[closedMonthField]) 
				{ 
					spParam._ClosedMonth = rulObj.closedMonth; 
				} 
			} 
			else if (rulObj.closedMonth != DateTime.MinValue)
			{ 
				spParam._ClosedMonth = rulObj.closedMonth; 
			} 
	
			//regularRowsInserted property
			if (!dr.IsNull(regularRowsInsertedField))
			{ 
				if (rulObj.regularRowsInserted != (Int32)dr[regularRowsInsertedField]) 
				{ 
					spParam._RegularRowsInserted = rulObj.regularRowsInserted; 
				} 
			} 
			else if (rulObj.regularRowsInserted != Int32.MinValue)
			{ 
				spParam._RegularRowsInserted = rulObj.regularRowsInserted; 
			} 
	
			//occasionalRowsInserted property
			if (!dr.IsNull(occasionalRowsInsertedField))
			{ 
				if (rulObj.occasionalRowsInserted != (Int32)dr[occasionalRowsInsertedField]) 
				{ 
					spParam._OccasionalRowsInserted = rulObj.occasionalRowsInserted; 
				} 
			} 
			else if (rulObj.occasionalRowsInserted != Int32.MinValue)
			{ 
				spParam._OccasionalRowsInserted = rulObj.occasionalRowsInserted; 
			} 
	
			//isSuccessful property
			if (!dr.IsNull(isSuccessfulField))
			{ 
				if (rulObj.isSuccessful != (bool)dr[isSuccessfulField]) 
				{ 
					spParam._IsSuccessful = rulObj.isSuccessful; 
				} 
			} 
			else if (rulObj.isSuccessful != false)
			{ 
				spParam._IsSuccessful = rulObj.isSuccessful; 
			} 
	
			//history property
			if (!dr.IsNull(historyField))
			{ 
				if (rulObj.history != (string)dr[historyField]) 
				{ 
					spParam._History = rulObj.history; 
				} 
			} 
			else if (rulObj.history != string.Empty)
			{ 
				spParam._History = rulObj.history; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (rulObj.id > 0)
			{
				spParams.spD_VtkRollupLog spParam = new spParams.spD_VtkRollupLog ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = rulObj.id;
				spParam._Ver = rulObj.version; 
				spSProcs.spD_VtkRollupLog spSProc = new spSProcs.spD_VtkRollupLog();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("RollupLog", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + RollupLogMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, RollupLogMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
