﻿
/*

			Class:              ScheduleWorkdayBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVolunteerScheduleWorkdays
	/// </summary>
	public abstract class ScheduleWorkdayBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Code database field
		/// </summary>
		protected internal string  code;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Days database field
		/// </summary>
		protected internal string  days;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.AppearsAs database field
		/// </summary>
		protected internal string  appearsAs;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerScheduleWorkdays.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to code class field
		/// </summary>
		public string  Code
		{
			get { return code;}    set {isChanged = true; code = value;}
		}
		
		/// <summary>
		/// Property that maps to days class field
		/// </summary>
		public string  Days
		{
			get { return days;}    set {isChanged = true; days = value;}
		}
		
		/// <summary>
		/// Property that maps to appearsAs class field
		/// </summary>
		public string  AppearsAs
		{
			get { return appearsAs;}    set {isChanged = true; appearsAs = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected ScheduleWorkdayBase() : base()
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerScheduleWorkdays entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected ScheduleWorkdayBase(int id) : base()
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVolunteerScheduleWorkdays</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVolunteerScheduleWorkdays definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected ScheduleWorkdayBase(DataRow dr) : base()
		{
			FillCommon((int)dr[ScheduleWorkdayMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			code = string.Empty;
			days = string.Empty;
			appearsAs = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new ScheduleWorkdayMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of ScheduleWorkday.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for Code property values
		/// </summary>
		/// <param name="value">Current instance value of Code</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateCode(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ScheduleWorkday";
			ret.PropertyName = "Code";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Code' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Code' length (" + value.Length +  ") is greater than 1 characters.";
			}
			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("spS_ScheduleWorkdayExists", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("RETURN_VALUE", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlParam							= sqlCmd.Parameters.Add("@Code", SqlDbType.VarChar, 1);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= value;
			
			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();
			int RETURN_VALUE = Convert.ToInt32(sqlCmd.Parameters["RETURN_VALUE"].Value);
			sqlConn.Close();

			if((ret.Status	== si.Pass) && (RETURN_VALUE > 0))
			{
				ret.Status	= si.Fail;
				ret.ErrorText = "The code already exists, please try another code.";
			}

			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Days property values
		/// </summary>
		/// <param name="value">Current instance value of Days</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateDays(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ScheduleWorkday";
			ret.PropertyName = "Days";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Days' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 40))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Days' length (" + value.Length +  ") is greater than 40 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for AppearsAs property values
		/// </summary>
		/// <param name="value">Current instance value of AppearsAs</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateAppearsAs(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ScheduleWorkday";
			ret.PropertyName = "AppearsAs";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AppearsAs' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 8))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'AppearsAs' length (" + value.Length +  ") is greater than 8 characters.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVolunteerScheduleWorkdays.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVolunteerScheduleWorkdays table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVolunteerScheduleWorkdays entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return ScheduleWorkdayMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "Code")  {return code.ToString();}
			if (prop == "Days")  {return days.ToString();}
			if (prop == "AppearsAs")  {return appearsAs.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
