﻿
/*

			Class:              ServiceMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkBenefitingServices
	/// </summary>
	public class ServiceMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ServiceBase servObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkBenefitingServices)
		/// </summary>
		public static string tableName = "VtkBenefitingServices";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Code database field
		/// </summary>
		public const string codeField = "Code";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.ServiceName database field
		/// </summary>
		public const string serviceNameField = "ServiceName";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Subdivision database field
		/// </summary>
		public const string subdivisionField = "Subdivision";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Abbreviation database field
		/// </summary>
		public const string abbreviationField = "Abbreviation";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Scope database field
		/// </summary>
		public const string scopeField = "Scope";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.ServiceWithSubdivision database field
		/// </summary>
		public const string serviceWithSubdivisionField = "ServiceWithSubdivision";
		
		/// <summary>
		/// Class field that maps to VtkBenefitingServices.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "servObj"></param>
		public ServiceMsSqlSrv(ServiceBase servObj)
		{
			Initialize(servObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "servObj"></param>
		private void Initialize(ServiceBase servObj)
		{
			this.servObj = servObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = servObj.AppCon;
			this.databaseTableName = ServiceMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ServiceMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(servObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Service instance. Invalid ID: " + servObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				servObj.id = (Int32)dr[idField];
			}
			else
			{
				servObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(codeField))
			{
				servObj.code = (string)dr[codeField];
			}
			else
			{
				servObj.code = string.Empty;
			}
		
			if (!dr.IsNull(serviceNameField))
			{
				servObj.serviceName = (string)dr[serviceNameField];
			}
			else
			{
				servObj.serviceName = string.Empty;
			}
		
			if (!dr.IsNull(subdivisionField))
			{
				servObj.subdivision = (string)dr[subdivisionField];
			}
			else
			{
				servObj.subdivision = string.Empty;
			}
		
			if (!dr.IsNull(abbreviationField))
			{
				servObj.abbreviation = (string)dr[abbreviationField];
			}
			else
			{
				servObj.abbreviation = string.Empty;
			}
		
			if (!dr.IsNull(scopeField))
			{
				servObj.scope = (string)dr[scopeField];
			}
			else
			{
				servObj.scope = string.Empty;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				servObj.stationId = (Int32)dr[stationIdField];
			}
			else
			{
				servObj.stationId = Int32.MinValue;
			}
		
			if (!dr.IsNull(serviceWithSubdivisionField))
			{
				servObj.serviceWithSubdivision = (string)dr[serviceWithSubdivisionField];
			}
			else
			{
				servObj.serviceWithSubdivision = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				servObj.version = (Int32)dr[versionField];
			}
			else
			{
				servObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkBenefitingServices spParam = new spParams.spI_VtkBenefitingServices ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Code = servObj.code;
			spParam._ServiceName = servObj.serviceName;
			spParam._Subdivision = servObj.subdivision;
			spParam._Scope = servObj.scope;
			spParam._Ver = servObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (servObj.abbreviation != string.Empty) {spParam._Abbreviation = servObj.abbreviation;}
			if (servObj.stationId != Int32.MinValue) {spParam._StationFK = servObj.stationId;}
	
			spSProcs.spI_VtkBenefitingServices spSProc = new spSProcs.spI_VtkBenefitingServices();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {servObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Service", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return servObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ServiceMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkBenefitingServices spParam = new spParams.spU_VtkBenefitingServices();
 
			if (servObj.IsChanged && (!servObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkBenefitingServices spSProc = new spSProcs.spU_VtkBenefitingServices(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Service", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (servObj.code == string.Empty && !dr.IsNull(codeField))  {return true;} 
			else
			if (servObj.serviceName == string.Empty && !dr.IsNull(serviceNameField))  {return true;} 
			else
			if (servObj.subdivision == string.Empty && !dr.IsNull(subdivisionField))  {return true;} 
			else
			if (servObj.abbreviation == string.Empty && !dr.IsNull(abbreviationField))  {return true;} 
			else
			if (servObj.scope == string.Empty && !dr.IsNull(scopeField))  {return true;} 
			else
			if (servObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (servObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkBenefitingServices spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  servObj.id; 
			spParam._Code =  servObj.code; 
			spParam._ServiceName =  servObj.serviceName; 
			spParam._Subdivision =  servObj.subdivision; 
			spParam._Scope =  servObj.scope; 
			spParam._Ver =  servObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (servObj.abbreviation != string.Empty)  {spParam._Abbreviation = servObj.abbreviation;}
			if (servObj.stationId != Int32.MinValue)  {spParam._StationFK = servObj.stationId;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkBenefitingServices spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = servObj.id; 
			spParam._Code = servObj.code; 
			spParam._ServiceName = servObj.serviceName; 
			spParam._Subdivision = servObj.subdivision; 
			spParam._Scope = servObj.scope; 
			spParam._Ver =  servObj.version; 
	
			//abbreviation property
			if (!dr.IsNull(abbreviationField))
			{ 
				if (servObj.abbreviation != (string)dr[abbreviationField]) 
				{ 
					spParam._Abbreviation = servObj.abbreviation; 
				} 
			} 
			else if (servObj.abbreviation != string.Empty)
			{ 
				spParam._Abbreviation = servObj.abbreviation; 
			} 
	
			//stationId property
			if (!dr.IsNull(stationIdField))
			{ 
				if (servObj.stationId != (Int32)dr[stationIdField]) 
				{ 
					spParam._StationFK = servObj.stationId; 
				} 
			} 
			else if (servObj.stationId != Int32.MinValue)
			{ 
				spParam._StationFK = servObj.stationId; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (servObj.id > 0)
			{
				spParams.spD_VtkBenefitingServices spParam = new spParams.spD_VtkBenefitingServices ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = servObj.id;
				spParam._Ver = servObj.version; 
				spSProcs.spD_VtkBenefitingServices spSProc = new spSProcs.spD_VtkBenefitingServices();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Service", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ServiceMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ServiceMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
