﻿
/*

			Class:              StaffTitleMsSqlSrv

			Date Produced:      5/9/2002 12:43:02 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        5/2/2002 8:06:06 AM
			Revision:           635

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.851.29826\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.851.29826

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkStaffTitles
	/// </summary>
	public class StaffTitleMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private StaffTitleBase sttlObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkStaffTitles)
		/// </summary>
		public static string tableName = "VtkStaffTitles";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Title database field
		/// </summary>
		public const string titleField = "Title";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.IsVolChiefSupervisor database field
		/// </summary>
		public const string isVolChiefSupervisorField = "IsVolChiefSupervisor";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Description database field
		/// </summary>
		public const string descriptionField = "Description";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Scope database field
		/// </summary>
		public const string scopeField = "Scope";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkStaffTitles.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "sttlObj"></param>
		public StaffTitleMsSqlSrv(StaffTitleBase sttlObj)
		{
			Initialize(sttlObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "sttlObj"></param>
		private void Initialize(StaffTitleBase sttlObj)
		{
			this.sttlObj = sttlObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = sttlObj.AppCon;
			this.databaseTableName = StaffTitleMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = StaffTitleMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(sttlObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create StaffTitle instance. Invalid ID: " + sttlObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				sttlObj.id = (Int32)dr[idField];
			}
			else
			{
				sttlObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(titleField))
			{
				sttlObj.title = (string)dr[titleField];
			}
			else
			{
				sttlObj.title = string.Empty;
			}
		
			if (!dr.IsNull(isVolChiefSupervisorField))
			{
				sttlObj.isVolChiefSupervisor = (bool)dr[isVolChiefSupervisorField];
			}
			else
			{
				sttlObj.isVolChiefSupervisor = false;
			}
		
			if (!dr.IsNull(descriptionField))
			{
				sttlObj.description = (string)dr[descriptionField];
			}
			else
			{
				sttlObj.description = string.Empty;
			}
		
			if (!dr.IsNull(scopeField))
			{
				sttlObj.scope = (string)dr[scopeField];
			}
			else
			{
				sttlObj.scope = string.Empty;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				sttlObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				sttlObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				sttlObj.version = (Int32)dr[versionField];
			}
			else
			{
				sttlObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkStaffTitles spParam = new spParams.spI_VtkStaffTitles ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Title = sttlObj.title;
			spParam._Ver = sttlObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (sttlObj.isVolChiefSupervisor == false) {spParam._IsVolChiefSupervisor = (0);} // set to default Value 
			else {spParam._IsVolChiefSupervisor = sttlObj.isVolChiefSupervisor;}
			if (sttlObj.description != string.Empty) {spParam._Description = sttlObj.description;}
			if (sttlObj.scope != string.Empty) {spParam._Scope = sttlObj.scope;}
			if (sttlObj.institutionId != Int32.MinValue) {spParam._InstitutionFK = sttlObj.institutionId;}
	
			spSProcs.spI_VtkStaffTitles spSProc = new spSProcs.spI_VtkStaffTitles();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {sttlObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("StaffTitle", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return sttlObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[StaffTitleMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkStaffTitles spParam = new spParams.spU_VtkStaffTitles();
 
			if (sttlObj.IsChanged && (!sttlObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkStaffTitles spSProc = new spSProcs.spU_VtkStaffTitles(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("StaffTitle", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (sttlObj.title == string.Empty && !dr.IsNull(titleField))  {return true;} 
			else
			if (sttlObj.isVolChiefSupervisor == false && !dr.IsNull(isVolChiefSupervisorField))  {return true;} 
			else
			if (sttlObj.description == string.Empty && !dr.IsNull(descriptionField))  {return true;} 
			else
			if (sttlObj.scope == string.Empty && !dr.IsNull(scopeField))  {return true;} 
			else
			if (sttlObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (sttlObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkStaffTitles spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  sttlObj.id; 
			spParam._Title =  sttlObj.title; 
			spParam._Ver =  sttlObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (sttlObj.isVolChiefSupervisor != false)  {spParam._IsVolChiefSupervisor = sttlObj.isVolChiefSupervisor;}
			if (sttlObj.description != string.Empty)  {spParam._Description = sttlObj.description;}
			if (sttlObj.scope != string.Empty)  {spParam._Scope = sttlObj.scope;}
			if (sttlObj.institutionId != Int32.MinValue)  {spParam._InstitutionFK = sttlObj.institutionId;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkStaffTitles spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = sttlObj.id; 
			spParam._Title = sttlObj.title; 
			spParam._Ver =  sttlObj.version; 
	
			//isVolChiefSupervisor property
			if (!dr.IsNull(isVolChiefSupervisorField))
			{ 
				if (sttlObj.isVolChiefSupervisor != (bool)dr[isVolChiefSupervisorField]) 
				{ 
					spParam._IsVolChiefSupervisor = sttlObj.isVolChiefSupervisor; 
				} 
			} 
			else if (sttlObj.isVolChiefSupervisor != false)
			{ 
				spParam._IsVolChiefSupervisor = sttlObj.isVolChiefSupervisor; 
			} 
	
			//description property
			if (!dr.IsNull(descriptionField))
			{ 
				if (sttlObj.description != (string)dr[descriptionField]) 
				{ 
					spParam._Description = sttlObj.description; 
				} 
			} 
			else if (sttlObj.description != string.Empty)
			{ 
				spParam._Description = sttlObj.description; 
			} 
	
			//scope property
			if (!dr.IsNull(scopeField))
			{ 
				if (sttlObj.scope != (string)dr[scopeField]) 
				{ 
					spParam._Scope = sttlObj.scope; 
				} 
			} 
			else if (sttlObj.scope != string.Empty)
			{ 
				spParam._Scope = sttlObj.scope; 
			} 
	
			//institutionId property
			if (!dr.IsNull(institutionIdField))
			{ 
				if (sttlObj.institutionId != (Int32)dr[institutionIdField]) 
				{ 
					spParam._InstitutionFK = sttlObj.institutionId; 
				} 
			} 
			else if (sttlObj.institutionId != Int32.MinValue)
			{ 
				spParam._InstitutionFK = sttlObj.institutionId; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (sttlObj.id > 0)
			{
				spParams.spD_VtkStaffTitles spParam = new spParams.spD_VtkStaffTitles ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = sttlObj.id;
				spParam._Ver = sttlObj.version; 
				spSProcs.spD_VtkStaffTitles spSProc = new spSProcs.spD_VtkStaffTitles();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("StaffTitle", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + StaffTitleMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, StaffTitleMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
