﻿
/*

			Class:              StationParametersBase

			Date Produced:      6/25/2002 11:07:45 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        08/26/2004 00:00:00 AM
								Manually modified the class to incorporate 4 new columns.
			Revision:           655

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVoluntaryStationParameters
	/// </summary>
	public abstract class StationParametersBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.InstitutionFK database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IntroductoryText database field
		/// </summary>
		protected internal string  introductoryText;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsRequireAlternateLanguage database field
		/// </summary>
		protected internal bool  isRequireAlternateLanguage;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DefaultLanguageFK database field
		/// </summary>
		protected internal Int32  defaultLanguageId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.AlternateLanguageFK database field
		/// </summary>
		protected internal Int32  alternateLanguageId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.NumberOfMeals database field
		/// </summary>
		protected internal Int32  numberOfMeals;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.MealAuthorization database field
		/// </summary>
		protected internal string  mealAuthorization;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsSaturdayMeal database field
		/// </summary>
		protected internal bool  isSaturdayMeal;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsSundayMeal database field
		/// </summary>
		protected internal bool  isSundayMeal;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsHolidayMeal database field
		/// </summary>
		protected internal bool  isHolidayMeal;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.MealPrice database field
		/// </summary>
		protected internal decimal  mealPrice;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DurationForMeal1 database field
		/// </summary>
		protected internal Int32  durationForMeal1;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.CutOffTimeForMeal1 database field
		/// </summary>
		protected internal string  cutOffTimeForMeal1;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DurationForMeal2 database field
		/// </summary>
		protected internal Int32  durationForMeal2;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.CutOffTimeForMeal2 database field
		/// </summary>
		protected internal string  cutOffTimeForMeal2;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.VoluntarySignatureLine database field
		/// </summary>
		protected internal string  voluntarySignatureLine;

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.isVALetterHead database field
		/// </summary>
		protected internal bool  isVALetterHead;

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DirectorSignatureLine database field
		/// </summary>
		protected internal string  directorSignatureLine;

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.ValueAmount database field
		/// </summary>
		protected internal decimal  valueAmount;

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}    set {isChanged = true; id = value;}
		}
		
		/// <summary>
		/// Property that maps to introductoryText class field
		/// </summary>
		public string  IntroductoryText
		{
			get { return introductoryText;}    set {isChanged = true; introductoryText = value;}
		}
		
		/// <summary>
		/// Property that maps to isRequireAlternateLanguage class field
		/// </summary>
		public bool  IsRequireAlternateLanguage
		{
			get { return isRequireAlternateLanguage;}    set {isChanged = true; isRequireAlternateLanguage = value;}
		}
		
		/// <summary>
		/// Property that maps to defaultLanguageId class field
		/// </summary>
		public Int32  DefaultLanguageId
		{
			get { return defaultLanguageId;}    set {isChanged = true; defaultLanguageId = value;}
		}
		
		/// <summary>
		/// Property that maps to alternateLanguageId class field
		/// </summary>
		public Int32  AlternateLanguageId
		{
			get { return alternateLanguageId;}    set {isChanged = true; alternateLanguageId = value;}
		}
		
		/// <summary>
		/// Property that maps to numberOfMeals class field
		/// </summary>
		public Int32  NumberOfMeals
		{
			get { return numberOfMeals;}    set {isChanged = true; numberOfMeals = value;}
		}
		
		/// <summary>
		/// Property that maps to mealAuthorization class field
		/// </summary>
		public string  MealAuthorization
		{
			get { return mealAuthorization;}    set {isChanged = true; mealAuthorization = value;}
		}
		
		/// <summary>
		/// Property that maps to isSaturdayMeal class field
		/// </summary>
		public bool  IsSaturdayMeal
		{
			get { return isSaturdayMeal;}    set {isChanged = true; isSaturdayMeal = value;}
		}
		
		/// <summary>
		/// Property that maps to isSundayMeal class field
		/// </summary>
		public bool  IsSundayMeal
		{
			get { return isSundayMeal;}    set {isChanged = true; isSundayMeal = value;}
		}
		
		/// <summary>
		/// Property that maps to isHolidayMeal class field
		/// </summary>
		public bool  IsHolidayMeal
		{
			get { return isHolidayMeal;}    set {isChanged = true; isHolidayMeal = value;}
		}
		
		/// <summary>
		/// Property that maps to mealPrice class field
		/// </summary>
		public decimal  MealPrice
		{
			get { return mealPrice;}    set {isChanged = true; mealPrice = value;}
		}
		
		/// <summary>
		/// Property that maps to durationForMeal1 class field
		/// </summary>
		public Int32  DurationForMeal1
		{
			get { return durationForMeal1;}    set {isChanged = true; durationForMeal1 = value;}
		}
		
		/// <summary>
		/// Property that maps to cutOffTimeForMeal1 class field
		/// </summary>
		public string  CutOffTimeForMeal1
		{
			get { return cutOffTimeForMeal1;}    set {isChanged = true; cutOffTimeForMeal1 = value;}
		}
		
		/// <summary>
		/// Property that maps to durationForMeal2 class field
		/// </summary>
		public Int32  DurationForMeal2
		{
			get { return durationForMeal2;}    set {isChanged = true; durationForMeal2 = value;}
		}
		
		/// <summary>
		/// Property that maps to cutOffTimeForMeal2 class field
		/// </summary>
		public string  CutOffTimeForMeal2
		{
			get { return cutOffTimeForMeal2;}    set {isChanged = true; cutOffTimeForMeal2 = value;}
		}
		
		/// <summary>
		/// Property that maps to VoluntarySignatureLine class field
		/// </summary>
		public string  VoluntarySignatureLine
		{
			get { return voluntarySignatureLine;}    set {isChanged = true; voluntarySignatureLine = value;}
		}

		/// <summary>
		/// Property that maps to DirectorSignatureLine class field
		/// </summary>
		public string  DirectorSignatureLine
		{
			get { return directorSignatureLine;}    set {isChanged = true; directorSignatureLine = value;}
		}

		/// <summary>
		/// Property that maps to ValueAmount class field
		/// </summary>
		public decimal  ValueAmount
		{
			get { return valueAmount;}    set {isChanged = true; valueAmount = value;}
		}

		/// <summary>
		/// Property that maps to IsVALetterHead class field
		/// </summary>
		public bool  IsVALetterHead
		{
			get { return isVALetterHead;}    set {isChanged = true; isVALetterHead = value;}
		}

		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected StationParametersBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected StationParametersBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVoluntaryStationParameters</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVoluntaryStationParameters definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected StationParametersBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[StationParametersMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			id = Int32.MinValue;
			introductoryText = string.Empty;
			isRequireAlternateLanguage = false;
			defaultLanguageId = Int32.MinValue;
			alternateLanguageId = Int32.MinValue;
			numberOfMeals = Int32.MinValue;
			mealAuthorization = string.Empty;
			isSaturdayMeal = false;
			isSundayMeal = false;
			isHolidayMeal = false;
			mealPrice = Decimal.MinValue;
			durationForMeal1 = Int32.MinValue;
			cutOffTimeForMeal1 = string.Empty;
			durationForMeal2 = Int32.MinValue;
			cutOffTimeForMeal2 = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new StationParametersMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of StationParameters.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for IntroductoryText property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of IntroductoryText</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateIntroductoryText(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "IntroductoryText";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 240))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'IntroductoryText' length (" + value.Length +  ") is greater than 240 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsRequireAlternateLanguage property values
		/// </summary>
		///<Params>
		/// <param name="value" type="bool">Current instance value of IsRequireAlternateLanguage</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateIsRequireAlternateLanguage(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "IsRequireAlternateLanguage";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for DefaultLanguageId property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of DefaultLanguageId</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateDefaultLanguageId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "DefaultLanguageId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!LanguageBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'DefaultLanguageId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for AlternateLanguageId property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of AlternateLanguageId</param>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"/>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateAlternateLanguageId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "AlternateLanguageId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!LanguageBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'AlternateLanguageId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for NumberOfMeals property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of NumberOfMeals</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateNumberOfMeals(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "NumberOfMeals";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for MealAuthorization property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of MealAuthorization</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateMealAuthorization(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "MealAuthorization";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'MealAuthorization' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'MealAuthorization' length (" + value.Length +  ") is greater than 1 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsSaturdayMeal property values
		/// </summary>
		///<Params>
		/// <param name="value" type="bool">Current instance value of IsSaturdayMeal</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateIsSaturdayMeal(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "IsSaturdayMeal";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsSundayMeal property values
		/// </summary>
		///<Params>
		/// <param name="value" type="bool">Current instance value of IsSundayMeal</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateIsSundayMeal(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "IsSundayMeal";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for IsHolidayMeal property values
		/// </summary>
		///<Params>
		/// <param name="value" type="bool">Current instance value of IsHolidayMeal</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateIsHolidayMeal(bool value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "IsHolidayMeal";
			
			// quit if field allows nulls and currently set to default
			if (value == false) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for MealPrice property values
		/// </summary>
		///<Params>
		/// <param name="value" type="decimal">Current instance value of MealPrice</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateMealPrice(decimal value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "MealPrice";
			
			// quit if field allows nulls and currently set to default
			if (value == Decimal.MinValue) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for DurationForMeal1 property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of DurationForMeal1</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateDurationForMeal1(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "DurationForMeal1";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for CutOffTimeForMeal1 property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of CutOffTimeForMeal1</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateCutOffTimeForMeal1(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "CutOffTimeForMeal1";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 4))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'CutOffTimeForMeal1' length (" + value.Length +  ") is greater than 4 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for DurationForMeal2 property values
		/// </summary>
		///<Params>
		/// <param name="value" type="Int32">Current instance value of DurationForMeal2</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateDurationForMeal2(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "DurationForMeal2";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for CutOffTimeForMeal2 property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of CutOffTimeForMeal2</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateCutOffTimeForMeal2(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "CutOffTimeForMeal2";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 4))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'CutOffTimeForMeal2' length (" + value.Length +  ") is greater than 4 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for VoluntarySignatureLine property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of VoluntarySignatureLine</param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateVoluntarySignatureLine(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "VoluntarySignatureLine";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 50))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'VoluntarySignatureLine' length (" + value.Length +  ") is greater than 50 characters.";
			}
			
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric validation checks for DirectorSignatureLine property values
		/// </summary>
		///<Params>
		/// <param name="value" type="string">Current instance value of DirectorSignatureLine </param>
		///</Params>
		/// <returns type="Vha.Vtk.Kernel.Common.ReturnStatus"></returns>
		protected static ReturnStatus ValidateDirectorSignatureLine (string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationParameters";
			ret.PropertyName = "DirectorSignatureLine ";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 50))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Error: 'DirectorSignatureLine ' length (" + value.Length +  ") is greater than 50 characters.";
			}
			
			return ret;
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVoluntaryStationParameters.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVoluntaryStationParameters table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVoluntaryStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return StationParametersMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "IntroductoryText")  {return introductoryText.ToString();}
			if (prop == "IsRequireAlternateLanguage")  {return isRequireAlternateLanguage.ToString();}
			if (prop == "DefaultLanguageId")  {return defaultLanguageId.ToString();}
			if (prop == "AlternateLanguageId")  {return alternateLanguageId.ToString();}
			if (prop == "NumberOfMeals")  {return numberOfMeals.ToString();}
			if (prop == "MealAuthorization")  {return mealAuthorization.ToString();}
			if (prop == "IsSaturdayMeal")  {return isSaturdayMeal.ToString();}
			if (prop == "IsSundayMeal")  {return isSundayMeal.ToString();}
			if (prop == "IsHolidayMeal")  {return isHolidayMeal.ToString();}
			if (prop == "MealPrice")  {return mealPrice.ToString();}
			if (prop == "DurationForMeal1")  {return durationForMeal1.ToString();}
			if (prop == "CutOffTimeForMeal1")  {return cutOffTimeForMeal1.ToString();}
			if (prop == "DurationForMeal2")  {return durationForMeal2.ToString();}
			if (prop == "CutOffTimeForMeal2")  {return cutOffTimeForMeal2.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
