﻿
/*

			Class:              StationParametersMsSqlSrv

			Date Produced:      6/25/2002 11:07:45 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        6/18/2002 11:43:05 AM
			Revision:           655

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.868.22959\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.868.22959

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVoluntaryStationParameters
	/// </summary>
	public class StationParametersMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private StationParametersBase spObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVoluntaryStationParameters)
		/// </summary>
		public static string tableName = "VtkVoluntaryStationParameters";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.InstitutionFK database field
		/// </summary>
		public const string idField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IntroductoryText database field
		/// </summary>
		public const string introductoryTextField = "IntroductoryText";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsRequireAlternateLanguage database field
		/// </summary>
		public const string isRequireAlternateLanguageField = "IsRequireAlternateLanguage";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DefaultLanguageFK database field
		/// </summary>
		public const string defaultLanguageIdField = "DefaultLanguageFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.AlternateLanguageFK database field
		/// </summary>
		public const string alternateLanguageIdField = "AlternateLanguageFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.NumberOfMeals database field
		/// </summary>
		public const string numberOfMealsField = "NumberOfMeals";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.MealAuthorization database field
		/// </summary>
		public const string mealAuthorizationField = "MealAuthorization";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsSaturdayMeal database field
		/// </summary>
		public const string isSaturdayMealField = "IsSaturdayMeal";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsSundayMeal database field
		/// </summary>
		public const string isSundayMealField = "IsSundayMeal";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsHolidayMeal database field
		/// </summary>
		public const string isHolidayMealField = "IsHolidayMeal";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.MealPrice database field
		/// </summary>
		public const string mealPriceField = "MealPrice";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DurationForMeal1 database field
		/// </summary>
		public const string durationForMeal1Field = "DurationForMeal1";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.CutOffTimeForMeal1 database field
		/// </summary>
		public const string cutOffTimeForMeal1Field = "CutOffTimeForMeal1";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DurationForMeal2 database field
		/// </summary>
		public const string durationForMeal2Field = "DurationForMeal2";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.CutOffTimeForMeal2 database field
		/// </summary>
		public const string cutOffTimeForMeal2Field = "CutOffTimeForMeal2";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.VoluntarySignatureLine database field
		/// </summary>
		public const string voluntarySignatureLineField = "VoluntarySignatureLine";

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.DirectorSignatureLine database field
		/// </summary>
		public const string directorSignatureLineField = "DirectorSignatureLine";

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.ValueAmount database field
		/// </summary>
		public const string valueAmountField = "ValueAmount";

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.IsVALetterHead database field
		/// </summary>
		public const string isVALetterHeadField = "isVALetterHead";

		/// <summary>
		/// Class field that maps to VtkVoluntaryStationParameters.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "spObj"></param>
		public StationParametersMsSqlSrv(StationParametersBase spObj)
		{
			Initialize(spObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "spObj"></param>
		private void Initialize(StationParametersBase spObj)
		{
			this.spObj = spObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = spObj.AppCon;
			this.databaseTableName = StationParametersMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = StationParametersMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(spObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create StationParameters instance. Invalid ID: " + spObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				spObj.id = (Int32)dr[idField];
			}
			else
			{
				spObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(introductoryTextField))
			{
				spObj.introductoryText = (string)dr[introductoryTextField];
			}
			else
			{
				spObj.introductoryText = string.Empty;
			}
		
			if (!dr.IsNull(isRequireAlternateLanguageField))
			{
				spObj.isRequireAlternateLanguage = (bool)dr[isRequireAlternateLanguageField];
			}
			else
			{
				spObj.isRequireAlternateLanguage = false;
			}
		
			if (!dr.IsNull(defaultLanguageIdField))
			{
				spObj.defaultLanguageId = (Int32)dr[defaultLanguageIdField];
			}
			else
			{
				spObj.defaultLanguageId = Int32.MinValue;
			}
		
			if (!dr.IsNull(alternateLanguageIdField))
			{
				spObj.alternateLanguageId = (Int32)dr[alternateLanguageIdField];
			}
			else
			{
				spObj.alternateLanguageId = Int32.MinValue;
			}
		
			if (!dr.IsNull(numberOfMealsField))
			{
				spObj.numberOfMeals = (Int32)dr[numberOfMealsField];
			}
			else
			{
				spObj.numberOfMeals = Int32.MinValue;
			}
		
			if (!dr.IsNull(mealAuthorizationField))
			{
				spObj.mealAuthorization = (string)dr[mealAuthorizationField];
			}
			else
			{
				spObj.mealAuthorization = string.Empty;
			}
		
			if (!dr.IsNull(isSaturdayMealField))
			{
				spObj.isSaturdayMeal = (bool)dr[isSaturdayMealField];
			}
			else
			{
				spObj.isSaturdayMeal = false;
			}
		
			if (!dr.IsNull(isSundayMealField))
			{
				spObj.isSundayMeal = (bool)dr[isSundayMealField];
			}
			else
			{
				spObj.isSundayMeal = false;
			}
		
			if (!dr.IsNull(isHolidayMealField))
			{
				spObj.isHolidayMeal = (bool)dr[isHolidayMealField];
			}
			else
			{
				spObj.isHolidayMeal = false;
			}
		
			if (!dr.IsNull(mealPriceField))
			{
				spObj.mealPrice = (decimal)dr[mealPriceField];
			}
			else
			{
				spObj.mealPrice = Decimal.MinValue;
			}
		
			if (!dr.IsNull(durationForMeal1Field))
			{
				spObj.durationForMeal1 = (Int32)dr[durationForMeal1Field];
			}
			else
			{
				spObj.durationForMeal1 = Int32.MinValue;
			}
		
			if (!dr.IsNull(cutOffTimeForMeal1Field))
			{
				spObj.cutOffTimeForMeal1 = (string)dr[cutOffTimeForMeal1Field];
			}
			else
			{
				spObj.cutOffTimeForMeal1 = string.Empty;
			}
		
			if (!dr.IsNull(durationForMeal2Field))
			{
				spObj.durationForMeal2 = (Int32)dr[durationForMeal2Field];
			}
			else
			{
				spObj.durationForMeal2 = Int32.MinValue;
			}
		
			if (!dr.IsNull(cutOffTimeForMeal2Field))
			{
				spObj.cutOffTimeForMeal2 = (string)dr[cutOffTimeForMeal2Field];
			}
			else
			{
				spObj.cutOffTimeForMeal2 = string.Empty;
			}
		
			if (!dr.IsNull(voluntarySignatureLineField))
			{
				spObj.voluntarySignatureLine = (string)dr[voluntarySignatureLineField];
			}
			else
			{
				spObj.voluntarySignatureLine = string.Empty;
			}

			if (!dr.IsNull(directorSignatureLineField))
			{
				spObj.directorSignatureLine = (string)dr[directorSignatureLineField];
			}
			else
			{
				spObj.directorSignatureLine = string.Empty;
			}

			if (!dr.IsNull(valueAmountField))
			{
				spObj.valueAmount = (decimal)dr[valueAmountField];
			}
			else
			{
				spObj.valueAmount = decimal.MinValue;
			}

			if (!dr.IsNull(isVALetterHeadField))
			{
				spObj.isVALetterHead = (bool)dr[isVALetterHeadField];
			}
			else
			{
				spObj.isVALetterHead = false;
			}

			if (!dr.IsNull(versionField))
			{
				spObj.version = (Int32)dr[versionField];
			}
			else
			{
				spObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVoluntaryStationParameters spParam = new spParams.spI_VtkVoluntaryStationParameters ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Ver = spObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (spObj.introductoryText != string.Empty) {spParam._IntroductoryText = spObj.introductoryText;}
			if (spObj.isRequireAlternateLanguage == false) {spParam._IsRequireAlternateLanguage = (0);} // set to default Value 
			else {spParam._IsRequireAlternateLanguage = spObj.isRequireAlternateLanguage;}
			if (spObj.defaultLanguageId != Int32.MinValue) {spParam._DefaultLanguageFK = spObj.defaultLanguageId;}
			if (spObj.alternateLanguageId != Int32.MinValue) {spParam._AlternateLanguageFK = spObj.alternateLanguageId;}
			if (spObj.numberOfMeals == Int32.MinValue) {spParam._NumberOfMeals = (1);} // set to default Value 
			else {spParam._NumberOfMeals = spObj.numberOfMeals;}
			if (spObj.mealAuthorization == string.Empty) {spParam._MealAuthorization = ("L");} // set to default Value 
			else {spParam._MealAuthorization = spObj.mealAuthorization;}
			if (spObj.isSaturdayMeal == false) {spParam._IsSaturdayMeal = (0);} // set to default Value 
			else {spParam._IsSaturdayMeal = spObj.isSaturdayMeal;}
			if (spObj.isSundayMeal == false) {spParam._IsSundayMeal = (0);} // set to default Value 
			else {spParam._IsSundayMeal = spObj.isSundayMeal;}
			if (spObj.isHolidayMeal == false) {spParam._IsHolidayMeal = (0);} // set to default Value 
			else {spParam._IsHolidayMeal = spObj.isHolidayMeal;}
			if (spObj.mealPrice != Decimal.MinValue) {spParam._MealPrice = spObj.mealPrice;}
			if (spObj.durationForMeal1 != Int32.MinValue) {spParam._DurationForMeal1 = spObj.durationForMeal1;}
			if (spObj.cutOffTimeForMeal1 != string.Empty) {spParam._CutOffTimeForMeal1 = spObj.cutOffTimeForMeal1;}
			if (spObj.durationForMeal2 != Int32.MinValue) {spParam._DurationForMeal2 = spObj.durationForMeal2;}
			if (spObj.cutOffTimeForMeal2 != string.Empty) {spParam._CutOffTimeForMeal2 = spObj.cutOffTimeForMeal2;}
			if (spObj.voluntarySignatureLine != string.Empty) {spParam._VoluntarySignatureLine = spObj.voluntarySignatureLine;}
			if (spObj.directorSignatureLine != string.Empty) {spParam._DirectorSignatureLine = spObj.directorSignatureLine;}
			if (spObj.valueAmount != Decimal.MinValue) {spParam._ValueAmount = spObj.valueAmount;}
			if (spObj.isVALetterHead == false) {spParam._IsVALetterHead = (0);} // set to default Value 
			else {spParam._IsVALetterHead = spObj.isVALetterHead;}
	
			spSProcs.spI_VtkVoluntaryStationParameters spSProc = new spSProcs.spI_VtkVoluntaryStationParameters();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._InstitutionFK != null) {spObj.id = (Int32)spParam._InstitutionFK;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("StationParameters", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return spObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[StationParametersMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVoluntaryStationParameters spParam = new spParams.spU_VtkVoluntaryStationParameters();
 
			if (spObj.IsChanged && (!spObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVoluntaryStationParameters spSProc = new spSProcs.spU_VtkVoluntaryStationParameters(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("StationParameters", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (spObj.introductoryText == string.Empty && !dr.IsNull(introductoryTextField))  {return true;} 
			else
			if (spObj.isRequireAlternateLanguage == false && !dr.IsNull(isRequireAlternateLanguageField))  {return true;} 
			else
			if (spObj.defaultLanguageId == Int32.MinValue && !dr.IsNull(defaultLanguageIdField))  {return true;} 
			else
			if (spObj.alternateLanguageId == Int32.MinValue && !dr.IsNull(alternateLanguageIdField))  {return true;} 
			else
			if (spObj.numberOfMeals == Int32.MinValue && !dr.IsNull(numberOfMealsField))  {return true;} 
			else
			if (spObj.mealAuthorization == string.Empty && !dr.IsNull(mealAuthorizationField))  {return true;} 
			else
			if (spObj.isSaturdayMeal == false && !dr.IsNull(isSaturdayMealField))  {return true;} 
			else
			if (spObj.isSundayMeal == false && !dr.IsNull(isSundayMealField))  {return true;} 
			else
			if (spObj.isHolidayMeal == false && !dr.IsNull(isHolidayMealField))  {return true;} 
			else
			if (spObj.mealPrice == Decimal.MinValue && !dr.IsNull(mealPriceField))  {return true;} 
			else
			if (spObj.durationForMeal1 == Int32.MinValue && !dr.IsNull(durationForMeal1Field))  {return true;} 
			else
			if (spObj.cutOffTimeForMeal1 == string.Empty && !dr.IsNull(cutOffTimeForMeal1Field))  {return true;} 
			else
			if (spObj.durationForMeal2 == Int32.MinValue && !dr.IsNull(durationForMeal2Field))  {return true;} 
			else
			if (spObj.cutOffTimeForMeal2 == string.Empty && !dr.IsNull(cutOffTimeForMeal2Field))  {return true;} 
			else
			if (spObj.voluntarySignatureLine == string.Empty && !dr.IsNull(voluntarySignatureLineField))  {return true;} 
			else
			if (spObj.directorSignatureLine == string.Empty && !dr.IsNull(directorSignatureLineField))  {return true;} 
			else
			if (spObj.valueAmount == Decimal.MinValue && !dr.IsNull(valueAmountField))  {return true;} 
			else
			if (spObj.isVALetterHead == false && !dr.IsNull(isVALetterHeadField))  {return true;} 
			else
			if (spObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVoluntaryStationParameters spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._InstitutionFK =  spObj.id; 
			spParam._Ver =  spObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (spObj.introductoryText != string.Empty)  {spParam._IntroductoryText = spObj.introductoryText;}
			if (spObj.isRequireAlternateLanguage != false)  {spParam._IsRequireAlternateLanguage = spObj.isRequireAlternateLanguage;}
			if (spObj.defaultLanguageId != Int32.MinValue)  {spParam._DefaultLanguageFK = spObj.defaultLanguageId;}
			if (spObj.alternateLanguageId != Int32.MinValue)  {spParam._AlternateLanguageFK = spObj.alternateLanguageId;}
			if (spObj.numberOfMeals != Int32.MinValue)  {spParam._NumberOfMeals = spObj.numberOfMeals;}
			if (spObj.mealAuthorization != string.Empty)  {spParam._MealAuthorization = spObj.mealAuthorization;}
			if (spObj.isSaturdayMeal != false)  {spParam._IsSaturdayMeal = spObj.isSaturdayMeal;}
			if (spObj.isSundayMeal != false)  {spParam._IsSundayMeal = spObj.isSundayMeal;}
			if (spObj.isHolidayMeal != false)  {spParam._IsHolidayMeal = spObj.isHolidayMeal;}
			if (spObj.mealPrice != Decimal.MinValue)  {spParam._MealPrice = spObj.mealPrice;}
			if (spObj.durationForMeal1 != Int32.MinValue)  {spParam._DurationForMeal1 = spObj.durationForMeal1;}
			if (spObj.cutOffTimeForMeal1 != string.Empty)  {spParam._CutOffTimeForMeal1 = spObj.cutOffTimeForMeal1;}
			if (spObj.durationForMeal2 != Int32.MinValue)  {spParam._DurationForMeal2 = spObj.durationForMeal2;}
			if (spObj.cutOffTimeForMeal2 != string.Empty)  {spParam._CutOffTimeForMeal2 = spObj.cutOffTimeForMeal2;}
			if (spObj.voluntarySignatureLine != string.Empty)  {spParam._VoluntarySignatureLine = spObj.voluntarySignatureLine;}
			if (spObj.directorSignatureLine != string.Empty)  {spParam._DirectorSignatureLine = spObj.directorSignatureLine;}
			if (spObj.valueAmount != Decimal.MinValue)  {spParam._ValueAmount = spObj.valueAmount;}
			if (spObj.isVALetterHead != false)  {spParam._IsVALetterHead = spObj.isVALetterHead;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVoluntaryStationParameters spParam, DataRow dr)
		{
			//required or bool properties
			spParam._InstitutionFK = spObj.id; 
			spParam._Ver =  spObj.version; 
	
			//introductoryText property
			if (!dr.IsNull(introductoryTextField))
			{ 
				if (spObj.introductoryText != (string)dr[introductoryTextField]) 
				{ 
					spParam._IntroductoryText = spObj.introductoryText; 
				} 
			} 
			else if (spObj.introductoryText != string.Empty)
			{ 
				spParam._IntroductoryText = spObj.introductoryText; 
			} 
	
			//isRequireAlternateLanguage property
			if (!dr.IsNull(isRequireAlternateLanguageField))
			{ 
				if (spObj.isRequireAlternateLanguage != (bool)dr[isRequireAlternateLanguageField]) 
				{ 
					spParam._IsRequireAlternateLanguage = spObj.isRequireAlternateLanguage; 
				} 
			} 
			else if (spObj.isRequireAlternateLanguage != false)
			{ 
				spParam._IsRequireAlternateLanguage = spObj.isRequireAlternateLanguage; 
			} 
	
		//defaultLanguageId property
			if (!dr.IsNull(defaultLanguageIdField))
			{ 
				if (spObj.defaultLanguageId != (Int32)dr[defaultLanguageIdField]) 
				{ 
					spParam._DefaultLanguageFK = spObj.defaultLanguageId; 
				} 
			} 
			else if (spObj.defaultLanguageId != Int32.MinValue)
			{ 
				spParam._DefaultLanguageFK = spObj.defaultLanguageId; 
			} 
	
			//alternateLanguageId property
			if (!dr.IsNull(alternateLanguageIdField))
			{ 
				if (spObj.alternateLanguageId != (Int32)dr[alternateLanguageIdField]) 
				{ 
					spParam._AlternateLanguageFK = spObj.alternateLanguageId; 
				} 
			} 
			else if (spObj.alternateLanguageId != Int32.MinValue)
			{ 
				spParam._AlternateLanguageFK = spObj.alternateLanguageId; 
			} 
	
			//numberOfMeals property
			if (!dr.IsNull(numberOfMealsField))
			{ 
				if (spObj.numberOfMeals != (Int32)dr[numberOfMealsField]) 
				{ 
					spParam._NumberOfMeals = spObj.numberOfMeals; 
				} 
			} 
			else if (spObj.numberOfMeals != Int32.MinValue)
			{ 
				spParam._NumberOfMeals = spObj.numberOfMeals; 
			} 
	
			//mealAuthorization property
			if (!dr.IsNull(mealAuthorizationField))
			{ 
				if (spObj.mealAuthorization != (string)dr[mealAuthorizationField]) 
				{ 
					spParam._MealAuthorization = spObj.mealAuthorization; 
				} 
			} 
			else if (spObj.mealAuthorization != string.Empty)
			{ 
				spParam._MealAuthorization = spObj.mealAuthorization; 
			} 
	
			//isSaturdayMeal property
			if (!dr.IsNull(isSaturdayMealField))
			{ 
				if (spObj.isSaturdayMeal != (bool)dr[isSaturdayMealField]) 
				{ 
					spParam._IsSaturdayMeal = spObj.isSaturdayMeal; 
				} 
			} 
			else if (spObj.isSaturdayMeal != false)
			{ 
				spParam._IsSaturdayMeal = spObj.isSaturdayMeal; 
			} 
	
			//isSundayMeal property
			if (!dr.IsNull(isSundayMealField))
			{ 
				if (spObj.isSundayMeal != (bool)dr[isSundayMealField]) 
				{ 
					spParam._IsSundayMeal = spObj.isSundayMeal; 
				} 
			} 
			else if (spObj.isSundayMeal != false)
			{ 
				spParam._IsSundayMeal = spObj.isSundayMeal; 
			} 
	
			//isHolidayMeal property
			if (!dr.IsNull(isHolidayMealField))
			{ 
				if (spObj.isHolidayMeal != (bool)dr[isHolidayMealField]) 
				{ 
					spParam._IsHolidayMeal = spObj.isHolidayMeal; 
				} 
			} 
			else if (spObj.isHolidayMeal != false)
			{ 
				spParam._IsHolidayMeal = spObj.isHolidayMeal; 
			} 
	
			//mealPrice property
			if (!dr.IsNull(mealPriceField))
			{ 
				if (spObj.mealPrice != (decimal)dr[mealPriceField]) 
				{ 
					spParam._MealPrice = spObj.mealPrice; 
				} 
			} 
			else if (spObj.mealPrice != Decimal.MinValue)
			{ 
				spParam._MealPrice = spObj.mealPrice; 
			} 
	
			//durationForMeal1 property
			if (!dr.IsNull(durationForMeal1Field))
			{ 
				if (spObj.durationForMeal1 != (Int32)dr[durationForMeal1Field]) 
				{ 
					spParam._DurationForMeal1 = spObj.durationForMeal1; 
				} 
			} 
			else if (spObj.durationForMeal1 != Int32.MinValue)
			{ 
				spParam._DurationForMeal1 = spObj.durationForMeal1; 
			} 
	
			//cutOffTimeForMeal1 property
			if (!dr.IsNull(cutOffTimeForMeal1Field))
			{ 
				if (spObj.cutOffTimeForMeal1 != (string)dr[cutOffTimeForMeal1Field]) 
				{ 
					spParam._CutOffTimeForMeal1 = spObj.cutOffTimeForMeal1; 
				} 
			} 
			else if (spObj.cutOffTimeForMeal1 != string.Empty)
			{ 
				spParam._CutOffTimeForMeal1 = spObj.cutOffTimeForMeal1; 
			} 
	
			//durationForMeal2 property
			if (!dr.IsNull(durationForMeal2Field))
			{ 
				if (spObj.durationForMeal2 != (Int32)dr[durationForMeal2Field]) 
				{ 
					spParam._DurationForMeal2 = spObj.durationForMeal2; 
				} 
			} 
			else if (spObj.durationForMeal2 != Int32.MinValue)
			{ 
				spParam._DurationForMeal2 = spObj.durationForMeal2; 
			} 
	
			//cutOffTimeForMeal2 property
			if (!dr.IsNull(cutOffTimeForMeal2Field))
			{ 
				if (spObj.cutOffTimeForMeal2 != (string)dr[cutOffTimeForMeal2Field]) 
				{ 
					spParam._CutOffTimeForMeal2 = spObj.cutOffTimeForMeal2; 
				} 
			} 
			else if (spObj.cutOffTimeForMeal2 != string.Empty)
			{ 
				spParam._CutOffTimeForMeal2 = spObj.cutOffTimeForMeal2; 
			} 
	
			//voluntarySignatureLine property
			if (!dr.IsNull(voluntarySignatureLineField))
			{ 
				if (spObj.voluntarySignatureLine != (string)dr[voluntarySignatureLineField]) 
				{ 
					spParam._VoluntarySignatureLine = spObj.voluntarySignatureLine; 
				} 
			} 
			else if (spObj.voluntarySignatureLine != string.Empty)
			{ 
				spParam._VoluntarySignatureLine = spObj.voluntarySignatureLine; 
			} 

			//directorSignatureLine property
			if (!dr.IsNull(directorSignatureLineField))
			{ 
				if (spObj.directorSignatureLine != (string)dr[directorSignatureLineField]) 
				{ 
					spParam._DirectorSignatureLine = spObj.directorSignatureLine; 
				} 
			} 
			else if (spObj.directorSignatureLine != string.Empty)
			{ 
				spParam._DirectorSignatureLine = spObj.directorSignatureLine; 
			} 

			//ValueAmount property
			if (!dr.IsNull(valueAmountField))
			{ 
				if (spObj.valueAmount != (decimal)dr[valueAmountField]) 
				{ 
					spParam._ValueAmount = spObj.valueAmount; 
				} 
			} 
			else if (spObj.valueAmount != decimal.MinValue)
			{ 
				spParam._ValueAmount = spObj.valueAmount; 
			} 

			//isVALetterHead property
			if (!dr.IsNull(isVALetterHeadField))
			{ 
				if (spObj.isVALetterHead != (bool)dr[isVALetterHeadField]) 
				{ 
					spParam._IsVALetterHead = spObj.isVALetterHead; 
				} 
			} 
			else if (spObj.isVALetterHead != false)
			{ 
				spParam._IsVALetterHead = spObj.isVALetterHead; 
			} 
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (spObj.id > 0)
			{
				spParams.spD_VtkVoluntaryStationParameters spParam = new spParams.spD_VtkVoluntaryStationParameters ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._InstitutionFK  = spObj.id;
				spParam._Ver = spObj.version; 
				spSProcs.spD_VtkVoluntaryStationParameters spSProc = new spSProcs.spD_VtkVoluntaryStationParameters();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("StationParameters", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + StationParametersMsSqlSrv.tableName + " WHERE InstitutionFK = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, StationParametersMsSqlSrv.tableName, "InstitutionFK");
		}
		
		#endregion
		
	}
}
