﻿
/*

			Class:              SupervisedProgramsMsSqlSrv

			Date Produced:      3/8/2002 1:13:32 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        3/7/2002 10:53:17 AM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.789.33698\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.789.33698

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkSupervisedPrograms
	/// </summary>
	public class SupervisedProgramsMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private SupervisedProgramsBase ssdObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkSupervisedPrograms)
		/// </summary>
		public static string tableName = "VtkSupervisedPrograms";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkSupervisedPrograms.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkSupervisedPrograms.ProgramFK database field
		/// </summary>
		public const string programIdField = "ProgramFK";
		
		/// <summary>
		/// Class field that maps to VtkSupervisedPrograms.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkSupervisedPrograms.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "ssdObj"></param>
		public SupervisedProgramsMsSqlSrv(SupervisedProgramsBase ssdObj)
		{
			Initialize(ssdObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "ssdObj"></param>
		private void Initialize(SupervisedProgramsBase ssdObj)
		{
			this.ssdObj = ssdObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = ssdObj.AppCon;
			this.databaseTableName = SupervisedProgramsMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = SupervisedProgramsMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(ssdObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create SupervisedPrograms instance. Invalid ID: " + ssdObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				ssdObj.id = (Int32)dr[idField];
			}
			else
			{
				ssdObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(programIdField))
			{
				ssdObj.programId = (Int32)dr[programIdField];
			}
			else
			{
				ssdObj.programId = Int32.MinValue;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				ssdObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				ssdObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				ssdObj.version = (Int32)dr[versionField];
			}
			else
			{
				ssdObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkSupervisedPrograms spParam = new spParams.spI_VtkSupervisedPrograms ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._ProgramFK = ssdObj.programId;
			spParam._InstitutionFK = ssdObj.institutionId;
			spParam._Ver = ssdObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkSupervisedPrograms spSProc = new spSProcs.spI_VtkSupervisedPrograms();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {ssdObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("SupervisedPrograms", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return ssdObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[SupervisedProgramsMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkSupervisedPrograms spParam = new spParams.spU_VtkSupervisedPrograms();
 
			if (ssdObj.IsChanged && (!ssdObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkSupervisedPrograms spSProc = new spSProcs.spU_VtkSupervisedPrograms(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("SupervisedPrograms", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (ssdObj.programId == Int32.MinValue && !dr.IsNull(programIdField))  {return true;} 
			else
			if (ssdObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (ssdObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkSupervisedPrograms spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  ssdObj.id; 
			spParam._ProgramFK =  ssdObj.programId; 
			spParam._InstitutionFK =  ssdObj.institutionId; 
			spParam._Ver =  ssdObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkSupervisedPrograms spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = ssdObj.id; 
			spParam._ProgramFK = ssdObj.programId; 
			spParam._InstitutionFK = ssdObj.institutionId; 
			spParam._Ver =  ssdObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (ssdObj.id > 0)
			{
				spParams.spD_VtkSupervisedPrograms spParam = new spParams.spD_VtkSupervisedPrograms ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = ssdObj.id;
				spParam._Ver = ssdObj.version; 
				spSProcs.spD_VtkSupervisedPrograms spSProc = new spSProcs.spD_VtkSupervisedPrograms();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("SupervisedPrograms", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + SupervisedProgramsMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, SupervisedProgramsMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
