﻿
/*

			Class:              UserRoleMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkUserRoles
	/// </summary>
	public class UserRoleMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private UserRoleBase usroleObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkUserRoles)
		/// </summary>
		public static string tableName = "VtkUserRoles";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkUserRoles.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkUserRoles.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkUserRoles.UserFK database field
		/// </summary>
		public const string userIdField = "UserFK";
		
		/// <summary>
		/// Class field that maps to VtkUserRoles.RoleFK database field
		/// </summary>
		public const string roleIdField = "RoleFK";
		
		/// <summary>
		/// Class field that maps to VtkUserRoles.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "usroleObj"></param>
		public UserRoleMsSqlSrv(UserRoleBase usroleObj)
		{
			Initialize(usroleObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "usroleObj"></param>
		private void Initialize(UserRoleBase usroleObj)
		{
			this.usroleObj = usroleObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = usroleObj.AppCon;
			this.databaseTableName = UserRoleMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = UserRoleMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(usroleObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create UserRole instance. Invalid ID: " + usroleObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				usroleObj.id = (Int32)dr[idField];
			}
			else
			{
				usroleObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				usroleObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				usroleObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(userIdField))
			{
				usroleObj.userId = (Int32)dr[userIdField];
			}
			else
			{
				usroleObj.userId = Int32.MinValue;
			}
		
			if (!dr.IsNull(roleIdField))
			{
				usroleObj.roleId = (Int32)dr[roleIdField];
			}
			else
			{
				usroleObj.roleId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				usroleObj.version = (Int32)dr[versionField];
			}
			else
			{
				usroleObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkUserRoles spParam = new spParams.spI_VtkUserRoles ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._InstitutionFK = usroleObj.institutionId;
			spParam._UserFK = usroleObj.userId;
			spParam._RoleFK = usroleObj.roleId;
			spParam._Ver = usroleObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkUserRoles spSProc = new spSProcs.spI_VtkUserRoles();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {usroleObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("UserRole", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return usroleObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[UserRoleMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkUserRoles spParam = new spParams.spU_VtkUserRoles();
 
			if (usroleObj.IsChanged && (!usroleObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkUserRoles spSProc = new spSProcs.spU_VtkUserRoles(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("UserRole", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (usroleObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (usroleObj.userId == Int32.MinValue && !dr.IsNull(userIdField))  {return true;} 
			else
			if (usroleObj.roleId == Int32.MinValue && !dr.IsNull(roleIdField))  {return true;} 
			else
			if (usroleObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkUserRoles spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  usroleObj.id; 
			spParam._InstitutionFK =  usroleObj.institutionId; 
			spParam._UserFK =  usroleObj.userId; 
			spParam._RoleFK =  usroleObj.roleId; 
			spParam._Ver =  usroleObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkUserRoles spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = usroleObj.id; 
			spParam._InstitutionFK = usroleObj.institutionId; 
			spParam._UserFK = usroleObj.userId; 
			spParam._RoleFK = usroleObj.roleId; 
			spParam._Ver =  usroleObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (usroleObj.id > 0)
			{
				spParams.spD_VtkUserRoles spParam = new spParams.spD_VtkUserRoles ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = usroleObj.id;
				spParam._Ver = usroleObj.version; 
				spSProcs.spD_VtkUserRoles spSProc = new spSProcs.spD_VtkUserRoles();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("UserRole", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + UserRoleMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, UserRoleMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
