﻿
/*

			Class:              ServiceTypeBase

			Date Produced:      3/8/2002 1:13:32 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        3/7/2002 10:53:17 AM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.789.33698\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.789.33698

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVoluntaryServiceTypes
	/// </summary>
	public abstract class ServiceTypeBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Type database field
		/// </summary>
		protected internal string  type;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Description database field
		/// </summary>
		protected internal string  description;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceTypes.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to type class field
		/// </summary>
		public string  Type
		{
			get { return type;}    set {isChanged = true; type = value;}
		}
		
		/// <summary>
		/// Property that maps to description class field
		/// </summary>
		public string  Description
		{
			get { return description;}    set {isChanged = true; description = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected ServiceTypeBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryServiceTypes entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected ServiceTypeBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVoluntaryServiceTypes</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVoluntaryServiceTypes definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected ServiceTypeBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[ServiceTypeMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			type = string.Empty;
			description = string.Empty;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new ServiceTypeMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of ServiceType.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for Type property values
		/// </summary>
		/// <param name="value">Current instance value of Type</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateType(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceType";
			ret.PropertyName = "Type";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Type' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 20))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Type' length (" + value.Length +  ") is greater than 20 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Description property values
		/// </summary>
		/// <param name="value">Current instance value of Description</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateDescription(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "ServiceType";
			ret.PropertyName = "Description";
			
			// quit if field allows nulls and currently set to default
			if (value == string.Empty) return ret;
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1000))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Description' length (" + value.Length +  ") is greater than 1000 characters.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVoluntaryServiceTypes.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVoluntaryServiceTypes table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVoluntaryServiceTypes entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return ServiceTypeMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "Type")  {return type.ToString();}
			if (prop == "Description")  {return description.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
