﻿
/*

			Class:              ProgramsBase

			Date Produced:      3/8/2002 1:13:32 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        3/7/2002 10:53:17 AM
			Revision:           602

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.789.33698\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.789.33698

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text;
using System.Text.RegularExpressions;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVoluntaryPrograms
	/// </summary>
	public abstract class ProgramsBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Id database field
		/// </summary>
		protected internal Int32  id;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Code database field
		/// </summary>
		protected internal Int32  code;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.ProgramName database field
		/// </summary>
		protected internal string  programName;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Scope database field
		/// </summary>
		protected internal string  scope;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.InstitutionFK database field
		/// </summary>
		protected internal Int32  institutionId;
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		/// <summary>
		/// Class field that indicates whether the Code passed for Add or Update already exists
		/// </summary>
		protected internal bool isCodeExisting;

		/// <summary>
		/// Class field that indicates whether the ProgramName passed for Add or Update already exists
		/// </summary>
		protected internal bool isProgramNameExisting;
		#endregion
		
		#region Section: Property Definitions		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>
		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to code class field
		/// </summary>
		public Int32  Code
		{
			get { return code;}    set {isChanged = true; code = value;}
		}
		
		/// <summary>
		/// Property that maps to programName class field
		/// </summary>
		public string  ProgramName
		{
			get { return programName;}    set {isChanged = true; programName = value;}
		}
		
		/// <summary>
		/// Property that maps to scope class field
		/// </summary>
		public string  Scope
		{
			get { return scope;}    set {isChanged = true; scope = value;}
		}
		
		/// <summary>
		/// Property that maps to institutionId class field
		/// </summary>
		public Int32  InstitutionId
		{
			get { return institutionId;}    set {isChanged = true; institutionId = value;}
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		/// <summary>
		/// Property that maps to isCodeExisting class field
		/// </summary>
		public bool IsCodeExisting
		{
			get{ return isCodeExisting; }		set {isCodeExisting = value; }
		}

		/// <summary>
		/// Property that maps to isProgramNameExisting class field
		/// </summary>
		public bool IsProgramNameExisting
		{
			get{ return isProgramNameExisting; } set {isProgramNameExisting = value; }
		}
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected ProgramsBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkVoluntaryPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		protected ProgramsBase(int id, ApplicationConnection appCon) : base(appCon)
		{
			FillData(id);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVoluntaryPrograms</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVoluntaryPrograms definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected ProgramsBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			FillCommon((int)dr[ProgramsMsSqlSrv.idField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			FillCommon(0);
			isNew = true;
		
			//set default fields values for new record
			code = Int32.MinValue;
			programName = string.Empty;
			scope = string.Empty;
			institutionId = Int32.MinValue;
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		private void FillData(int id)
		{
			FillCommon(id);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		private void FillCommon(int id)
		{
			this.id       = id;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
			this.dataSrv = new ProgramsMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of Programs.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for Code property values
		/// </summary>
		/// <param name="value" type="System.Int32">Current instance value of Code</param>
		/// <param name="Scope" type="System.String"/>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateCode(Int32 value, String Scope)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Programs";
			ret.PropertyName = "Code";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Code' is a required. No value is entered.";
			}
			
			if((ret.Status == si.Pass) && 
				 (Scope == "N") && 
				 (value < 001 || value > 99))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Code' for National must be between 001 and 099";
			}
			else if((ret.Status == si.Pass) && 
				      (Scope == "L") && 
				      (value < 100 || value > 1000))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Code' for Local must be between 100 and 999";
			}
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for ProgramName property values
		/// </summary>
		/// <param name="value">Current instance value of ProgramName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateProgramName(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Programs";
			ret.PropertyName = "ProgramName";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'ProgramName' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 30))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'ProgramName' length (" + value.Length +  ") is greater than 30 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for Scope property values
		/// </summary>
		/// <param name="value">Current instance value of Scope</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateScope(string value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Programs";
			ret.PropertyName = "Scope";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == string.Empty))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Scope' is a required. No value is entered.";
			}
			
			// max length check
			if ((ret.Status == si.Pass) && (value.Length > 1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'Scope' length (" + value.Length +  ") is greater than 1 characters.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for InstitutionId property values
		/// </summary>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "Programs";
			ret.PropertyName = "InstitutionId";
			
			// quit if field allows nulls and currently set to default
			if (value == Int32.MinValue) return ret;
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ServicesBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'InstitutionId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVoluntaryPrograms.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVoluntaryPrograms table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="idValue">Primary key value for VtkVoluntaryPrograms entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public static bool DoesExist(int idValue)
		{
			return ProgramsMsSqlSrv.DoesExist(idValue);
		}
		#endif
		
		/// <summary>
		/// Returns the default external string value for the current instance
		/// </summary>
		public override string ToString()
		{
			return id.ToString();
		}
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "ID")  {return id.ToString();}
			if (prop == "Code")  {return code.ToString();}
			if (prop == "ProgramName")  {return programName.ToString();}
			if (prop == "Scope")  {return scope.ToString();}
			if (prop == "InstitutionId")  {return institutionId.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return this.ToString();
		}
		
		#endregion
		
	}
}
