﻿
/*

			Class:              ProgramsMsSqlSrv

			Date Produced:      3/14/2002 12:29:46 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVoluntaryPrograms
	/// </summary>
	public class ProgramsMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ProgramsBase vprgObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVoluntaryPrograms)
		/// </summary>
		public static string tableName = "VtkVoluntaryPrograms";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Code database field
		/// </summary>
		public const string codeField = "Code";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.ProgramName database field
		/// </summary>
		public const string programNameField = "ProgramName";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Scope database field
		/// </summary>
		public const string scopeField = "Scope";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryPrograms.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "vprgObj"></param>
		public ProgramsMsSqlSrv(ProgramsBase vprgObj)
		{
			Initialize(vprgObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "vprgObj"></param>
		private void Initialize(ProgramsBase vprgObj)
		{
			this.vprgObj = vprgObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = vprgObj.AppCon;
			this.databaseTableName = ProgramsMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ProgramsMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(vprgObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Programs instance. Invalid ID: " + vprgObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				vprgObj.id = (Int32)dr[idField];
			}
			else
			{
				vprgObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(codeField))
			{
				vprgObj.code = (Int32)dr[codeField];
			}
			else
			{
				vprgObj.code = Int32.MinValue;
			}
		
			if (!dr.IsNull(programNameField))
			{
				vprgObj.programName = (string)dr[programNameField];
			}
			else
			{
				vprgObj.programName = string.Empty;
			}
		
			if (!dr.IsNull(scopeField))
			{
				vprgObj.scope = (string)dr[scopeField];
			}
			else
			{
				vprgObj.scope = string.Empty;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				vprgObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				vprgObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				vprgObj.version = (Int32)dr[versionField];
			}
			else
			{
				vprgObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVoluntaryPrograms spParam = new spParams.spI_VtkVoluntaryPrograms ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._Code = vprgObj.code;
			spParam._ProgramName = vprgObj.programName;
			spParam._Scope = vprgObj.scope;
			spParam._Ver = vprgObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (vprgObj.institutionId != Int32.MinValue) {spParam._InstitutionFK = vprgObj.institutionId;}
	
			spSProcs.spI_VtkVoluntaryPrograms spSProc = new spSProcs.spI_VtkVoluntaryPrograms();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {vprgObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Programs", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return vprgObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ProgramsMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVoluntaryPrograms spParam = new spParams.spU_VtkVoluntaryPrograms();
 
			if (vprgObj.IsChanged && (!vprgObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVoluntaryPrograms spSProc = new spSProcs.spU_VtkVoluntaryPrograms(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Programs", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (vprgObj.code == Int32.MinValue && !dr.IsNull(codeField))  {return true;} 
			else
			if (vprgObj.programName == string.Empty && !dr.IsNull(programNameField))  {return true;} 
			else
			if (vprgObj.scope == string.Empty && !dr.IsNull(scopeField))  {return true;} 
			else
			if (vprgObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (vprgObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVoluntaryPrograms spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  vprgObj.id; 
			spParam._Code =  vprgObj.code; 
			spParam._ProgramName =  vprgObj.programName; 
			spParam._Scope =  vprgObj.scope; 
			spParam._Ver =  vprgObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (vprgObj.institutionId != Int32.MinValue)  {spParam._InstitutionFK = vprgObj.institutionId;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVoluntaryPrograms spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = vprgObj.id; 
			spParam._Code = vprgObj.code; 
			spParam._ProgramName = vprgObj.programName; 
			spParam._Scope = vprgObj.scope; 
			spParam._Ver =  vprgObj.version; 
	
			//institutionId property
			if (!dr.IsNull(institutionIdField))
			{ 
				if (vprgObj.institutionId != (Int32)dr[institutionIdField]) 
				{ 
					spParam._InstitutionFK = vprgObj.institutionId; 
				} 
			} 
			else if (vprgObj.institutionId != Int32.MinValue)
			{ 
				spParam._InstitutionFK = vprgObj.institutionId; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (vprgObj.id > 0)
			{
				spParams.spD_VtkVoluntaryPrograms spParam = new spParams.spD_VtkVoluntaryPrograms ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = vprgObj.id;
				spParam._Ver = vprgObj.version; 
				spSProcs.spD_VtkVoluntaryPrograms spSProc = new spSProcs.spD_VtkVoluntaryPrograms();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Programs", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ProgramsMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ProgramsMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
