﻿
/*

			Class:              ServiceStaffMsSqlSrv

			Date Produced:      3/14/2002 12:41:51 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley & Sachy Kulkarni
			LastUpdated:        3/14/2002 12:18:09 PM
			Revision:           619

			SQL Server Version: 08.00.0194
			Server:             ISF-LANGLEYM
			Database:           [VSS_Current]
			Code generated in:  D:\Olymars_test\1.0.801.27617\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.801.27617

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVoluntaryServiceStaff
	/// </summary>
	public class ServiceStaffMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ServiceStaffBase vssObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVoluntaryServiceStaff)
		/// </summary>
		public static string tableName = "VtkVoluntaryServiceStaff";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.UserFK database field
		/// </summary>
		public const string userIdField = "UserFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.InstitutionFK database field
		/// </summary>
		public const string institutionIdField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.ReportOrder database field
		/// </summary>
		public const string reportOrderField = "ReportOrder";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.IsChief database field
		/// </summary>
		public const string isChiefField = "IsChief";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.IsVISNLiaison database field
		/// </summary>
		public const string isVISNLiaisonField = "IsVISNLiaison";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.ProgramFK database field
		/// </summary>
		public const string programIdField = "ProgramFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Comment database field
		/// </summary>
		public const string commentField = "Comment";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServiceStaff.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "vssObj"></param>
		public ServiceStaffMsSqlSrv(ServiceStaffBase vssObj)
		{
			Initialize(vssObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "vssObj"></param>
		private void Initialize(ServiceStaffBase vssObj)
		{
			this.vssObj = vssObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = vssObj.AppCon;
			this.databaseTableName = ServiceStaffMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ServiceStaffMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(vssObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
			
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create ServiceStaff instance. Invalid ID: " + vssObj.ID);
			}			
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				vssObj.id = (Int32)dr[idField];
			}
			else
			{
				vssObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(userIdField))
			{
				vssObj.userId = (Int32)dr[userIdField];
			}
			else
			{
				vssObj.userId = Int32.MinValue;
			}
		
			if (!dr.IsNull(institutionIdField))
			{
				vssObj.institutionId = (Int32)dr[institutionIdField];
			}
			else
			{
				vssObj.institutionId = Int32.MinValue;
			}
		
			if (!dr.IsNull(reportOrderField))
			{
				vssObj.reportOrder = (Int32)dr[reportOrderField];
			}
			else
			{
				vssObj.reportOrder = Int32.MinValue;
			}
		
			if (!dr.IsNull(isChiefField))
			{
				vssObj.isChief = (bool)dr[isChiefField];
			}
			else
			{
				vssObj.isChief = false;
			}
		
			if (!dr.IsNull(isVISNLiaisonField))
			{
				vssObj.isVISNLiaison = (bool)dr[isVISNLiaisonField];
			}
			else
			{
				vssObj.isVISNLiaison = false;
			}
		
			if (!dr.IsNull(programIdField))
			{
				vssObj.programId = (Int32)dr[programIdField];
			}
			else
			{
				vssObj.programId = Int32.MinValue;
			}
		
			if (!dr.IsNull(commentField))
			{
				vssObj.comment = (string)dr[commentField];
			}
			else
			{
				vssObj.comment = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				vssObj.version = (Int32)dr[versionField];
			}
			else
			{
				vssObj.version = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVoluntaryServiceStaff spParam = new spParams.spI_VtkVoluntaryServiceStaff ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._UserFK = vssObj.userId;
			spParam._InstitutionFK = vssObj.institutionId;
			spParam._ReportOrder = vssObj.reportOrder;
			spParam._Ver = vssObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (vssObj.isChief == false) {spParam._IsChief = (0);} // set to default Value 
			else {spParam._IsChief = vssObj.isChief;}
			if (vssObj.isVISNLiaison == false) {spParam._IsVISNLiaison = (0);} // set to default Value 
			else {spParam._IsVISNLiaison = vssObj.isVISNLiaison;}
			if (vssObj.programId != Int32.MinValue) {spParam._ProgramFK = vssObj.programId;}
			if (vssObj.comment != string.Empty) {spParam._Comment = vssObj.comment;}
	
			spSProcs.spI_VtkVoluntaryServiceStaff spSProc = new spSProcs.spI_VtkVoluntaryServiceStaff();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {vssObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("ServiceStaff", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return vssObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ServiceStaffMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVoluntaryServiceStaff spParam = new spParams.spU_VtkVoluntaryServiceStaff();
 
			if (vssObj.IsChanged && (!vssObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVoluntaryServiceStaff spSProc = new spSProcs.spU_VtkVoluntaryServiceStaff(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("ServiceStaff", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (vssObj.userId == Int32.MinValue && !dr.IsNull(userIdField))  {return true;} 
			else
			if (vssObj.institutionId == Int32.MinValue && !dr.IsNull(institutionIdField))  {return true;} 
			else
			if (vssObj.reportOrder == Int32.MinValue && !dr.IsNull(reportOrderField))  {return true;} 
			else
			if (vssObj.isChief == false && !dr.IsNull(isChiefField))  {return true;} 
			else
			if (vssObj.isVISNLiaison == false && !dr.IsNull(isVISNLiaisonField))  {return true;} 
			else
			if (vssObj.programId == Int32.MinValue && !dr.IsNull(programIdField))  {return true;} 
			else
			if (vssObj.comment == string.Empty && !dr.IsNull(commentField))  {return true;} 
			else
			if (vssObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVoluntaryServiceStaff spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  vssObj.id; 
			spParam._UserFK =  vssObj.userId; 
			spParam._InstitutionFK =  vssObj.institutionId; 
			spParam._ReportOrder =  vssObj.reportOrder; 
			spParam._Ver =  vssObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (vssObj.isChief != false)  {spParam._IsChief = vssObj.isChief;}
			if (vssObj.isVISNLiaison != false)  {spParam._IsVISNLiaison = vssObj.isVISNLiaison;}
			if (vssObj.programId != Int32.MinValue)  {spParam._ProgramFK = vssObj.programId;}
			if (vssObj.comment != string.Empty)  {spParam._Comment = vssObj.comment;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVoluntaryServiceStaff spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = vssObj.id; 
			spParam._UserFK = vssObj.userId; 
			spParam._InstitutionFK = vssObj.institutionId; 
			spParam._ReportOrder = vssObj.reportOrder; 
			spParam._Ver =  vssObj.version; 
	
			//isChief property
			if (!dr.IsNull(isChiefField))
			{ 
				if (vssObj.isChief != (bool)dr[isChiefField]) 
				{ 
					spParam._IsChief = vssObj.isChief; 
				} 
			} 
			else if (vssObj.isChief != false)
			{ 
				spParam._IsChief = vssObj.isChief; 
			} 
	
			//isVISNLiaison property
			if (!dr.IsNull(isVISNLiaisonField))
			{ 
				if (vssObj.isVISNLiaison != (bool)dr[isVISNLiaisonField]) 
				{ 
					spParam._IsVISNLiaison = vssObj.isVISNLiaison; 
				} 
			} 
			else if (vssObj.isVISNLiaison != false)
			{ 
				spParam._IsVISNLiaison = vssObj.isVISNLiaison; 
			} 
	
			//programId property
			if (!dr.IsNull(programIdField))
			{ 
				if (vssObj.programId != (Int32)dr[programIdField]) 
				{ 
					spParam._ProgramFK = vssObj.programId; 
				} 
			} 
			else if (vssObj.programId != Int32.MinValue)
			{ 
				spParam._ProgramFK = vssObj.programId; 
			} 
	
			//comment property
			if (!dr.IsNull(commentField))
			{ 
				if (vssObj.comment != (string)dr[commentField]) 
				{ 
					spParam._Comment = vssObj.comment; 
				} 
			} 
			else if (vssObj.comment != string.Empty)
			{ 
				spParam._Comment = vssObj.comment; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (vssObj.id > 0)
			{
				spParams.spD_VtkVoluntaryServiceStaff spParam = new spParams.spD_VtkVoluntaryServiceStaff ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = vssObj.id;
				spParam._Ver = vssObj.version; 
				spSProcs.spD_VtkVoluntaryServiceStaff spSProc = new spSProcs.spD_VtkVoluntaryServiceStaff();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("ServiceStaff", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ServiceStaffMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ServiceStaffMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
