﻿
/*

			Class:              ServicesMsSqlSrv

			Date Produced:      4/24/2002 1:04:19 PM
			Responsible Team:   VistA Migration
			Developer(s):       Pascal Belaud
			LastUpdated:        4/23/2002 2:50:47 PM
			Revision:           620

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Development]
			Code generated in:  D:\Olymars_test\1.0.842.2440\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.842.2440

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVoluntaryServices
	/// </summary>
	public class ServicesMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private ServicesBase vsrvObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVoluntaryServices)
		/// </summary>
		public static string tableName = "VtkVoluntaryServices";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.InstitutionFK database field
		/// </summary>
		public const string idField = "InstitutionFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.ServiceTitle database field
		/// </summary>
		public const string serviceTitleField = "ServiceTitle";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.MailStop database field
		/// </summary>
		public const string mailStopField = "MailStop";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.TypeFK database field
		/// </summary>
		public const string typeIdField = "TypeFK";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.IsOwnVAVSCommittee database field
		/// </summary>
		public const string isOwnVAVSCommitteeField = "IsOwnVAVSCommittee";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.PrimaryPhone database field
		/// </summary>
		public const string primaryPhoneField = "PrimaryPhone";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.SecondaryPhone database field
		/// </summary>
		public const string secondaryPhoneField = "SecondaryPhone";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.FaxNumber database field
		/// </summary>
		public const string faxNumberField = "FaxNumber";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.OperatingCosts database field
		/// </summary>
		public const string operatingCostsField = "OperatingCosts";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.StaffCosts database field
		/// </summary>
		public const string staffCostsField = "StaffCosts";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.LastUpdated database field
		/// </summary>
		public const string lastUpdatedField = "LastUpdated";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		/// <summary>
		/// Class field that maps to VtkVoluntaryServices.ChiefManager database field
		/// </summary>
		public const string chiefManagerField = "ChiefManager";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "vsrvObj"></param>
		public ServicesMsSqlSrv(ServicesBase vsrvObj)
		{
			Initialize(vsrvObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "vsrvObj"></param>
		private void Initialize(ServicesBase vsrvObj)
		{
			this.vsrvObj = vsrvObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = vsrvObj.AppCon;
			this.databaseTableName = ServicesMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = ServicesMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(vsrvObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Services instance. Invalid ID: " + vsrvObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				vsrvObj.id = (Int32)dr[idField];
			}
			else
			{
				vsrvObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(serviceTitleField))
			{
				vsrvObj.serviceTitle = (string)dr[serviceTitleField];
			}
			else
			{
				vsrvObj.serviceTitle = string.Empty;
			}
		
			if (!dr.IsNull(mailStopField))
			{
				vsrvObj.mailStop = (string)dr[mailStopField];
			}
			else
			{
				vsrvObj.mailStop = string.Empty;
			}
		
			if (!dr.IsNull(typeIdField))
			{
				vsrvObj.typeId = (Int32)dr[typeIdField];
			}
			else
			{
				vsrvObj.typeId = Int32.MinValue;
			}
		
			if (!dr.IsNull(isOwnVAVSCommitteeField))
			{
				vsrvObj.isOwnVAVSCommittee = (bool)dr[isOwnVAVSCommitteeField];
			}
			else
			{
				vsrvObj.isOwnVAVSCommittee = false;
			}
		
			if (!dr.IsNull(primaryPhoneField))
			{
				vsrvObj.primaryPhone = (string)dr[primaryPhoneField];
			}
			else
			{
				vsrvObj.primaryPhone = string.Empty;
			}
		
			if (!dr.IsNull(secondaryPhoneField))
			{
				vsrvObj.secondaryPhone = (string)dr[secondaryPhoneField];
			}
			else
			{
				vsrvObj.secondaryPhone = string.Empty;
			}
		
			if (!dr.IsNull(faxNumberField))
			{
				vsrvObj.faxNumber = (string)dr[faxNumberField];
			}
			else
			{
				vsrvObj.faxNumber = string.Empty;
			}
		
			if (!dr.IsNull(operatingCostsField))
			{
				vsrvObj.operatingCosts = (decimal)dr[operatingCostsField];
			}
			else
			{
				vsrvObj.operatingCosts = Decimal.MinValue;
			}
		
			if (!dr.IsNull(staffCostsField))
			{
				vsrvObj.staffCosts = (decimal)dr[staffCostsField];
			}
			else
			{
				vsrvObj.staffCosts = Decimal.MinValue;
			}
		
			if (!dr.IsNull(lastUpdatedField))
			{
				vsrvObj.lastUpdated = (DateTime)dr[lastUpdatedField];
			}
			else
			{
				vsrvObj.lastUpdated = DateTime.MinValue;
			}
		
			if (!dr.IsNull(versionField))
			{
				vsrvObj.version = (Int32)dr[versionField];
			}
			else
			{
				vsrvObj.version = Int32.MinValue;
			}
		
			if (!dr.IsNull(chiefManagerField))
			{
				vsrvObj.chiefManager = (string)dr[chiefManagerField];
			}
			else
			{
				vsrvObj.chiefManager = string.Empty;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVoluntaryServices spParam = new spParams.spI_VtkVoluntaryServices ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._ServiceTitle = vsrvObj.serviceTitle;
			spParam._Ver = vsrvObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (vsrvObj.mailStop != string.Empty) {spParam._MailStop = vsrvObj.mailStop;}
			if (vsrvObj.typeId != Int32.MinValue) {spParam._TypeFK = vsrvObj.typeId;}
			if (vsrvObj.isOwnVAVSCommittee != false) {spParam._IsOwnVAVSCommittee = vsrvObj.isOwnVAVSCommittee;}
			if (vsrvObj.primaryPhone != string.Empty) {spParam._PrimaryPhone = vsrvObj.primaryPhone;}
			if (vsrvObj.secondaryPhone != string.Empty) {spParam._SecondaryPhone = vsrvObj.secondaryPhone;}
			if (vsrvObj.faxNumber != string.Empty) {spParam._FaxNumber = vsrvObj.faxNumber;}
			if (vsrvObj.operatingCosts != Decimal.MinValue) {spParam._OperatingCosts = vsrvObj.operatingCosts;}
			if (vsrvObj.staffCosts != Decimal.MinValue) {spParam._StaffCosts = vsrvObj.staffCosts;}
			if (vsrvObj.lastUpdated == DateTime.MinValue) {spParam._LastUpdated = (DateTime.Now);} // set to default Value 
			else {spParam._LastUpdated = vsrvObj.lastUpdated;}
			if (vsrvObj.chiefManager != string.Empty) {spParam._ChiefManager = vsrvObj.chiefManager;}
	
			spSProcs.spI_VtkVoluntaryServices spSProc = new spSProcs.spI_VtkVoluntaryServices();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._InstitutionFK != null) {vsrvObj.id = (Int32)spParam._InstitutionFK;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Services", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return vsrvObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[ServicesMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVoluntaryServices spParam = new spParams.spU_VtkVoluntaryServices();
 
			if (vsrvObj.IsChanged && (!vsrvObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVoluntaryServices spSProc = new spSProcs.spU_VtkVoluntaryServices(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Services", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (vsrvObj.serviceTitle == string.Empty && !dr.IsNull(serviceTitleField))  {return true;} 
			else
			if (vsrvObj.mailStop == string.Empty && !dr.IsNull(mailStopField))  {return true;} 
			else
			if (vsrvObj.typeId == Int32.MinValue && !dr.IsNull(typeIdField))  {return true;} 
			else
			if (vsrvObj.isOwnVAVSCommittee == false && !dr.IsNull(isOwnVAVSCommitteeField))  {return true;} 
			else
			if (vsrvObj.primaryPhone == string.Empty && !dr.IsNull(primaryPhoneField))  {return true;} 
			else
			if (vsrvObj.secondaryPhone == string.Empty && !dr.IsNull(secondaryPhoneField))  {return true;} 
			else
			if (vsrvObj.faxNumber == string.Empty && !dr.IsNull(faxNumberField))  {return true;} 
			else
			if (vsrvObj.operatingCosts == Decimal.MinValue && !dr.IsNull(operatingCostsField))  {return true;} 
			else
			if (vsrvObj.staffCosts == Decimal.MinValue && !dr.IsNull(staffCostsField))  {return true;} 
			else
			if (vsrvObj.lastUpdated == DateTime.MinValue && !dr.IsNull(lastUpdatedField))  {return true;} 
			else
			if (vsrvObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			if (vsrvObj.chiefManager == string.Empty && !dr.IsNull(chiefManagerField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVoluntaryServices spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._InstitutionFK =  vsrvObj.id; 
			spParam._ServiceTitle =  vsrvObj.serviceTitle; 
			spParam._Ver =  vsrvObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (vsrvObj.mailStop != string.Empty)  {spParam._MailStop = vsrvObj.mailStop;}
			if (vsrvObj.typeId != Int32.MinValue)  {spParam._TypeFK = vsrvObj.typeId;}
			if (vsrvObj.isOwnVAVSCommittee != false)  {spParam._IsOwnVAVSCommittee = vsrvObj.isOwnVAVSCommittee;}
			if (vsrvObj.primaryPhone != string.Empty)  {spParam._PrimaryPhone = vsrvObj.primaryPhone;}
			if (vsrvObj.secondaryPhone != string.Empty)  {spParam._SecondaryPhone = vsrvObj.secondaryPhone;}
			if (vsrvObj.faxNumber != string.Empty)  {spParam._FaxNumber = vsrvObj.faxNumber;}
			if (vsrvObj.operatingCosts != Decimal.MinValue)  {spParam._OperatingCosts = vsrvObj.operatingCosts;}
			if (vsrvObj.staffCosts != Decimal.MinValue)  {spParam._StaffCosts = vsrvObj.staffCosts;}
			if (vsrvObj.lastUpdated != DateTime.MinValue)  {spParam._LastUpdated = vsrvObj.lastUpdated;}
			if (vsrvObj.chiefManager != string.Empty)  {spParam._ChiefManager = vsrvObj.chiefManager;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVoluntaryServices spParam, DataRow dr)
		{
			//required or bool properties
			spParam._InstitutionFK = vsrvObj.id; 
			spParam._ServiceTitle = vsrvObj.serviceTitle; 
			spParam._Ver =  vsrvObj.version; 
	
			//mailStop property
			if (!dr.IsNull(mailStopField))
			{ 
				if (vsrvObj.mailStop != (string)dr[mailStopField]) 
				{ 
					spParam._MailStop = vsrvObj.mailStop; 
				} 
			} 
			else if (vsrvObj.mailStop != string.Empty)
			{ 
				spParam._MailStop = vsrvObj.mailStop; 
			} 
	
			//typeId property
			if (!dr.IsNull(typeIdField))
			{ 
				if (vsrvObj.typeId != (Int32)dr[typeIdField]) 
				{ 
					spParam._TypeFK = vsrvObj.typeId; 
				} 
			} 
			else if (vsrvObj.typeId != Int32.MinValue)
			{ 
				spParam._TypeFK = vsrvObj.typeId; 
			} 
	
			//isOwnVAVSCommittee property
			if (!dr.IsNull(isOwnVAVSCommitteeField))
			{ 
				if (vsrvObj.isOwnVAVSCommittee != (bool)dr[isOwnVAVSCommitteeField]) 
				{ 
					spParam._IsOwnVAVSCommittee = vsrvObj.isOwnVAVSCommittee; 
				} 
			} 
			else if (vsrvObj.isOwnVAVSCommittee != false)
			{ 
				spParam._IsOwnVAVSCommittee = vsrvObj.isOwnVAVSCommittee; 
			} 
	
			//primaryPhone property
			if (!dr.IsNull(primaryPhoneField))
			{ 
				if (vsrvObj.primaryPhone != (string)dr[primaryPhoneField]) 
				{ 
					spParam._PrimaryPhone = vsrvObj.primaryPhone; 
				} 
			} 
			else if (vsrvObj.primaryPhone != string.Empty)
			{ 
				spParam._PrimaryPhone = vsrvObj.primaryPhone; 
			} 
	
			//secondaryPhone property
			if (!dr.IsNull(secondaryPhoneField))
			{ 
				if (vsrvObj.secondaryPhone != (string)dr[secondaryPhoneField]) 
				{ 
					spParam._SecondaryPhone = vsrvObj.secondaryPhone; 
				} 
			} 
			else if (vsrvObj.secondaryPhone != string.Empty)
			{ 
				spParam._SecondaryPhone = vsrvObj.secondaryPhone; 
			} 
	
			//faxNumber property
			if (!dr.IsNull(faxNumberField))
			{ 
				if (vsrvObj.faxNumber != (string)dr[faxNumberField]) 
				{ 
					spParam._FaxNumber = vsrvObj.faxNumber; 
				} 
			} 
			else if (vsrvObj.faxNumber != string.Empty)
			{ 
				spParam._FaxNumber = vsrvObj.faxNumber; 
			} 
	
			//operatingCosts property
			if (!dr.IsNull(operatingCostsField))
			{ 
				if (vsrvObj.operatingCosts != (decimal)dr[operatingCostsField]) 
				{ 
					spParam._OperatingCosts = vsrvObj.operatingCosts; 
				} 
			} 
			else if (vsrvObj.operatingCosts != Decimal.MinValue)
			{ 
				spParam._OperatingCosts = vsrvObj.operatingCosts; 
			} 
	
			//staffCosts property
			if (!dr.IsNull(staffCostsField))
			{ 
				if (vsrvObj.staffCosts != (decimal)dr[staffCostsField]) 
				{ 
					spParam._StaffCosts = vsrvObj.staffCosts; 
				} 
			} 
			else if (vsrvObj.staffCosts != Decimal.MinValue)
			{ 
				spParam._StaffCosts = vsrvObj.staffCosts; 
			} 
	
			//lastUpdated property
			if (!dr.IsNull(lastUpdatedField))
			{ 
				if (vsrvObj.lastUpdated != (DateTime)dr[lastUpdatedField]) 
				{ 
					spParam._LastUpdated = vsrvObj.lastUpdated; 
				} 
			} 
			else if (vsrvObj.lastUpdated != DateTime.MinValue)
			{ 
				spParam._LastUpdated = vsrvObj.lastUpdated; 
			} 
	
			//chiefManager property
			if (!dr.IsNull(chiefManagerField))
			{ 
				if (vsrvObj.chiefManager != (string)dr[chiefManagerField]) 
				{ 
					spParam._ChiefManager = vsrvObj.chiefManager; 
				} 
			} 
			else if (vsrvObj.chiefManager != string.Empty)
			{ 
				spParam._ChiefManager = vsrvObj.chiefManager; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (vsrvObj.id > 0)
			{
				spParams.spD_VtkVoluntaryServices spParam = new spParams.spD_VtkVoluntaryServices ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._InstitutionFK  = vsrvObj.id;
				spParam._Ver = vsrvObj.version; 
				spSProcs.spD_VtkVoluntaryServices spSProc = new spSProcs.spD_VtkVoluntaryServices();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Services", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + ServicesMsSqlSrv.tableName + " WHERE InstitutionFK = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, ServicesMsSqlSrv.tableName, "InstitutionFK");
		}
		
		#endregion
		
	}
}
