﻿
/*

			Class:              VolunteerHoursBase

			Date Produced:      12/17/2001 1:06:30 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	/// Abstract class mapped to VtkVolunteerHours
	/// </summary>
	public abstract class VolunteerHoursBase : EntityBase
	{
		
		#region Section: Database Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.Id database field
		/// </summary>

		protected internal Int32  id; 
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.VolunteerFK database field
		/// </summary>
		protected internal Int32  volunteerId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.StationFK database field
		/// </summary>
		protected internal Int32  stationId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.OrganizationFK database field
		/// </summary>
		protected internal Int32  organizationId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.ScheduleFK database field
		/// </summary>
		protected internal Int32  scheduleId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.BenefitingServiceFK database field
		/// </summary>
		protected internal Int32  benefitingServiceId;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.DateWorked database field
		/// </summary>
		protected internal DateTime  dateWorked;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.HoursWorked database field
		/// </summary>
		protected internal Int32  hoursWorked;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.RecordStatus database field
		/// </summary>
		protected internal string  recordStatus;
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.Ver database field
		/// </summary>
		protected internal Int32  version;
		
		#endregion
		
		#region Section: Property Definitions
		
		
		/// <summary>
		/// Property that maps to id class field
		/// </summary>

		public Int32  ID
		{
			get { return id;}
		}
		
		/// <summary>
		/// Property that maps to volunteerId class field
		/// </summary>
		public Int32  VolunteerId
		{
			get { return volunteerId;}    set {isChanged = true; volunteerId = value;}
		}
		
		/// <summary>
		/// Property that maps to stationId class field
		/// </summary>
		public Int32  StationId
		{
			get { return stationId;}    set {isChanged = true; stationId = value;}
		}
		
		/// <summary>
		/// Property that maps to organizationId class field
		/// </summary>
		public Int32  OrganizationId
		{
			get { return organizationId;}    set {isChanged = true; organizationId = value;}
		}
		
		/// <summary>
		/// Property that maps to scheduleId class field
		/// </summary>
		public Int32  ScheduleId
		{
			get { return scheduleId;}    set {isChanged = true; scheduleId = value;}
		}
		
		/// <summary>
		/// Property that maps to benefitingServiceId class field
		/// </summary>
		public Int32  BenefitingServiceId
		{
			get { return benefitingServiceId;}    set {isChanged = true; benefitingServiceId = value;}
		}
		
		/// <summary>
		/// Property that maps to dateWorked class field
		/// </summary>
		public DateTime  DateWorked
		{
			get { return dateWorked;}    set {isChanged = true; dateWorked = value;}
		}
		
		/// <summary>
		/// Property that maps to hoursWorked class field
		/// </summary>
		public Int32  HoursWorked
		{
			get { return hoursWorked;}    set {isChanged = true; hoursWorked = value;}
		}
		
		/// <summary>
		/// Property that maps to recordStatus class field
		/// </summary>
		public string  RecordStatus
		{
			get { return recordStatus; }
			set { recordStatus = value; }
		}
		
		/// <summary>
		/// Property that maps to version class field
		/// </summary>
		public Int32  Version
		{
			get { return version;}
		}
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Basic constructor
		/// </summary>
		/// <Params>
		/// <param name="appCon" type="Vha.Vtk.Kernel.Common.ApplicationConnection"></param>
		/// </Params>
		protected VolunteerHoursBase(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <Params>
		/// <param name="VolunteerId">Int32</param>
		/// <param name="StationId">Int32</param>
		/// <param name="OrganizationId">Int32</param>
		/// <param name="ScheduleId">Int32</param>
		/// <param name="BenefitingServiceId">Int32</param>
		/// <param name="DateWorked">DateTime: Date volunteer worked</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// </Params>
		protected VolunteerHoursBase(	int VolunteerId,
										int StationId,
										int OrganizationId,
										int ScheduleId,
										int BenefitingServiceId,
										DateTime DateWorked, 
										ApplicationConnection appCon) : base(appCon)
		{
			FillData(	VolunteerId, 
						StationId,
						OrganizationId,
						ScheduleId,
						BenefitingServiceId,
						DateWorked);
		}
		/// <summary>
		/// Constructor used by collections Populate method.
		/// </summary>
		/// <param name="dr">DataRow for entry in VtkVolunteerHours</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		/// Column names in DataRow are the same as those in VtkVolunteerHours definition.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		/// This constructor may be obsolete as a result of changes made in vtk.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		protected VolunteerHoursBase(DataRow dr, ApplicationConnection appCon) : base(appCon)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			FillCommon(	(int)dr[VolunteerHoursMsSqlSrv.volunteerIdField],
						(int)dr[VolunteerHoursMsSqlSrv.scheduleIdField],
						(int)dr[VolunteerHoursMsSqlSrv.organizationIdField],
						(int)dr[VolunteerHoursMsSqlSrv.scheduleIdField],
						(int)dr[VolunteerHoursMsSqlSrv.benefitingServiceIdField],
						(DateTime)dr[VolunteerHoursMsSqlSrv.dateWorkedField]);
			Populate(dr);
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes new record
		/// </summary>
		protected void FillDataNew()
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.
			FillCommon(0, 0, 0, 0, 0, DateTime.Today);
			isNew = true;
		
			//set default fields values for new record
			volunteerId = Int32.MinValue;
			stationId = Int32.MinValue;
			organizationId = Int32.MinValue;
			scheduleId = Int32.MinValue;
			benefitingServiceId = Int32.MinValue;
			dateWorked = DateTime.MinValue;
			hoursWorked = Int32.MinValue;
			recordStatus = "E";
			version = 1;
		}
		
		/// <summary>
		/// Initializes existing record
		/// </summary>
		/// <Params>
		/// <param name="VolunteerId">Int32</param>
		/// <param name="StationId">Int32</param>
		/// <param name="OrganizationId">Int32</param>
		/// <param name="ScheduleId">Int32</param>
		/// <param name="BenefitingServiceId">Int32</param>
		/// <param name="DateWorked">DateTime: Date volunteer worked</param>
		/// </Params>
		private void FillData(	int VolunteerId,
								int StationId,
								int OrganizationId,
								int ScheduleId,
								int BenefitingServiceId,
								DateTime DateWorked)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			FillCommon(	VolunteerId, 
						StationId,
						OrganizationId,
						ScheduleId,
						BenefitingServiceId,
						DateWorked);
			Refresh();
		}
		
		/// <summary>
		/// Initializes field common to both new and existing records
		/// </summary>
		/// <Params>
		/// <param name="VolunteerId">Int32</param>
		/// <param name="StationId">Int32</param>
		/// <param name="OrganizationId">Int32</param>
		/// <param name="ScheduleId">Int32</param>
		/// <param name="BenefitingServiceId">Int32</param>
		/// <param name="DateWorked">DateTime: Date volunteer worked</param>
		/// </Params>
		private void FillCommon(int VolunteerId,
								int StationId,
								int OrganizationId,
								int ScheduleId,
								int BenefitingServiceId,
								DateTime DateWorked)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			this.volunteerId  = VolunteerId;
			this.stationId = StationId;
			this.organizationId = OrganizationId;
			this.scheduleId = ScheduleId;
			this.benefitingServiceId = BenefitingServiceId;
			this.dateWorked = DateWorked;
			allowDelete   = true;
			allowUnDelete = true;
			#if msSql
				this.dataSrv = new VolunteerHoursMsSqlSrv(this);
			#endif
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Releases the resources used by an instance of VolunteerHours.
		/// </summary>
		public override void Dispose()
		{
			dataSrv.Dispose();
		}
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Performs basic database-centric validation checks for VolunteerId property values
		/// </summary>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "VolunteerId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'VolunteerId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!VolunteerBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'VolunteerId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for StationId property values
		/// </summary>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "StationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'StationId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!StationParametersBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'StationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for OrganizationId property values
		/// </summary>
		/// <param name="value">Current instance value of OrganizationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "OrganizationId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'OrganizationId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!OrganizationBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'OrganizationId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for ScheduleId property values
		/// </summary>
		/// <param name="value">Current instance value of ScheduleId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateScheduleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "ScheduleId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'ScheduleId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ScheduleWorkdayBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'ScheduleId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for BenefitingServiceId property values
		/// </summary>
		/// <param name="value">Current instance value of BenefitingServiceId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateBenefitingServiceId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "BenefitingServiceId";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'BenefitingServiceId' is a required. No value is entered.";
			}
			
			// foreign key check
			if ((ret.Status == si.Pass) && (appCon.DoForeignKeyChecks))
			{
				if (!ServiceBase.DoesExist(value))
				{
					ret.Status = si.Fail;
					ret.ErrorText = "'BenefitingServiceId' is not valid. (" + value + ")";
				}
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for DateWorked property values
		/// </summary>
		/// <param name="value">Current instance value of DateWorked</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateDateWorked(DateTime value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "DateWorked";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == DateTime.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'DateWorked' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric validation checks for HoursWorked property values
		/// </summary>
		/// <param name="value">Current instance value of HoursWorked</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		protected static ReturnStatus ValidateHoursWorked(Int32 value)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "VolunteerHours";
			ret.PropertyName = "HoursWorked";
			
			// required field check
			if ((ret.Status == si.Pass) && (value == Int32.MinValue))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'HoursWorked' is a required. No value is entered.";
			}
			
			return ret;
		}
		
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves current instance
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>This method saves inserts, updates and deletes to VtkVolunteerHours.</description>
		/// </item>
		/// <item>
		/// <description>For inserts, updates field validation is performed.</description>
		/// </item>
		/// </list>
		/// </remarks>
		public override ReturnStatus Save()
		{
			if (isDeleted)
			{
				dataSrv.Delete();
				return returnStatus;
			}
			
			if (appCon.BypassValidation)
			{
				returnStatus.Clear();
			}
			else
			{
				returnStatus = Validate();
			}
			
			if (returnStatus.Status != si.Pass) throw new VhaValidationException(returnStatus.ErrorText, returnStatus.ClassName, returnStatus.PropertyName);
			
			if (isChanged)
			{
				if (isNew)
				{
					id    = dataSrv.Insert();
					isNew = false;
				}
				else
				{
					dataSrv.Update();
				}
			isChanged = false;
			Refresh();
			}
			
			return returnStatus;
		}
		
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		/// <summary>
		/// Determines if entry exists in VtkVolunteerHours table for the specified idValue
		/// </summary>
		/// <returns>
		/// <list type="bullet">
		/// <item>
		/// <description> true : entry exists in database</description>
		/// </item>
		/// <item>
		/// <description> false : entry does not exists in database</description>
		/// </item>
		/// </list>
		/// </returns>
		/// <param name="iVolunteerFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iStationFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iOrganizationFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iScheduleFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iBenefitingServiceFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="dDateWorked">Primary key value element for VtkVolunteerHours entry</param>
		public static bool DoesExist(	int iVolunteerFK,
										int iStationFK,
										int iOrganizationFK,
										int iScheduleFK,
										int iBenefitingServiceFK,
										DateTime dDateWorked)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			return VolunteerHoursMsSqlSrv.DoesExist(iVolunteerFK, iStationFK, iOrganizationFK, iScheduleFK, iBenefitingServiceFK, dDateWorked);
		}
		#endif
		
		/// <summary>
		/// Returns the external string for a property value of the current instance
		/// </summary>
		/// <param name="prop">Name of the property</param>
		public virtual string ToString(string prop)
		{
			if (prop == "VolunteerId")  {return volunteerId.ToString();}
			if (prop == "StationId")  {return stationId.ToString();}
			if (prop == "OrganizationId")  {return organizationId.ToString();}
			if (prop == "ScheduleId")  {return scheduleId.ToString();}
			if (prop == "BenefitingServiceId")  {return benefitingServiceId.ToString();}
			if (prop == "DateWorked")  {return dateWorked.ToString();}
			if (prop == "HoursWorked")  {return hoursWorked.ToString();}
			if (prop == "RecordStatus")  {return recordStatus.ToString();}
			if (prop == "Version")  {return version.ToString();}
			return "None";
		}
		
		#endregion
		
	}
}
