﻿
/*

			Class:              VolunteerHoursMsSqlSrv

			Date Produced:      12/17/2001 1:06:31 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        12/15/2001 4:30:20 PM
			Revision:           593

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteerHours
	/// </summary>
	public class VolunteerHoursMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private VolunteerHoursBase vhrsObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteerHours)
		/// </summary>
		public static string tableName = "VtkVolunteerHours";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.VolunteerFK database field
		/// </summary>
		public const string volunteerIdField = "VolunteerFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.StationFK database field
		/// </summary>
		public const string stationIdField = "StationFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.OrganizationFK database field
		/// </summary>
		public const string organizationIdField = "OrganizationFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.ScheduleFK database field
		/// </summary>
		public const string scheduleIdField = "ScheduleFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.BenefitingServiceFK database field
		/// </summary>
		public const string benefitingServiceIdField = "BenefitingServiceFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.DateWorked database field
		/// </summary>
		public const string dateWorkedField = "DateWorked";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.HoursWorked database field
		/// </summary>
		public const string hoursWorkedField = "HoursWorked";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.RecordStatus database field
		/// </summary>
		public const string recordStatusField = "RecordStatus";
		
		/// <summary>
		/// Class field that maps to VtkVolunteerHours.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "vhrsObj"></param>
		public VolunteerHoursMsSqlSrv(VolunteerHoursBase vhrsObj)
		{
			Initialize(vhrsObj);
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "vhrsObj"></param>
		private void Initialize(VolunteerHoursBase vhrsObj)
		{
			this.vhrsObj = vhrsObj;
		
			// initialize fields inherited form MsSqlDataSrv
			this.appCon = vhrsObj.AppCon;
			this.databaseTableName = VolunteerHoursMsSqlSrv.tableName;
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
		
			string tableName = VolunteerHoursMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(	GetIdSelectString(	vhrsObj.VolunteerId,
																		vhrsObj.StationId,
																		vhrsObj.OrganizationId,
																		vhrsObj.ScheduleId,
																		vhrsObj.BenefitingServiceId,
																		vhrsObj.DateWorked), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create VolunteerHours instance. Invalid VolunteerId: " + vhrsObj.VolunteerId + " or StationId: " + vhrsObj.StationId + " or OrganizationId: " + vhrsObj.OrganizationId + " or ScheduleId: " + vhrsObj.ScheduleId + " or BenefitingServiceIdId: " + vhrsObj.BenefitingServiceId + " or DateWorked: " + vhrsObj.DateWorked);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			vhrsObj.id = 1;

			if (!dr.IsNull(volunteerIdField))
			{
				vhrsObj.volunteerId = (Int32)dr[volunteerIdField];
			}
			else
			{
				vhrsObj.volunteerId = Int32.MinValue;
			}
		
			if (!dr.IsNull(stationIdField))
			{
				vhrsObj.stationId = (Int16)dr[stationIdField];
			}
			else
			{
				vhrsObj.stationId = Int16.MinValue;
			}
		
			if (!dr.IsNull(organizationIdField))
			{
				vhrsObj.organizationId = (Int16)dr[organizationIdField];
			}
			else
			{
				vhrsObj.organizationId = Int16.MinValue;
			}
		
			if (!dr.IsNull(scheduleIdField))
			{
				vhrsObj.scheduleId = (Int16)dr[scheduleIdField];
			}
			else
			{
				vhrsObj.scheduleId = Int16.MinValue;
			}
		
			if (!dr.IsNull(benefitingServiceIdField))
			{
				vhrsObj.benefitingServiceId = (Int16)dr[benefitingServiceIdField];
			}
			else
			{
				vhrsObj.benefitingServiceId = Int16.MinValue;
			}
		
			if (!dr.IsNull(dateWorkedField))
			{
				vhrsObj.dateWorked = (DateTime)dr[dateWorkedField];
			}
			else
			{
				vhrsObj.dateWorked = DateTime.MinValue;
			}
		
			if (!dr.IsNull(hoursWorkedField))
			{
				vhrsObj.hoursWorked = (byte)dr[hoursWorkedField];
			}
			else
			{
				vhrsObj.hoursWorked =  byte.MinValue;
			}
		
			if (!dr.IsNull(recordStatusField))
			{
				vhrsObj.recordStatus = (string)dr[recordStatusField];
			}
			else
			{
				vhrsObj.recordStatus = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				vhrsObj.version = (Int16)dr[versionField];
			}
			else
			{
				vhrsObj.version = Int16.MinValue;
			}
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			int retVal=0;
			spParams.spI_VtkVolunteerHours spParam = new spParams.spI_VtkVolunteerHours ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._VolunteerFK = vhrsObj.volunteerId;
			spParam._StationFK = vhrsObj.stationId;
			spParam._OrganizationFK = vhrsObj.organizationId;
			spParam._ScheduleFK = vhrsObj.scheduleId;
			spParam._BenefitingServiceFK = vhrsObj.benefitingServiceId;
			spParam._DateWorked = vhrsObj.dateWorked;
			spParam._HoursWorked = vhrsObj.hoursWorked;
			spParam._RecordStatus = vhrsObj.recordStatus;
			spParam._Ver = vhrsObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
	
			spSProcs.spI_VtkVolunteerHours spSProc = new spSProcs.spI_VtkVolunteerHours();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._VolunteerFK != null) {vhrsObj.volunteerId = (Int32)spParam._VolunteerFK;}
					if (spParam._StationFK != null) {vhrsObj.stationId = (Int32)spParam._StationFK;}
					if (spParam._OrganizationFK != null) {vhrsObj.organizationId = (Int32)spParam._OrganizationFK;}
					if (spParam._ScheduleFK != null) {vhrsObj.scheduleId = (Int32)spParam._ScheduleFK;}
					if (spParam._BenefitingServiceFK != null) {vhrsObj.benefitingServiceId = (Int32)spParam._BenefitingServiceFK;}
					if (spParam._DateWorked != null) {vhrsObj.dateWorked = (DateTime)spParam._DateWorked;}
				}
				DoCommitTransaction();
				retVal = 1;
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("VolunteerHours", "Insert", spParam);
				retVal = 0;
			}
			spParam.Dispose();
			spSProc.Dispose();
			return retVal;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[VolunteerHoursMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteerHours spParam = new spParams.spU_VtkVolunteerHours();
 
			SetAllProperties(spParam, dr);

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteerHours spSProc = new spSProcs.spU_VtkVolunteerHours(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("VolunteerHours", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (vhrsObj.volunteerId == Int32.MinValue && !dr.IsNull(volunteerIdField))  {return true;} 
			else
			if (vhrsObj.stationId == Int32.MinValue && !dr.IsNull(stationIdField))  {return true;} 
			else
			if (vhrsObj.organizationId == Int32.MinValue && !dr.IsNull(organizationIdField))  {return true;} 
			else
			if (vhrsObj.scheduleId == Int32.MinValue && !dr.IsNull(scheduleIdField))  {return true;} 
			else
			if (vhrsObj.benefitingServiceId == Int32.MinValue && !dr.IsNull(benefitingServiceIdField))  {return true;} 
			else
			if (vhrsObj.dateWorked == DateTime.MinValue && !dr.IsNull(dateWorkedField))  {return true;} 
			else
			if (vhrsObj.hoursWorked == Int32.MinValue && !dr.IsNull(hoursWorkedField))  {return true;} 
			else
			if (vhrsObj.recordStatus == string.Empty && !dr.IsNull(recordStatusField))  {return true;} 
			else
			if (vhrsObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteerHours spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._VolunteerFK =  vhrsObj.volunteerId; 
			spParam._StationFK =  vhrsObj.stationId; 
			spParam._OrganizationFK =  vhrsObj.organizationId; 
			spParam._ScheduleFK =  vhrsObj.scheduleId; 
			spParam._BenefitingServiceFK =  vhrsObj.benefitingServiceId; 
			spParam._DateWorked =  vhrsObj.dateWorked; 
			spParam._HoursWorked =  vhrsObj.hoursWorked; 
			spParam._RecordStatus =  vhrsObj.recordStatus; 
			spParam._Ver =  vhrsObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteerHours spParam, DataRow dr)
		{
			//required or bool properties
			spParam._VolunteerFK = vhrsObj.volunteerId; 
			spParam._StationFK = vhrsObj.stationId; 
			spParam._OrganizationFK = vhrsObj.organizationId; 
			spParam._ScheduleFK = vhrsObj.scheduleId; 
			spParam._BenefitingServiceFK = vhrsObj.benefitingServiceId; 
			spParam._DateWorked = vhrsObj.dateWorked; 
			spParam._HoursWorked = vhrsObj.hoursWorked; 
			spParam._RecordStatus = vhrsObj.recordStatus; 
			spParam._Ver =  vhrsObj.version; 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (vhrsObj.volunteerId > 0 &&
				vhrsObj.stationId > 0 &&
				vhrsObj.organizationId > 0 &&
				vhrsObj.scheduleId > 0 &&
				vhrsObj.benefitingServiceId > 0)
			{
				spParams.spD_VtkVolunteerHours spParam = new spParams.spD_VtkVolunteerHours ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._VolunteerFK = vhrsObj.volunteerId;
				spParam._StationFK = vhrsObj.stationId; 
				spParam._OrganizationFK = vhrsObj.organizationId;
				spParam._ScheduleFK = vhrsObj.scheduleId;
				spParam._BenefitingServiceFK = vhrsObj.benefitingServiceId;
				spParam._DateWorked = vhrsObj.dateWorked;
				spParam._Ver = vhrsObj.version; 
				spSProcs.spD_VtkVolunteerHours spSProc = new spSProcs.spD_VtkVolunteerHours();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("VolunteerHours", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(	int iVolunteerFK,
												int iStationFK,
												int iOrganizationFK,
												int iScheduleFK,
												int iBenefitingServiceFK,
												DateTime dDateWorked)
		{
			// MSG 11/22/2004 Hour's Breakout change.
			// Removed ID column as primary key.
			// Added Vol ID, Stn ID, Org ID, Svc ID, Sch ID and Datworked as primary key.

			return "SELECT * FROM " + 
					VolunteerHoursMsSqlSrv.tableName + 
					" WHERE VolunteerFK = "  + iVolunteerFK.ToString() + " AND " +
					"StationFK = "  + iStationFK.ToString() + " AND " +
					"OrganizationFK = "  + iOrganizationFK.ToString() + " AND " +
					"ScheduleFK = "  + iScheduleFK.ToString() + " AND " +
					"BenefitingServiceFK = "  + iBenefitingServiceFK.ToString() + " AND " +
					"DateWorked = '"  + dDateWorked.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="iVolunteerFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iStationFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iOrganizationFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iScheduleFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="iBenefitingServiceFK">Primary key value element for VtkVolunteerHours entry</param>
		/// <param name="dDateWorked">Primary key value element for VtkVolunteerHours entry</param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static new bool DoesExist(int iVolunteerFK,
										 int iStationFK,
										 int iOrganizationFK,
										 int iScheduleFK,
										 int iBenefitingServiceFK,
										 DateTime dDateWorked)
		{
			return MsSqlDataSrv.DoesExist(iVolunteerFK, iStationFK, iOrganizationFK, iScheduleFK, iBenefitingServiceFK, dDateWorked);
		}
		
		#endregion
		
	}
}
