﻿
/*

			Class:              VolunteerMsSqlSrv

			Date Produced:      03/05/2003 9:26:48 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        02/27/2003 9:10:36 AM
			Revision:           673

			SQL Server Version: 08.00.0760
			Server:             ISF-LANGLEYM
			Database:           [VSS_Games_Test]
			Code generated in:  D:\Olymars_test\1.0.1070.23427\DataClasses\CS\

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1070.23427

*/

#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;

using Vha.Vtk.Kernel.Common;
using spParams = Vha.Vtk.DataClasses.Parameters;
using spSProcs = Vha.Vtk.DataClasses.StoredProcedures;
using spErr    = Vha.Vtk.DataClasses.ErrorHandle;
using si       = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
		
#endregion
		
namespace Vha.Vtk.DataClasses
{
	/// <summary>
	///   Sql Server Data Class mapped to VtkVolunteers
	/// </summary>
	public class VolunteerMsSqlSrv : MsSqlDataSrv, IDataSrv
	{
		
		#region Section: Processing Fields
		
		
		/// <summary>
		/// declares an internal class object 
		/// </summary>
		private VolunteerBase volObj;
		
		/// <summary>
		/// class field mapped to the name of the MS SQL Server table (VtkVolunteers)
		/// </summary>
		public static string tableName = "VtkVolunteers";
		
		#endregion
		
		#region Section: Database Constant Fields
		
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.Id database field
		/// </summary>
		public const string idField = "Id";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.LastName database field
		/// </summary>
		public const string lastNameField = "LastName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.FirstName database field
		/// </summary>
		public const string firstNameField = "FirstName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.MiddleName database field
		/// </summary>
		public const string middleNameField = "MiddleName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.NameSuffix database field
		/// </summary>
		public const string nameSuffixField = "NameSuffix";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.LowercaseNameForDisplay database field
		/// </summary>
		public const string lowercaseNameForDisplayField = "LowercaseNameForDisplay";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.UppercaseNameForDisplay database field
		/// </summary>
		public const string uppercaseNameForDisplayField = "UppercaseNameForDisplay";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.SocialSecurityNumber database field
		/// </summary>
		public const string socialSecurityNumberField = "SocialSecurityNumber";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.Sex database field
		/// </summary>
		public const string sexField = "Sex";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.DateOfBirth database field
		/// </summary>
		public const string dateOfBirthField = "DateOfBirth";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.DateOfBirthImprecision database field
		/// </summary>
		public const string dateOfBirthImprecisionField = "DateOfBirthImprecision";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.Age database field
		/// </summary>
		public const string ageField = "Age";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.Remarks database field
		/// </summary>
		public const string remarksField = "Remarks";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.IsVAEmployee database field
		/// </summary>
		public const string isVAEmployeeField = "IsVAEmployee";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.IsPseudoSSN database field
		/// </summary>
		public const string isPseudoSSNField = "IsPseudoSSN";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.NickName database field
		/// </summary>
		public const string nickNameField = "NickName";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.PreferredLanguageForLoginFK database field
		/// </summary>
		public const string preferredLanguageForLoginIdField = "PreferredLanguageForLoginFK";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.IdentifyingCode database field
		/// </summary>
		public const string identifyingCodeField = "IdentifyingCode";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.FullNameForReports database field
		/// </summary>
		public const string fullNameForReportsField = "FullNameForReports";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.Ver database field
		/// </summary>
		public const string versionField = "Ver";
		
		/// <summary>
		/// Class field that maps to VtkVolunteers.D0 database field
		/// </summary>
		public const string d0Field = "D0";
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		///   Main Constructor 
		/// </summary>
		///<param name = "volObj"></param>
		public VolunteerMsSqlSrv(VolunteerBase volObj)
		{
			try
			{
				Initialize(volObj);
			}
			catch(Exception ex)
			{
				throw new Exception("Failed in VolunteerMsSqlSrv.Constructor(VolunteerBase volObj). Message: " + ex.Message);
			}
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		///   Initializes existing record 
		/// </summary>
		///<param name = "volObj"></param>
		private void Initialize(VolunteerBase volObj)
		{
			try
			{
				this.volObj = volObj;
		
				// initialize fields inherited form MsSqlDataSrv
				this.appCon = volObj.AppCon;
				this.databaseTableName = VolunteerMsSqlSrv.tableName;
			}
			catch(Exception ex)
			{
				throw new Exception("Failed in VolunteerMsSqlSrv.Initize. Message: " + ex.Message);
			}
		}
		
		/// <summary>
		/// Retrieves DataSet for instance based on primary key and associates DataSet with instance.
		/// </summary>
		public void GetIdData()
		{
			Clean();
			
			string tableName = VolunteerMsSqlSrv.tableName;
			SqlDataAdapter da = new SqlDataAdapter(GetIdSelectString(volObj.ID), appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds, tableName);
			da.Dispose();
		
			if (ds.Tables[0].Rows.Count == 1)
			{
				SetDataSetInfo(ds, tableName, 0);
			}
			else
			{
				throw new Exception("Cannot create Volunteer instance. Invalid ID: " + volObj.ID);
			}
		}
		
		/// <summary>
		/// Populates instance properties with DataSet data.
		/// </summary>
		public void Populate()
		{
			Populate(dsRec.Tables[dsRecTableName].Rows[dsRecTableRow]);
		}
		
		/// <summary>
		/// Populates instance with data from a row produced by a 'SELECT *' statement.
		/// </summary>
		/// <param name="dr">DataRow that contains data to populate an object</param>
		public void Populate(DataRow dr)
		{
			if (!dr.IsNull(idField))
			{
				volObj.id = (Int32)dr[idField];
			}
			else
			{
				volObj.id = Int32.MinValue;
			}
		
			if (!dr.IsNull(lastNameField))
			{
				volObj.lastName = (string)dr[lastNameField];
			}
			else
			{
				volObj.lastName = string.Empty;
			}
		
			if (!dr.IsNull(firstNameField))
			{
				volObj.firstName = (string)dr[firstNameField];
			}
			else
			{
				volObj.firstName = string.Empty;
			}
		
			if (!dr.IsNull(middleNameField))
			{
				volObj.middleName = (string)dr[middleNameField];
			}
			else
			{
				volObj.middleName = string.Empty;
			}
		
			if (!dr.IsNull(nameSuffixField))
			{
				volObj.nameSuffix = (string)dr[nameSuffixField];
			}
			else
			{
				volObj.nameSuffix = string.Empty;
			}
		
			if (!dr.IsNull(lowercaseNameForDisplayField))
			{
				volObj.lowercaseNameForDisplay = (string)dr[lowercaseNameForDisplayField];
			}
			else
			{
				volObj.lowercaseNameForDisplay = string.Empty;
			}
		
			if (!dr.IsNull(uppercaseNameForDisplayField))
			{
				volObj.uppercaseNameForDisplay = (string)dr[uppercaseNameForDisplayField];
			}
			else
			{
				volObj.uppercaseNameForDisplay = string.Empty;
			}
		
			if (!dr.IsNull(socialSecurityNumberField))
			{
				volObj.socialSecurityNumber = (string)dr[socialSecurityNumberField];
			}
			else
			{
				volObj.socialSecurityNumber = string.Empty;
			}
		
			if (!dr.IsNull(sexField))
			{
				volObj.sex = (string)dr[sexField];
			}
			else
			{
				volObj.sex = string.Empty;
			}
		
			if (!dr.IsNull(dateOfBirthField))
			{
				volObj.dateOfBirth = (DateTime)dr[dateOfBirthField];
			}
			else
			{
				volObj.dateOfBirth = DateTime.MinValue;
			}
		
			if (!dr.IsNull(dateOfBirthImprecisionField))
			{
				volObj.dateOfBirthImprecision = (string)dr[dateOfBirthImprecisionField];
			}
			else
			{
				volObj.dateOfBirthImprecision = string.Empty;
			}
		
			if (!dr.IsNull(ageField))
			{
				volObj.age = (Int32)dr[ageField];
			}
			else
			{
				volObj.age = Int32.MinValue;
			}
		
			if (!dr.IsNull(remarksField))
			{
				volObj.remarks = (string)dr[remarksField];
			}
			else
			{
				volObj.remarks = string.Empty;
			}
		
			if (!dr.IsNull(isVAEmployeeField))
			{
				volObj.isVAEmployee = (bool)dr[isVAEmployeeField];
			}
			else
			{
				volObj.isVAEmployee = false;
			}
		
			if (!dr.IsNull(isPseudoSSNField))
			{
				volObj.isPseudoSSN = (bool)dr[isPseudoSSNField];
			}
			else
			{
				volObj.isPseudoSSN = false;
			}
		
			if (!dr.IsNull(nickNameField))
			{
				volObj.nickName = (string)dr[nickNameField];
			}
			else
			{
				volObj.nickName = string.Empty;
			}
		
			if (!dr.IsNull(preferredLanguageForLoginIdField))
			{
				volObj.preferredLanguageForLoginId = (Int32)dr[preferredLanguageForLoginIdField];
			}
			else
			{
				volObj.preferredLanguageForLoginId = Int32.MinValue;
			}
		
			if (!dr.IsNull(identifyingCodeField))
			{
				volObj.identifyingCode = (string)dr[identifyingCodeField];
			}
			else
			{
				volObj.identifyingCode = string.Empty;
			}
		
			if (!dr.IsNull(fullNameForReportsField))
			{
				volObj.fullNameForReports = (string)dr[fullNameForReportsField];
			}
			else
			{
				volObj.fullNameForReports = string.Empty;
			}
		
			if (!dr.IsNull(versionField))
			{
				volObj.version = (Int32)dr[versionField];
			}
			else
			{
				volObj.version = Int32.MinValue;
			}
		
			if (!dr.IsNull(d0Field))
			{
				volObj.d0 = (Int32)dr[d0Field];
			}
			else
			{
				volObj.d0 = Int32.MinValue;
			}
		
		}
		
		/// <summary>
		/// Sets Dataset, tablename and tablerow properties for instance.
		/// </summary>
		/// <param name="ds">DataSet to associate with instance. DataSet should have only 1 table.</param>
		/// <param name="tableName">Name of table inside DataSet (ds)</param>
		/// <param name="tableRow">Data row number to associate with instance</param>
		/// <remarks>
		///   This method will be used mostly by collections when populating a collection object.
		/// </remarks>
		public void SetDataSetInfo(DataSet ds, string tableName, int tableRow)
		{
			this.dsRec = ds;
			this.dsRecTableName = tableName;
			this.dsRecTableRow  = tableRow;
		}
		
		#endregion
		
		#region Section: Finalizers
		
		/// <summary>
		/// Disposes of class instance properly. This override allows any special cleanup.
		/// </summary>
		public override void Dispose()
		{
			this.Clean();
		}
		
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Inserts new record into database using instance data.
		/// </summary>
		/// <returns> returns integer value of 1 if successful or 0 if unsucessful</returns>
		public int Insert()
		{
			
			spParams.spI_VtkVolunteers spParam = new spParams.spI_VtkVolunteers ();

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			//set parameter for Required and bool columns
			spParam._LastName = volObj.lastName;
			spParam._FirstName = volObj.firstName;
			spParam._SocialSecurityNumber = volObj.socialSecurityNumber;
			spParam._Sex = volObj.sex;
			spParam._DateOfBirth = volObj.dateOfBirth;
			spParam._IsVAEmployee = volObj.isVAEmployee;
			spParam._IsPseudoSSN = volObj.isPseudoSSN;
			spParam._Ver = volObj.version;
		
			//set parameter for columns that allow nulls if value exists, else if null set to default value
			if (volObj.middleName != string.Empty) {spParam._MiddleName = volObj.middleName;}
			if (volObj.nameSuffix != string.Empty) {spParam._NameSuffix = volObj.nameSuffix;}
			if (volObj.dateOfBirthImprecision != string.Empty) {spParam._DateOfBirthImprecision = volObj.dateOfBirthImprecision;}
			if (volObj.remarks != string.Empty) {spParam._Remarks = volObj.remarks;}
			if (volObj.nickName != string.Empty) {spParam._NickName = volObj.nickName;}
			if (volObj.preferredLanguageForLoginId != Int32.MinValue) {spParam._PreferredLanguageForLoginFK = volObj.preferredLanguageForLoginId;}
			if (volObj.d0 != Int32.MinValue) {spParam._D0 = volObj.d0;}
	
			spSProcs.spI_VtkVolunteers spSProc = new spSProcs.spI_VtkVolunteers();
			if (spSProc.Execute(ref spParam))
			{
				if (spParam._RETURN_VALUE != null)
				{
					if (spParam._Id != null) {volObj.id = (Int32)spParam._Id;}
				}
				DoCommitTransaction();
			}
			else
			{
				DoRollbackTransaction();
				spErr.ErrorHandler("Volunteer", "Insert", spParam);
			}
			spParam.Dispose();
			spSProc.Dispose();
			return volObj.id;
		}
 
		
		/// <summary>
		/// Updates existing record into database using instance data.
		/// </summary>
		public void Update()
		{
			//DataRow dr = dsRec.Tables[VolunteerMsSqlSrv.tableName].Rows[tableRow];
			DataRow dr = dsRec.Tables[dsRecTableName].Rows[dsRecTableRow];
			spParams.spU_VtkVolunteers spParam = new spParams.spU_VtkVolunteers();
 
			if (volObj.IsChanged && (!volObj.IsNew)) 
			{
				if (IsSettingValueToNull(dr)) 
				{
					SetAllProperties(spParam, dr); 
					spParam._ConsiderNull = true; 
				}
				else 
				{
					spParam._ConsiderNull = false; 
					SetChangedProperties(spParam, dr); 
				} 
			}

			DoBeginTransaction();
			spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
			spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;

			spSProcs.spU_VtkVolunteers spSProc = new spSProcs.spU_VtkVolunteers(); 
			if (spSProc.Execute(ref spParam))
			{
				DoCommitTransaction(); 
			}
			else
			{
				DoRollbackTransaction(); 
				spErr.ErrorHandler("Volunteer", "Update", spParam); 
			} 
 
			spParam.Dispose(); 
			spSProc.Dispose(); 
		}
	
		private bool IsSettingValueToNull(DataRow dr) 
		{
			if (volObj.lastName == string.Empty && !dr.IsNull(lastNameField))  {return true;} 
			else
			if (volObj.firstName == string.Empty && !dr.IsNull(firstNameField))  {return true;} 
			else
			if (volObj.middleName == string.Empty && !dr.IsNull(middleNameField))  {return true;} 
			else
			if (volObj.nameSuffix == string.Empty && !dr.IsNull(nameSuffixField))  {return true;} 
			else
			if (volObj.socialSecurityNumber == string.Empty && !dr.IsNull(socialSecurityNumberField))  {return true;} 
			else
			if (volObj.sex == string.Empty && !dr.IsNull(sexField))  {return true;} 
			else
			if (volObj.dateOfBirth == DateTime.MinValue && !dr.IsNull(dateOfBirthField))  {return true;} 
			else
			if (volObj.dateOfBirthImprecision == string.Empty && !dr.IsNull(dateOfBirthImprecisionField))  {return true;} 
			else
			if (volObj.remarks == string.Empty && !dr.IsNull(remarksField))  {return true;} 
			else
			if (volObj.isVAEmployee == false && !dr.IsNull(isVAEmployeeField))  {return true;} 
			else
			if (volObj.isPseudoSSN == false && !dr.IsNull(isPseudoSSNField))  {return true;} 
			else
			if (volObj.nickName == string.Empty && !dr.IsNull(nickNameField))  {return true;} 
			else
			if (volObj.preferredLanguageForLoginId == Int32.MinValue && !dr.IsNull(preferredLanguageForLoginIdField))  {return true;} 
			else
			if (volObj.version == Int32.MinValue && !dr.IsNull(versionField))  {return true;} 
			else
			if (volObj.d0 == Int32.MinValue && !dr.IsNull(d0Field))  {return true;} 
			else
			return false;
		} 
 
		private void SetAllProperties(spParams.spU_VtkVolunteers spParam, DataRow dr)
		{
			//set all required properties and bool properties 
			spParam._Id =  volObj.id; 
			spParam._LastName =  volObj.lastName; 
			spParam._FirstName =  volObj.firstName; 
			spParam._SocialSecurityNumber =  volObj.socialSecurityNumber; 
			spParam._Sex =  volObj.sex; 
			spParam._DateOfBirth =  volObj.dateOfBirth; 
			spParam._IsVAEmployee =  volObj.isVAEmployee; 
			spParam._IsPseudoSSN =  volObj.isPseudoSSN; 
			spParam._Ver =  volObj.version; 
	
			//Set all non-null, not required properties, otherwise leave null (default value)
			if (volObj.middleName != string.Empty)  {spParam._MiddleName = volObj.middleName;}
			if (volObj.nameSuffix != string.Empty)  {spParam._NameSuffix = volObj.nameSuffix;}
			if (volObj.dateOfBirthImprecision != string.Empty)  {spParam._DateOfBirthImprecision = volObj.dateOfBirthImprecision;}
			if (volObj.remarks != string.Empty)  {spParam._Remarks = volObj.remarks;}
			if (volObj.nickName != string.Empty)  {spParam._NickName = volObj.nickName;}
			if (volObj.preferredLanguageForLoginId != Int32.MinValue)  {spParam._PreferredLanguageForLoginFK = volObj.preferredLanguageForLoginId;}
			if (volObj.d0 != Int32.MinValue)  {spParam._D0 = volObj.d0;}
		}
	
		private void SetChangedProperties(spParams.spU_VtkVolunteers spParam, DataRow dr)
		{
			//required or bool properties
			spParam._Id = volObj.id; 
			spParam._LastName = volObj.lastName; 
			spParam._FirstName = volObj.firstName; 
			spParam._SocialSecurityNumber = volObj.socialSecurityNumber; 
			spParam._Sex = volObj.sex; 
			spParam._DateOfBirth = volObj.dateOfBirth; 
			spParam._IsVAEmployee = volObj.isVAEmployee; 
			spParam._IsPseudoSSN = volObj.isPseudoSSN; 
			spParam._Ver =  volObj.version; 
	
			//middleName property
			if (!dr.IsNull(middleNameField))
			{ 
				if (volObj.middleName != (string)dr[middleNameField]) 
				{ 
					spParam._MiddleName = volObj.middleName; 
				} 
			} 
			else if (volObj.middleName != string.Empty)
			{ 
				spParam._MiddleName = volObj.middleName; 
			} 
	
			//nameSuffix property
			if (!dr.IsNull(nameSuffixField))
			{ 
				if (volObj.nameSuffix != (string)dr[nameSuffixField]) 
				{ 
					spParam._NameSuffix = volObj.nameSuffix; 
				} 
			} 
			else if (volObj.nameSuffix != string.Empty)
			{ 
				spParam._NameSuffix = volObj.nameSuffix; 
			} 
	
			//dateOfBirthImprecision property
			if (!dr.IsNull(dateOfBirthImprecisionField))
			{ 
				if (volObj.dateOfBirthImprecision != (string)dr[dateOfBirthImprecisionField]) 
				{ 
					spParam._DateOfBirthImprecision = volObj.dateOfBirthImprecision; 
				} 
			} 
			else if (volObj.dateOfBirthImprecision != string.Empty)
			{ 
				spParam._DateOfBirthImprecision = volObj.dateOfBirthImprecision; 
			} 
	
			//remarks property
			if (!dr.IsNull(remarksField))
			{ 
				if (volObj.remarks != (string)dr[remarksField]) 
				{ 
					spParam._Remarks = volObj.remarks; 
				} 
			} 
			else if (volObj.remarks != string.Empty)
			{ 
				spParam._Remarks = volObj.remarks; 
			} 
	
			//nickName property
			if (!dr.IsNull(nickNameField))
			{ 
				if (volObj.nickName != (string)dr[nickNameField]) 
				{ 
					spParam._NickName = volObj.nickName; 
				} 
			} 
			else if (volObj.nickName != string.Empty)
			{ 
				spParam._NickName = volObj.nickName; 
			} 
	
			//preferredLanguageForLoginId property
			if (!dr.IsNull(preferredLanguageForLoginIdField))
			{ 
				if (volObj.preferredLanguageForLoginId != (Int32)dr[preferredLanguageForLoginIdField]) 
				{ 
					spParam._PreferredLanguageForLoginFK = volObj.preferredLanguageForLoginId; 
				} 
			} 
			else if (volObj.preferredLanguageForLoginId != Int32.MinValue)
			{ 
				spParam._PreferredLanguageForLoginFK = volObj.preferredLanguageForLoginId; 
			} 
	
			//d0 property
			if (!dr.IsNull(d0Field))
			{ 
				if (volObj.d0 != (Int32)dr[d0Field]) 
				{ 
					spParam._D0 = volObj.d0; 
				} 
			} 
			else if (volObj.d0 != Int32.MinValue)
			{ 
				spParam._D0 = volObj.d0; 
			} 
	
		} 
 
		
		/// <summary>
		/// Deletes existing record from database using instance data.
		/// </summary>
		public void Delete()
		{
			if (volObj.id > 0)
			{
				spParams.spD_VtkVolunteers spParam = new spParams.spD_VtkVolunteers ();
				
				DoBeginTransaction();
				spParam.SqlTransaction = (SqlTransaction)appCon.Transaction;
				spParam.SqlConnection  = (SqlConnection)appCon.TransactionConnection;
				
				spParam._Id  = volObj.id;
				spParam._Ver = volObj.version; 
				spSProcs.spD_VtkVolunteers spSProc = new spSProcs.spD_VtkVolunteers();
				if (spSProc.Execute(ref spParam))
				{ 
					DoCommitTransaction(); 
				} 
				else 
				{
					DoRollbackTransaction(); 
					spErr.ErrorHandler("Volunteer", "Delete", spParam);
				}
				spParam.Dispose();
				spSProc.Dispose();
			}
		}
 
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		/// get SQL Statement to return string
		/// </summary>
		/// <param name="id">The integer ID of the record to retrieve</param>
		///<returns> string value of SQL statement to retrieve DataRow for current object</returns>
		public static string GetIdSelectString(int id)
		{
			return "SELECT * FROM " + VolunteerMsSqlSrv.tableName + " WHERE Id = '"  + id.ToString() + "'";
		}
		
		/// <summary>
		/// Method to determine if an entry exists
		/// </summary>
		/// <param name="idValue">The integer ID of the record</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		///<returns> boolean value if entry (idValue) exists</returns>
		public static bool DoesExist(int idValue)
		{
			return MsSqlDataSrv.DoesExist(idValue, VolunteerMsSqlSrv.tableName, "Id");
		}
		
		#endregion
		
	}
}
