﻿
/*

			Class:              Donation

			Date Produced:      11/14/2002 8:30:07 AM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        08/27/2004 0:00:00 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\Vha.Vtk.Donations

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.DonationMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Donations
{
	/// <summary>
	///  Public Class mapped to VtkDonation
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Donation : DonationBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkDonation entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Donation(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Donation(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Donation thate will be used to add a record to the VtkDonation database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Donation"/></returns>
		public static Donation AddRecord(ApplicationConnection appCon)
		{
			Donation dntsObj = new Donation(appCon);
			dntsObj.FillDataNew();
			return dntsObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonationTypeId(DonationTypeId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonorId(DonorId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
//			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonationGPF(DonationFPD);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsMonetary(IsMonetary);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCheckNumber(CheckNumber, DonationTypeId);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCheckDate(CheckDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonationDate(DonationDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAcknowledgementDate(AcknowledgementDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonationReferenceFK(DonationReferenceFK, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonationDescription(DonationDescription);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateGeneralPostFund(GeneralPostFund);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFieldServiceReceipt(FieldServiceReceipt);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDesignation(Designation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidatePost_Unit_Chapter(Post_Unit_Chapter);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInMemoryOf(InMemoryOf);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateSalutation(Salutation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCC1(CC1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCC2(CC2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCC3(CC3);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCC4(CC4);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCC5(CC5);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFamilyContact(FamilyContact);

			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonationTypeId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonationTypeId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonationTypeId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonationTypeId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonationBase.ValidateDonationTypeId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'DonationTypeId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonorId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonorId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonorId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonorId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonationBase.ValidateDonorId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'DonorId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonationBase.ValidateInstitutionId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'InstitutionId'.
		 
			return ret;
		}

/*		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonationValue property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonationValue.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonationValue</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonationValue(decimal value)
		{
			ReturnStatus ret = DonationBase.ValidateDonationValue(value);		 
			return ret;
		} */
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsMonetary property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateIsMonetary.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsMonetary</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsMonetary(bool value)
		{
			ReturnStatus ret = DonationBase.ValidateIsMonetary(value);
		 
			// TODO: Add property specific validation logic for 'IsMonetary'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for CheckNumber property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCheckNumber.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CheckNumber</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCheckNumber(string value, Int32 value1)
		{
			ReturnStatus ret = DonationBase.ValidateCheckNumber(value, value1);
		 
			// TODO: Add property specific validation logic for 'CheckNumber'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for CheckDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCheckDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CheckDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCheckDate(DateTime value)
		{
			ReturnStatus ret = DonationBase.ValidateCheckDate(value);
		 
			// TODO: Add property specific validation logic for 'CheckDate'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonationDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonationDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonationDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonationDate(DateTime value)
		{
			ReturnStatus ret = DonationBase.ValidateDonationDate(value);
		 
			// TODO: Add property specific validation logic for 'DonationDate'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AcknowledgementDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateAcknowledgementDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AcknowledgementDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAcknowledgementDate(DateTime value)
		{
			ReturnStatus ret = DonationBase.ValidateAcknowledgementDate(value);
		 
			// TODO: Add property specific validation logic for 'AcknowledgementDate'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonationReferenceFK property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonationReferenceFK.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonationReferenceFK</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonationReferenceFK(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonationBase.ValidateDonationReferenceFK(value, appCon);
		 
			// TODO: Add property specific validation logic for 'DonationReferenceFK'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonationDescription property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDonationDescription.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonationDescription</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonationDescription(string value)
		{
			ReturnStatus ret = DonationBase.ValidateDonationDescription(value);
		 
			// TODO: Add property specific validation logic for 'DonationDescription'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for GeneralPostFund property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateGeneralPostFund.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of GeneralPostFund</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateGeneralPostFund(string value)
		{
			ReturnStatus ret = DonationBase.ValidateGeneralPostFund(value);
		 
			// TODO: Add property specific validation logic for 'GeneralPostFund'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FieldServiceReceipt property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateFieldServiceReceipt.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FieldServiceReceipt</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFieldServiceReceipt(string value)
		{
			ReturnStatus ret = DonationBase.ValidateFieldServiceReceipt(value);
		 
			// TODO: Add property specific validation logic for 'FieldServiceReceipt'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Designation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateDesignation.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Designation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDesignation(string value)
		{
			ReturnStatus ret = DonationBase.ValidateDesignation(value);
		 
			// TODO: Add property specific validation logic for 'Designation'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Post_Unit_Chapter property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidatePost_Unit_Chapter.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Post_Unit_Chapter</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidatePost_Unit_Chapter(string value)
		{
			ReturnStatus ret = DonationBase.ValidatePost_Unit_Chapter(value);
		 
			// TODO: Add property specific validation logic for 'Post_Unit_Chapter'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InMemoryOf property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateInMemoryOf.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InMemoryOf</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInMemoryOf(string value)
		{
			ReturnStatus ret = DonationBase.ValidateInMemoryOf(value);
		 
			// TODO: Add property specific validation logic for 'InMemoryOf'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Salutation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateSalutation.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Salutation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateSalutation(string value)
		{
			ReturnStatus ret = DonationBase.ValidateSalutation(value);
		 
			// TODO: Add property specific validation logic for 'Salutation'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for CC1 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCC1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CC1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCC1(string value)
		{
			ReturnStatus ret = DonationBase.ValidateCC1(value);
		 
			// TODO: Add property specific validation logic for 'CC1'.
		 
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for CC2 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCC2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CC2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCC2(string value)
		{
			ReturnStatus ret = DonationBase.ValidateCC2(value);
		 
			// TODO: Add property specific validation logic for 'CC2'.
		 
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for CC3 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCC3.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CC3</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCC3(string value)
		{
			ReturnStatus ret = DonationBase.ValidateCC3(value);
		 
			// TODO: Add property specific validation logic for 'CC3'.
		 
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for CC4 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCC4.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CC4</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCC4(string value)
		{
			ReturnStatus ret = DonationBase.ValidateCC4(value);
		 
			// TODO: Add property specific validation logic for 'CC4'.
		 
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for CC5 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.ValidateCC5.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CC5</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCC5(string value)
		{
			ReturnStatus ret = DonationBase.ValidateCC5(value);
		 
			// TODO: Add property specific validation logic for 'CC5'.
		 
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for FamilyContact property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonationBase.FamilyContact.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FamilyContact</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFamilyContact(string value)
		{
			ReturnStatus ret = DonationBase.ValidateFamilyContact(value);
		 
			// TODO: Add property specific validation logic for 'FamilyContact'.
		 
			return ret;
		}

		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'Donation'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkDonation table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkDonation entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// Returns dataset for entry.
		/// <li>DataSet TableName:</li> <ul><li><b>Donation</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>DonationTypeId</b>  [Int32]</li>
		///  <li><b>DonorId</b>  [Int32]</li>
		///  <li><b>InstitutionId</b>  [Int32]</li>
		///  <li><b>IsMonetary</b>  [bool]</li>
		///  <li><b>CheckNumber</b>  [string]</li>
		///  <li><b>CheckDate</b>  [DateTime]</li>
		///  <li><b>DonationDate</b>  [DateTime]</li>
		///  <li><b>AcknowledgementDate</b>  [DateTime]</li>
		///  <li><b>DonationReferenceFK</b>  [string]</li>
		///  <li><b>DonationDescription</b>  [string]</li>
		///  <li><b>GeneralPostFund</b>  [string]</li>
		///  <li><b>FieldServiceReceipt</b>  [string]</li>
		///  <li><b>Designation</b>  [string]</li>
		///  <li><b>Post_Unit_Chapter</b>  [string]</li>
		///  <li><b>InMemoryOf</b>  [string]</li>
		///  <li><b>Salutation</b>  [string]</li>
		///  <li><b>CC1</b>  [string]</li>
		///  <li><b>CC2</b>  [string]</li>
		///  <li><b>CC3</b>  [string]</li>
		///  <li><b>CC4</b>  [string]</li>
		///  <li><b>CC5</b>  [string]</li>
		///  <li><b>FamilyContact</b>  [string]</li>
		///  <li><b>Version</b>  [Int32]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Not Specified</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select "
				 + DonationMsSqlSrv.idField + " As ID"
				 + ", " + DonationMsSqlSrv.donationTypeIdField + " As DonationTypeId"
				 + ", " + DonationMsSqlSrv.donorIdField + " As DonorId"
				 + ", " + DonationMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + DonationMsSqlSrv.donationValueField + " As DonationValue"
				 + ", " + DonationMsSqlSrv.isMonetaryField + " As IsMonetary"
				 + ", " + DonationMsSqlSrv.checkNumberField + " As CheckNumber"
				 + ", " + DonationMsSqlSrv.checkDateField + " As CheckDate"
				 + ", " + DonationMsSqlSrv.donationDateField + " As DonationDate"
				 + ", " + DonationMsSqlSrv.acknowledgementDateField + " As AcknowledgementDate"
				 + ", " + DonationMsSqlSrv.donationReferenceFKField + " As DonationReferenceFK"
				 + ", " + DonationMsSqlSrv.donationDescriptionField + " As DonationDescription"
				 + ", " + DonationMsSqlSrv.generalPostFundField + " As GeneralPostFund"
				 + ", " + DonationMsSqlSrv.fieldServiceReceiptField + " As FieldServiceReceipt"
				 + ", " + DonationMsSqlSrv.designationField + " As Designation"
				 + ", " + DonationMsSqlSrv.post_Unit_ChapterField + " As Post_Unit_Chapter"
				 + ", " + DonationMsSqlSrv.inMemoryOfField + " As InMemoryOf"
				 + ", " + DonationMsSqlSrv.salutationField + " As Salutation"
				 + ", " + DonationMsSqlSrv.cc1Field + " As CC1"
				 + ", " + DonationMsSqlSrv.cc2Field + " As CC2"
				 + ", " + DonationMsSqlSrv.cc3Field + " As CC3"
				 + ", " + DonationMsSqlSrv.cc4Field + " As CC4"
				 + ", " + DonationMsSqlSrv.cc5Field + " As CC5"
				 + ", " + DonationMsSqlSrv.familyContactField + " As FamilyContact"
				 + ", " + DonationMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName ;

			StringBuilder command = new StringBuilder(sCommand);
			if(idValue != 0)
				 command.Append(" WHERE Id = '" + idValue + "' ");

			return ApplicationConnection.ExecuteQuery(command.ToString(), "DonationList");
		}
		
		public static DataSet GetQuickList()
		{
			return GetQuickList(0);
		}

		public static DataSet GetQuickListBy_StationId(int StationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsQuickListBy_StationId " + StationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId", out Success);			
		}

		public static DataSet GetQuickListReferencesBy_StationId(int StationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsQuickListReferencesBy_StationId " + StationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListReferencesBy_StationId", out Success);			
		}

/*		public static DataSet GetQuickListReferences1By_StationId(int StationId, int Id)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsGetListReferencesBy_StationId " + StationId.ToString() + ", " + Id.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListReferences1By_StationId", out Success);			
		}

		public static DataSet GetQuickListGPFs1By_StationId(int StationId, int Id)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsGetListGPFsBy_StationId " + StationId.ToString() + ", " + Id.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListGPFs1By_StationId", out Success);			
		}*/

		public static DataSet GetQuickListDonationDetailsBy_DonationId(int DonationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsGetDetailsBy_DonationId " + DonationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "DonationDetails", out Success);
		}

		public static DataSet GetQuickListGPFsBy_StationId(int StationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsQuickListGPFsBy_StationId " + StationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListGPFsBy_StationId", out Success);			
		}

		public static DataSet GetQuickListDonationsBy_GPFs(int gfpFK)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsBy_GPFs " + gfpFK.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "DonationsBy_GPFs", out Success);			
		}

		public static DataSet GetQuickListDonationsBy_REFs(int refFK)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsBy_REFs " + refFK.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "DonationsBy_REFs", out Success);			
		}

		public static DataSet GetQuickListBy_StationId_DonorId(int StationId, int DonorId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonationsQuickListBy_StationId_DonorId ");
			sCommand.Append(StationId.ToString() + ", " + DonorId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId_DonorId", out Success);			
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="StationId"></param>
		/// <param name="DonationDate"></param>
		/// <returns type="DataSet"/>
		public static DataSet GetQuickListBy_StationId_DonationDate(int StationId, DateTime DonationDate)
		{
			SqlCommand sqlCmd			= new SqlCommand("spS_DonationQuickListBy_StationId_DonationDate");
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			//Create Parameters for the Volunteer
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@StationId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= StationId;

			sqlParam							= sqlCmd.Parameters.Add("@DonationDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= DonationDate;
			
			return ApplicationConnection.ExecuteQuery(sqlCmd, "GetQuickListBy_StationId_DonationDate");
		}
		
		public static DataSet GetQuickListBy_StationId_BeginDate_EndDate(int StationId, DateTime BeginDate, DateTime EndDate)
		{
			SqlCommand sqlCmd			= new SqlCommand("spS_DonationQuickListBy_StationId_BeginDate_EndDate");
			sqlCmd.CommandType		= CommandType.StoredProcedure;
			
			//Create Parameters for the Volunteer
			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@StationId", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= StationId;

			sqlParam							= sqlCmd.Parameters.Add("@BeginDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= BeginDate;
			
			sqlParam							= sqlCmd.Parameters.Add("@EndDate", SqlDbType.DateTime);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= EndDate;

			return ApplicationConnection.ExecuteQuery(sqlCmd, "GetQuickListBy_StationId_BeginDate_EndDate");
		}
		#endif

		// this will make the call to the sproc to return data for the CO VS01 dataview (report)
		public static DataSet GetQuickListDataForDonationSearch(string Inst, string BeginDate, string EndDate,
			string DonorType, int Value, string GPF, string Check, string LastName, string Org, string LocalBranch,
			string OtherGroup, string Reference, string InMemoryOf)
		{
			StringBuilder sCommand = new StringBuilder("spQL_VtkDonationSearch '" + Inst + "', '" + BeginDate + "', '"
				+ EndDate + "', '" + DonorType + "', '" + Value + "', '" + GPF + "', '" + Check + "', '" + LastName + "', '"
				+ Org + "', '" + LocalBranch + "', '" + OtherGroup + "', '" + Reference + "', '" + InMemoryOf + "'");
			
			int Success = 0;
			return ApplicationConnection.ExecuteQueryTimeout(sCommand.ToString(), "GetQuickListDataForDonationSearch");			
		}
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
