﻿
/*

			Class:              Donor

			Date Produced:      11/15/2002 8:37:24 AM
			Responsible Team:   VistA Migration
			Developer(s):       <Developer Name Here>
			LastUpdated:        11/14/2002 8:25:39 AM
			Revision:           660

			SQL Server Version: 08.00.0534
			Server:             ISF-LANGLEYM
			Database:           [VSS_Beta]
			Code generated in:  D:\Olymars_test\1.0.1037.41160\Vha.Vtk.Donations

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1037.41160

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Text;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel;
using Vha.Vtk.Kernel.Data;

//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.DonorMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Donations
{
	/// <summary>
	///  Public Class mapped to VtkDonor
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Donor : DonorBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkDonor entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Donor(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private Donor(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of Donor thate will be used to add a record to the VtkDonor database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Donor"/></returns>
		public static Donor AddRecord(ApplicationConnection appCon)
		{
			Donor donorObj = new Donor(appCon);
			donorObj.FillDataNew();
			return donorObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonorTypeId(DonorTypeId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationId(OrganizationId, DonorTypeId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNamePrefix(NamePrefix);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFirstName(FirstName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMiddleName(MiddleName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLastName(LastName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNameSuffix(NameSuffix);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDonorAffiliation(DonorAffiliation, DonorTypeId);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAddress1(Address1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAddress2(Address2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCity(City);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStateId(StateId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateZip(Zip);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonorTypeId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateDonorTypeId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonorTypeId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonorTypeId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonorBase.ValidateDonorTypeId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'DonorTypeId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonorBase.ValidateInstitutionId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'InstitutionId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateOrganizationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of OrganizationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateOrganizationId(Int32 value, Int32 value1, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonorBase.ValidateOrganizationId(value, value1, appCon);
		 
			// TODO: Add property specific validation logic for 'OrganizationId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NamePrefix property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateNamePrefix.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NamePrefix</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNamePrefix(string value)
		{
			ReturnStatus ret = DonorBase.ValidateNamePrefix(value);
		 
			// TODO: Add property specific validation logic for 'NamePrefix'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FirstName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateFirstName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FirstName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFirstName(string value)
		{
			ReturnStatus ret = DonorBase.ValidateFirstName(value);
		 
			// TODO: Add property specific validation logic for 'FirstName'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MiddleName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateMiddleName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MiddleName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMiddleName(string value)
		{
			ReturnStatus ret = DonorBase.ValidateMiddleName(value);
		 
			// TODO: Add property specific validation logic for 'MiddleName'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LastName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateLastName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of LastName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateLastName(string value)
		{
			ReturnStatus ret = DonorBase.ValidateLastName(value);
		 
			// TODO: Add property specific validation logic for 'LastName'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NameSuffix property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateNameSuffix.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NameSuffix</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNameSuffix(string value)
		{
			ReturnStatus ret = DonorBase.ValidateNameSuffix(value);
		 
			// TODO: Add property specific validation logic for 'NameSuffix'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DonorAffiliation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateDonorAffiliation.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DonorAffiliation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDonorAffiliation(string value, Int32 value1)
		{
			ReturnStatus ret = DonorBase.ValidateDonorAffiliation(value, value1);
		 
			// TODO: Add property specific validation logic for 'DonorAffiliation'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Address1 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateAddress1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Address1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAddress1(string value)
		{
			ReturnStatus ret = DonorBase.ValidateAddress1(value);
		 
			// TODO: Add property specific validation logic for 'Address1'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Address2 property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateAddress2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Address2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateAddress2(string value)
		{
			ReturnStatus ret = DonorBase.ValidateAddress2(value);
		 
			// TODO: Add property specific validation logic for 'Address2'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for City property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateCity.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of City</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCity(string value)
		{
			ReturnStatus ret = DonorBase.ValidateCity(value);
		 
			// TODO: Add property specific validation logic for 'City'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StateId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateStateId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StateId</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStateId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = DonorBase.ValidateStateId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'StateId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Zip property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling DonorBase.ValidateZip.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Zip</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateZip(string value)
		{
			ReturnStatus ret = DonorBase.ValidateZip(value);
		 
			// TODO: Add property specific validation logic for 'Zip'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'Donor'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkDonor table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkDonor entry</param>
		/// <returns type="DataSet">
		///		<Columns>
		///			<Column name="ID" type="Int32"/>
		///			<Column name="DonorTypeId" type="Int32"/>
		///			<Column name="InstitutionId" type="Int32"/>
		///			<Column name="OrganizationId" type="Int32"/>
		///			<Column name="NamePrefix" type="string"/>
		///			<Column name="FirstName" type="string"/>
		///			<Column name="MiddleName" type="string"/>
		///			<Column name="LastName" type="string"/>
		///			<Column name="NameSuffix" type="string"/>
		///			<Column name="DonorAffiliation" type="string"/>
		///			<Column name="Address1" type="string"/>
		///			<Column name="Address2" type="string"/>
		///			<Column name="City" type="string"/>
		///			<Column name="StateId" type="Int32"/>
		///			<Column name="Zip" type="string"/>
		///			<Column name="Version" type="Int32"/>
		///		</Columns>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select "
				 + DonorMsSqlSrv.idField + " As ID"
				 + ", " + DonorMsSqlSrv.donorTypeIdField + " As DonorTypeId"
				 + ", " + DonorMsSqlSrv.institutionIdField + " As InstitutionId"
				 + ", " + DonorMsSqlSrv.organizationIdField + " As OrganizationId"
				 + ", " + DonorMsSqlSrv.namePrefixField + " As NamePrefix"
				 + ", " + DonorMsSqlSrv.firstNameField + " As FirstName"
				 + ", " + DonorMsSqlSrv.middleNameField + " As MiddleName"
				 + ", " + DonorMsSqlSrv.lastNameField + " As LastName"
				 + ", " + DonorMsSqlSrv.nameSuffixField + " As NameSuffix"
				 + ", " + DonorMsSqlSrv.donorAffiliationField + " As DonorAffiliation"
				 + ", " + DonorMsSqlSrv.address1Field + " As Address1"
				 + ", " + DonorMsSqlSrv.address2Field + " As Address2"
				 + ", " + DonorMsSqlSrv.cityField + " As City"
				 + ", " + DonorMsSqlSrv.stateIdField + " As StateId"
				 + ", " + DonorMsSqlSrv.zipField + " As Zip"
				 + ", " + DonorMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName ;
			
			StringBuilder command = new StringBuilder(sCommand);
			if(idValue != 0)
				 command.Append(" WHERE Id = '" + idValue + "' ");
		
			return ApplicationConnection.ExecuteQuery(command.ToString(), "DonorList");
		}
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkDonor table.>
		/// </summary>
		/// <returns type="DataSet">
		///		<Columns>
		///			<Column name="ID" type="Int32"/>
		///			<Column name="DonorTypeId" type="Int32"/>
		///			<Column name="InstitutionId" type="Int32"/>
		///			<Column name="OrganizationId" type="Int32"/>
		///			<Column name="NamePrefix" type="string"/>
		///			<Column name="FirstName" type="string"/>
		///			<Column name="MiddleName" type="string"/>
		///			<Column name="LastName" type="string"/>
		///			<Column name="NameSuffix" type="string"/>
		///			<Column name="DonorAffiliation" type="string"/>
		///			<Column name="Address1" type="string"/>
		///			<Column name="Address2" type="string"/>
		///			<Column name="City" type="string"/>
		///			<Column name="StateId" type="Int32"/>
		///			<Column name="Zip" type="string"/>
		///			<Column name="Version" type="Int32"/>
		///		</Columns>
		/// </returns>
		public static DataSet GetQuickList()
		{
			return GetQuickList(0);
		}
		/// <summary>
		/// 
		/// </summary>
		/// <param name="StationId"></param>
		/// <param name="DonorAffiliation"></param>
		/// <returns></returns>
		public static DataSet GetQuickListBy_StationId_DonorAffiliation(int StationId, string DonorAffiliation)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonorQuickListBy_StationId_DonorAffilitation ");
			sCommand.Append(StationId.ToString() + ", '" + DonorAffiliation + "'");
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId_DonorAffiliation", out Success);			
		}
		/// <summary>
		/// 
		/// </summary>
		/// <param name="StationId"></param>
		/// <param name="LastName"></param>
		/// <returns></returns>
		public static DataSet GetQuickListBy_StationId_LastName(int StationId, string LastName)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonorQuickListBy_StationId_LastName ");
			sCommand.Append(StationId.ToString() + ", '" + LastName + "'");
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId_LastName", out Success);			
		}
		/// <summary>
		/// 
		/// </summary>
		/// <param name="StationId"></param>
		/// <param name="OrganizationId"></param>
		/// <returns></returns>
		public static DataSet GetQuickListBy_StationId_OrganizationId(int StationId, int OrganizationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonorQuickListBy_StationId_OrganizationId ");
			sCommand.Append(StationId.ToString() + ", " + OrganizationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId_OrganizationId", out Success);			
		}
		/// <summary>
		/// 
		/// </summary>
		/// <param name="StationId"></param>
		/// <returns></returns>
		public static DataSet GetQuickListBy_StationId(int StationId)
		{
			StringBuilder sCommand = new StringBuilder("spS_DonorQuickListBy_StationId " + StationId.ToString());
			
			int Success = 0;
			return ApplicationConnection.ExecuteQuery(sCommand.ToString(), "GetQuickListBy_StationId", out Success);			
		}
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
