﻿
/*

			Class:              GamesRegistration

			Date Produced:      02/27/2003 12:37:57 PM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Langley
			LastUpdated:        02/27/2003 9:10:36 AM
			Revision:           673

			SQL Server Version: 08.00.0760
			Server:             ISF-LANGLEYM
			Database:           [VSS_Games_Test]
			Code generated in:  D:\Olymars_test\1.0.1070.23427\Vha.Vtk.Games

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.1070.23427

*/

#define msSql
		
#region Section: Using Declarations
		
// TODO: Determine if all 'using' statements are needed.
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text;

using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
//using Vha.Vtk.Kernel.Data;
//using Vha.Vtk.Kernel.Data.SystemTables;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.GamesRegistrationMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Games
{
	/// <summary>
	///  Public Class mapped to VtkGamesRegistration
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class GamesRegistration : GamesRegistrationBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkGamesRegistration entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public GamesRegistration(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private GamesRegistration(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of GamesRegistration thate will be used to add a record to the VtkGamesRegistration database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="GamesRegistration"/></returns>
		public static GamesRegistration AddRecord(ApplicationConnection appCon)
		{
			GamesRegistration gamesObj = new GamesRegistration(appCon);
			gamesObj.FillDataNew();
			return gamesObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationProfilesId(StationProfilesId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVAEmployeeStatusId(VAEmployeeStatusId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateGameScheduleId(GameScheduleId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateShirtSizeId(ShirtSizeId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTransportationStatus(TransportationStatus);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTransportationStation(TransportationStation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLodgingCode(LodgingCode);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFirstTimeParticipant(FirstTimeParticipant);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStartDate(StartDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEndDate(EndDate);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfilesId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateStationProfilesId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationProfilesId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStationProfilesId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateStationProfilesId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'StationProfilesId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VAEmployeeStatusId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateVAEmployeeStatusId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of VAEmployeeStatusId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateVAEmployeeStatusId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateVAEmployeeStatusId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'VAEmployeeStatusId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for GameScheduleId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateGameScheduleId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of GameScheduleId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateGameScheduleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateGameScheduleId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'GameScheduleId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ShirtSizeId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateShirtSizeId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ShirtSizeId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateShirtSizeId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateShirtSizeId(value, appCon);
		 
			// TODO: Add property specific validation logic for 'ShirtSizeId'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for TransportationStatus property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateTransportationStatus.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TransportationStatus</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateTransportationStatus(bool value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateTransportationStatus(value);
		 
			// TODO: Add property specific validation logic for 'TransportationStatus'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for TransportationStation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateTransportationStation.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TransportationStation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateTransportationStation(string value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateTransportationStation(value);
		 
			// TODO: Add property specific validation logic for 'TransportationStation'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LodgingCode property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateLodgingCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of LodgingCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateLodgingCode(string value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateLodgingCode(value);
		 
			// TODO: Add property specific validation logic for 'LodgingCode'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FirstTimeParticipant property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateFirstTimeParticipant.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FirstTimeParticipant</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFirstTimeParticipant(bool value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateFirstTimeParticipant(value);
		 
			// TODO: Add property specific validation logic for 'FirstTimeParticipant'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StartDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateStartDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StartDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStartDate(DateTime value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateStartDate(value);
		 
			// TODO: Add property specific validation logic for 'StartDate'.
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EndDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling GamesRegistrationBase.ValidateEndDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of EndDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateEndDate(DateTime value)
		{
			ReturnStatus ret = GamesRegistrationBase.ValidateEndDate(value);
		 
			// TODO: Add property specific validation logic for 'EndDate'.
		 
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		// TODO: Add quick lists for 'GamesRegistration'.
		
		#if msSql
		
		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkGamesRegistration table.>
		/// </summary>
		/// <param name="idValue">Primary key value for VtkGamesRegistration entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		///<Columns Description="Returns dataset for entry.">
		///		<Column name="ID" type="Int32"/>
		///		<Column name="StationProfilesId" type="Int32"/>
		///		<Column name="GamesTypeId" type="Int32"/>
		///		<Column name="ShirtSizeId" type="Int32"/>
		///		<Column name="TransportationStatus" type="bool"/>
		///		<Column name="TransportationStation" type="System.String"/>
		///		<Column name="LodgingCode" type="System.String"/>
		///		<Column name="FirstTimeParticipant" type="bool"/>
		///		<Column name="StartDate" type="DateTime"/>
		///		<Column name="EndDate" type="DateTime"/>
		///		<Column name="Version" type="Int32"/>
		///</Columns>
		/// </returns>
		public static DataSet GetQuickList(int idValue)
		{
			string sCommand = 
				"Select "
				 + GamesRegistrationMsSqlSrv.idField + " As ID"
				 + ", " + GamesRegistrationMsSqlSrv.stationProfilesIdField + " As StationProfilesId"
				 + ", " + GamesRegistrationMsSqlSrv.vaEmployeeStatusIdField + " As VAEmployeeStatusId"
				 + ", " + GamesRegistrationMsSqlSrv.gameScheduleIdField + " As GameScheduleId"
				 + ", " + GamesRegistrationMsSqlSrv.shirtSizeIdField + " As ShirtSizeId"
				 + ", " + GamesRegistrationMsSqlSrv.transportationStatusField + " As TransportationStatus"
				 + ", " + GamesRegistrationMsSqlSrv.transportationStationField + " As TransportationStation"
				 + ", " + GamesRegistrationMsSqlSrv.lodgingCodeField + " As LodgingCode"
				 + ", " + GamesRegistrationMsSqlSrv.firstTimeParticipantField + " As FirstTimeParticipant"
				 + ", " + GamesRegistrationMsSqlSrv.startDateField + " As StartDate"
				 + ", " + GamesRegistrationMsSqlSrv.endDateField + " As EndDate"
				 + ", " + GamesRegistrationMsSqlSrv.versionField + " As Version"
				 + " FROM  " + sqlDrv.tableName ;

			StringBuilder command = new StringBuilder(sCommand);
			if(idValue != 0)
				 command.Append(" WHERE Id = '" + idValue + "' ");
			
			return ApplicationConnection.ExecuteQuery(command.ToString(), "GamesRegistrationList");
		}

		/// <summary>
		/// Basic method the retrieves all the fields for an entry in the VtkGamesRegistration table.>
		/// </summary>
		/// <param name="idValue" type="Int32">Primary key value for VtkGamesRegistration entry</param>
		/// <returns type="DataSet">
		///		<Columns>
		///			<Column name="ID" type="Int32"/>
		///			<Column name="StationProfilesId" type="Int32"/>
		///			<Column name="GamesTypeId" type="Int32"/>
		///			<Column name="ShirtSizeId" type="Int32"/>
		///			<Column name="TransportationStatus" type="bool"/>
		///			<Column name="TransportationStation" type="System.String"/>
		///			<Column name="LodgingCode" type="System.String"/>
		///			<Column name="FirstTimeParticipant" type="bool"/>
		///			<Column name="StartDate" type="DateTime"/>
		///			<Column name="EndDate" type="DateTime"/>
		///			<Column name="Version" type="Int32"/>
		///		</Columns>
		/// </returns>
		public static DataSet GetQuickList()
		{
			return GetQuickList(0);
		}

		public static DataSet GetQuickListByGameSchedule(int GamesScheduleId)
		{
			return ApplicationConnection.ExecuteQuery("spS_GetQuickListByGamesSchedule " + GamesScheduleId.ToString(), "GamesRegistrationList");
		}
		public static int FindGamesRegistrationId(int GamesScheduleId, int VolunteerStationProfileId)
		{
				DataSet ds = ApplicationConnection.ExecuteQuery("spS_FindGamesRegistrationId " + GamesScheduleId.ToString() + ", " + VolunteerStationProfileId.ToString(), "GamesRegistration");			
				if(ds.Tables["GamesRegistration"].Rows.Count >= 1)
					return (int)ds.Tables["GamesRegistration"].Rows[0]["ID"];
				else
					return 0;
		}
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related 
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
