﻿
/*

			Class:              Holiday

			Date Produced:      11/6/2001 9:14:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations

using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.HolidayMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkHolidays
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Holiday : HolidayBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		

		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkHolidays entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Holiday(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		// This section contains no methods since it is a static/uneditable table.
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists

		#if msSql
		/// <summary>
		/// Returns DataSet of all Holidays in TableName:  <b>'HolidayList'</b>
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet TableName:</li> <ul><li><b>HolidayList</b></li></ul>
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [int]</li>
		///  <li><b>ObservanceDate</b>  [DateTime]</li>
		///  <li><b>HolidayName</b>  [string (40)]</li>
		///  <li><b>IsFederalHoliday</b> [bool]</li>
		///  </ul>
		/// <br> </br>
		/// <li>Sorted By:  <b>Id</b></li>
		/// </ul>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (5) Doubt this is called often...if at all.
			string sCommand = "Select id ID, " + 
				sqlDrv.observanceDateField     + " ObservanceDate, " +
				sqlDrv.holidayNameField        + " HolidayName, " +
				sqlDrv.isFederalHolidayField   + " IsFederalHoliday " +
				"  FROM  " + sqlDrv.tableName;
			
			return ApplicationConnection.ExecuteQuery(sCommand, "HolidayList");
		}

		/// <summary>
		/// Returns boolean value of whether a date is in the VtkHolidays table
		/// </summary>
		/// <param name="day">DateTime of Holdiay to check</param>
		/// <param name="appCon">ApplicationConnection Object Reference</param>
		/// <returns>
		/// <ul><li>bool (holiday exists)</li></ul>
		/// </returns>
		public static bool IsHoliday(DateTime day)
		{
			// TODO: Stored Procedure: (1) Used often for meal eligibility?
			// TODO: Code Enhancement Possibility: (1) Change to SqlCommand.ExecuteScalar call! (See Users.ValidateRelations for example.) 
			string sCommand = "Select Id FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.observanceDateField + " = '" + day.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "' ";

			return (ApplicationConnection.ExecuteQuery(sCommand, "HolidayList").Tables["HolidayList"].Rows.Count > 0);
		}
		
		#endif
		
		#endregion
	
		#region Section: Utilities
		
		
		#endregion
		
	}
}
