﻿
/*

			Class:              Language

			Date Produced:      11/6/2001 9:14:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.LanguageMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkLanguages
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Language : LanguageBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkLanguages entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Language(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		// This section contains no methods since it is a static/uneditable table.
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		///  Returns a list of all languages
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet TableName: <b>LanguageList</b></br>
		/// <br></br>
		/// <br>Data Columns returned: </br>
		/// <br><b> ID</b> [int]</br>
		/// <br><b> LanguageName</b> [string (20)]</br>
		/// <br><b> Culture </b> [string (10)]</br>
		/// <br><b> CultureIdentifier </b> [string (6)]</br>
		/// <br><b> CountryOrRegion </b> [string (20)]</br>
		/// <br><b> LanguageWithLocale</b> [string (610)]</br>
		/// <br></br>
		/// <br>Sorted By: Id</br>
		/// <br></br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (1) Used by auto-logon?
			// TODO: Code Enhancement Possibility: (1) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.languageNameField       + " LanguageName, " +
				sqlDrv.cultureField            + " Culture, " +
				sqlDrv.cultureIdentifierField  + " CultureIdentifier, " +
				sqlDrv.countryOrRegionField    + " CountryOrRegion, " +
				sqlDrv.languageWithLocaleField + " LanguageWithLocale " +
				" FROM  " + sqlDrv.tableName;

			return ApplicationConnection.ExecuteQuery(sCommand, "LanguageList");
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		
		/// <summary>
		/// Retrieves primary key for a culture.
		/// </summary>
		/// <param name="culture">Culture code</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>Primay key of a culture</returns>
		public static int GetIdForCulture(string culture)
		{
			// TODO: Code Enhancement Possibility: (1) Change to SqlCommand.ExecuteScalar call! (See Users.ValidateRelations for example.) 
			Object value;
			string sCommand = "SELECT " + LanguageMsSqlSrv.idField + " " + 
				"FROM " + LanguageMsSqlSrv.tableName + " " +
				"WHERE " + LanguageMsSqlSrv.cultureField + " = '" + culture + "'";

			SqlConnection conn = new SqlConnection(ApplicationConnection.GetConnectionString());
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			value = cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();

			return (value != null) ? (int)value : -1;
		}

		#endif

		#endregion
		
	}
}
