﻿
/*

			Class:              Role

			Date Produced:      11/6/2001 9:14:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations

using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.RoleMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkRoles
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class Role : RoleBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkRoles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public Role(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		// This section contains no methods since it is a static/uneditable table.
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists

		/// <summary>
		/// Returns a list of all roles
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet TableName: <b>RoleList</b></br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b> ID</b> [int]</br>
		/// <br><b> RoleName</b> [string (30)]</br>
		/// <br><b> Description </b> [string (20)]</br>
		/// <br></br>
		/// Sorted By:  RoleName
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (2) Used by User functionality?
			// TODO: Code Enhancement Possibility: (2) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, " + 
				sqlDrv.roleNameField           + " RoleName, " +
				sqlDrv.descriptionField        + " Description " +
				" FROM " + sqlDrv.tableName    +
				" ORDER BY " + sqlDrv.roleNameField;
 
			return ApplicationConnection.ExecuteQuery(sCommand, "RoleList");
		}

		/// Returns a list of all roles in the NameObjectCollection.
		/// DataReader: 
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>RoleName</b>  [string]</li>
		///  <li><b>Description</b>  [string]</li>
		///  </ul>
		/// <br></br>
		/// <br>Sorted By: RoleName</br>
		/// </returns>
		public static NameObjectCollection GetQuickDRList()
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "Select id ID, " + 
				sqlDrv.roleNameField           + " RoleName, " +
				sqlDrv.descriptionField        + " Description " +
				" FROM " + sqlDrv.tableName    +
				" ORDER BY " + sqlDrv.roleNameField;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}


		#endregion
		
		#region Section: Utilities
		
		
#if msSql
		
		/// <summary>
		/// Retrieves primary key for a role.
		/// </summary>
		/// <param name="role">Role Name</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>Primay key of a role</returns>
		public static int GetIdForRole(string role)
		{
			// TODO: Code Enhancement Possibility: (1) Change to SqlCommand.ExecuteScalar call! (See Users.ValidateRelations for example.) 
			Object value;
			string sCommand = "SELECT " + RoleMsSqlSrv.idField + " " + 
				"FROM " + RoleMsSqlSrv.tableName + " " +
				"WHERE " + RoleMsSqlSrv.roleNameField + " = '" + role + "'";

			SqlConnection conn = new SqlConnection(ApplicationConnection.GetConnectionString());
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			value = cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();

			return (value != null) ? (int)value : -1;
		}

		#endif

		#endregion
		
	}
}
