﻿
/*

			Class:              User

			Date Produced:      11/6/2001 9:14:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text.RegularExpressions;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.UserMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkUsers
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class User : UserBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkUsers entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public User(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private User(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Create instance based on DataRow from User table.
		/// </summary>
		/// <param name="dr">DataRow to be used to fill instance</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		private User(DataRow dr, ApplicationConnection appCon) : base(dr, appCon)
	{
	}
		/// <summary>
		/// Create instance to be used to add a new User to the database.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>Blank User instance</returns>
		public static User AddRecord(ApplicationConnection appCon)
		{
			User userObj = new User(appCon);
			userObj.FillDataNew();
			return userObj;
		}
		/// <summary>
		/// Create a user instance given an Windows User Name.
		/// </summary>
		/// <param name="windowsUserName"></param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// If no User record exists for Windows User Name than null is returned, otherwise a User 
		/// instance is returned.
		/// </returns>
		#if msSql
		public static User GetUserForWindowsUserName(string windowsUserName, ApplicationConnection appCon)
		{
			// TODO: Stored Procedure: (3) This method was requested.
			string sCommand = 
				"SELECT * " +
				"FROM "     + UserMsSqlSrv.tableName + " " + 
				"WHERE "    + UserMsSqlSrv.ntUserNameField + " = '" + Vha.Vtk.Kernel.Common.MsSqlTools.PrepareString(windowsUserName) + "'";

			string tableName = "User";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,tableName);
			da.Dispose();

			User usrObj = null;
			if (ds.Tables[tableName].Rows.Count == 1)
			{
				usrObj = new User(ds.Tables[tableName].Rows[0], appCon);
				usrObj.dataSrv.SetDataSetInfo(ds, tableName, 0);
			}
			ds.Dispose();
			return usrObj;
		}
		#endif
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters

		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			//if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNtUserName(NtUserName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLastName(LastName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateFirstName(FirstName);
      if (returnStatus.Status == si.Pass) returnStatus = ValidateMiddleName(MiddleName);
      if (returnStatus.Status == si.Pass) returnStatus = ValidatePrimaryInstitution(PrimaryInstitution, appCon);
      if (returnStatus.Status == si.Pass) returnStatus = ValidateNickname(Nickname);
      if (returnStatus.Status == si.Pass) returnStatus = ValidateJobTitleId(JobTitleId, appCon);
      if (returnStatus.Status == si.Pass) returnStatus = ValidatePositionStartDate(PositionStartDate);
      if (returnStatus.Status == si.Pass) returnStatus = ValidateSex(Sex);
      if (returnStatus.Status == si.Pass) returnStatus = ValidateGrade(Grade);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEMailAddress(EMailAddress);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDefaultInstitutionId(DefaultInstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = CheckForDuplicates(ID, NtUserName);
			return returnStatus;
		}

		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>NT User name must ne unique</description></item>
		/// <item><description>Email address must be unique</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "User";
			ret.Status = si.Pass;			
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for NtUserName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateNtUserName.</description></item>
		/// <item><description>Also see <see cref="ValidateRelations"/> for other NtUserName validity checks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NtUserName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateNtUserName(string value)
		{
			ReturnStatus ret = UserBase.ValidateNtUserName(value);	
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LastName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateLastName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of LastName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateLastName(string value)
		{
			ReturnStatus ret = UserBase.ValidateLastName(value);
		 
			// Property Specific Validation
			if ((ret.Status == si.Pass) && (value.IndexOf(",") > -1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'LastName' contains a comma ',' and is not allowed.";
			}
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for FirstName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateFirstName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of FirstName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateFirstName(string value)
		{
			ReturnStatus ret = UserBase.ValidateFirstName(value);
		 
			// Property Specific Validation
			if ((ret.Status == si.Pass) && (value.IndexOf(",") > -1))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'FirstName' contains a comma ',' and is not allowed.";
			}
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MiddleName property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateMiddleName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MiddleName</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMiddleName(string value)
		{
			ReturnStatus ret = UserBase.ValidateMiddleName(value);		 
			return ret;
		}
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for PrimaryInstitution property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidatePrimaryInstitution.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of PrimaryInstitution</param>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidatePrimaryInstitution(Int32 value, ApplicationConnection appCon)
    {
      ReturnStatus ret = UserBase.ValidatePrimaryInstitution(value, appCon);
		 
      // TODO: Add property specific validation logic for 'PrimaryInstitution'.
		 
      return ret;
    }
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for Nickname property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateNickname.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of Nickname</param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidateNickname(string value)
    {
      ReturnStatus ret = UserBase.ValidateNickname(value);
		 
      // TODO: Add property specific validation logic for 'Nickname'.
		 
      return ret;
    }
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for JobTitleId property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateJobTitleId.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of JobTitleId</param>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidateJobTitleId(Int32 value, ApplicationConnection appCon)
    {
      ReturnStatus ret = UserBase.ValidateJobTitleId(value, appCon);
		 
      // TODO: Add property specific validation logic for 'JobTitleId'.
		 
      return ret;
    }
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for PositionStartDate property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidatePositionStartDate.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of PositionStartDate</param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidatePositionStartDate(DateTime value)
    {
      ReturnStatus ret = UserBase.ValidatePositionStartDate(value);
		 
      // TODO: Add property specific validation logic for 'PositionStartDate'.
		 
      return ret;
    }
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for Sex property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateSex.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of Sex</param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidateSex(string value)
    {
      ReturnStatus ret = UserBase.ValidateSex(value);
		 
      // TODO: Add property specific validation logic for 'Sex'.
		 
      return ret;
    }
		 
    /// <summary>
    /// Performs basic database-centric and any special validation checks for Grade property values.
    /// </summary>
    /// <remarks>
    /// <list type="bullet">
    /// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateGrade.</description></item>
    /// </list>
    /// </remarks>
    /// <param name="value">Current instance value of Grade</param>
    /// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
    public static new ReturnStatus ValidateGrade(string value)
    {
      ReturnStatus ret = UserBase.ValidateGrade(value);
		 
      // TODO: Add property specific validation logic for 'Grade'.
		 
      return ret;
    }
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EMailAddress property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateEMailAddress.</description></item>
		/// <item><description>Also see <see cref="ValidateRelations"/> for other EMailAddress validity checks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of EMailAddress</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateEMailAddress(string value)
		{
			ReturnStatus ret = UserBase.ValidateEMailAddress(value);
		 
			// Property Specific Validation
			if ((ret.Status == si.Pass) && ((value.Length > 0) && (value.IndexOf("@") < 1)))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'EMailAddress' must contain an '@' after the first character.";
			}
		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DefaultInstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserBase.ValidateDefaultInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DefaultInstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateDefaultInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = UserBase.ValidateDefaultInstitutionId(value, appCon);
		 
			return ret;
		}
		 
		
		private static ReturnStatus CheckForDuplicates(int ID, string NtUserName)
		{			
			
			//Run a DB Check to see if another Volunteer exists with this SSN
			SqlConnection sqlConn = new SqlConnection(ApplicationConnection.GetConnectionString());

			SqlCommand sqlCmd			= new SqlCommand("VtkNtUserNameExistsQuery", sqlConn);
			sqlCmd.CommandType		= CommandType.StoredProcedure;

			SqlParameter sqlParam	= sqlCmd.Parameters.Add("@NtUserName", SqlDbType.VarChar, 40);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= NtUserName;

			sqlParam							= sqlCmd.Parameters.Add("@UserId", SqlDbType.VarChar, 3);
			sqlParam.Direction		= ParameterDirection.Input;
			sqlParam.Value				= ID;

			//These are all Return Parameters and Return Value
			sqlParam							= sqlCmd.Parameters.Add("@IsNtUserNameExisting", SqlDbType.Bit);
			sqlParam.Direction		= ParameterDirection.Output;			

			sqlParam							= sqlCmd.Parameters.Add("RETURN_STATUS", SqlDbType.Int);
			sqlParam.Direction		= ParameterDirection.ReturnValue;

			sqlConn.Open();
			sqlCmd.ExecuteNonQuery();

			bool RETURN_ISNTUSERNAMEEXISTS = Convert.ToBoolean(sqlCmd.Parameters["@IsNtUserNameExisting"].Value);
			bool RETURN_STATUS = Convert.ToBoolean(sqlCmd.Parameters["RETURN_STATUS"].Value);
			sqlConn.Close();

			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "Organization";

			if(RETURN_STATUS)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "An error accured while checking for duplicates in the User table.";		
			}
			else if(RETURN_ISNTUSERNAMEEXISTS)
			{
				ret.Status = si.Fail;
				ret.PropertyName = "NtUserName";
				ret.ErrorText = "'NtUserName'(" + NtUserName + ")  already exists, please enter another value.";
			}
			return ret;
		}
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
 
	/// <summary>
	/// Returns a list of all users.
	/// </summary>
	/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
	/// <returns>
	/// <br>DataSet TableName: <b>UserList</b></br>
    /// <br></br>
    /// <li>Data Columns Returned:</li>
    ///  <ul>
    ///  <li><b>ID</b>  [Int32]</li>
    ///  <li><b>NtUserName</b>  [string]</li>
    ///  <li><b>LastName</b>  [string]</li>
    ///  <li><b>FirstName</b>  [string]</li>
    ///  <li><b>MiddleName</b>  [string]</li>
    ///  <li><b>PrimaryInstitution</b>  [Int32]</li>
    ///  <li><b>Nickname</b>  [string]</li>
    ///  <li><b>JobTitleId</b>  [Int32]</li>
    ///  <li><b>PositionStartDate</b>  [DateTime]</li>
    ///  <li><b>Sex</b>  [string]</li>
    ///  <li><b>Grade</b>  [string]</li>
    ///  <li><b>LowercaseNameForDisplay</b>  [string]</li>
    ///  <li><b>UppercaseNameForDisplay</b>  [string]</li>
    ///  <li><b>FullNameForReports</b>  [string]</li>
    ///  <li><b>EMailAddress</b>  [string]</li>
    ///  <li><b>DefaultInstitutionId</b>  [Int32]</li>
    ///  <li><b>Version</b>  [Int32]</li>
    ///  </ul>
		/// <br></br>
		/// <br>Sorted By: FullNameForReports</br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (5) Doubt this is called often...if at all
			string sCommand = "Select id ID, "      + 
				sqlDrv.lastNameField                + " LastName, " +
				sqlDrv.firstNameField               + " FirstName, " +
				sqlDrv.middleNameField              + " MiddleName, " +
				sqlDrv.fullNameForReportsField		+ " FullNameForReports, " +
				sqlDrv.lowercaseNameForDisplayField + " LowercaseNameForDisplay, " +
				sqlDrv.uppercaseNameForDisplayField + " UppercaseNameForDisplay, " +
				sqlDrv.ntUserNameField              + " NtUserName, " +
				sqlDrv.eMailAddressField            + " EMailAddress, " +
				sqlDrv.defaultInstitutionIdField    + " DefaultInstitutionId " +
				" FROM " + sqlDrv.tableName         +
				" ORDER BY " + sqlDrv.fullNameForReportsField;
			
			return ApplicationConnection.ExecuteQuery(sCommand, "UserList");
		}

		/// Returns a list of all users in the NameObjectCollection.
		/// DataReader: 
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>FullNameForReports</b>  [string]</li>
		///  </ul>
		/// <br></br>
		/// <br>Sorted By: FullNameForReports</br>
		/// </returns>
		public static NameObjectCollection GetQuickDRList()
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "Select id ID, "      + 
				sqlDrv.fullNameForReportsField		+ " FullNameForReports " +
				" FROM " + sqlDrv.tableName         +
				" ORDER BY " + sqlDrv.fullNameForReportsField;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		//**
		/// <summary>
		/// Returns data where User.NtUserName equals ntUser param.
		/// </summary>
		/// <param name="ntUser">NtUserName (from windows authentication)</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet TableName: <b>UserList</b></br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>Id</b> [int]</br>
		/// <br><b>LastName</b> [string (30)] </br>
		/// <br><b>FirstName</b>[string (30)] </br>
		/// <br><b>MiddleName</b>[string (20)] </br>
		/// <br><b>LowercaseNameForDisplay</b> [string (92)] </br>
		/// <br><b>UpperCaseNameForDisplay</b>[string (162)] </br>
		/// <br><b>NtUserName</b> [string (50)] </br>
		/// <br><b>EmailAddress</b> [string (50)]</br>
		/// <br><b>DefaultInstitutionId</b> [int]</br>
		/// <br></br>
		/// <br>Sorted By: FullNameForReports</br>
		/// </returns>
		public static DataSet GetUserInfoByNTUserName(string ntUser)
		{
			// TODO: Stored Procedure: (3) This quicklist was requested.
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "Select id ID, "       + 
				sqlDrv.lastNameField                 + " LastName, " +
				sqlDrv.firstNameField                + " FirstName, " +
				sqlDrv.middleNameField               + " MiddleName, " +
				sqlDrv.lowercaseNameForDisplayField  + " LowercaseNameForDisplay, " +
				sqlDrv.uppercaseNameForDisplayField  + " UppercaseNameForDisplay, " +
				sqlDrv.ntUserNameField               + " NtUserName, "  +
				sqlDrv.eMailAddressField             + " EMailAddress, " +
				sqlDrv.defaultInstitutionIdField     + " DefaultInstitutionId " +
				" FROM "     + sqlDrv.tableName       +
				" WHERE "    + sqlDrv.ntUserNameField + " = '" + ntUser + "' " +
				" ORDER BY " + sqlDrv.fullNameForReportsField;
			
			return ApplicationConnection.ExecuteQuery(sCommand, "UserList");
    }

    /// <summary>
    /// Returns all users for a specific InstitutionId.
    /// </summary>
    /// <param name="InstitutionId">InstitutionId [int]</param>
    /// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
    /// <returns>
    /// <br>DataSet TableName: <b>UserList</b></br>
    /// <br></br>
    /// <br>Data Columns Returned:</br>
    /// <br><b>Id</b> [int]</br>
    /// <br><b>DisplayName</b></br>
    /// <br></br>
    /// <br>Sorted By: Unspecified</br>
    /// </returns>
    public static DataSet GetQuickListByInstitutionId(int InstitutionId)
    {
      string sCommand = "VtkUsersNameQuery " + InstitutionId;
			
			return ApplicationConnection.ExecuteQuery(sCommand, "UserList");
    }
		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
