﻿
/*

			Class:              UserRole

			Date Produced:      11/6/2001 9:14:04 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.Kernel.Data

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
			
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.UserRoleMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.Kernel.Data.SystemTables
{
	/// <summary>
	///  Public Class mapped to VtkUserRoles
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class UserRole : UserRoleBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main constructor.
		/// </summary>
		/// <param name="id">Primary key value for VtkUserRoles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public UserRole(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private UserRole(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of UserRole thate will be used to add a record to the VtkUserRoles database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="UserRole"/></returns>
		public static UserRole AddRecord(ApplicationConnection appCon)
		{
			UserRole usroleObj = new UserRole(appCon);
			usroleObj.FillDataNew();
			return usroleObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateInstitutionId(InstitutionId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateUserId(UserId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRoleId(RoleId, appCon);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for InstitutionId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserRoleBase.ValidateInstitutionId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of InstitutionId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateInstitutionId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = UserRoleBase.ValidateInstitutionId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for UserId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserRoleBase.ValidateUserId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of UserId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateUserId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = UserRoleBase.ValidateUserId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for RoleId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling UserRoleBase.ValidateRoleId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of RoleId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateRoleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = UserRoleBase.ValidateRoleId(value, appCon);
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists

		/// <summary>
		/// Returns all user role entries for all stations.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Tablename: UserRoleList</br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>ID</b> [int]</br>
		/// <br><b>UserId</b> [int]</br>
		/// <br><b>RoleId</b> [int]</br>
		/// <br><b>InstitutionId [int]</b></br>
		/// <br></br>
		/// <br>Sorted By: RoleId</br>
		/// </returns>
		public static DataSet GetQuickList()
		{
			// TODO: Stored Procedure: (5) Doubt this is called often...if at all.
			string sCommand = "Select id ID, " + 
				sqlDrv.userIdField        + " UserId, " +
				sqlDrv.roleIdField        + " RoleId, " +
				sqlDrv.institutionIdField + " InstitutionId " +
				" FROM " + sqlDrv.tableName +
				" ORDER BY " + sqlDrv.roleIdField;
 
			return ApplicationConnection.ExecuteQuery(sCommand, "UserRoleList");
		}

		/// <summary>
		/// Returns list of users in a specified role Id for a specified station Id
		/// </summary>
		/// <param name="roleId">Primary key of a VtkRole entry</param>
		/// <param name="stationId">Primary key of a VtkStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Tablename: UserRoleList</br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>ID</b> [int]</br>
		/// <br><b>UserId</b> [int]</br>
		/// <br><b>RoleId</b> [int]</br>
		/// <br><b>InstitutionId [int]</b></br>
		/// <br><b>UserDisplayName</b> [string] (a.k.a. FullNameForReports)</br>
		/// <br></br>
		/// <br>Sorted By: FullNameForReports</br>
		/// </returns>
		public static DataSet GetUsersByStationRoleId(int roleId, int stationId, ApplicationConnection appCon)
		{
			// TODO: Stored Procedure: (3) This quicklist was requested.
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = 
				"SELECT " +
				"UR." + UserRoleMsSqlSrv.idField             + " AS ID, " +
				"UR." + UserRoleMsSqlSrv.userIdField         + " AS UserId, " +
				"UR." + UserRoleMsSqlSrv.roleIdField         + " AS RoleId, " +
				"UR." + UserRoleMsSqlSrv.institutionIdField  + " AS InstitutionId, " +
				"U."  + UserMsSqlSrv.fullNameForReportsField + " AS UserDisplayName " +
				"FROM "       + UserRoleMsSqlSrv.tableName + " UR " +
				"INNER JOIN " + UserMsSqlSrv.tableName     + " U ON U." + UserMsSqlSrv.idField + " = UR." + UserRoleMsSqlSrv.userIdField + " " + 
				"WHERE UR."   + UserRoleMsSqlSrv.institutionIdField + " = " + stationId.ToString() + " " +
				"AND UR."     + UserRoleMsSqlSrv.roleIdField        + " = " + roleId.ToString()    + " " +
				"ORDER BY U." + UserMsSqlSrv.fullNameForReportsField;


			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"UserRoleList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// <br>Returns two (2) tables:</br>
		/// <br><b>UserRolesAtSites</b> from VtkNtUserSitesRoles StoredProcedure</br>
		/// <br><b>UserRoleInstitutionList</b>Distinct List of institutions where ntUserName has roles.</br>
		/// </summary>
		/// <param name="ntUserName">NtUserName (from Windows Authentication)</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table 0 Name: UserRolesAtSites</br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b> InstitutionId </b> [int]</br>
		/// <br><b> InstitutionName </b> [string (40)]</br>
		/// <br><b> InstitutionNumber </b> (same as stationNumber) [string (7)]</br>
		/// <br><b> RoleId</b> [int] </br>
		/// <br><b> RoleName</b>[string] </br>
		/// <br></br>
		/// <br>Sorted By: InstitutionId</br>
		/// <br></br>
		/// <br>DataSet Table 1 Name: UserRoleInstitutionList (Same as DistinctInstitutionQuickList)</br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>InstitutionId</b> [int]</br>
		/// <br><b>InstitutionName</b> [string (40)]</br>
		/// <br><b>InstitutionNumber</b> [string (7)]</br>
		/// <br><b>DisplayName</b> combination of Name and StationNumber (i.e. 'Name (number)')</br>
		/// <br></br>
		/// <br>Sorted By: InstitutionName</br>
		/// </returns>
		public static DataSet GetUserRoleAtSites(string ntUserName, ApplicationConnection appCon)
		{
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			if (appCon.Connection == null) {appCon.Connect();}
			SqlCommand cmd  = new SqlCommand("VtkNtUserSitesRoles", (SqlConnection)appCon.Connection);
			cmd.CommandType = CommandType.StoredProcedure;

			// define parameter
			SqlParameter param = null;
			param = new SqlParameter("@NtuserName", System.Data.SqlDbType.VarChar, 50);
			param.Direction = ParameterDirection.Input;
			param.Value     = ntUserName;
			cmd.Parameters.Add(param);

			DataSet ds = new DataSet();
			SqlDataAdapter da = new SqlDataAdapter();
			da.SelectCommand = cmd;
			da.Fill(ds,"UserRolesAtSites"); 
			da.Dispose();
			cmd.Dispose();

			ds = GetDistinctInstitutionQuickList(ds, ntUserName, appCon);
			return ds;
		}
		/// <summary>
		/// Gets a sites list of roles for an NT User Name.
		/// </summary>
		/// <param name="ntUserName" type="System.String"/>
		/// <param name="siteId" type="System.String"/>
		/// <returns type="System.Data.DataSet">
		public static DataSet GetUserRolesAtSite(int userId, int siteId)
		{
			string sCommand = "VtkUserRolesAtSite " + userId + ", " + siteId;
			SqlDataAdapter da = new SqlDataAdapter(sCommand, ApplicationConnection.GetConnectionString());
			DataSet ds = new DataSet();
			da.Fill(ds,"UserRolesAtSite");
			da.Dispose();
			return ds;
		}

		
		/// Gets a sites list of roles in the NameObjectCollection for an NT User Name.
		/// DataReader: 
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <li>Data Columns Returned:</li>
		///  <ul>
		///  <li><b>ID</b>  [Int32]</li>
		///  <li><b>RoleName</b>  [string]</li>
		///  <li><b>Description</b>  [string]</li>
		///  </ul>
		/// <br></br>
		/// <br>Sorted By: RoleName</br>
		/// </returns>
		public static NameObjectCollection GetUserRolesDRAtSite(int userId, int siteId)
		{
			SqlCommand sqlCommand = new SqlCommand();
			string sCommand = "VtkUserRolesAtSite " + userId + ", " + siteId;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		/// <summary>
		/// Returns Distinct list of Institutions where ntUserName has roles
		/// </summary>
		/// <param name="ntUserName">NtUserName (from Windows Authentication)</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet TableName: <b>UserRoleInstitutionList</b></br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>InstitutionId</b> [int]</br>
		/// <br><b>InstitutionName</b> [string (40)]</br>
		/// <br><b>InstitutionNumber</b> [string (7)]</br>
		/// <br><b>DisplayName</b> combination of Name and StationNumber (i.e. 'Name (number)')</br>
		/// <br></br>
		/// <br>Sorted By: InstitutionName</br>
		/// </returns>
		public static DataSet GetDistinctInstitutionQuickList(string ntUserName, ApplicationConnection appCon)
		{
			DataSet ds = new DataSet();
			return GetDistinctInstitutionQuickList(ds, ntUserName, appCon);
		}

		private static DataSet GetDistinctInstitutionQuickList(DataSet ds, string ntUserName, ApplicationConnection appCon)
		{
			// TODO: Stored Procedure: (3) This quicklist was requested.
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = "SELECT DISTINCT I.Id as InstitutionId, " +
				"I.NameOfInstitution as InstitutionName, " +
				"I.StationNumber as InstitutionNumber, " +
				"I.NameOfInstitution + ' (' + I.StationNumber + ')' AS DisplayName " +
				" FROM VtkUsers U " +
				" INNER JOIN VtkUserRoles UR ON UR.UserFK = U.Id " + 
				" INNER JOIN VtkInstitutions I ON UR.InstitutionFK = I.Id " +
				" INNER JOIN VtkRoles R ON UR.RoleFK = R.Id " + 
				" WHERE U.NtUserName = '" + ntUserName + "' " +
				" ORDER BY I.NameOfInstitution";

			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			da.Fill(ds,"UserRoleInstitutionList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns list of users in a specified role name for a specified station Id
		/// </summary>
		/// <param name="roleName">Name of role</param>
		/// <param name="stationId">Primary key of a VtkStationParameters entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet TableName: <b>UserList</b></br>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>UserId</b> [int]</br>
		/// <br><b>DisplayName</b> combination of First, Last name of user </br>
		/// <br></br>
		/// <br>Sorted By: FulNameForReports</br>
		/// </returns>
		public static DataSet GetUsersByStationRoleName(string roleName, int stationId, ApplicationConnection appCon)
		{
			// TODO: Stored Procedure: (3) This quicklist was requested.
			// TODO: Code Enhancement Possibility: (3) SqlCommand.DataReader candidate?
			string sCommand = 
				"SELECT " +
				"U."  + UserMsSqlSrv.idField                 + " AS UserId, " +
				"U."  + UserMsSqlSrv.fullNameForReportsField + " AS DisplayName " +
				"FROM "       + UserRoleMsSqlSrv.tableName + " UR " +
				"INNER JOIN " + RoleMsSqlSrv.tableName     + " R ON R." + RoleMsSqlSrv.idField + " = UR." + UserRoleMsSqlSrv.roleIdField + " " + 
				"INNER JOIN " + UserMsSqlSrv.tableName     + " U ON U." + UserMsSqlSrv.idField + " = UR." + UserRoleMsSqlSrv.userIdField + " " + 
				"WHERE (UR."   + UserRoleMsSqlSrv.institutionIdField + " = " + stationId.ToString() + ") " +
				"AND (R." + RoleMsSqlSrv.roleNameField + " = '" + roleName + "') " +
				"ORDER BY U." + UserMsSqlSrv.fullNameForReportsField;

			DataSet ds = new DataSet();
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			da.Fill(ds,"UserList");
			da.Dispose();
			return ds;
		}

		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
