﻿/*
			Class:              CombinationAssignment

			Date Produced:      11/6/2001 9:51:21 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using Vha.Vtk.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.CombinationAssignmentMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerCombinationAssignments
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class CombinationAssignment : CombinationAssignmentBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors

		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id">Primary Key Value for VtkVolunteerCombinationAssignments</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public CombinationAssignment(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private CombinationAssignment(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of CombinationAssignment that will be used to add a record to the VtkVolunteerCombinationAssignments database table.
		/// Must specify the StationProfile that the record will be created for.
		/// </summary>
		/// <param name="stationProfileId"><see cref="Vha.Vtk.TimeKeeping.StationProfile"/></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="CombinationAssignment" /></returns>
		public static CombinationAssignment AddRecord(int stationProfileId, ApplicationConnection appCon)
		{
			CombinationAssignment caObj = new CombinationAssignment(appCon);
			caObj.FillDataNew();
			caObj.StationProfileId = stationProfileId;
			return caObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns> <see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationProfileId(StationProfileId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationId(OrganizationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateWorkdayScheduleId(WorkdayScheduleId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateBenefitingServiceId(BenefitingServiceId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCombinationCode(CombinationCode);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsInactive(IsInactive);
			return returnStatus;
		}
		
		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Validates that OrganizationId references an Active Organization</description></item>
		/// <item><description>Ensures Local Organizations are local to the StationId.</description></item>
		/// <item><description>Only allow service code 135A with schedule codes R, D, H, A.</description></item>
		/// <item><description>Ensures Local Services are local to the StationId.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "CombinationAssignment";
			ret.PropertyName = "[Relations Check]";

			// only allow service code 135A with schedule codes R, D, H, A
			Service srv  = new Service(this.benefitingServiceId, appCon);
			string serviceCode  = srv.Code;
			string scheduleCode = new ScheduleWorkday(this.workdayScheduleId).Code;

			if (( serviceCode == "135A") &&
				( scheduleCode != "R"  ) &&
				( scheduleCode != "D"  ) &&
				( scheduleCode != "H"  ) &&
				( scheduleCode != "A"  ))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Service Code '135A' must be paired with a Workday Schedule code of 'R', 'D', 'H' or 'A'. (Workday Code Entered: " + scheduleCode + ")";
				return ret;
			}

			// local code check
			StationProfile sp = new StationProfile(this.StationProfileId, appCon);
			if ((srv.Scope == "L") && (srv.StationId != sp.StationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local service code entered.\r\n (Invalid Code / StationId: " + srv.Code + " / " + sp.StationId + ")";
				return ret;
			}

			// inactive check
			Organization org = new Organization(this.organizationId, appCon);
			if (org.IsInactive)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Only active organizations are allowed. (Organization: " + org.OrganizationName + " (ID: " + this.organizationId.ToString() + ") is inactive)";
				return ret;
			}

			// local code check
			if ((org.Scope == "L") && (org.StationId != sp.StationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local organization code entered.\r\n (Invalid Code / StationId: " + org.Code + " / " + sp.StationId + ")";
				return ret;
			}
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationProfileId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateStationProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateStationProfileId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of OrganizationId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateOrganizationId(value, appCon);
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of WorkdayScheduleId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateWorkdayScheduleId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateWorkdayScheduleId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of BenefitingServiceId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateBenefitingServiceId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateBenefitingServiceId(value, appCon);
			return ret;
		} 

		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CombinationCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCombinationCode(string value)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateCombinationCode(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling CombinationAssignmentBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsInactive</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateIsInactive(bool value)
		{
			ReturnStatus ret = CombinationAssignmentBase.ValidateIsInactive(value);
		 	return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers

		/// <summary>
		/// Saves inserts, updates and deletes of the current instance of the CombinationAssignment class.
		/// </summary>
		/// <remarks>Calculates the correct combinatin code for the Organization, WorkdaySchedule, and BenefitingService.</remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public override ReturnStatus Save()
		{
			if (!this.isDeleted)
				this.CombinationCode = GetComboCode(this.OrganizationId, this.WorkdayScheduleId, this.BenefitingServiceId, this.appCon);
			return base.Save();
		}

		#endregion
		
		#region Section: Quick Lists
				
		#if msSql
		
		/// <summary>
		/// Returns Active and Inactive Combination Codes for a specific Volunteer at a specific Station
		///      along with the names of the Organization and  BenefitingService.
		///     
		///      DataSet Table Name: CombinationAssignmentList
		///            
		/// DataRows from this dataset are used by VolunteerHours.GetVolunteerHoursInstance
		/// 
		/// Note: The VolunteerId and StationId columns are strings and do not typecast to int
		///       use Convert.ToInt32(dr["VolunteerId"].ToString()) instead.  (As done in
		///       VolunteerHours.GetVolunteerHoursInstance)
		///     
		/// </summary>
		/// <param name="volId">Value of VolunteerId</param>
		/// <param name="stationId">Value of StationParameterId</param>
		/// <returns>
		/// Returns the CombinationAssignments for the specified Volunteer at the specified station
		/// <list type="bullet">
		/// <item><description>DataSet Table Name: <list type="bullet"><item>
		/// <description><b>CombinationAssignmentList</b></description></item></list></description></item> 
		/// <br></br>
		/// <item><description>Data Columns Returned:
		/// <list type="bullet">
		/// <item><description><b>Id</b> [int]</description></item>
		/// <item><description><b>DisplayName</b> [string]</description></item>
		/// <item><description><b>StationProfilesId</b> [int]</description></item>
		/// <item><description><b>OrganizationId</b> [int]</description></item>
		/// <item><description><b>OrganizationName</b> [string]</description></item>
		/// <item><description><b>ScheduleId</b> [int]</description></item>
		/// <item><description><b>BenefitingServiceId </b>[int]</description></item>
		/// <item><description><b>BenefitingServiceName</b> [string]</description></item>
		/// <item><description><b>CombinationCode</b> [string]</description></item>
		/// <item><description><b>IsInactive</b> [bool]</description></item>
		/// <item><description><b>Inactive</b> [string (3)]  returns 'Yes' if IsInactive=true</description></item>
		/// <item><description><b>tationId</b> [string]</description></item>
		/// <item><description><b>VolunteerId</b> [string]</description></item>
		///	</list></description></item>
		/// <br></br>
		///	<item>Sorted By: None Specified</item>
		///	<br></br>
		///	</list>
		/// </returns> 
		public static DataSet GetQuickList(int volId, int stationId)
		{		
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickLists " + volId.ToString() + ", " + stationId.ToString(), "CombinationAssignmentList");
		}
 
		public static DataSet GetActiveQuickList(int volId, int stationId)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickLists " + volId.ToString() + ", " + stationId.ToString() + ", 1", "CombinationAssignmentList");
		}

		public static NameObjectCollection GetActiveQuickDRList(int volId, int stationId)
		{
			SqlCommand sqlCommand = new SqlCommand();

			string sCommand = "spS_CombinationAssignments_GetQuickLists " + volId.ToString() + ", " + stationId.ToString() + ", 1";
			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}


		public static DataSet GetInActiveQuickList(int volId, int stationId)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickLists " + volId.ToString() + ", " + stationId.ToString() + ", 0 ", "CombinationAssignmentList");
		}

		public static DataSet GetQuickListForGames(int volId, int stationId)
		{		
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString(), "CombinationAssignmentList");
		}

		public static DataSet GetActiveQuickListForGames(int volId, int stationId)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString() + ", 1", "CombinationAssignmentList");
		}

		public static DataSet GetInActiveQuickListForGames(int volId, int stationId)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString() + ", 0", "CombinationAssignmentList");
		}
		

		public static DataSet GetQuickListForGames(int volId, int stationId, string GamesCode)
		{		
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString() + ", NULL, " + GamesCode, "CombinationAssignmentList");
		}

		public static DataSet GetActiveQuickListForGames(int volId, int stationId, string GamesCode)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString() + ", 1, " + GamesCode, "CombinationAssignmentList");
		}

		public static DataSet GetInActiveQuickListForGames(int volId, int stationId, string GamesCode)
		{			
			return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForGames " + volId.ToString() + ", " + stationId.ToString() + ", 0, " + GamesCode, "CombinationAssignmentList");
		}

		public static DataSet GetQuickListForAutoLogin(int volId, int stationId)
		{			
			//return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForAutoLogin " + volId.ToString() + ", " + stationId.ToString(), "CombinationAssignmentList");
			//return ApplicationConnection.ExecuteQuery("spS_CombinationAssignments_GetQuickListForAutoLogin " + volId.ToString() + ", " + stationId.ToString(), "CombinationAssignmentList");
			return ApplicationConnection.ExecuteQueryRetry("spS_CombinationAssignments_GetQuickListForAutoLogin " + volId.ToString() + ", " + stationId.ToString(), "CombinationAssignmentList", 3);

		}
		public static NameObjectCollection GetQuickListDRForAutoLogin(int volId, int stationId)
		{
					SqlCommand sqlCommand = new SqlCommand();
					string sCommand = "spS_CombinationAssignments_GetQuickListForAutoLogin " + volId.ToString() + ", " + stationId.ToString();
			
					sqlCommand.CommandText = sCommand;
					sqlCommand.CommandType = CommandType.Text;
					return ApplicationConnection.ExecuteReader(sqlCommand);
		}

		#endif
		
		#endregion
		
		#region Section: Utilities
		
		#if msSql
		
		/// <summary>
		/// Calculates the correct combinatin code for the Organization, WorkdaySchedule, and BenefitingService.
		/// Used by the save method
		/// </summary>
		/// <param name="orgId">Primary key of an entry in VtkOrganization table</param>
		/// <param name="scheduleId">Primary key of an entry in VtkWorkdaySchedule table</param>
		/// <param name="serviceId">Primary key VtkBenefitingService table</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>Returns combination code</returns>
		public static string GetComboCode(int orgId, int scheduleId, int serviceId, ApplicationConnection appCon)
		{
			string orgCode;
			string scheduleCode;
			string serviceCode;
			string x;
			
			SqlCommand cmd = new SqlCommand();
			cmd.Connection = new SqlConnection(appCon.ConnectString);
			cmd.Connection.Open();

			// organization code
			cmd.CommandText =
				"SELECT Code " +
				"FROM " + OrganizationMsSqlSrv.tableName + " " +
				"WHERE " + OrganizationMsSqlSrv.idField + " = " + orgId.ToString();
			x = cmd.ExecuteScalar().ToString();
			orgCode = (x != "") ? x : "<org>"; 

			// schedule code
			cmd.CommandText =
				"SELECT Code " +
				"FROM " + ScheduleWorkdayMsSqlSrv.tableName + " " +
				"WHERE " + ScheduleWorkdayMsSqlSrv.idField + " = " + scheduleId.ToString();
			x = cmd.ExecuteScalar().ToString();
			scheduleCode = (x != "") ? x : "<sch>"; 

			// serviceCode
			cmd.CommandText =
				"SELECT Code " +
				"FROM " + ServiceMsSqlSrv.tableName + " " +
				"WHERE " + ServiceMsSqlSrv.idField + " = " + serviceId.ToString();
			x = cmd.ExecuteScalar().ToString();
			serviceCode = (x != "") ? x : "<srv>"; 

			// clean up
			cmd.Connection.Close();
			cmd.Connection.Dispose();
			cmd.Dispose();

			return orgCode + scheduleCode + serviceCode;
		}
		#endif

		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
