﻿
/*

			Class:              ContactInformation

			Date Produced:      11/6/2001 9:51:21 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ContactInformationMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerContactInformation
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class ContactInformation : ContactInformationBase
	{
		#region Section: Constructors

		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id">Primary Key value for VtkVolunteerContactInformation</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public ContactInformation(int id) : base(id)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private ContactInformation() : base()
		{
		}
		
		/// <summary>
		/// Creates an instance of ParkingSticker that will be used to add a record to the VtkParkingSticker database table.
		/// Must specify the volunteerId that the record will be created for
		/// </summary>
		/// <returns><see cref="ContactInformation" /></returns>
		public static ContactInformation AddRecord()
		{
			ContactInformation ciObj = new ContactInformation();
			ciObj.FillDataNew();
			return ciObj;
		}
		
		/// <summary>
		/// Creates an instance of ParkingSticker that will be used to add a record to the VtkParkingSticker database table.
		/// Must specify the volunteerId that the record will be created for
		/// </summary>
		/// <param name="volunteerId">Primary key of the Volunteer entry</param>
		/// <returns><see cref="ContactInformation" /></returns>
		public static ContactInformation AddRecord(int volunteerId)
		{
			ContactInformation ciObj = new ContactInformation();
			ciObj.FillDataNew();
			ciObj.VolunteerId = volunteerId;
			return ciObj;
		}
		
		#endregion		
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStreetAddress1(StreetAddress1);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStreetAddress2(StreetAddress2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCity(City);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStateId(StateId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateZipCode(ZipCode);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTelephone(Telephone);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAlternateTelephone(AlternateTelephone);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAlternateTelephone2(AlternateTelephone2);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEMailAddress(EMailAddress);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of VolunteerId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ContactInformationBase.ValidateVolunteerId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StreetAddress1 property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateStreetAddress1.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of StreetAddress1</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStreetAddress1(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateStreetAddress1(value);
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StreetAddress2 property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateStreetAddress2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of StreetAddress2</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStreetAddress2(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateStreetAddress2(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for City property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateCity.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of City</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateCity(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateCity(value); 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StateId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateStateId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of StateId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStateId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ContactInformationBase.ValidateStateId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ZipCode property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateZipCode.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of ZipCode</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateZipCode(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateZipCode(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Telephone property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateTelephone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of Telephone</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateTelephone(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateTelephone(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AlternateTelephone property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateAlternateTelephone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of AlternateTelephone</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAlternateTelephone(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateAlternateTelephone(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AlternateTelephone2 property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateAlternateTelephone2.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of AlternateTelephone</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAlternateTelephone2(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateAlternateTelephone2(value);
			return ret;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EMailAddress property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ContactInformationBase.ValidateEMailAddress.</description></item>
		/// <item><description>Validate the EMailAddress is longer than 3 characters and contains an '@' after the first character.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current Instance Value of EMailAddress</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateEMailAddress(string value)
		{
			ReturnStatus ret = ContactInformationBase.ValidateEMailAddress(value);
			if (ret.Status != si.Pass) {return ret;}

			// Property Specific Validation
			if (value.Length > 0) 
			{
				if ((value.Length < 3) || (value.IndexOf("@") < 1))
				{
					ret.Status    = si.Fail;
					ret.ErrorText = "'EMailAddress' must be longer than 3 characters and contain an '@' after the first character.";
				}
			}

			return ret;
		}
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		
		/// <summary>
		/// Returns all contact Informatation for a specified volunteer.
		/// DataSet Table Name: 'ContactInformationList'
		/// </summary>
		/// <param name="volId">Volunteer ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <list type="bullet">
		/// <item><description>DataSet Table Name:  <list type="bullet"><item><description><b> ContactInformationList</b></description></item></list></description></item>  
		/// <br></br>
		/// <item><description>Data Columns Returned:
		/// <list type="bullet">
		/// <item><description><b>ID</b> [int]</description></item>
		/// <item><description><b>VolunteerId</b> [int]</description></item>
		/// <item><description><b>StreetAddress1</b> [string (35)]</description></item>
		/// <item><description><b>StreetAddress2</b> [string (35)]</description></item>
		/// <item><description><b>City</b> [string (30)]</description></item>
		/// <item><description><b>StateId</b> [int]</description></item>
		/// <item><description><b>Telephone</b> [string (30)]</description></item>
		/// <item><description><b>AlternateTelephone</b> [string (30)]</description></item>
		/// <item><description><b>AlternateTelephone2</b> [string (30)]</description></item>
		/// <item><description><b>EMailAddress</b> [string (50)]</description></item>
		///	</list>
		/// </description></item>
		///	<br></br>
		///	<item><description>Sorted By: None Specified</description></item>
		///	</list>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int volId, ApplicationConnection appCon)
		{
			string sCommand = "Select id ID, "  +
				sqlDrv.volunteerIdField         + " VolunteerId, " +
				sqlDrv.streetAddress1Field      + " StreetAddress1, " +
				sqlDrv.streetAddress2Field      + " StreetAddress2, " +
				sqlDrv.cityField                + " City, " +
				sqlDrv.stateIdField             + " StateId, " +
				sqlDrv.zipCodeField             + " ZipCode, " +
				sqlDrv.telephoneField           + " Telephone, " +
				sqlDrv.alternateTelephoneField  + " AlternateTelephone, " +
				sqlDrv.alternateTelephone2Field + " AlternateTelephone2, " +
				sqlDrv.eMailAddressField        + " EMailAddress " +
				" FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.volunteerIdField + " = '" + volId + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"ContactInformationList");
			da.Dispose();
			return ds;
		}
		
		/// <summary>
		///  Get list of stations for a ContactInformationId
		/// DataSet Table Name: 'StationListForContact'
		/// </summary>
		/// <param name="contactId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <b>StationListForContact</b></li>
		/// <br>Data Columns Returned:</br>
		/// <ul>
		/// <li><b>StationDisplayName</b> [string] (StationName (StationNumber))</li>
		/// <li><b>StationId</b> [int]</li>
		/// </ul>
		///	<li>Sorted By: nothing Specified</li>
		/// </ul>
		/// </returns>
		public static DataSet GetListOfStationsForContact(int contactId, ApplicationConnection appCon)
		{
			string sCommand = "SELECT " + 
				" VI." + InstitutionMsSqlSrv.nameOfInstitutionField + " + ' (' + VI." + InstitutionMsSqlSrv.stationNumberField + " + ') ' AS StationDisplayName, " +
				" VI." + InstitutionMsSqlSrv.idField + " AS StationID " +
				" FROM " + sqlDrv.tableName + " CONT " +
				" INNER JOIN " + VolunteerMsSqlSrv.tableName + " VOL ON CONT." + ContactInformationMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + StationProfileMsSqlSrv.tableName + " VOLSP ON VOL." + VolunteerMsSqlSrv.idField + "  = VOLSP. " + StationProfileMsSqlSrv.volunteerIdField + 
				" INNER JOIN " + InstitutionMsSqlSrv.tableName + " VI ON VI.Id = VOLSP.StationFK " +
				" WHERE CONT." + sqlDrv.idField + " = '" + contactId + "' ";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"StationListForContact");
			da.Dispose();
			return ds;
		}
		#endif
		
		#endregion
		
		#region Section: Utilities

		#if msSql

		/// <summary>
		/// Returns the volunteerId for a contactInformation Entry
		/// Used by the StationProfile.ValidateContactInformationId() 
		/// to ensure that both records refer to the same volunteer.
		/// </summary>
		/// <param name="contactId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// VolunteerId [int]
		/// </returns>
		public static int GetVolunteerId(int contactId, ApplicationConnection appCon)
		{
			int returnVolId = 0;
			string sCommand = "SELECT " + sqlDrv.volunteerIdField + " AS VolunteerId " +
				" FROM " + sqlDrv.tableName + 
				" WHERE " + sqlDrv.idField + " = '" + contactId + "' ";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"VolId");
			da.Dispose();
			if (ds.Tables["VolId"].Rows.Count > 0)
			{
				DataRow dr = ds.Tables["VolId"].Rows[0];
				returnVolId = (int)dr["VolunteerId"];
			}
			ds.Dispose();
			return returnVolId;
		}

		#endif
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
