﻿
/*

			Class:              NextOfKin

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.NextOfKinMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkNextOfKin
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class NextOfKin : NextOfKinBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id">Primary Key value for VtkNextOfKin</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public NextOfKin(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private NextOfKin(ApplicationConnection appCon) : base(appCon)
		{
		}
		
		/// <summary>
		/// Creates an instance of NextOfKin that will be used to add a record to the VtkNextOfKin database table.
		/// Must specify the VolunteerId that the record will be created for
		/// </summary>
		/// <param name="volunteerId">Primary Key to the Volunteer entry.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="NextOfKin" /></returns>
		public static NextOfKin AddRecord(int volunteerId, ApplicationConnection appCon)
		{
			NextOfKin nkObj = new NextOfKin(appCon);
			nkObj.FillDataNew();
			nkObj.VolunteerId = volunteerId;
			return nkObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateKinsName(KinsName);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelationship(Relationship);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTelephone(Telephone);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAlternateTelephone(AlternateTelephone);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NextOfKinBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instances value of VolunteerId.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = NextOfKinBase.ValidateVolunteerId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for KinsName property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NextOfKinBase.ValidateKinsName.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of KinsName.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateKinsName(string value)
		{
			ReturnStatus ret = NextOfKinBase.ValidateKinsName(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Relationship property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NextOfKinBase.ValidateRelationship.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Relationship.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateRelationship(string value)
		{
			ReturnStatus ret = NextOfKinBase.ValidateRelationship(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Telephone property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NextOfKinBase.ValidateTelephone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Telephone.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateTelephone(string value)
		{
			ReturnStatus ret = NextOfKinBase.ValidateTelephone(value);		 
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AlternateTelephone property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling NextOfKinBase.ValidateAlternateTelephone.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AlternateTelephone.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAlternateTelephone(string value)
		{
			ReturnStatus ret = NextOfKinBase.ValidateAlternateTelephone(value);
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
			
		#if msSql
		
		/// <summary>
		/// Returns all NextOfKin information for a specified Volunteer.  
		///		DataSet Table Name: NextOfKinList
		/// </summary>
		/// <param name="volId">Volunteer ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <list type="bullet">
		/// <item><description>DataSet Table Name:  <list type="bullet"><item><description><b> NextOfKinList</b></description></item></list></description></item>  
		/// <br></br>
		/// <item><description>Data Columns Returned:
		/// <list type="bullet">
		/// <item><description><b>ID</b> [int]</description></item>
		/// <item><description><b>VolunteerId</b> [int]</description></item>
		/// <item><description><b>KinsName</b> [string (30)]</description></item>
		/// <item><description><b>Relationship</b> [string (15)]</description></item>
		/// <item><description><b>Telephone</b> [string (30)]</description></item>
		/// <item><description><b>AlternateTelephone</b> [string (30)]</description></item>
		///	</list>
		///	</description></item>
		///	<br></br>
		///	<item><description>Sorted By: None Specified</description></item>
		///	</list>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int volId, ApplicationConnection appCon)
		{
			string sCommand = "Select id ID, " +
				sqlDrv.volunteerIdField        + " VolunteerId, " +
				sqlDrv.kinsNameField           + " KinsName, " +
				sqlDrv.relationshipField       + " Relationship, " +
				sqlDrv.telephoneField          + " Telephone, " +
				sqlDrv.alternateTelephoneField + " AlternateTelephone " +
				" FROM " + sqlDrv.tableName    +
				" WHERE " + sqlDrv.volunteerIdField + " = '" + volId + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"NextOfKinList");
			da.Dispose();
			return ds;
		}
		
		/// <summary>
		/// Get list of stations for a NextOfKinId.  
		///		DataSet Table Name: 'StationListForNextOfKin'
		/// </summary>
		/// <param name="nokId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <ul>
		/// <li>DataSet Table Name: <b>StationListForNextOfKin</b></li>
		/// <br>Data Columns Returned:</br>
		/// <ul>
		/// <li><b>StationDisplayName</b> [string] (StationName (StationNumber))</li>
		/// <li><b>StationId</b> [int]</li>
		/// </ul>
		///	<li>Sorted By: nothing Specified</li>
		/// </ul>
		/// </returns>
		public static DataSet GetListOfStationsForNOK(int nokId, ApplicationConnection appCon)
		{
			string sCommand = "SELECT " + 
				" VI." + InstitutionMsSqlSrv.nameOfInstitutionField + " + ' (' + VI." + InstitutionMsSqlSrv.stationNumberField + " + ') ' AS StationDisplayName, " +
				" VI." + InstitutionMsSqlSrv.idField + " AS StationID " +
				" FROM " + sqlDrv.tableName + " NOK " +
				" INNER JOIN " + VolunteerMsSqlSrv.tableName + " VOL ON NOK." + NextOfKinMsSqlSrv.volunteerIdField + " = VOL." + sqlDrv.idField + " " +
				" INNER JOIN " + StationProfileMsSqlSrv.tableName + " VOLSP ON VOL." + VolunteerMsSqlSrv.idField + "  = VOLSP. " + StationProfileMsSqlSrv.volunteerIdField + 
				" INNER JOIN " + InstitutionMsSqlSrv.tableName + " VI ON VI.Id = VOLSP.StationFK " +
				" WHERE NOK." + sqlDrv.idField + " = '" + nokId + "' ";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"StationListForNextOfKin");
			da.Dispose();
			return ds;
		}
	
		#endif
		
		#endregion
		
		#region Section: Utilities
		
#if msSql

		/// <summary>
		/// Returns the volunteerId for a contactInformation Entry
		/// Used by the StationProfile.ValidateNextOfKinId() 
		/// to ensure that both records refer to the same volunteer.
		/// </summary>
		/// <param name="nokId">value for NextOfKinId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// VolunteerId [int]
		/// </returns>
		public static int GetVolunteerId(int nokId, ApplicationConnection appCon)
		{
			int returnVolId = 0;
			string sCommand = "SELECT " + sqlDrv.volunteerIdField + " AS VolunteerId " +
				" FROM " + sqlDrv.tableName + 
				" WHERE " + sqlDrv.idField + " = '" + nokId + "' ";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"VolId");
			da.Dispose();
			if (ds.Tables["VolId"].Rows.Count > 0)
			{
				DataRow dr = ds.Tables["VolId"].Rows[0];
				returnVolId = (int)dr["VolunteerId"];
			}
			ds.Dispose();
			return returnVolId;
		}

		#endif


		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}

		#endregion
		
	}
}
