﻿
/*

			Class:              OccasionalHours

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
			
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Common;
using Vha.Vtk.Kernel.Common;
using Vha.Vss.Utility;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.OccasionalHoursMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkOccasionalVolunteerTimeSheets
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class OccasionalHours : OccasionalHoursBase
	{
		
		#region Section: Database Fields
		
		//from other tables

		internal string voluntaryInstitutionNameOfInstitution;
		internal string benefitingServiceServiceName;
		internal string volunteerOrganizationOrganizationName;
		
		#endregion

		#region Section: Database Constant Fields

		//from other tables
		private const string voluntaryInstitutionNameOfInstitutionField = "NameOfInstitution";
		private const string benefitingServiceServiceNameField          = "ServiceName";
		private const string benefitingServiceCodeField                 = "Code";
		private const string volunteerOrganizationOrganizationNameField = "OrganizationName";
		private const string volunteerOrganizationCodeField             = "Code";
		#endregion

		#region Section: Property Definitions

		/// <summary>
		/// This property is from another table, Institution.NameOfInstitution
		/// </summary>
		/// <value>This property is from another table, Institution.NameOfInstitution</value>
		public string VoluntaryInstitutionNameOfInstitution
		{
			get {return voluntaryInstitutionNameOfInstitution;}
		}

		/// <summary>
		/// This property is from another table, BenefitingService.ServiceName
		/// </summary>
		/// <value>This property is from another table, BenefitingService.ServiceName</value>
		public string BenefitingServiceServiceName
		{
			get {return benefitingServiceServiceName;}
		}

		/// <summary>
		/// This property is from another table, Organization.OrganizationName
		/// </summary>
		/// <value>This property is from another table, Organization.OrganizationName</value>
		public string VolunteerOrganizationOrganizationName
		{
			get {return volunteerOrganizationOrganizationName;}
		}
				
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id"> Primary key value for VtkOccasionalVolunteerTimeSheets</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public OccasionalHours(int id) : base(id)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		private OccasionalHours() : base()
		{
		}
		
		/// <summary>
		/// Creates an instance of OccasionalHours that will be used to add a record to the VtkOccasionalVolunteerTimeSheets database table.
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="OccasionalHours" /></returns>
		public static OccasionalHours AddRecord()
		{
			OccasionalHours ohObj = new OccasionalHours();
			ohObj.InitializeData();
			//ohObj.recordStatus = "E";
			return ohObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		/// <summary>
		/// Initializes data from other tables to default values and sets RecordStatus = 'E'.
		/// </summary>
		/// <remarks>Initializes data from other tables to default values.</remarks>
		private void InitializeData()
		{
			base.FillDataNew();

			voluntaryInstitutionNameOfInstitution = "";
			benefitingServiceServiceName          = "";
			volunteerOrganizationOrganizationName = "";
		}
		
		/// <summary>
		/// Refreshes data from other tables to current values
		/// </summary>
		public override void Refresh()
		{
			base.Refresh();

			DataRow drOther = GetOtherTableData();

			if (ServiceAssignmentId > 0)
			{
				if (!drOther.IsNull(benefitingServiceServiceNameField)) 
				{
					this.benefitingServiceServiceName = drOther[benefitingServiceServiceNameField].ToString();
				}
			}
			if ((!drOther.IsNull(voluntaryInstitutionNameOfInstitutionField)) && (StationId > 0)) 
			{voluntaryInstitutionNameOfInstitution = drOther[voluntaryInstitutionNameOfInstitutionField].ToString();}

			if ((!drOther.IsNull(volunteerOrganizationOrganizationNameField)) && (OrganizationId > 0)) 
			{volunteerOrganizationOrganizationName = drOther[volunteerOrganizationOrganizationNameField].ToString();}
		}

		/// <summary>
		/// Retrieves data from other tables.
		/// </summary>
		/// <returns>DataRow containing data from other tables.</returns>
		private DataRow GetOtherTableData()
		{
			string sCommand =  "SELECT VT.id, BS.ServiceName, VI.NameOfInstitution, VO.OrganizationName " 
				+ " FROM " + sqlDrv.tableName + " VT "
				+ " LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField
				+ " LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField
				+ " LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField
				+ " WHERE VT.id = '"  + this.ToString() + "'";

			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OtherTableData");
			da.Dispose();

			return ds.Tables["OtherTableData"].Rows[0];
		}

		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateComments(Comments);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateOrganizationId(OrganizationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateServiceAssignmentId(ServiceAssignmentId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNumberInGroup(NumberInGroup);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTotalHours(TotalHours);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateWorkProvided(DateWorkProvided);
			return returnStatus;
		}
		
		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Validates OrganizationId references an active Organizaiton.</description></item>
		/// <item><description>If OrganizationId references a local Organization, validates that the Organization if local to the same StationId.</description></item>
		/// <item><description>If ServiceAssignmentId references a local Service, validates that the Organization if local to the same ServiceAssignmentId.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "OccasionalHours";
			ret.PropertyName = "[Relations Check]";

			// inactive check
			// TODO: Re-evaluate this check in Phase II since there is currently no way to determine if organization was active on work date. 
			Organization org = new Organization(this.organizationId, appCon);
			if (org.IsInactive)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Only active organizations are allowed. (Organization: " + org.OrganizationName + " (ID: " + this.organizationId.ToString() + ") is inactive)";
				return ret;
			}

			// local code check
			if ((org.Scope == "L") && (org.StationId != this.stationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local organization code entered.\r\n (Invalid Code / StationId: " + org.Code + " / " + this.stationId + ")";
				return ret;
			}

			// local code check
			Service srv  = new Service(this.serviceAssignmentId, appCon);
			if ((srv.Scope == "L") && (srv.StationId != this.stationId))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "Current station is not associated with the local service code entered.\r\n (Invalid Code / StationId: " + srv.Code + " / " + this.stationId + ")";
				return ret;
			}

			return ret;
		}


		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateStationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationId.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateStationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Comments property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateComments.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Comments.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateComments(string value)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateComments(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for OrganizationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateOrganizationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of OrganizationId.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateOrganizationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateOrganizationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for ServiceAssignmentId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateServiceAssignmentId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ServiceAssignmentId.</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateServiceAssignmentId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateServiceAssignmentId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NumberInGroup property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateNumberInGroup.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NumberInGroup.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateNumberInGroup(Int32 value)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateNumberInGroup(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for TotalHours property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateTotalHours.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TotalHours.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateTotalHours(Int32 value)
		{
			ReturnStatus ret = OccasionalHoursBase.ValidateTotalHours(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateWorkProvided property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling OccasionalHoursBase.ValidateDateWorkProvided.</description></item>
		/// <item><description>Validates that DateWorkProvided in not a future date.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DateWorkProvided.</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateDateWorkProvided(DateTime value)
		{
			// TODO: Add check of VtkRollupLog MAX(CloseMonth)
			ReturnStatus ret = OccasionalHoursBase.ValidateDateWorkProvided(value);

			// DateWorkProvided can not be greater than today
			if ((ret.Status == si.Pass) && (value.Date > DateTime.Today))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'DateWorkProvided' can not be Greater than today's date.";
			}

			return ret;
		}
		 
		#endregion
		
		#region Section: Filers
		
		/// <summary>
		/// Saves inserts, updates and deletes of the current instance of the CombinationAssignment class.
		/// </summary>
		/// <remarks>Updates and deletes are not allowed for an OccasionalHours entry with a 'RecordStatus' Of Closed.</remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Save()
		{
			ReturnStatus ret = SaveCheck();
			if (ret.Status != si.Pass) throw new VhaValidationException(ret.ErrorText, ret.ClassName, returnStatus.PropertyName);

			return base.Save();
		}
		
		/// <summary>
		/// Updates and deletes are not allowed for an OccasionalHours entry with a 'Record Status' of 'Closed'.
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public ReturnStatus SaveCheck()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "OccasionalHours";
			ret.PropertyName = "RecordStatus";
			
			// can't save if record status is 'C'losed
			if (RecordStatus == "C")
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Updates and deletes are not allowed for an OccasionalHours entry with a 'Record Status' of 'Closed'.";
			}			
			return ret;
		}
		 		
		
		#endregion
		
		#region Section: Quick Lists

		#if msSql
		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Institution ID</param>
		/// <param name="includeClosedRecords">boolean (should 'C'losed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: <b>OccasionalHoursList</b></br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>	
		/// <ul>
		/// <li><b>ID</b></li>
		///	<li><b>StationId</b></li>
		///	<li><b>OrganizationId</b></li>
		///	<li><b>Comments</b></li>
		///	<li><b>ServiceAssignmentId</b></li>
		///	<li><b>DateWorkProvided</b></li>
		///	<li><b>TotalHours</b></li>
		///	<li><b>RecordStatus</b></li>
		///	</ul>
		///	<br></br>
		///	<ul><li>Sorted By: <b>InstitutionId</b></li></ul>
		///</returns>
		public static DataSet GetQuickList(int stationId, bool includeClosedRecords, ApplicationConnection appCon)
		{
			string sCommand = "Select id ID, "  + 
				sqlDrv.stationIdField           + " StationId, " +
				sqlDrv.organizationIdField      + " OrganizationId, " +
				sqlDrv.commentsField            + " Comments, " +
				sqlDrv.serviceAssignmentIdField + " ServiceAssignmentId, " +
				sqlDrv.dateWorkProvidedField    + " DateWorkProvided, " +
				sqlDrv.totalHoursField          + " TotalHours, " +
				sqlDrv.recordStatusField        + " RecordStatus " +
				" FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.stationIdField + " = " + stationId + " ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (" + sqlDrv.recordStatusField + " <> 'C') ";}

			// not used any more....too many records
			//" FROM " + sqlDrv.tableName;
			//if (stationId > 0) {sCommand = sCommand + " WHERE " + sqlDrv.stationIdField + " = " + stationId + " ";}
			
			sCommand = sCommand + " ORDER BY " + sqlDrv.stationIdField;
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station that do not have a 'C'losed RecordStatus.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Institution ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: <b>OccasionalHoursList</b></br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>	
		/// <ul>
		/// <li><b>ID</b></li>
		///	<li><b>StationId</b></li>
		///	<li><b>OrganizationId</b></li>
		///	<li><b>Comments</b></li>
		///	<li><b>ServiceAssignmentId</b></li>
		///	<li><b>DateWorkProvided</b></li>
		///	<li><b>TotalHours</b></li>
		///	<li><b>RecordStatus</b></li>
		///	</ul>
		///	<br></br>
		///	<ul><li>Sorted By: <b>InstitutionId</b></li></ul>
		///</returns>
		public static DataSet GetQuickList(int stationId, ApplicationConnection appCon)
		{
			return GetQuickList(stationId, false, appCon);
		}		

		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="includeClosedRecords">boolean (should 'C'losed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: InstitutionId</br>
		/// </returns>
		public static DataSet GetQuickListExpanded(int stationId, bool includeClosedRecords, ApplicationConnection appCon)
		{
			string sCommand = "Select VT.id ID, " + 
				"VT." + sqlDrv.stationIdField              + " StationId, " +
				"VT." + sqlDrv.organizationIdField         + " OrganizationId, " +
				"VT." + sqlDrv.commentsField               + " Comments, " +
				"VT." + sqlDrv.serviceAssignmentIdField    + " ServiceAssignmentId, " +
				"VT." + sqlDrv.dateWorkProvidedField       + " DateWorkProvided, " +
				"VT." + sqlDrv.totalHoursField             + " TotalHours, " +
				" VT." + sqlDrv.recordStatusField          + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode "+
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE VT." + sqlDrv.stationIdField + " = '" + stationId + "' ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VT." + sqlDrv.stationIdField;
			DbDataAdapter da = new SqlDataAdapter(sCommand,appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		
		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station that do not have a 'C'losed RecordStatus..
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: InstitutionId</br>
		/// </returns>
		public static DataSet GetQuickListExpanded(int stationId, ApplicationConnection appCon)
		{
			return GetQuickListExpanded(stationId, false, appCon);
		}


		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station ordered by OrganizationName.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: VolunteerOrganizationOrganizationName</br>
		/// </returns>
		public static DataSet GetQuickListByOrgName(int stationId, bool includeClosedRecords, ApplicationConnection appCon)
		{
			string sCommand = "Select VT.id ID, "          + 
				"VT." + sqlDrv.stationIdField              + " StationId, " +
				"VT." + sqlDrv.organizationIdField         + " OrganizationId, " +
				"VT." + sqlDrv.commentsField               + " Comments, " +
				"VT." + sqlDrv.serviceAssignmentIdField    + " ServiceAssignmentId, " +
				"VT." + sqlDrv.dateWorkProvidedField       + " DateWorkProvided, " +
				"VT." + sqlDrv.totalHoursField             + " TotalHours, " +
				" VT." + sqlDrv.recordStatusField          + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode "+
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE VT." + sqlDrv.stationIdField + " = '" + stationId + "' ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VO." + volunteerOrganizationOrganizationNameField;
			DbDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns all Occassional Hours lists for a specified Station ordered by OrganizationName that do not have a 'C'losed RecordStatus.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: VolunteerOrganizationOrganizationName</br>
		/// </returns>
		public static DataSet GetQuickListByOrgName(int stationId, ApplicationConnection appCon)
		{
			return GetQuickListByOrgName(stationId, false, appCon);
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified.
		/// Ordered by Date.
		/// NameObjectCollection object is returned
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: DateWorkProvided</br>
		/// </returns>
		public static NameObjectCollection GetSiteMonthlyQuickDRListByDate(int stationId, int month, int year, bool includeClosedRecords)
		{
			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd   = dateBegin.AddMonths(1).AddDays(-1);

			SqlCommand sqlCommand = new SqlCommand();                      

			string sCommand = "Select VT.id ID, "   + 
				" VT." + sqlDrv.dateWorkProvidedField       + " DateWorkProvided, " +
				" VT." + sqlDrv.stationIdField              + " StationId, " +
				" VT." + sqlDrv.organizationIdField         + " OrganizationId, " +
				" VT." + sqlDrv.commentsField               + " Comments, " +
				" VT." + sqlDrv.serviceAssignmentIdField    + " ServiceAssignmentId, " +
				" VT." + sqlDrv.totalHoursField             + " TotalHours, " +
				" VT." + sqlDrv.recordStatusField           + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode "+
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE (VT." + sqlDrv.stationIdField + " = '" + stationId + "') " +
				" AND ((VT." + sqlDrv.dateWorkProvidedField + " >= '" + dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') " +
				" AND (VT." + sqlDrv.dateWorkProvidedField + " <= '" + dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "')) ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VT." + sqlDrv.dateWorkProvidedField;

			sqlCommand.CommandText = sCommand;
			sqlCommand.CommandType = CommandType.Text;
			return ApplicationConnection.ExecuteReader(sqlCommand);

		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified.
		/// Ordered by Date.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: DateWorkProvided</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListByDate(int stationId, int month, int year, bool includeClosedRecords, ApplicationConnection appCon)
		{
			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd   = dateBegin.AddMonths(1).AddDays(-1);

			string sCommand = "Select VT.id ID, "   + 
				" VT." + sqlDrv.dateWorkProvidedField       + " DateWorkProvided, " +
				" VT." + sqlDrv.stationIdField              + " StationId, " +
				" VT." + sqlDrv.organizationIdField         + " OrganizationId, " +
				" VT." + sqlDrv.commentsField               + " Comments, " +
				" VT." + sqlDrv.serviceAssignmentIdField    + " ServiceAssignmentId, " +
				" VT." + sqlDrv.totalHoursField             + " TotalHours, " +
				" VT." + sqlDrv.recordStatusField           + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode "+
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE (VT." + sqlDrv.stationIdField + " = '" + stationId + "') " +
				" AND ((VT." + sqlDrv.dateWorkProvidedField + " >= '" + dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') " +
				" AND (VT." + sqlDrv.dateWorkProvidedField + " <= '" + dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "')) ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VT." + sqlDrv.dateWorkProvidedField;
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified that do not have a 'C'losed RecordStatus..
		/// Ordered by Date.
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: DateWorkProvided</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListByDate(int stationId, int month, int year, ApplicationConnection appCon)
		{
			return GetSiteMonthlyQuickListByDate(stationId, month, year, false, appCon);
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified that do not have a 'C'losed RecordStatus..
		/// Ordered by Date.
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: DateWorkProvided</br>
		/// </returns>
		public static NameObjectCollection GetSiteMonthlyQuickDRListByDate(int stationId, int month, int year)
		{
			return GetSiteMonthlyQuickDRListByDate(stationId, month, year, false);
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified.
		/// Ordered by Id
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: Id</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListById(int stationId, int month, int year, bool includeClosedRecords, ApplicationConnection appCon)
		{	
			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd = dateBegin.AddMonths(1).AddDays(-1);

			string sCommand = "Select VT.id ID, "           + 
				" VT." + sqlDrv.stationIdField              + " StationId, " +
				" VT." + sqlDrv.organizationIdField         + " OrganizationId, " +
				" VT." + sqlDrv.commentsField               + " Comments, " +
				" VT." + sqlDrv.serviceAssignmentIdField    + " ServiceAssignmentId, " +
				" VT." + sqlDrv.dateWorkProvidedField       + " DateWorkProvided, " +
				" VT." + sqlDrv.totalHoursField             + " TotalHours, " +	
				" VT." + sqlDrv.recordStatusField           + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode " +
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE (VT." + sqlDrv.stationIdField + " = '" + stationId + "')  " + 
				" AND ((VT." + sqlDrv.dateWorkProvidedField + " >= '" + dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') " +
				" AND (VT." + sqlDrv.dateWorkProvidedField + " <= '" + dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "')) ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VT.Id " ;
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified that do not have a 'C'losed RecordStatus..
		/// Ordered by Id
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId">Station ID</param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: Id</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListById(int stationId, int month, int year, ApplicationConnection appCon)
		{
			return GetSiteMonthlyQuickListById(stationId, month, year, false, appCon);
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified.
		/// Ordered by Organization Code
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId"></param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="includeClosedRecords">boolean (should closed, uneditable, records be returned)</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: VolunteerOrganizationCode</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListByOrgCode(int stationId, int month, int year, bool includeClosedRecords, ApplicationConnection appCon)
		{
			DateTime dateBegin = new DateTime(year, month, 1);
			DateTime dateEnd   = dateBegin.AddMonths(1).AddDays(-1);

			string sCommand = "Select VT.id ID, "              + 
				" VO." + volunteerOrganizationCodeField        + " VolunteerOrganizationCode, "+
				" VT." + sqlDrv.stationIdField                 + " StationId, " +
				" VT." + sqlDrv.organizationIdField            + " OrganizationId, " +
				" VT." + sqlDrv.commentsField                  + " Comments, " +
				" VT." + sqlDrv.serviceAssignmentIdField       + " ServiceAssignmentId, " +
				" VT." + sqlDrv.dateWorkProvidedField          + " DateWorkProvided, " +
				" VT." + sqlDrv.totalHoursField                + " TotalHours, " +
				" VT." + sqlDrv.recordStatusField              + " RecordStatus, " +
				" VI." + voluntaryInstitutionNameOfInstitutionField + " VoluntaryInstitutionNameOfInstitution, " +
				" BS." + benefitingServiceServiceNameField          + " BenefitingServiceServiceName, " +
				" BS." + benefitingServiceCodeField                 + " BenefitingServiceCode, " +
				" VO." + volunteerOrganizationOrganizationNameField + " VolunteerOrganizationOrganizationName, " +
				" VO." + volunteerOrganizationCodeField             + " VolunteerOrganizationCode "+
				" FROM " + sqlDrv.tableName + " VT " +
				" LEFT OUTER JOIN VtkBenefitingServices BS ON BS.ID = VT." + sqlDrv.serviceAssignmentIdField +
				" LEFT OUTER JOIN VtkInstitutions VI ON VI.ID = VT." + sqlDrv.stationIdField +
				" LEFT OUTER JOIN VtkVolunteerOrganizations VO ON VO.ID = VT." + sqlDrv.organizationIdField +
				" WHERE (VT." + sqlDrv.stationIdField + " = '" + stationId + "')  " + 
				" AND ((VT." + sqlDrv.dateWorkProvidedField + " >= '" + dateBegin.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "') " +
				" AND (VT." + sqlDrv.dateWorkProvidedField + " <= '" + dateEnd.ToString("d", System.Globalization.DateTimeFormatInfo.InvariantInfo) + "')) ";
			if (!includeClosedRecords) {sCommand = sCommand + " AND (VT." + sqlDrv.recordStatusField + " <> 'C') ";}
			sCommand = sCommand + " ORDER BY VO." + volunteerOrganizationCodeField;
			DbDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"OccasionalHoursList");
			da.Dispose();
			return ds;
		}

		/// <summary>
		/// Returns Occassional Hours lists for a specified Station for the month/Year specified that do not have a 'C'losed RecordStatus.
		/// Ordered by Organization Code
		/// DataSet Table Name: 'OccasionalHoursList'
		/// </summary>
		/// <param name="stationId"></param>
		/// <param name="month">Work Month</param>
		/// <param name="year">Work Year</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <br>DataSet Table Name: OccasionalHoursList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br>ID</br>
		/// <br>StationId</br>
		/// <br>OrganizationId</br>
		/// <br>Comments</br>
		/// <br>ServiceAssignmentId</br>
		/// <br>DateWorkProvided</br>
		/// <br>TotalHours</br>
		/// <br>RecordStatus</br>
		/// <br>VoluntaryInstitutionNameOfInstitution</br>
		/// <br>BenefitingServiceServiceName</br>
		/// <br>BenefitingServiceCode</br>
		/// <br>VolunteerOrganizationOrganizationName</br>
		/// <br>VolunteerOrganizationCode</br>
		/// <br></br>
		///	<br>Sorted By: VolunteerOrganizationCode</br>
		/// </returns>
		public static DataSet GetSiteMonthlyQuickListByOrgCode(int stationId, int month, int year, ApplicationConnection appCon)
		{
			return GetSiteMonthlyQuickListByOrgCode(stationId, month, year, false, appCon);
		}
		#endif

		#endregion
		
		#region Section: Utilities
		
		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}
		
		#endregion
		
	}
}
