﻿
/*

			Class:              ParkingSticker

			Date Produced:      11/6/2001 9:51:20 AM
			Responsible Team:   VistA Migration
			Developer(s):       Mike Kilmade and Alan Skinner
			LastUpdated:        11/6/2001 9:11:08 AM
			Revision:           246

			SQL Server Version: 08.00.0194
			Server:             vhaisamul34
			Database:           [bizlayer_vha_Vol]
			Code generated in:  C:\vm\vss\vtk\businessLayer\GeneratedClasses\Vha.Vtk.TimeKeeping

			Generator Used:     SQL Server Centric .NET Code Generator
			Developer:          Pascal Belaud
			Company:            Microsoft Corporation (France)
			Olymars Library:    v1.0.669.10200
			Olymars Utility:    v1.0.669.10206

*/

#define msSql
		
#region Section: Using Declarations
				
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;

#if msSql
using sqlDrv = Vha.Vtk.DataClasses.ParkingStickerMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkParkingSticker
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class ParkingSticker : ParkingStickerBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		/// <summary>
		/// Main Constructor
		/// </summary>
		public ParkingSticker() : base()
		{

		}
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id"> Primary Key value for VtkParkingSticker</param>
		public ParkingSticker(int id) : base(id)
		{
			
		}
				
		/// <summary>
		/// Creates an instance of ParkingSticker that will be used to add a record to the VtkParkingSticker database table.
		/// Must specify the stationProfileId that the record will be created for
		/// </summary>
		/// <param name="stationProfileId"></param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="ParkingSticker" /></returns>
		public static ParkingSticker AddRecord(int stationProfileId)
		{
			ParkingSticker psObj = new ParkingSticker();
			psObj.FillDataNew();
			psObj.StationProfileId = stationProfileId;
			return psObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationProfileId(StationProfileId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStickerNumber(StickerNumber);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStateId(StateId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateLicensePlate(LicensePlate);
			return returnStatus;
		}
		
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationProfileId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ParkingStickerBase.ValidateStationProfileId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationProfileId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStationProfileId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ParkingStickerBase.ValidateStationProfileId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StickerNumber property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ParkingStickerBase.ValidateStickerNumber.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StickerNumber</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStickerNumber(string value)
		{
			ReturnStatus ret = ParkingStickerBase.ValidateStickerNumber(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StateId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ParkingStickerBase.ValidateStateId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StateId</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStateId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = ParkingStickerBase.ValidateStateId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for LicensePlate property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling ParkingStickerBase.ValidateLicensePlate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of LicensePlate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateLicensePlate(string value)
		{
			ReturnStatus ret = ParkingStickerBase.ValidateLicensePlate(value);
			return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers
		
		
		#endregion
		
		#region Section: Quick Lists
		
		
		#if msSql
		
		/// <summary>
		/// returns all Parking Stickers for a StationProfile
		/// DataSet Table Name: ParkingStickerList
		/// </summary>
		/// <param name="stationProfileId">Station Profile ID</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns>
		/// <list type="bullet">
		/// <item><description>DataSet Table Name:  <list type="bullet"><item><description><b> ParkingStickerList</b></description></item></list></description></item>  
		/// <br></br>
		/// <item><description>Data Columns Returned:
		/// <list type="bullet">
		/// <item><description><b>ID</b> [int]</description></item>
		/// <item><description><b>StationProfileId</b> [int]</description></item>
		/// <item><description><b>StateId</b> [int]</description></item>
		/// <item><description><b>StickerNumber</b> [string (13)]</description></item>
		/// <item><description><b>LicensePlate</b> [string (12)]</description></item>
		///	</list>
		///	</description></item>
		///	<br></br>
		///	<item><description>Sorted By: None Specified</description></item>
		///	</list>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int stationProfileId, ApplicationConnection appCon)
		{
			string sCommand = "Select "      +
				sqlDrv.idField               + " ID, " +
				sqlDrv.stationProfileIdField + " StationProfileId, " +
				sqlDrv.stateIdField          + " StateId, " +
				sqlDrv.licensePlateField     + " LicensePlate, " +
				sqlDrv.stickerNumberField    + " StickerNumber " +
				" FROM " + sqlDrv.tableName  +
				" WHERE " + sqlDrv.stationProfileIdField + " = '" + stationProfileId + "' ";
		
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"ParkingStickerList");
			da.Dispose();
			return ds;
		}
		
		#endif
		
		#endregion
		
		#region Section: Utilities

		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		/// <param name="version">Version number to be used when saving instance</param>
		internal void SetVersion(int version)
		{
			this.version = version;
		}

		#endregion
		
	}
}
