﻿
/*

    Class:              StationProfile

    Date Produced:      6/18/2002 9:35:48 AM
    Responsible Team:   VistA Migration
    Developer(s):       Mike Langley
    LastUpdated:        6/17/2002 1:07:16 PM
    Revision:           651

    SQL Server Version: 08.00.0534
    Server:             ISF-LANGLEYM
    Database:           [VSS_Development]
    Code generated in:  D:\Olymars_test\1.0.868.22959\Vha.Vtk.TimeKeeping

    Generator Used:     SQL Server Centric .NET Code Generator
    Developer:          Pascal Belaud
    Company:            Microsoft Corporation (France)
    Olymars Library:    v1.0.868.22959

*/

#define msSql
		
#region Section: Using Declarations
		
using System;
using System.Collections;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Text.RegularExpressions;
using System.Web;
using Vha.Vtk.DataClasses;
using Vha.Vtk.Kernel.Common;
using si = Vha.Vtk.Kernel.Common.ReturnStatusIndicator;
#if msSql
using sqlDrv = Vha.Vtk.DataClasses.StationProfileMsSqlSrv;
#endif
		
#endregion
		
namespace Vha.Vtk.TimeKeeping
{
	/// <summary>
	///  Public Class mapped to VtkVolunteerStationProfiles
	///  All developer editing of classes should occur in this file.
	/// </summary>
	public class StationProfile : StationProfileBase
	{
		
		#region Section: Database Fields
		
		
		#endregion
		
		#region Section: Property Definitions
		
		
		#endregion
		
		#region Section: Constructors
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		public StationProfile() : base()
		{
		}
		
		/// <summary>
		/// Main Constructor
		/// </summary>
		/// <param name="id">Primary key value for VtkVolunteerStationProfiles entry</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		public StationProfile(int id, ApplicationConnection appCon) : base(id, appCon)
		{
		}
		
		/// <summary>
		/// Create instance based on DataRow from StationProfile table.
		/// </summary>
		/// <param name="dr">DataRow to be used to fill instance</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		private StationProfile(DataRow dr, ApplicationConnection appCon) : base(dr, appCon)
		{
		}
		
		/// <summary>
		/// Basic constructor used by <see cref="AddRecord" />
		/// </summary>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		private StationProfile(ApplicationConnection appCon) : base(appCon)
		{
		}

		/// <summary>
		/// Creates an instance of StationProfile that will be used to add a record to the VtkVolunteerStationProfile database table.
		/// Must specify the VolunteerId that the record will be created for
		/// </summary>
		/// <returns><see cref="StationProfile" /></returns>
		public static StationProfile AddRecord()
		{
			StationProfile staproObj = new StationProfile();
			staproObj.FillDataNew();
			return staproObj;
		}

		/// <summary>
		/// Creates an instance of StationProfile that will be used to add a record to the VtkVolunteerStationProfile database table.
		/// Must specify the VolunteerId that the record will be created for
		/// </summary>
		/// <param name="volunteerId">Primary key to volunteer entry</param>
		/// <param name="appCon">Current ApplicationConnection <see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="StationProfile" /></returns>
		public static StationProfile AddRecord(int volunteerId, ApplicationConnection appCon)
		{
			StationProfile staproObj = new StationProfile(appCon);
			staproObj.FillDataNew();
			staproObj.VolunteerId = volunteerId;
			return staproObj;
		}
		
		/// <summary>
		/// Retrieves or creates a StationProfile instance for a volunteer for a station based
		/// on a data passed in the parameters.
		/// </summary>
		/// <param name="volunteerId">Primary key of volunteer</param>
		/// <param name="stationId">Primary key of station</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="StationProfile" /></returns>
		public static StationProfile Create(int volunteerId, int stationId, ApplicationConnection appCon)
		{
			string sCommand = 
				//"SELECT " + StationProfileMsSqlSrv.idField + " " +
				"SELECT * " +
				"FROM "   + StationProfileMsSqlSrv.tableName + " " + 
				"WHERE (" + StationProfileMsSqlSrv.volunteerIdField + " = " + volunteerId.ToString() + ") " +
				"AND ("   + StationProfileMsSqlSrv.stationIdField +   " = " + stationId.ToString() + ")";

			string tableName = "StationProfiles";
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,tableName);
			da.Dispose();

			StationProfile staproObj;
			if (ds.Tables[tableName].Rows.Count == 1)
			{
				staproObj = new StationProfile(ds.Tables[tableName].Rows[0], appCon);
				staproObj.dataSrv.SetDataSetInfo(ds, tableName, 0);
				//staproObj = new StationProfile((int)ds.Tables[tableName].Rows[0][StationProfileMsSqlSrv.idField], appCon);
			}
			else if (ds.Tables[tableName].Rows.Count == 0)
			{
				staproObj = StationProfile.AddRecord(volunteerId, appCon);
				staproObj.StationId = stationId;
			}
			else
			{
				string msg;
				msg =
					"More than one StationProfile entry already exists: \r\n" +
					" VolunteerId: "         + volunteerId.ToString() + "\r\n" +
					" StationId: "           + stationId.ToString() + "\r\n";
				throw new Exception(msg);
			}
			return staproObj;
		}

		/// <summary>
		/// Creates an instance of StationProfile thate will be used to add a record to the VtkVolunteerStationProfiles database table.
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="StationProfile"/></returns>
		public static StationProfile AddRecord(ApplicationConnection appCon)
		{
			StationProfile staproObj = new StationProfile(appCon);
			staproObj.FillDataNew();
			return staproObj;
		}
		
		#endregion
		
		#region Section: Initializers
		
		
		#endregion
		
		#region Section: Finalizers
		
		
		#endregion
		
		#region Section: Field Validaters
		
		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus ValidateNew()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNewRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEntryDate(EntryDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEligibleForMeals(EligibleForMeals);
			return returnStatus;
		}

		/// <summary>
		/// Main validator method that calls all the properties validator method.
		/// </summary>
		/// <remarks>
		/// This method is called by the Save() method.
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Validate()
		{
			returnStatus.Clear();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRelations();
			if (returnStatus.Status == si.Pass) returnStatus = ValidateStationId(StationId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateVolunteerId(VolunteerId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateContactInfoId(ContactInfoId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateNextOfKinId(NextOfKinId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEntryDate(EntryDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateYearsAtStation(YearsAtStation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidatePriorYearsHoursServed(PriorYearsHoursServed);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateCurrentYearHoursServed(CurrentYearHoursServed);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateHoursLastAward(HoursLastAward);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateDateLastAward(DateLastAward);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateAwardCodesId(AwardCodesId, appCon);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateTerminationDate(TerminationDate);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateIsTerminatedWithCause(IsTerminatedWithCause);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateRemarks(Remarks);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateMethodOfTransportation(MethodOfTransportation);
			if (returnStatus.Status == si.Pass) returnStatus = ValidateEligibleForMeals(EligibleForMeals);
			return returnStatus;
		}

		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Validates that the ContactInfoId references the same VolunteerId as the StationProfile.</description></item>
		/// <item><description>Validates that the NextOfKinId references the same VolunteerId as the StationProfile.</description></item>
		/// <item><description>Validates StationProfile.TotalHoursServed is greater than Award.RequiredHours.</description></item>
		/// <item><description>Validates that age of Volunteer not greater than 21 for Youth (Award.AwardType=Youth) awards.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateNewRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "StationProfile";
			ret.PropertyName = "[Relations Check]";
			
			if (this.awardCodesId >= 1)
			{

				DataRow awardData = GetAwardRequiredHours(this.awardCodesId, appCon);
				int requiredHours = (int)awardData["RequiredHours"];
				string awardType = awardData["AwardType"].ToString();
				
				// StationProfile.TotalHours must be greater or equal to Required hours
				if (this.totalHoursServed < requiredHours)
				{
					ret.Status    = si.Fail;
					ret.ErrorText = "'AwardCodesId' references a Award that requires more hours than TotalHoursServed.";
					return ret;
				}
			}
			//Check entrydate isn't a future date
			if(this.entryDate > DateTime.Now)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Entry Date' can't be a date greater than today's date.";
				return ret;
			}
			//Check dateLastAward isn't a future date
			if(this.dateLastAward > DateTime.Now)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Date of Last Award' can't be a date greater than todays date.";
				return ret;
			}
			//if EntryDate < TerminationDate throw exception
			if((this.entryDate > this.terminationDate)&&(this.terminationDate != DateTime.MinValue))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Entry Date' can't occur after the 'Termination Date'";
				return ret;
			}
			return ret;
		}
	
		/// <summary>
		/// Validates special relational constraints between properties and database values, like uniqueness.
		/// </summary>
		/// <remarks>
		/// Checks performed:
		/// <list type="bullet">
		/// <item><description>Validates that the ContactInfoId references the same VolunteerId as the StationProfile.</description></item>
		/// <item><description>Validates that the NextOfKinId references the same VolunteerId as the StationProfile.</description></item>
		/// <item><description>Validates StationProfile.TotalHoursServed is greater than Award.RequiredHours.</description></item>
		/// <item><description>Validates that age of Volunteer not greater than 21 for Youth (Award.AwardType=Youth) awards.</description></item>
		/// </list>
		/// </remarks>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public ReturnStatus ValidateRelations()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName = "StationProfile";
			ret.PropertyName = "[Relations Check]";
			
			//no ContactInformation specified
			if (this.contactInfoId != Int32.MinValue) 
			{
				// get contactInformation.VolunteerId and validate it matches StationProfile.VolunteerId
				int contactInfoVolId = ContactInformation.GetVolunteerId(this.contactInfoId, appCon);
				if (this.volunteerId != contactInfoVolId)
				{
					ret.Status    = si.Fail;
					ret.ErrorText = "Entry not allowed.  ContactInformation is for a different VolunteerId (" + contactInfoVolId + ") than the StationProfile VolunteerId (" + this.volunteerId + "). ";
					return ret;
				}
			}

			//no NextOfKin specified
			if (this.nextOfKinId != Int32.MinValue)
			{
				// get NextOfKin.VolunteerId and validate it matches StationProfile.VolunteerId
				int nextOfKinVolId = NextOfKin.GetVolunteerId(this.nextOfKinId, appCon);
				if (this.volunteerId != nextOfKinVolId)
				{
					ret.Status    = si.Fail;
					ret.ErrorText = "Entry not allowed.  NextOfKin is for a different VolunteerId (" + nextOfKinVolId + ") than the StationProfile VolunteerId (" + this.volunteerId + "). ";
					return ret;
				}
			}

			if (this.awardCodesId >= 1)
			{

				DataRow awardData = GetAwardRequiredHours(this.awardCodesId, appCon);
				int requiredHours = (int)awardData["RequiredHours"];
				string awardType = awardData["AwardType"].ToString();
				
				// StationProfile.TotalHours must be greater or equal to Required hours
				if (this.totalHoursServed < requiredHours)
				{
					ret.Status    = si.Fail;
					ret.ErrorText = "'AwardCodesId' references a Award that requires more hours than TotalHoursServed.";
					return ret;
				}


				// if youth award, volunteer must be youth (at time award received).
				if (awardType == "Y") 
				{	
					DataSet volDs = new DataSet();
					volDs = Volunteer.GetQuickList(this.volunteerId);
					DateTime volDob = (DateTime)volDs.Tables["VolunteerList"].Rows[0]["DateOfBirth"];
					TimeSpan volTs  = this.dateLastAward.Subtract(volDob);
					float ageAtAward= (volTs.Days/365);
					if (ageAtAward > 21.9999)
					{
						ret.Status    = si.Fail;
						ret.ErrorText = "'AwardCodesId' is a youth award and the volunteer is over 21.";
						return ret;
					}
				}
			}
			//Check entrydate isn't a future date
			if(this.entryDate > DateTime.Now)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Entry Date' can't be a date greater than today's date.";
				return ret;
			}
			//Check dateLastAward isn't a future date
			if(this.dateLastAward > DateTime.Now)
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Date of Last Award' can't be a date greater than todays date.";
				return ret;
			}
			//if EntryDate < TerminationDate throw exception
			if((this.entryDate > this.terminationDate)&&(this.terminationDate != DateTime.MinValue))
			{
				ret.Status = si.Fail;
				ret.ErrorText = "'Entry Date' can't occur after the 'Termination Date'";
				return ret;
			}
			return ret;
		}
	
		/// <summary>
		/// Performs basic database-centric and any special validation checks for StationId property.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateStationId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of StationId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateStationId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationProfileBase.ValidateStationId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for VolunteerId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateVolunteerId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of VolunteerId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateVolunteerId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationProfileBase.ValidateVolunteerId(value, appCon);
			return ret;
		}

		/// <summary>
		/// Validates that this is a unique VolunteerId/StationId pair.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Validates that this is a unique VolunteerId/StationId pair</description></item>
		/// </list>
		/// </remarks>
		/// <param name="staproObj">Current Instance of StationProfile Object</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static ReturnStatus ValidateVolunteerIdStationIdPair(StationProfile staproObj, ApplicationConnection appCon)
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationProfile";
			ret.PropertyName = "StationId/VolunteerIdPair Already Exists";

			// Volunteer can have only one entry per station
			if (GetVolunteerStationEntryCount(staproObj.id, staproObj.stationId, staproObj.volunteerId, appCon) > 0)
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Entry not allowed. Another entry exists for this station Id / volunteer Id pair (" + staproObj.stationId.ToString() + "/" + staproObj.volunteerId.ToString() + ")";
			}	
		
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for ContactInfoId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateContactInfoId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of ContactInfoId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateContactInfoId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationProfileBase.ValidateContactInfoId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for NextOfKinId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateNextOfKinId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of NextOfKinId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateNextOfKinId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationProfileBase.ValidateNextOfKinId(value, appCon);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EntryDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateEntryDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of EntryDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateEntryDate(DateTime value)
		{
			ReturnStatus ret = StationProfileBase.ValidateEntryDate(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for YearsAtStation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateYearsAtStation.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of YearsAtStation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateYearsAtStation(Int32 value)
		{
			ReturnStatus ret = StationProfileBase.ValidateYearsAtStation(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for PriorYearsHoursServed property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidatePriorYearsHoursServed.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of PriorYearsHoursServed</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidatePriorYearsHoursServed(Int32 value)
		{
			ReturnStatus ret = StationProfileBase.ValidatePriorYearsHoursServed(value);
			return ret;
		}

		/// <summary>
		/// Performs basic database-centric and any special validation checks for CurrentYearHoursServed property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateCurrentYearHoursServed.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of CurrentYearHoursServed</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateCurrentYearHoursServed(Int32 value)
		{
			ReturnStatus ret = StationProfileBase.ValidateCurrentYearHoursServed(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for HoursLastAward property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateHoursLastAward.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of HoursLastAward</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateHoursLastAward(Int32 value)
		{
			ReturnStatus ret = StationProfileBase.ValidateHoursLastAward(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for DateLastAward property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateDateLastAward.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of DateLastAward</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateDateLastAward(DateTime value)
		{
			ReturnStatus ret = StationProfileBase.ValidateDateLastAward(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for AwardCodesId property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateAwardCodesId.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of AwardCodesId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection" /></param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateAwardCodesId(Int32 value, ApplicationConnection appCon)
		{
			ReturnStatus ret = StationProfileBase.ValidateAwardCodesId(value, appCon);
			return ret;
		}

		#if msSql

		//todo:  move to award class as a public quicklist
		private static DataRow GetAwardRequiredHours(int awardCodeId, ApplicationConnection appCon)
		{
			string sCommand = "SELECT " + 
					AwardMsSqlSrv.awardNameField     + " AwardName, " +
				    AwardMsSqlSrv.requiredHoursField + " RequiredHours, " +
					AwardMsSqlSrv.awardTypeField     + " AwardType " +
			    
				" FROM "  + AwardMsSqlSrv.tableName +
				" WHERE " + AwardMsSqlSrv.idField + " = '" + awardCodeId + "'";
			
			SqlDataAdapter da = new SqlDataAdapter(sCommand, appCon.ConnectString);
			DataSet ds = new DataSet();
			da.Fill(ds,"AwardData");
			DataRow dr = ds.Tables["AwardData"].Rows[0];
			da.Dispose();
			return dr;
		}

		#endif

		/// <summary>
		/// Performs basic database-centric and any special validation checks for TerminationDate property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateTerminationDate.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of TerminationDate</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateTerminationDate(DateTime value)
		{
			ReturnStatus ret = StationProfileBase.ValidateTerminationDate(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for IsTerminatedWithCause property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateIsTerminatedWithCause.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of IsTerminatedWithCause</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateIsTerminatedWithCause(bool value)
		{
			ReturnStatus ret = StationProfileBase.ValidateIsTerminatedWithCause(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for Remarks property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateRemarks.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of Remarks</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateRemarks(string value)
		{
			ReturnStatus ret = StationProfileBase.ValidateRemarks(value);
			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for MethodOfTransportation property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateMethodOfTransportation.</description></item>
		/// <item><description>Validates MethodOfTransportation is of limited set {1, 2, 3, 4}.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of MethodOfTransportation</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/></returns>
		public static new ReturnStatus ValidateMethodOfTransportation(string value)
		{
			ReturnStatus ret = StationProfileBase.ValidateMethodOfTransportation(value);
			if (ret.Status != si.Pass) return ret;
			
			// value is not set and not required
			if (value == string.Empty) return ret;

			if (!Regex.IsMatch(value, @"\b[1|2|3|4]\b"))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "'MethodOfTransportation' is not valid.";
			}

			return ret;
		}
		 
		/// <summary>
		/// Performs basic database-centric and any special validation checks for EligibleForMeals property values.
		/// </summary>
		/// <remarks>
		/// <list type="bullet">
		/// <item><description>Database-centric validation checks are performed by calling StationProfileBase.ValidateEligibleForMeals.</description></item>
		/// </list>
		/// </remarks>
		/// <param name="value">Current instance value of EligibleForMeals</param>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static new ReturnStatus ValidateEligibleForMeals(Int32 value)
		{
			ReturnStatus ret = StationProfileBase.ValidateEligibleForMeals(value);
		 	return ret;
		}
		 
		
		#endregion
		
		#region Section: Filers

		/// <summary>
		/// Save current instance
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public override ReturnStatus Save()
		{
			ReturnStatus ret = DeleteCheck();
			if (ret.Status != si.Pass) throw new VhaValidationException(ret.ErrorText, ret.ClassName, returnStatus.PropertyName);

			ret = SaveCheck();
			if (ret.Status != si.Pass) throw new VhaValidationException(ret.ErrorText, ret.ClassName, returnStatus.PropertyName);

			return base.Save();
		}

		/// <summary>
		/// Updates award related fields of all the records in the dataset.
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public static int SaveAwards(string AwardList, ApplicationConnection appCon)
		{
			SqlParameter xmlParam = new System.Data.SqlClient.SqlParameter();
			SqlConnection conn = new SqlConnection(appCon.ConnectString);
			SqlCommand sqlCommand = new SqlCommand("spU_VtkStationProfilesAwards", conn);
			sqlCommand.CommandType = CommandType.StoredProcedure;

			int Success = 0;
			int TotalSize = 8000;

			xmlParam				= sqlCommand.Parameters.Add("@AwardList1", SqlDbType.VarChar, 8000);
			xmlParam.Direction		= ParameterDirection.Input;

			if (AwardList.Length < (TotalSize * 1) + 1 )
			{
				xmlParam.Value			= AwardList;
			}
			else
			{
				xmlParam.Value			= AwardList.Substring(0, (TotalSize * 1));
			}

			xmlParam				= sqlCommand.Parameters.Add("@AwardList2", SqlDbType.VarChar, 8000);
			xmlParam.Direction		= ParameterDirection.Input;

			if (AwardList.Length < ((TotalSize * 2) + 1) && AwardList.Length > (TotalSize * 1))
			{
				xmlParam.Value			= AwardList.Substring((TotalSize * 1));
			}
			else if (AwardList.Length > (TotalSize * 2))
			{
				xmlParam.Value			= AwardList.Substring(((TotalSize * 1)), (TotalSize * 1));
			}
			else
			{
				xmlParam.Value			= "";
			}


			xmlParam				= sqlCommand.Parameters.Add("@AwardList3", SqlDbType.VarChar, 8000);
			xmlParam.Direction		= ParameterDirection.Input;

			if (AwardList.Length < ((TotalSize * 3) + 1) && AwardList.Length > (TotalSize * 2))
			{
				xmlParam.Value			= AwardList.Substring((TotalSize * 2));
			}
			else if (AwardList.Length > (TotalSize * 3))
			{
				xmlParam.Value			= AwardList.Substring(((TotalSize * 2)), (TotalSize * 1));
			}
			else
			{
				xmlParam.Value			= "";
			}

			xmlParam				= sqlCommand.Parameters.Add("@AwardList4", SqlDbType.VarChar, 8000);
			xmlParam.Direction		= ParameterDirection.Input;

			if (AwardList.Length < ((TotalSize * 4) + 1) && AwardList.Length > (TotalSize * 3))
			{
				xmlParam.Value			= AwardList.Substring((TotalSize * 3));
			}
			else if (AwardList.Length > (TotalSize * 4))
			{
				xmlParam.Value			= AwardList.Substring(((TotalSize * 3)), (TotalSize * 1));
			}
			else
			{
				xmlParam.Value			= "";
			}

			try
			{
				conn.Open();
				Success = sqlCommand.ExecuteNonQuery();
			}
			catch(SqlException SqlEx)
			{
				throw SqlEx;
			}
			return Success;

		}


		/// <summary>
		/// Checks to ensure that a duplicate record is not entered.
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public ReturnStatus SaveCheck()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationProfile";
			ret.PropertyName = "SaveCheck Logic";

			if (this.IsDeleted) return ret;

			// Volunteer can have only one entry per station
			if ((ret.Status == si.Pass) && (GetVolunteerStationEntryCount(this.id, this.stationId, this.volunteerId, this.appCon) > 0))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Entry not allowed. Another entry exists for this station Id / volunteer Id pair (" + stationId.ToString() + "/" + volunteerId.ToString() + ")";
			}	
		
			return ret;
		}

		/// <summary>
		/// Overall check before Deleting. 
		/// Validate that there are no VolunteerHour entries for this StationProfile.
		/// Validate that Current Year Hours served = 0.
		/// Validate that Prior Year Hours served = 0.
		/// </summary>
		/// <returns><see cref="Vha.Vtk.Kernel.Common.ReturnStatus"/> </returns>
		public ReturnStatus DeleteCheck()
		{
			ReturnStatus ret = new ReturnStatus();
			ret.ClassName    = "StationProfile";
			ret.PropertyName = "DeleteCheck Logic";

			// return if not deleting
			if (!this.IsDeleted) return ret;
			
			// can't delete if current year has data
			if ((ret.Status == si.Pass) && (this.currentYearHoursServed != 0))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Deletion not allowed. 'Current Year Hours Served' data exists for this station Id / volunteer Id pair (" + stationId.ToString() + "/" + volunteerId.ToString() + ")";
			}
			
			// can't delete if prior year field has data
			if ((ret.Status == si.Pass) && (this.priorYearsHoursServed != 0))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Deletion not allowed. 'Prior Year Hours Served' data exists for this station Id / volunteer Id pair (" + stationId.ToString() + "/" + volunteerId.ToString() + ")";
			}			

			// can't delete if prior year field has data
			if ((ret.Status == si.Pass) && (GetVolunteerHoursEntryCount(this.stationId, this.volunteerId, this.appCon) > 0))
			{
				ret.Status    = si.Fail;
				ret.ErrorText = "Deletion not allowed. Volunteer hours entries exists for this station Id / volunteer Id pair (" + stationId.ToString() + "/" + volunteerId.ToString() + ")";
			}			
			return ret;
		}
		
		#if msSql
		
		/// <summary>
		/// Returns count of entries for stationId / volunteerId pair in VtkVolunteerHours
		/// </summary>
		/// <param name="stationId">Primary key for station</param>
		/// <param name="volunteerId">Primary key for volunteer</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <br>Count of number of records in VtkVolunteerHours table for stationId/volunteerId pair</br> 
		/// </returns>
		private static int GetVolunteerHoursEntryCount(int stationId, int volunteerId, ApplicationConnection appCon)
		{
			string sCommand = 
				"SELECT COUNT(*)" +
				" FROM "  + VolunteerHoursMsSqlSrv.tableName +
				" WHERE " + VolunteerHoursMsSqlSrv.stationIdField + " = '" + stationId + "'" +
				" AND "   + VolunteerHoursMsSqlSrv.volunteerIdField + " = '" + volunteerId + "'";
		
			SqlConnection conn = new SqlConnection(appCon.ConnectString);
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			int count = (int)cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();
			return count;
		}

		/// <summary>
		/// Returns count of entries for VolunteerId/StationId pair to prevent duplicates.
		/// Does not count current entry.
		/// </summary>
		/// <param name="id"></param>
		/// <param name="stationId"></param>
		/// <param name="volunteerId"></param>
		/// <param name="appCon"></param>
		/// <returns>Integer</returns>
		private static int GetVolunteerStationEntryCount(int id, int stationId, int volunteerId, ApplicationConnection appCon)
		{
			string sCommand = 
				"SELECT COUNT(*)" +
				" FROM "  + sqlDrv.tableName +
				" WHERE " + sqlDrv.idField + " <> '" + id + "' " + 
				" AND "   + sqlDrv.stationIdField + " = '" + stationId + "'" +
				" AND "   + sqlDrv.volunteerIdField + " = '" + volunteerId + "'";
		
			SqlConnection conn = new SqlConnection(appCon.ConnectString);
			SqlCommand cmd = new SqlCommand(sCommand, conn);
			cmd.Connection.Open();
			int count = (int)cmd.ExecuteScalar();
			cmd.Connection.Close();
			cmd.Dispose();
			conn.Dispose();
			return count;
		}

		#endif
		#endregion
		
		#region Section: Quick Lists
		
		#if msSql
		/// <summary>
		///  Station Profile by StationProfileId
		///  DataSet Table Name: 'StationProfileList'
		/// </summary>
		/// <param name="stationProfileId">StationProfile Id</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <br>DataSet Table Name: StationProfileList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>Id</b> [int]</br>
		/// <br><b>StationId</b> [int]</br>
		/// <br><b>VolunteerId</b> [int] </br>
		/// <br><b>ContactInfoId</b> [int]</br>
		/// <br><b>NextOfKinId</b> [int]</br>
		/// <br><b>EntryDate</b> [DateTime]</br>
		/// <br><b>YearsAtStation</b> [int]</br>
		/// <br><b>PriorYearsHoursServed</b> [int]</br>
		/// <br><b>CurrentYearHoursServed</b> [int]</br>
		/// <br><b>TotalHoursServed</b> [int]</br>
		/// <br><b>HoursLastAward</b> [int]</br>
		/// <br><b>DateLastAward</b> [DateTime]</br>
		/// <br><b>AwardCodesId</b> [int]</br>
		/// <br><b>TerminationDate</b> [DateTime]</br>
		/// <br><b>IsTerminatedWithCause</b> [bool]</br>
		/// <br><b>Remarks</b> [string (800)]</br>
		/// <br><b>MethodOfTransportation</b> [string (1)] (acceptable values? not documented in database)</br>
		/// <br><b>Version</b> [int]</br>
		/// <br><b>IsEligibleForMeals</b> [bool]</br>
		///	<br></br>
		///	<br>Sorted By: None Specified</br>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickList(int stationProfileId)
		{
			string sCommand = "Select "  +
				sqlDrv.idField                     + " Id, " +
				sqlDrv.awardCodesIdField           + " AwardCodeId, " +
				sqlDrv.contactInfoIdField          + " ContactInfoId, " +
				sqlDrv.currentYearHoursServedField + " CurrentYearHoursServed, " +
				sqlDrv.dateLastAwardField          + " DateLastAwardField, " +
				sqlDrv.entryDateField              + " EntryDate, " +
				sqlDrv.hoursLastAwardField         + " HoursLastAward, " +
				sqlDrv.totalHoursServedField       + " TotalHoursServed, " +
				sqlDrv.eligibleForMealsField     + " EligibleForMeals, " +
				sqlDrv.isTerminatedWithCauseField  + " IsTerminatedWithCause, " +
				sqlDrv.methodOfTransportationField + " MethodOfTransportation, " +
				sqlDrv.nextOfKinIdField            + " NextOfKinId, " +
				sqlDrv.priorYearsHoursServedField  + " PriorYearsServed, " +
				sqlDrv.remarksField                + " Remarks, " +
				sqlDrv.stationIdField              + " StationId, " +
				sqlDrv.terminationDateField        + " TerminationDate, " +
				sqlDrv.volunteerIdField            + " VolunteerId, " +
				sqlDrv.versionField                + " Version, " +
				sqlDrv.yearsAtStationField         + " YearsAtStation " +
				" FROM " + sqlDrv.tableName +
				" WHERE " + sqlDrv.idField + " = '" + stationProfileId + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "StationProfileList");
		}

		/// <summary>
		/// StationProfiles For a specific Vol Id
		/// DataSet Table Name: 'StationProfileList'
		/// </summary>
		/// <param name="volId">VolunteerId</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <br>DataSet Table Name: StationProfileList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>Id</b> [int]</br>
		/// <br><b>StationId</b> [int]</br>
		/// <br><b>VolunteerId</b> [int] </br>
		/// <br><b>ContactInfoId</b> [int]</br>
		/// <br><b>NextOfKinId</b> [int]</br>
		/// <br><b>EntryDate</b> [DateTime]</br>
		/// <br><b>YearsAtStation</b> [int]</br>
		/// <br><b>PriorYearsHoursServed</b> [int]</br>
		/// <br><b>CurrentYearHoursServed</b> [int]</br>
		/// <br><b>TotalHoursServed</b> [int]</br>
		/// <br><b>HoursLastAward</b> [int]</br>
		/// <br><b>DateLastAward</b> [DateTime]</br>
		/// <br><b>AwardCodesId</b> [int]</br>
		/// <br><b>TerminationDate</b> [DateTime]</br>
		/// <br><b>IsTerminatedWithCause</b> [bool]</br>
		/// <br><b>Remarks</b> [string (800)]</br>
		/// <br><b>MethodOfTransportation</b> [string (1)] (1,2,3,or 4)</br>
		/// <br><b>Version</b> [int]</br>
		/// <br><b>IsEligibleForMeals</b> [bool]</br>
		///	<br></br>
		///	<br>Sorted By: None Specified</br>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickListByVol(int volId)
		{
			string sCommand = "Select "  +
				"VSP." + sqlDrv.idField                     + " Id, " +
				"VSP." + sqlDrv.awardCodesIdField           + " AwardCodeId, " +
				"VSP." + sqlDrv.contactInfoIdField          + " ContactInfoId, " +
				"VSP." + sqlDrv.currentYearHoursServedField + " CurrentYearHoursServed, " +
				"VSP." + sqlDrv.dateLastAwardField          + " DateLastAwardField, " +
				"VSP." + sqlDrv.entryDateField              + " EntryDate, " +
				"VSP." + sqlDrv.hoursLastAwardField         + " HoursLastAward, " +
				"VSP." + sqlDrv.totalHoursServedField       + " TotalHoursServed, " +
				"VSP." + sqlDrv.eligibleForMealsField     + " EligibleForMeals, " +
				"VSP." + sqlDrv.isTerminatedWithCauseField  + " IsTerminatedWithCause, " +
				"VSP." + sqlDrv.methodOfTransportationField + " MethodOfTransportation, " +
				"VSP." + sqlDrv.nextOfKinIdField            + " NextOfKinId, " +
				"VSP." + sqlDrv.priorYearsHoursServedField  + " PriorYearsServed, " +
				"VSP." + sqlDrv.remarksField                + " Remarks, " +
				"VSP." + sqlDrv.stationIdField              + " StationId, " +
				"VI.StationNumber StationNumber, " +
				"VSP." + sqlDrv.terminationDateField        + " TerminationDate, " +
				"VSP." + sqlDrv.volunteerIdField            + " VolunteerId, " +
				"VSP." + sqlDrv.versionField                + " Version, " +
				"VSP." + sqlDrv.yearsAtStationField         + " YearsAtStation " +
				" FROM " + sqlDrv.tableName + " VSP" +
				" INNER JOIN VtkInstitutions VI ON VSP.StationFK = VI.Id" +
				" WHERE " + sqlDrv.volunteerIdField + " = '" + volId + "' ";
		
			return ApplicationConnection.ExecuteQuery(sCommand, "StationProfileList");
		}
		
		/// <summary>
		/// StationProfile for a specific VolId at a specific stationId
		/// DataSet Table Name: 'StationProfileList'
		/// </summary>
		/// <param name="volId">Volunteer Id</param>
		/// <param name="stationId">StationParameter Id</param>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// <br>DataSet Table Name: StationProfileList</br> 
		/// <br></br>
		/// <br>Data Columns Returned:</br>
		/// <br><b>Id</b> [int]</br>
		/// <br><b>StationId</b> [int]</br>
		/// <br><b>VolunteerId</b> [int] </br>
		/// <br><b>ContactInfoId</b> [int]</br>
		/// <br><b>NextOfKinId</b> [int]</br>
		/// <br><b>EntryDate</b> [DateTime]</br>
		/// <br><b>YearsAtStation</b> [int]</br>
		/// <br><b>PriorYearsHoursServed</b> [int]</br>
		/// <br><b>CurrentYearHoursServed</b> [int]</br>
		/// <br><b>TotalHoursServed</b> [int]</br>
		/// <br><b>HoursLastAward</b> [int]</br>
		/// <br><b>DateLastAward</b> [DateTime]</br>
		/// <br><b>AwardCodesId</b> [int]</br>
		/// <br><b>TerminationDate</b> [DateTime]</br>
		/// <br><b>IsTerminatedWithCause</b> [bool]</br>
		/// <br><b>Remarks</b> [string (800)]</br>
		/// <br><b>MethodOfTransportation</b> [string (1)]</br>
		/// <br><b>Version</b> [int]</br>
		/// <br><b>IsEligibleForMeals</b> [bool]</br>
		///	<br></br>
		///	<br>Sorted By: None Specified</br>
		///	<br></br>
		/// </returns>
		public static DataSet GetQuickListByVolAndSite(int volId, int stationId)
		{
			string sCommand = "Select "  +
				"VSP." + sqlDrv.idField                     + " Id, " +
				"VSP." + sqlDrv.awardCodesIdField           + " AwardCodeId, " +
				"VSP." + sqlDrv.contactInfoIdField          + " ContactInfoId, " +
				"VSP." + sqlDrv.currentYearHoursServedField + " CurrentYearHoursServed, " +
				"VSP." + sqlDrv.dateLastAwardField          + " DateLastAwardField, " +
				"VSP." + sqlDrv.entryDateField              + " EntryDate, " +
				"VSP." + sqlDrv.hoursLastAwardField         + " HoursLastAward, " +
				"VSP." + sqlDrv.totalHoursServedField       + " TotalHoursServed, " +
				"VSP." + sqlDrv.eligibleForMealsField				+ " EligibleForMeals, " +
				"VSP." + sqlDrv.isTerminatedWithCauseField  + " IsTerminatedWithCause, " +
				"VSP." + sqlDrv.methodOfTransportationField + " MethodOfTransportation, " +
				"VSP." + sqlDrv.nextOfKinIdField            + " NextOfKinId, " +
				"VSP." + sqlDrv.priorYearsHoursServedField  + " PriorYearsServed, " +
				"VSP." + sqlDrv.remarksField                + " Remarks, " +
				"VI.StationNumber StationNumber, " +
				"VI.NameOfInstitution StationName, " +
				"VSP." + sqlDrv.stationIdField              + " StationId, " +
				"VSP." + sqlDrv.terminationDateField        + " TerminationDate, " +
				"VSP." + sqlDrv.volunteerIdField            + " VolunteerId, " +
				"VSP." + sqlDrv.versionField                + " Version, " +
				"VSP." + sqlDrv.yearsAtStationField         + " YearsAtStation " +
				" FROM " + sqlDrv.tableName + " VSP" +
				" INNER JOIN VtkInstitutions VI" +
				" ON VI.ID = VSP." + sqlDrv.stationIdField +
				" WHERE " + sqlDrv.volunteerIdField + " = '" + volId + "' " + 
				" AND " + sqlDrv.stationIdField + " = '" + stationId + "' ";
			
			return ApplicationConnection.ExecuteQuery(sCommand, "StationProfileList");
		}
		/// <summary>
		///  Returns a dataset containing the Key Column and External column of
		///  MethodOfTransportationList.  The External Column is to display to Users, 
		///  the Key column is set to the StationProfile.MethodOfTransportation property
		///  
		///  Allowable Entries are:
		///  1=Privately Owned Vehicle, 2=Public Transportation, 3=Walk/Bicycle, 4=Other
		/// </summary>
		/// <param name="appCon"><see cref="Vha.Vtk.Kernel.Common.ApplicationConnection"/></param>
		/// <returns>
		/// Returns a list of valid StationProfile.MethodOfTransportation internal and external values
		/// <ul>
		/// <li>DataSet Table Name:</li> <ul><li><b> MethodOfTransportationList</b></li></ul> 
		/// <br></br>
		/// <li>Data Columns Returned:</li>
		/// <ul>
		/// <li><b>Key</b> [string (1)]</li>
		/// <li><b>External</b> [string]</li>
		/// </ul>
		/// <br></br>
		///	<li>Sorted By:</li><ul><li> <b>Key</b></li></ul>
		///	</ul>
		/// </returns>
		public static DataSet GetMethodOfTransportationList()
		{
			DataSet ds = new DataSet("MethodOfTransportationList");

			DataTable dt = new DataTable("MethodOfTransportationList");
			DataColumn[] keys = new DataColumn[1];
			DataColumn keyCol = new DataColumn("Key",System.Type.GetType("System.String"));
			dt.Columns.Add(keyCol);
			keys[0] = keyCol;
			dt.PrimaryKey = keys;

			DataColumn externalCol = new DataColumn("External",System.Type.GetType("System.String"));
			dt.Columns.Add(externalCol);
			
			//1=Privately Owned Vehicle, 2=Public Transportation, 3=Walk/Bicycle, 4=Other
			DataRow dr;
			dr = dt.NewRow(); dr["Key"] = "1"; dr["External"] = "Privately Owned Vehicle"; dt.Rows.Add(dr);
			dr = dt.NewRow(); dr["Key"] = "2"; dr["External"] = "Public Transportation";   dt.Rows.Add(dr);
			dr = dt.NewRow(); dr["Key"] = "3"; dr["External"] = "Walk/Bicycle";            dt.Rows.Add(dr); 
			dr = dt.NewRow(); dr["Key"] = "4"; dr["External"] = "Other";                   dt.Rows.Add(dr); 

			ds.Tables.Add(dt);
			return ds;
		}
		#endif
		#endregion
		
		#region Section: Utilities

		/// <summary>
		///   Set version field for instance.
		/// </summary>
		/// <param name="version">Version number to be used when saving instance</param>
		/// <remarks>
		/// <list type="bullet">
		/// <item>
		/// <description>
		///   This method is mostly used by collection classes to re-set version number
		///   from data in a collection dataset.
		/// </description>
		/// </item>
		/// <item>
		/// <description>
		///   This protection level of this method is 'internal' so that only the related
		///   collection class will be able to edit the 'version' field.
		/// </description>
		/// </item>
		/// </list>
		/// </remarks>
		internal void SetVersion(int version)
		{
			this.version = version;
		}

		#endregion
		
	}
}
